/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IAuthenticationApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Authenticate
        /// </summary>
        /// <remarks>
        /// Authenticate user and return token (valid for 10 minutes)
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">The user name and password for login</param>
        /// <param name="softwareHouseUuid">The Software House ID (provided by Octopus)</param>
        /// <returns>AuthenticationToken</returns>
        AuthenticationToken AuthenticateUser (Credentials body, string softwareHouseUuid);

        /// <summary>
        /// Authenticate
        /// </summary>
        /// <remarks>
        /// Authenticate user and return token (valid for 10 minutes)
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">The user name and password for login</param>
        /// <param name="softwareHouseUuid">The Software House ID (provided by Octopus)</param>
        /// <returns>ApiResponse of AuthenticationToken</returns>
        ApiResponse<AuthenticationToken> AuthenticateUserWithHttpInfo (Credentials body, string softwareHouseUuid);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Authenticate
        /// </summary>
        /// <remarks>
        /// Authenticate user and return token (valid for 10 minutes)
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">The user name and password for login</param>
        /// <param name="softwareHouseUuid">The Software House ID (provided by Octopus)</param>
        /// <returns>Task of AuthenticationToken</returns>
        System.Threading.Tasks.Task<AuthenticationToken> AuthenticateUserAsync (Credentials body, string softwareHouseUuid);

        /// <summary>
        /// Authenticate
        /// </summary>
        /// <remarks>
        /// Authenticate user and return token (valid for 10 minutes)
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">The user name and password for login</param>
        /// <param name="softwareHouseUuid">The Software House ID (provided by Octopus)</param>
        /// <returns>Task of ApiResponse (AuthenticationToken)</returns>
        System.Threading.Tasks.Task<ApiResponse<AuthenticationToken>> AuthenticateUserAsyncWithHttpInfo (Credentials body, string softwareHouseUuid);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class AuthenticationApi : IAuthenticationApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="AuthenticationApi"/> class.
        /// </summary>
        /// <returns></returns>
        public AuthenticationApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="AuthenticationApi"/> class
        /// </summary>
        /// <returns></returns>
        public AuthenticationApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="AuthenticationApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public AuthenticationApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Authenticate Authenticate user and return token (valid for 10 minutes)
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">The user name and password for login</param>
        /// <param name="softwareHouseUuid">The Software House ID (provided by Octopus)</param>
        /// <returns>AuthenticationToken</returns>
        public AuthenticationToken AuthenticateUser (Credentials body, string softwareHouseUuid)
        {
             ApiResponse<AuthenticationToken> localVarResponse = AuthenticateUserWithHttpInfo(body, softwareHouseUuid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Authenticate Authenticate user and return token (valid for 10 minutes)
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">The user name and password for login</param>
        /// <param name="softwareHouseUuid">The Software House ID (provided by Octopus)</param>
        /// <returns>ApiResponse of AuthenticationToken</returns>
        public ApiResponse< AuthenticationToken > AuthenticateUserWithHttpInfo (Credentials body, string softwareHouseUuid)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling AuthenticationApi->AuthenticateUser");
            // verify the required parameter 'softwareHouseUuid' is set
            if (softwareHouseUuid == null)
                throw new ApiException(400, "Missing required parameter 'softwareHouseUuid' when calling AuthenticationApi->AuthenticateUser");

            var localVarPath = "/authentication";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (softwareHouseUuid != null) localVarHeaderParams.Add("softwareHouseUuid", this.Configuration.ApiClient.ParameterToString(softwareHouseUuid)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AuthenticateUser", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AuthenticationToken>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (AuthenticationToken) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(AuthenticationToken)));
        }

        /// <summary>
        /// Authenticate Authenticate user and return token (valid for 10 minutes)
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">The user name and password for login</param>
        /// <param name="softwareHouseUuid">The Software House ID (provided by Octopus)</param>
        /// <returns>Task of AuthenticationToken</returns>
        public async System.Threading.Tasks.Task<AuthenticationToken> AuthenticateUserAsync (Credentials body, string softwareHouseUuid)
        {
             ApiResponse<AuthenticationToken> localVarResponse = await AuthenticateUserAsyncWithHttpInfo(body, softwareHouseUuid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Authenticate Authenticate user and return token (valid for 10 minutes)
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">The user name and password for login</param>
        /// <param name="softwareHouseUuid">The Software House ID (provided by Octopus)</param>
        /// <returns>Task of ApiResponse (AuthenticationToken)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<AuthenticationToken>> AuthenticateUserAsyncWithHttpInfo (Credentials body, string softwareHouseUuid)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling AuthenticationApi->AuthenticateUser");
            // verify the required parameter 'softwareHouseUuid' is set
            if (softwareHouseUuid == null)
                throw new ApiException(400, "Missing required parameter 'softwareHouseUuid' when calling AuthenticationApi->AuthenticateUser");

            var localVarPath = "/authentication";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (softwareHouseUuid != null) localVarHeaderParams.Add("softwareHouseUuid", this.Configuration.ApiClient.ParameterToString(softwareHouseUuid)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AuthenticateUser", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AuthenticationToken>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (AuthenticationToken) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(AuthenticationToken)));
        }

    }
}
