/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IBalancingsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get modified balancings 
        /// </summary>
        /// <remarks>
        /// Accept dossier token and modifiedTimeStamp and return modified and deleted balancings
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>SyncBalancings</returns>
        SyncBalancings GetModifiedBalancingRelations (int? dossierId, string dossierToken, string modifiedTimeStamp);

        /// <summary>
        /// Get modified balancings 
        /// </summary>
        /// <remarks>
        /// Accept dossier token and modifiedTimeStamp and return modified and deleted balancings
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>ApiResponse of SyncBalancings</returns>
        ApiResponse<SyncBalancings> GetModifiedBalancingRelationsWithHttpInfo (int? dossierId, string dossierToken, string modifiedTimeStamp);
        /// <summary>
        /// Insert balancing
        /// </summary>
        /// <remarks>
        /// Accept dossier token and balancing data, and insert balancing
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Balancing data object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        void InsertBalancing (BalancingServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Insert balancing
        /// </summary>
        /// <remarks>
        /// Accept dossier token and balancing data, and insert balancing
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Balancing data object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> InsertBalancingWithHttpInfo (BalancingServiceData body, string dossierToken, int? dossierId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Get modified balancings 
        /// </summary>
        /// <remarks>
        /// Accept dossier token and modifiedTimeStamp and return modified and deleted balancings
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of SyncBalancings</returns>
        System.Threading.Tasks.Task<SyncBalancings> GetModifiedBalancingRelationsAsync (int? dossierId, string dossierToken, string modifiedTimeStamp);

        /// <summary>
        /// Get modified balancings 
        /// </summary>
        /// <remarks>
        /// Accept dossier token and modifiedTimeStamp and return modified and deleted balancings
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of ApiResponse (SyncBalancings)</returns>
        System.Threading.Tasks.Task<ApiResponse<SyncBalancings>> GetModifiedBalancingRelationsAsyncWithHttpInfo (int? dossierId, string dossierToken, string modifiedTimeStamp);
        /// <summary>
        /// Insert balancing
        /// </summary>
        /// <remarks>
        /// Accept dossier token and balancing data, and insert balancing
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Balancing data object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task InsertBalancingAsync (BalancingServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Insert balancing
        /// </summary>
        /// <remarks>
        /// Accept dossier token and balancing data, and insert balancing
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Balancing data object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> InsertBalancingAsyncWithHttpInfo (BalancingServiceData body, string dossierToken, int? dossierId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class BalancingsApi : IBalancingsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="BalancingsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public BalancingsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BalancingsApi"/> class
        /// </summary>
        /// <returns></returns>
        public BalancingsApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BalancingsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public BalancingsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Get modified balancings  Accept dossier token and modifiedTimeStamp and return modified and deleted balancings
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>SyncBalancings</returns>
        public SyncBalancings GetModifiedBalancingRelations (int? dossierId, string dossierToken, string modifiedTimeStamp)
        {
             ApiResponse<SyncBalancings> localVarResponse = GetModifiedBalancingRelationsWithHttpInfo(dossierId, dossierToken, modifiedTimeStamp);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get modified balancings  Accept dossier token and modifiedTimeStamp and return modified and deleted balancings
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>ApiResponse of SyncBalancings</returns>
        public ApiResponse< SyncBalancings > GetModifiedBalancingRelationsWithHttpInfo (int? dossierId, string dossierToken, string modifiedTimeStamp)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BalancingsApi->GetModifiedBalancingRelations");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BalancingsApi->GetModifiedBalancingRelations");
            // verify the required parameter 'modifiedTimeStamp' is set
            if (modifiedTimeStamp == null)
                throw new ApiException(400, "Missing required parameter 'modifiedTimeStamp' when calling BalancingsApi->GetModifiedBalancingRelations");

            var localVarPath = "/dossiers/{dossierId}/balancings/modified";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (modifiedTimeStamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modifiedTimeStamp", modifiedTimeStamp)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModifiedBalancingRelations", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SyncBalancings>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SyncBalancings) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SyncBalancings)));
        }

        /// <summary>
        /// Get modified balancings  Accept dossier token and modifiedTimeStamp and return modified and deleted balancings
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of SyncBalancings</returns>
        public async System.Threading.Tasks.Task<SyncBalancings> GetModifiedBalancingRelationsAsync (int? dossierId, string dossierToken, string modifiedTimeStamp)
        {
             ApiResponse<SyncBalancings> localVarResponse = await GetModifiedBalancingRelationsAsyncWithHttpInfo(dossierId, dossierToken, modifiedTimeStamp);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get modified balancings  Accept dossier token and modifiedTimeStamp and return modified and deleted balancings
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of ApiResponse (SyncBalancings)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SyncBalancings>> GetModifiedBalancingRelationsAsyncWithHttpInfo (int? dossierId, string dossierToken, string modifiedTimeStamp)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BalancingsApi->GetModifiedBalancingRelations");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BalancingsApi->GetModifiedBalancingRelations");
            // verify the required parameter 'modifiedTimeStamp' is set
            if (modifiedTimeStamp == null)
                throw new ApiException(400, "Missing required parameter 'modifiedTimeStamp' when calling BalancingsApi->GetModifiedBalancingRelations");

            var localVarPath = "/dossiers/{dossierId}/balancings/modified";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (modifiedTimeStamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modifiedTimeStamp", modifiedTimeStamp)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModifiedBalancingRelations", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SyncBalancings>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SyncBalancings) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SyncBalancings)));
        }

        /// <summary>
        /// Insert balancing Accept dossier token and balancing data, and insert balancing
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Balancing data object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        public void InsertBalancing (BalancingServiceData body, string dossierToken, int? dossierId)
        {
             InsertBalancingWithHttpInfo(body, dossierToken, dossierId);
        }

        /// <summary>
        /// Insert balancing Accept dossier token and balancing data, and insert balancing
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Balancing data object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> InsertBalancingWithHttpInfo (BalancingServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling BalancingsApi->InsertBalancing");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BalancingsApi->InsertBalancing");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BalancingsApi->InsertBalancing");

            var localVarPath = "/dossiers/{dossierId}/balancings";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertBalancing", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

        /// <summary>
        /// Insert balancing Accept dossier token and balancing data, and insert balancing
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Balancing data object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task InsertBalancingAsync (BalancingServiceData body, string dossierToken, int? dossierId)
        {
             await InsertBalancingAsyncWithHttpInfo(body, dossierToken, dossierId);

        }

        /// <summary>
        /// Insert balancing Accept dossier token and balancing data, and insert balancing
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Balancing data object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> InsertBalancingAsyncWithHttpInfo (BalancingServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling BalancingsApi->InsertBalancing");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BalancingsApi->InsertBalancing");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BalancingsApi->InsertBalancing");

            var localVarPath = "/dossiers/{dossierId}/balancings";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertBalancing", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

    }
}
