/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IBookingsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Add Attachement to booking
        /// </summary>
        /// <remarks>
        /// Accept dossiertoken, Dossier ID, Bookyear Key, Journal Key, Document sequence Nr. and attachement
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Attachement</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSequennceNr">Document Sequence Nr</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="bookyearId">Bookyear Id</param>
        /// <returns></returns>
        void AddAttachementToBooking (AttachementData body, string dossierToken, string journalKey, int? documentSequennceNr, int? dossierId, int? bookyearId);

        /// <summary>
        /// Add Attachement to booking
        /// </summary>
        /// <remarks>
        /// Accept dossiertoken, Dossier ID, Bookyear Key, Journal Key, Document sequence Nr. and attachement
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Attachement</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSequennceNr">Document Sequence Nr</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="bookyearId">Bookyear Id</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> AddAttachementToBookingWithHttpInfo (AttachementData body, string dossierToken, string journalKey, int? documentSequennceNr, int? dossierId, int? bookyearId);
        /// <summary>
        /// Get modified bookings
        /// </summary>
        /// <remarks>
        /// Accept dossier token, bookyear Id, Journal Type Id and modifiedTimeStamp and return modified and deleted bookings lists
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalTypeId">Journal Type ID (1 &#x3D; Buy, 2 &#x3D; Sell, 3 &#x3D; Financial, 4 &#x3D; Divers)</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>SyncBookings</returns>
        SyncBookings GetReportModifiedBooking (int? dossierId, string dossierToken, int? bookyearId, int? journalTypeId, string modifiedTimeStamp);

        /// <summary>
        /// Get modified bookings
        /// </summary>
        /// <remarks>
        /// Accept dossier token, bookyear Id, Journal Type Id and modifiedTimeStamp and return modified and deleted bookings lists
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalTypeId">Journal Type ID (1 &#x3D; Buy, 2 &#x3D; Sell, 3 &#x3D; Financial, 4 &#x3D; Divers)</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>ApiResponse of SyncBookings</returns>
        ApiResponse<SyncBookings> GetReportModifiedBookingWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, int? journalTypeId, string modifiedTimeStamp);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Add Attachement to booking
        /// </summary>
        /// <remarks>
        /// Accept dossiertoken, Dossier ID, Bookyear Key, Journal Key, Document sequence Nr. and attachement
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Attachement</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSequennceNr">Document Sequence Nr</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="bookyearId">Bookyear Id</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task AddAttachementToBookingAsync (AttachementData body, string dossierToken, string journalKey, int? documentSequennceNr, int? dossierId, int? bookyearId);

        /// <summary>
        /// Add Attachement to booking
        /// </summary>
        /// <remarks>
        /// Accept dossiertoken, Dossier ID, Bookyear Key, Journal Key, Document sequence Nr. and attachement
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Attachement</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSequennceNr">Document Sequence Nr</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="bookyearId">Bookyear Id</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> AddAttachementToBookingAsyncWithHttpInfo (AttachementData body, string dossierToken, string journalKey, int? documentSequennceNr, int? dossierId, int? bookyearId);
        /// <summary>
        /// Get modified bookings
        /// </summary>
        /// <remarks>
        /// Accept dossier token, bookyear Id, Journal Type Id and modifiedTimeStamp and return modified and deleted bookings lists
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalTypeId">Journal Type ID (1 &#x3D; Buy, 2 &#x3D; Sell, 3 &#x3D; Financial, 4 &#x3D; Divers)</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of SyncBookings</returns>
        System.Threading.Tasks.Task<SyncBookings> GetReportModifiedBookingAsync (int? dossierId, string dossierToken, int? bookyearId, int? journalTypeId, string modifiedTimeStamp);

        /// <summary>
        /// Get modified bookings
        /// </summary>
        /// <remarks>
        /// Accept dossier token, bookyear Id, Journal Type Id and modifiedTimeStamp and return modified and deleted bookings lists
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalTypeId">Journal Type ID (1 &#x3D; Buy, 2 &#x3D; Sell, 3 &#x3D; Financial, 4 &#x3D; Divers)</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of ApiResponse (SyncBookings)</returns>
        System.Threading.Tasks.Task<ApiResponse<SyncBookings>> GetReportModifiedBookingAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, int? journalTypeId, string modifiedTimeStamp);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class BookingsApi : IBookingsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="BookingsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public BookingsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BookingsApi"/> class
        /// </summary>
        /// <returns></returns>
        public BookingsApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BookingsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public BookingsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Add Attachement to booking Accept dossiertoken, Dossier ID, Bookyear Key, Journal Key, Document sequence Nr. and attachement
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Attachement</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSequennceNr">Document Sequence Nr</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="bookyearId">Bookyear Id</param>
        /// <returns></returns>
        public void AddAttachementToBooking (AttachementData body, string dossierToken, string journalKey, int? documentSequennceNr, int? dossierId, int? bookyearId)
        {
             AddAttachementToBookingWithHttpInfo(body, dossierToken, journalKey, documentSequennceNr, dossierId, bookyearId);
        }

        /// <summary>
        /// Add Attachement to booking Accept dossiertoken, Dossier ID, Bookyear Key, Journal Key, Document sequence Nr. and attachement
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Attachement</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSequennceNr">Document Sequence Nr</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="bookyearId">Bookyear Id</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> AddAttachementToBookingWithHttpInfo (AttachementData body, string dossierToken, string journalKey, int? documentSequennceNr, int? dossierId, int? bookyearId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling BookingsApi->AddAttachementToBooking");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BookingsApi->AddAttachementToBooking");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling BookingsApi->AddAttachementToBooking");
            // verify the required parameter 'documentSequennceNr' is set
            if (documentSequennceNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSequennceNr' when calling BookingsApi->AddAttachementToBooking");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BookingsApi->AddAttachementToBooking");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling BookingsApi->AddAttachementToBooking");

            var localVarPath = "/dossiers/{dossierId}/bookyears/{bookyearId}/bookings/attachements";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarPathParams.Add("bookyearId", this.Configuration.ApiClient.ParameterToString(bookyearId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (journalKey != null) localVarHeaderParams.Add("journalKey", this.Configuration.ApiClient.ParameterToString(journalKey)); // header parameter
            if (documentSequennceNr != null) localVarHeaderParams.Add("documentSequennceNr", this.Configuration.ApiClient.ParameterToString(documentSequennceNr)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AddAttachementToBooking", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

        /// <summary>
        /// Add Attachement to booking Accept dossiertoken, Dossier ID, Bookyear Key, Journal Key, Document sequence Nr. and attachement
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Attachement</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSequennceNr">Document Sequence Nr</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="bookyearId">Bookyear Id</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task AddAttachementToBookingAsync (AttachementData body, string dossierToken, string journalKey, int? documentSequennceNr, int? dossierId, int? bookyearId)
        {
             await AddAttachementToBookingAsyncWithHttpInfo(body, dossierToken, journalKey, documentSequennceNr, dossierId, bookyearId);

        }

        /// <summary>
        /// Add Attachement to booking Accept dossiertoken, Dossier ID, Bookyear Key, Journal Key, Document sequence Nr. and attachement
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Attachement</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSequennceNr">Document Sequence Nr</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="bookyearId">Bookyear Id</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> AddAttachementToBookingAsyncWithHttpInfo (AttachementData body, string dossierToken, string journalKey, int? documentSequennceNr, int? dossierId, int? bookyearId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling BookingsApi->AddAttachementToBooking");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BookingsApi->AddAttachementToBooking");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling BookingsApi->AddAttachementToBooking");
            // verify the required parameter 'documentSequennceNr' is set
            if (documentSequennceNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSequennceNr' when calling BookingsApi->AddAttachementToBooking");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BookingsApi->AddAttachementToBooking");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling BookingsApi->AddAttachementToBooking");

            var localVarPath = "/dossiers/{dossierId}/bookyears/{bookyearId}/bookings/attachements";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarPathParams.Add("bookyearId", this.Configuration.ApiClient.ParameterToString(bookyearId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (journalKey != null) localVarHeaderParams.Add("journalKey", this.Configuration.ApiClient.ParameterToString(journalKey)); // header parameter
            if (documentSequennceNr != null) localVarHeaderParams.Add("documentSequennceNr", this.Configuration.ApiClient.ParameterToString(documentSequennceNr)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AddAttachementToBooking", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

        /// <summary>
        /// Get modified bookings Accept dossier token, bookyear Id, Journal Type Id and modifiedTimeStamp and return modified and deleted bookings lists
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalTypeId">Journal Type ID (1 &#x3D; Buy, 2 &#x3D; Sell, 3 &#x3D; Financial, 4 &#x3D; Divers)</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>SyncBookings</returns>
        public SyncBookings GetReportModifiedBooking (int? dossierId, string dossierToken, int? bookyearId, int? journalTypeId, string modifiedTimeStamp)
        {
             ApiResponse<SyncBookings> localVarResponse = GetReportModifiedBookingWithHttpInfo(dossierId, dossierToken, bookyearId, journalTypeId, modifiedTimeStamp);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get modified bookings Accept dossier token, bookyear Id, Journal Type Id and modifiedTimeStamp and return modified and deleted bookings lists
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalTypeId">Journal Type ID (1 &#x3D; Buy, 2 &#x3D; Sell, 3 &#x3D; Financial, 4 &#x3D; Divers)</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>ApiResponse of SyncBookings</returns>
        public ApiResponse< SyncBookings > GetReportModifiedBookingWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, int? journalTypeId, string modifiedTimeStamp)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BookingsApi->GetReportModifiedBooking");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BookingsApi->GetReportModifiedBooking");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling BookingsApi->GetReportModifiedBooking");
            // verify the required parameter 'journalTypeId' is set
            if (journalTypeId == null)
                throw new ApiException(400, "Missing required parameter 'journalTypeId' when calling BookingsApi->GetReportModifiedBooking");
            // verify the required parameter 'modifiedTimeStamp' is set
            if (modifiedTimeStamp == null)
                throw new ApiException(400, "Missing required parameter 'modifiedTimeStamp' when calling BookingsApi->GetReportModifiedBooking");

            var localVarPath = "/dossiers/{dossierId}/bookyears/{bookyearId}/bookings/modified";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarPathParams.Add("bookyearId", this.Configuration.ApiClient.ParameterToString(bookyearId)); // path parameter
            if (journalTypeId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalTypeId", journalTypeId)); // query parameter
            if (modifiedTimeStamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modifiedTimeStamp", modifiedTimeStamp)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportModifiedBooking", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SyncBookings>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SyncBookings) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SyncBookings)));
        }

        /// <summary>
        /// Get modified bookings Accept dossier token, bookyear Id, Journal Type Id and modifiedTimeStamp and return modified and deleted bookings lists
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalTypeId">Journal Type ID (1 &#x3D; Buy, 2 &#x3D; Sell, 3 &#x3D; Financial, 4 &#x3D; Divers)</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of SyncBookings</returns>
        public async System.Threading.Tasks.Task<SyncBookings> GetReportModifiedBookingAsync (int? dossierId, string dossierToken, int? bookyearId, int? journalTypeId, string modifiedTimeStamp)
        {
             ApiResponse<SyncBookings> localVarResponse = await GetReportModifiedBookingAsyncWithHttpInfo(dossierId, dossierToken, bookyearId, journalTypeId, modifiedTimeStamp);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get modified bookings Accept dossier token, bookyear Id, Journal Type Id and modifiedTimeStamp and return modified and deleted bookings lists
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalTypeId">Journal Type ID (1 &#x3D; Buy, 2 &#x3D; Sell, 3 &#x3D; Financial, 4 &#x3D; Divers)</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of ApiResponse (SyncBookings)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SyncBookings>> GetReportModifiedBookingAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, int? journalTypeId, string modifiedTimeStamp)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BookingsApi->GetReportModifiedBooking");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BookingsApi->GetReportModifiedBooking");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling BookingsApi->GetReportModifiedBooking");
            // verify the required parameter 'journalTypeId' is set
            if (journalTypeId == null)
                throw new ApiException(400, "Missing required parameter 'journalTypeId' when calling BookingsApi->GetReportModifiedBooking");
            // verify the required parameter 'modifiedTimeStamp' is set
            if (modifiedTimeStamp == null)
                throw new ApiException(400, "Missing required parameter 'modifiedTimeStamp' when calling BookingsApi->GetReportModifiedBooking");

            var localVarPath = "/dossiers/{dossierId}/bookyears/{bookyearId}/bookings/modified";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarPathParams.Add("bookyearId", this.Configuration.ApiClient.ParameterToString(bookyearId)); // path parameter
            if (journalTypeId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalTypeId", journalTypeId)); // query parameter
            if (modifiedTimeStamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modifiedTimeStamp", modifiedTimeStamp)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportModifiedBooking", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SyncBookings>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SyncBookings) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SyncBookings)));
        }

    }
}
