/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IBuySellBookingsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get Buy Sell Booking
        /// </summary>
        /// <remarks>
        /// Accept Dossier ID, Dossier token, Bookyear Id, Journal ID, Document Nr and return Buy/Sell Booking
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>BuySellBookingServiceData</returns>
        BuySellBookingServiceData GetBuySellBooking (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr);

        /// <summary>
        /// Get Buy Sell Booking
        /// </summary>
        /// <remarks>
        /// Accept Dossier ID, Dossier token, Bookyear Id, Journal ID, Document Nr and return Buy/Sell Booking
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>ApiResponse of BuySellBookingServiceData</returns>
        ApiResponse<BuySellBookingServiceData> GetBuySellBookingWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr);
        /// <summary>
        /// Get modified Buy/Sell Bookings
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return modified Buy/Sell Bookings
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>List&lt;BuySellBookingServiceData&gt;</returns>
        List<BuySellBookingServiceData> GetModifiedBuySellBookings (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp);

        /// <summary>
        /// Get modified Buy/Sell Bookings
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return modified Buy/Sell Bookings
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>ApiResponse of List&lt;BuySellBookingServiceData&gt;</returns>
        ApiResponse<List<BuySellBookingServiceData>> GetModifiedBuySellBookingsWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp);
        /// <summary>
        /// Create Buy Sell Booking
        /// </summary>
        /// <remarks>
        /// Create Buy Sell Booking, with or without attachements
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object and attachment list</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        void InsertBuySellBooking (BuySellBookingAndAttachmentRequest body, string dossierToken, int? dossierId);

        /// <summary>
        /// Create Buy Sell Booking
        /// </summary>
        /// <remarks>
        /// Create Buy Sell Booking, with or without attachements
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object and attachment list</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> InsertBuySellBookingWithHttpInfo (BuySellBookingAndAttachmentRequest body, string dossierToken, int? dossierId);
        /// <summary>
        /// Update Booking
        /// </summary>
        /// <remarks>
        /// Modify Buy/Sell Booking
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        void UpdateBuySellBooking (BuySellBookingServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Update Booking
        /// </summary>
        /// <remarks>
        /// Modify Buy/Sell Booking
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> UpdateBuySellBookingWithHttpInfo (BuySellBookingServiceData body, string dossierToken, int? dossierId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Get Buy Sell Booking
        /// </summary>
        /// <remarks>
        /// Accept Dossier ID, Dossier token, Bookyear Id, Journal ID, Document Nr and return Buy/Sell Booking
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>Task of BuySellBookingServiceData</returns>
        System.Threading.Tasks.Task<BuySellBookingServiceData> GetBuySellBookingAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr);

        /// <summary>
        /// Get Buy Sell Booking
        /// </summary>
        /// <remarks>
        /// Accept Dossier ID, Dossier token, Bookyear Id, Journal ID, Document Nr and return Buy/Sell Booking
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>Task of ApiResponse (BuySellBookingServiceData)</returns>
        System.Threading.Tasks.Task<ApiResponse<BuySellBookingServiceData>> GetBuySellBookingAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr);
        /// <summary>
        /// Get modified Buy/Sell Bookings
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return modified Buy/Sell Bookings
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of List&lt;BuySellBookingServiceData&gt;</returns>
        System.Threading.Tasks.Task<List<BuySellBookingServiceData>> GetModifiedBuySellBookingsAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp);

        /// <summary>
        /// Get modified Buy/Sell Bookings
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return modified Buy/Sell Bookings
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of ApiResponse (List&lt;BuySellBookingServiceData&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<BuySellBookingServiceData>>> GetModifiedBuySellBookingsAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp);
        /// <summary>
        /// Create Buy Sell Booking
        /// </summary>
        /// <remarks>
        /// Create Buy Sell Booking, with or without attachements
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object and attachment list</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task InsertBuySellBookingAsync (BuySellBookingAndAttachmentRequest body, string dossierToken, int? dossierId);

        /// <summary>
        /// Create Buy Sell Booking
        /// </summary>
        /// <remarks>
        /// Create Buy Sell Booking, with or without attachements
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object and attachment list</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> InsertBuySellBookingAsyncWithHttpInfo (BuySellBookingAndAttachmentRequest body, string dossierToken, int? dossierId);
        /// <summary>
        /// Update Booking
        /// </summary>
        /// <remarks>
        /// Modify Buy/Sell Booking
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task UpdateBuySellBookingAsync (BuySellBookingServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Update Booking
        /// </summary>
        /// <remarks>
        /// Modify Buy/Sell Booking
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> UpdateBuySellBookingAsyncWithHttpInfo (BuySellBookingServiceData body, string dossierToken, int? dossierId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class BuySellBookingsApi : IBuySellBookingsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="BuySellBookingsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public BuySellBookingsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BuySellBookingsApi"/> class
        /// </summary>
        /// <returns></returns>
        public BuySellBookingsApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BuySellBookingsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public BuySellBookingsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Get Buy Sell Booking Accept Dossier ID, Dossier token, Bookyear Id, Journal ID, Document Nr and return Buy/Sell Booking
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>BuySellBookingServiceData</returns>
        public BuySellBookingServiceData GetBuySellBooking (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)
        {
             ApiResponse<BuySellBookingServiceData> localVarResponse = GetBuySellBookingWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get Buy Sell Booking Accept Dossier ID, Dossier token, Bookyear Id, Journal ID, Document Nr and return Buy/Sell Booking
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>ApiResponse of BuySellBookingServiceData</returns>
        public ApiResponse< BuySellBookingServiceData > GetBuySellBookingWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BuySellBookingsApi->GetBuySellBooking");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BuySellBookingsApi->GetBuySellBooking");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling BuySellBookingsApi->GetBuySellBooking");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling BuySellBookingsApi->GetBuySellBooking");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling BuySellBookingsApi->GetBuySellBooking");

            var localVarPath = "/dossiers/{dossierId}/buysellbookings";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetBuySellBooking", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BuySellBookingServiceData>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (BuySellBookingServiceData) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(BuySellBookingServiceData)));
        }

        /// <summary>
        /// Get Buy Sell Booking Accept Dossier ID, Dossier token, Bookyear Id, Journal ID, Document Nr and return Buy/Sell Booking
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>Task of BuySellBookingServiceData</returns>
        public async System.Threading.Tasks.Task<BuySellBookingServiceData> GetBuySellBookingAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)
        {
             ApiResponse<BuySellBookingServiceData> localVarResponse = await GetBuySellBookingAsyncWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get Buy Sell Booking Accept Dossier ID, Dossier token, Bookyear Id, Journal ID, Document Nr and return Buy/Sell Booking
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>Task of ApiResponse (BuySellBookingServiceData)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<BuySellBookingServiceData>> GetBuySellBookingAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BuySellBookingsApi->GetBuySellBooking");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BuySellBookingsApi->GetBuySellBooking");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling BuySellBookingsApi->GetBuySellBooking");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling BuySellBookingsApi->GetBuySellBooking");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling BuySellBookingsApi->GetBuySellBooking");

            var localVarPath = "/dossiers/{dossierId}/buysellbookings";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetBuySellBooking", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BuySellBookingServiceData>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (BuySellBookingServiceData) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(BuySellBookingServiceData)));
        }

        /// <summary>
        /// Get modified Buy/Sell Bookings Accept dossier token and return modified Buy/Sell Bookings
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>List&lt;BuySellBookingServiceData&gt;</returns>
        public List<BuySellBookingServiceData> GetModifiedBuySellBookings (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)
        {
             ApiResponse<List<BuySellBookingServiceData>> localVarResponse = GetModifiedBuySellBookingsWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, modifiedTimeStamp);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get modified Buy/Sell Bookings Accept dossier token and return modified Buy/Sell Bookings
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>ApiResponse of List&lt;BuySellBookingServiceData&gt;</returns>
        public ApiResponse< List<BuySellBookingServiceData> > GetModifiedBuySellBookingsWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BuySellBookingsApi->GetModifiedBuySellBookings");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BuySellBookingsApi->GetModifiedBuySellBookings");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling BuySellBookingsApi->GetModifiedBuySellBookings");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling BuySellBookingsApi->GetModifiedBuySellBookings");
            // verify the required parameter 'modifiedTimeStamp' is set
            if (modifiedTimeStamp == null)
                throw new ApiException(400, "Missing required parameter 'modifiedTimeStamp' when calling BuySellBookingsApi->GetModifiedBuySellBookings");

            var localVarPath = "/dossiers/{dossierId}/buysellbookings/modified";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (modifiedTimeStamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modifiedTimeStamp", modifiedTimeStamp)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModifiedBuySellBookings", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<BuySellBookingServiceData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<BuySellBookingServiceData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<BuySellBookingServiceData>)));
        }

        /// <summary>
        /// Get modified Buy/Sell Bookings Accept dossier token and return modified Buy/Sell Bookings
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of List&lt;BuySellBookingServiceData&gt;</returns>
        public async System.Threading.Tasks.Task<List<BuySellBookingServiceData>> GetModifiedBuySellBookingsAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)
        {
             ApiResponse<List<BuySellBookingServiceData>> localVarResponse = await GetModifiedBuySellBookingsAsyncWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, modifiedTimeStamp);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get modified Buy/Sell Bookings Accept dossier token and return modified Buy/Sell Bookings
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of ApiResponse (List&lt;BuySellBookingServiceData&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<BuySellBookingServiceData>>> GetModifiedBuySellBookingsAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BuySellBookingsApi->GetModifiedBuySellBookings");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BuySellBookingsApi->GetModifiedBuySellBookings");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling BuySellBookingsApi->GetModifiedBuySellBookings");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling BuySellBookingsApi->GetModifiedBuySellBookings");
            // verify the required parameter 'modifiedTimeStamp' is set
            if (modifiedTimeStamp == null)
                throw new ApiException(400, "Missing required parameter 'modifiedTimeStamp' when calling BuySellBookingsApi->GetModifiedBuySellBookings");

            var localVarPath = "/dossiers/{dossierId}/buysellbookings/modified";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (modifiedTimeStamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modifiedTimeStamp", modifiedTimeStamp)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModifiedBuySellBookings", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<BuySellBookingServiceData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<BuySellBookingServiceData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<BuySellBookingServiceData>)));
        }

        /// <summary>
        /// Create Buy Sell Booking Create Buy Sell Booking, with or without attachements
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object and attachment list</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        public void InsertBuySellBooking (BuySellBookingAndAttachmentRequest body, string dossierToken, int? dossierId)
        {
             InsertBuySellBookingWithHttpInfo(body, dossierToken, dossierId);
        }

        /// <summary>
        /// Create Buy Sell Booking Create Buy Sell Booking, with or without attachements
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object and attachment list</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> InsertBuySellBookingWithHttpInfo (BuySellBookingAndAttachmentRequest body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling BuySellBookingsApi->InsertBuySellBooking");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BuySellBookingsApi->InsertBuySellBooking");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BuySellBookingsApi->InsertBuySellBooking");

            var localVarPath = "/dossiers/{dossierId}/buysellbookings";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertBuySellBooking", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

        /// <summary>
        /// Create Buy Sell Booking Create Buy Sell Booking, with or without attachements
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object and attachment list</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task InsertBuySellBookingAsync (BuySellBookingAndAttachmentRequest body, string dossierToken, int? dossierId)
        {
             await InsertBuySellBookingAsyncWithHttpInfo(body, dossierToken, dossierId);

        }

        /// <summary>
        /// Create Buy Sell Booking Create Buy Sell Booking, with or without attachements
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object and attachment list</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> InsertBuySellBookingAsyncWithHttpInfo (BuySellBookingAndAttachmentRequest body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling BuySellBookingsApi->InsertBuySellBooking");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BuySellBookingsApi->InsertBuySellBooking");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BuySellBookingsApi->InsertBuySellBooking");

            var localVarPath = "/dossiers/{dossierId}/buysellbookings";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertBuySellBooking", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

        /// <summary>
        /// Update Booking Modify Buy/Sell Booking
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        public void UpdateBuySellBooking (BuySellBookingServiceData body, string dossierToken, int? dossierId)
        {
             UpdateBuySellBookingWithHttpInfo(body, dossierToken, dossierId);
        }

        /// <summary>
        /// Update Booking Modify Buy/Sell Booking
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> UpdateBuySellBookingWithHttpInfo (BuySellBookingServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling BuySellBookingsApi->UpdateBuySellBooking");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BuySellBookingsApi->UpdateBuySellBooking");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BuySellBookingsApi->UpdateBuySellBooking");

            var localVarPath = "/dossiers/{dossierId}/buysellbookings";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateBuySellBooking", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

        /// <summary>
        /// Update Booking Modify Buy/Sell Booking
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task UpdateBuySellBookingAsync (BuySellBookingServiceData body, string dossierToken, int? dossierId)
        {
             await UpdateBuySellBookingAsyncWithHttpInfo(body, dossierToken, dossierId);

        }

        /// <summary>
        /// Update Booking Modify Buy/Sell Booking
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Buy/Sell Booking object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> UpdateBuySellBookingAsyncWithHttpInfo (BuySellBookingServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling BuySellBookingsApi->UpdateBuySellBooking");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling BuySellBookingsApi->UpdateBuySellBooking");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling BuySellBookingsApi->UpdateBuySellBooking");

            var localVarPath = "/dossiers/{dossierId}/buysellbookings";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateBuySellBooking", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

    }
}
