/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IDeliveryNotesApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Export Delivery Note
        /// </summary>
        /// <remarks>
        /// Accept dossier token and export Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>ExportedDeliveryNoteResult</returns>
        ExportedDeliveryNoteResult ExportDeliveryNote (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnDeliveryNote, bool? returnPdfDocument);

        /// <summary>
        /// Export Delivery Note
        /// </summary>
        /// <remarks>
        /// Accept dossier token and export Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>ApiResponse of ExportedDeliveryNoteResult</returns>
        ApiResponse<ExportedDeliveryNoteResult> ExportDeliveryNoteWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnDeliveryNote, bool? returnPdfDocument);
        /// <summary>
        /// Generate Delivery Note
        /// </summary>
        /// <remarks>
        /// Generate Delivery Note in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Delivery Note method
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>ExportedDeliveryNoteResult</returns>
        ExportedDeliveryNoteResult GenerateDeliveryNote (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? publishPdfDocument, bool? returnDeliveryNote, bool? returnPdfDocument);

        /// <summary>
        /// Generate Delivery Note
        /// </summary>
        /// <remarks>
        /// Generate Delivery Note in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Delivery Note method
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>ApiResponse of ExportedDeliveryNoteResult</returns>
        ApiResponse<ExportedDeliveryNoteResult> GenerateDeliveryNoteWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? publishPdfDocument, bool? returnDeliveryNote, bool? returnPdfDocument);
        /// <summary>
        /// Get Delivery Note
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>DeliveryNoteServiceData</returns>
        DeliveryNoteServiceData GetDeliveryNote (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr);

        /// <summary>
        /// Get Delivery Note
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>ApiResponse of DeliveryNoteServiceData</returns>
        ApiResponse<DeliveryNoteServiceData> GetDeliveryNoteWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr);
        /// <summary>
        /// Get modified Delivery Notes
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return modified Delivery Notes
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>List&lt;DeliveryNoteServiceData&gt;</returns>
        List<DeliveryNoteServiceData> GetModifiedDeliveryNotes (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp);

        /// <summary>
        /// Get modified Delivery Notes
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return modified Delivery Notes
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>ApiResponse of List&lt;DeliveryNoteServiceData&gt;</returns>
        ApiResponse<List<DeliveryNoteServiceData>> GetModifiedDeliveryNotesWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp);
        /// <summary>
        /// Create Delivery Note
        /// </summary>
        /// <remarks>
        /// Create new Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        void InsertDeliveryNote (DeliveryNoteServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Create Delivery Note
        /// </summary>
        /// <remarks>
        /// Create new Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> InsertDeliveryNoteWithHttpInfo (DeliveryNoteServiceData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Update Delivery Note
        /// </summary>
        /// <remarks>
        /// Modify Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        void UpdateDeliveryNote (DeliveryNoteServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Update Delivery Note
        /// </summary>
        /// <remarks>
        /// Modify Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> UpdateDeliveryNoteWithHttpInfo (DeliveryNoteServiceData body, string dossierToken, int? dossierId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Export Delivery Note
        /// </summary>
        /// <remarks>
        /// Accept dossier token and export Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>Task of ExportedDeliveryNoteResult</returns>
        System.Threading.Tasks.Task<ExportedDeliveryNoteResult> ExportDeliveryNoteAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnDeliveryNote, bool? returnPdfDocument);

        /// <summary>
        /// Export Delivery Note
        /// </summary>
        /// <remarks>
        /// Accept dossier token and export Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>Task of ApiResponse (ExportedDeliveryNoteResult)</returns>
        System.Threading.Tasks.Task<ApiResponse<ExportedDeliveryNoteResult>> ExportDeliveryNoteAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnDeliveryNote, bool? returnPdfDocument);
        /// <summary>
        /// Generate Delivery Note
        /// </summary>
        /// <remarks>
        /// Generate Delivery Note in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Delivery Note method
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>Task of ExportedDeliveryNoteResult</returns>
        System.Threading.Tasks.Task<ExportedDeliveryNoteResult> GenerateDeliveryNoteAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? publishPdfDocument, bool? returnDeliveryNote, bool? returnPdfDocument);

        /// <summary>
        /// Generate Delivery Note
        /// </summary>
        /// <remarks>
        /// Generate Delivery Note in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Delivery Note method
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>Task of ApiResponse (ExportedDeliveryNoteResult)</returns>
        System.Threading.Tasks.Task<ApiResponse<ExportedDeliveryNoteResult>> GenerateDeliveryNoteAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? publishPdfDocument, bool? returnDeliveryNote, bool? returnPdfDocument);
        /// <summary>
        /// Get Delivery Note
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>Task of DeliveryNoteServiceData</returns>
        System.Threading.Tasks.Task<DeliveryNoteServiceData> GetDeliveryNoteAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr);

        /// <summary>
        /// Get Delivery Note
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>Task of ApiResponse (DeliveryNoteServiceData)</returns>
        System.Threading.Tasks.Task<ApiResponse<DeliveryNoteServiceData>> GetDeliveryNoteAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr);
        /// <summary>
        /// Get modified Delivery Notes
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return modified Delivery Notes
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of List&lt;DeliveryNoteServiceData&gt;</returns>
        System.Threading.Tasks.Task<List<DeliveryNoteServiceData>> GetModifiedDeliveryNotesAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp);

        /// <summary>
        /// Get modified Delivery Notes
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return modified Delivery Notes
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of ApiResponse (List&lt;DeliveryNoteServiceData&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<DeliveryNoteServiceData>>> GetModifiedDeliveryNotesAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp);
        /// <summary>
        /// Create Delivery Note
        /// </summary>
        /// <remarks>
        /// Create new Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task InsertDeliveryNoteAsync (DeliveryNoteServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Create Delivery Note
        /// </summary>
        /// <remarks>
        /// Create new Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> InsertDeliveryNoteAsyncWithHttpInfo (DeliveryNoteServiceData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Update Delivery Note
        /// </summary>
        /// <remarks>
        /// Modify Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task UpdateDeliveryNoteAsync (DeliveryNoteServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Update Delivery Note
        /// </summary>
        /// <remarks>
        /// Modify Delivery Note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> UpdateDeliveryNoteAsyncWithHttpInfo (DeliveryNoteServiceData body, string dossierToken, int? dossierId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class DeliveryNotesApi : IDeliveryNotesApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="DeliveryNotesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public DeliveryNotesApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DeliveryNotesApi"/> class
        /// </summary>
        /// <returns></returns>
        public DeliveryNotesApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DeliveryNotesApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public DeliveryNotesApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Export Delivery Note Accept dossier token and export Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>ExportedDeliveryNoteResult</returns>
        public ExportedDeliveryNoteResult ExportDeliveryNote (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnDeliveryNote, bool? returnPdfDocument)
        {
             ApiResponse<ExportedDeliveryNoteResult> localVarResponse = ExportDeliveryNoteWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr, returnDeliveryNote, returnPdfDocument);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Export Delivery Note Accept dossier token and export Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>ApiResponse of ExportedDeliveryNoteResult</returns>
        public ApiResponse< ExportedDeliveryNoteResult > ExportDeliveryNoteWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnDeliveryNote, bool? returnPdfDocument)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DeliveryNotesApi->ExportDeliveryNote");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling DeliveryNotesApi->ExportDeliveryNote");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling DeliveryNotesApi->ExportDeliveryNote");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling DeliveryNotesApi->ExportDeliveryNote");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling DeliveryNotesApi->ExportDeliveryNote");
            // verify the required parameter 'returnDeliveryNote' is set
            if (returnDeliveryNote == null)
                throw new ApiException(400, "Missing required parameter 'returnDeliveryNote' when calling DeliveryNotesApi->ExportDeliveryNote");
            // verify the required parameter 'returnPdfDocument' is set
            if (returnPdfDocument == null)
                throw new ApiException(400, "Missing required parameter 'returnPdfDocument' when calling DeliveryNotesApi->ExportDeliveryNote");

            var localVarPath = "/dossiers/{dossierId}/deliverynotes/export";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (returnDeliveryNote != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnDeliveryNote", returnDeliveryNote)); // query parameter
            if (returnPdfDocument != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnPdfDocument", returnPdfDocument)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ExportDeliveryNote", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ExportedDeliveryNoteResult>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ExportedDeliveryNoteResult) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ExportedDeliveryNoteResult)));
        }

        /// <summary>
        /// Export Delivery Note Accept dossier token and export Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>Task of ExportedDeliveryNoteResult</returns>
        public async System.Threading.Tasks.Task<ExportedDeliveryNoteResult> ExportDeliveryNoteAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnDeliveryNote, bool? returnPdfDocument)
        {
             ApiResponse<ExportedDeliveryNoteResult> localVarResponse = await ExportDeliveryNoteAsyncWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr, returnDeliveryNote, returnPdfDocument);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Export Delivery Note Accept dossier token and export Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>Task of ApiResponse (ExportedDeliveryNoteResult)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ExportedDeliveryNoteResult>> ExportDeliveryNoteAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnDeliveryNote, bool? returnPdfDocument)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DeliveryNotesApi->ExportDeliveryNote");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling DeliveryNotesApi->ExportDeliveryNote");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling DeliveryNotesApi->ExportDeliveryNote");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling DeliveryNotesApi->ExportDeliveryNote");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling DeliveryNotesApi->ExportDeliveryNote");
            // verify the required parameter 'returnDeliveryNote' is set
            if (returnDeliveryNote == null)
                throw new ApiException(400, "Missing required parameter 'returnDeliveryNote' when calling DeliveryNotesApi->ExportDeliveryNote");
            // verify the required parameter 'returnPdfDocument' is set
            if (returnPdfDocument == null)
                throw new ApiException(400, "Missing required parameter 'returnPdfDocument' when calling DeliveryNotesApi->ExportDeliveryNote");

            var localVarPath = "/dossiers/{dossierId}/deliverynotes/export";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (returnDeliveryNote != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnDeliveryNote", returnDeliveryNote)); // query parameter
            if (returnPdfDocument != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnPdfDocument", returnPdfDocument)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ExportDeliveryNote", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ExportedDeliveryNoteResult>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ExportedDeliveryNoteResult) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ExportedDeliveryNoteResult)));
        }

        /// <summary>
        /// Generate Delivery Note Generate Delivery Note in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Delivery Note method
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>ExportedDeliveryNoteResult</returns>
        public ExportedDeliveryNoteResult GenerateDeliveryNote (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? publishPdfDocument, bool? returnDeliveryNote, bool? returnPdfDocument)
        {
             ApiResponse<ExportedDeliveryNoteResult> localVarResponse = GenerateDeliveryNoteWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr, publishPdfDocument, returnDeliveryNote, returnPdfDocument);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Generate Delivery Note Generate Delivery Note in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Delivery Note method
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>ApiResponse of ExportedDeliveryNoteResult</returns>
        public ApiResponse< ExportedDeliveryNoteResult > GenerateDeliveryNoteWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? publishPdfDocument, bool? returnDeliveryNote, bool? returnPdfDocument)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'publishPdfDocument' is set
            if (publishPdfDocument == null)
                throw new ApiException(400, "Missing required parameter 'publishPdfDocument' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'returnDeliveryNote' is set
            if (returnDeliveryNote == null)
                throw new ApiException(400, "Missing required parameter 'returnDeliveryNote' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'returnPdfDocument' is set
            if (returnPdfDocument == null)
                throw new ApiException(400, "Missing required parameter 'returnPdfDocument' when calling DeliveryNotesApi->GenerateDeliveryNote");

            var localVarPath = "/dossiers/{dossierId}/deliverynotes/generate";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (publishPdfDocument != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "publishPdfDocument", publishPdfDocument)); // query parameter
            if (returnDeliveryNote != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnDeliveryNote", returnDeliveryNote)); // query parameter
            if (returnPdfDocument != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnPdfDocument", returnPdfDocument)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GenerateDeliveryNote", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ExportedDeliveryNoteResult>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ExportedDeliveryNoteResult) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ExportedDeliveryNoteResult)));
        }

        /// <summary>
        /// Generate Delivery Note Generate Delivery Note in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Delivery Note method
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>Task of ExportedDeliveryNoteResult</returns>
        public async System.Threading.Tasks.Task<ExportedDeliveryNoteResult> GenerateDeliveryNoteAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? publishPdfDocument, bool? returnDeliveryNote, bool? returnPdfDocument)
        {
             ApiResponse<ExportedDeliveryNoteResult> localVarResponse = await GenerateDeliveryNoteAsyncWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr, publishPdfDocument, returnDeliveryNote, returnPdfDocument);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Generate Delivery Note Generate Delivery Note in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Delivery Note method
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="returnDeliveryNote">return Delivery Note</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <returns>Task of ApiResponse (ExportedDeliveryNoteResult)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ExportedDeliveryNoteResult>> GenerateDeliveryNoteAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? publishPdfDocument, bool? returnDeliveryNote, bool? returnPdfDocument)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'publishPdfDocument' is set
            if (publishPdfDocument == null)
                throw new ApiException(400, "Missing required parameter 'publishPdfDocument' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'returnDeliveryNote' is set
            if (returnDeliveryNote == null)
                throw new ApiException(400, "Missing required parameter 'returnDeliveryNote' when calling DeliveryNotesApi->GenerateDeliveryNote");
            // verify the required parameter 'returnPdfDocument' is set
            if (returnPdfDocument == null)
                throw new ApiException(400, "Missing required parameter 'returnPdfDocument' when calling DeliveryNotesApi->GenerateDeliveryNote");

            var localVarPath = "/dossiers/{dossierId}/deliverynotes/generate";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (publishPdfDocument != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "publishPdfDocument", publishPdfDocument)); // query parameter
            if (returnDeliveryNote != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnDeliveryNote", returnDeliveryNote)); // query parameter
            if (returnPdfDocument != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnPdfDocument", returnPdfDocument)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GenerateDeliveryNote", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ExportedDeliveryNoteResult>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ExportedDeliveryNoteResult) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ExportedDeliveryNoteResult)));
        }

        /// <summary>
        /// Get Delivery Note Accept dossier token and return Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>DeliveryNoteServiceData</returns>
        public DeliveryNoteServiceData GetDeliveryNote (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)
        {
             ApiResponse<DeliveryNoteServiceData> localVarResponse = GetDeliveryNoteWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get Delivery Note Accept dossier token and return Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>ApiResponse of DeliveryNoteServiceData</returns>
        public ApiResponse< DeliveryNoteServiceData > GetDeliveryNoteWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DeliveryNotesApi->GetDeliveryNote");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling DeliveryNotesApi->GetDeliveryNote");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling DeliveryNotesApi->GetDeliveryNote");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling DeliveryNotesApi->GetDeliveryNote");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling DeliveryNotesApi->GetDeliveryNote");

            var localVarPath = "/dossiers/{dossierId}/deliverynotes";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDeliveryNote", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DeliveryNoteServiceData>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (DeliveryNoteServiceData) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DeliveryNoteServiceData)));
        }

        /// <summary>
        /// Get Delivery Note Accept dossier token and return Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>Task of DeliveryNoteServiceData</returns>
        public async System.Threading.Tasks.Task<DeliveryNoteServiceData> GetDeliveryNoteAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)
        {
             ApiResponse<DeliveryNoteServiceData> localVarResponse = await GetDeliveryNoteAsyncWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get Delivery Note Accept dossier token and return Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>Task of ApiResponse (DeliveryNoteServiceData)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DeliveryNoteServiceData>> GetDeliveryNoteAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DeliveryNotesApi->GetDeliveryNote");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling DeliveryNotesApi->GetDeliveryNote");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling DeliveryNotesApi->GetDeliveryNote");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling DeliveryNotesApi->GetDeliveryNote");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling DeliveryNotesApi->GetDeliveryNote");

            var localVarPath = "/dossiers/{dossierId}/deliverynotes";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDeliveryNote", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DeliveryNoteServiceData>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (DeliveryNoteServiceData) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DeliveryNoteServiceData)));
        }

        /// <summary>
        /// Get modified Delivery Notes Accept dossier token and return modified Delivery Notes
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>List&lt;DeliveryNoteServiceData&gt;</returns>
        public List<DeliveryNoteServiceData> GetModifiedDeliveryNotes (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)
        {
             ApiResponse<List<DeliveryNoteServiceData>> localVarResponse = GetModifiedDeliveryNotesWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, modifiedTimeStamp);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get modified Delivery Notes Accept dossier token and return modified Delivery Notes
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>ApiResponse of List&lt;DeliveryNoteServiceData&gt;</returns>
        public ApiResponse< List<DeliveryNoteServiceData> > GetModifiedDeliveryNotesWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DeliveryNotesApi->GetModifiedDeliveryNotes");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling DeliveryNotesApi->GetModifiedDeliveryNotes");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling DeliveryNotesApi->GetModifiedDeliveryNotes");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling DeliveryNotesApi->GetModifiedDeliveryNotes");
            // verify the required parameter 'modifiedTimeStamp' is set
            if (modifiedTimeStamp == null)
                throw new ApiException(400, "Missing required parameter 'modifiedTimeStamp' when calling DeliveryNotesApi->GetModifiedDeliveryNotes");

            var localVarPath = "/dossiers/{dossierId}/deliverynotes/modified";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (modifiedTimeStamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modifiedTimeStamp", modifiedTimeStamp)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModifiedDeliveryNotes", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<DeliveryNoteServiceData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<DeliveryNoteServiceData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<DeliveryNoteServiceData>)));
        }

        /// <summary>
        /// Get modified Delivery Notes Accept dossier token and return modified Delivery Notes
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of List&lt;DeliveryNoteServiceData&gt;</returns>
        public async System.Threading.Tasks.Task<List<DeliveryNoteServiceData>> GetModifiedDeliveryNotesAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)
        {
             ApiResponse<List<DeliveryNoteServiceData>> localVarResponse = await GetModifiedDeliveryNotesAsyncWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, modifiedTimeStamp);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get modified Delivery Notes Accept dossier token and return modified Delivery Notes
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of ApiResponse (List&lt;DeliveryNoteServiceData&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<DeliveryNoteServiceData>>> GetModifiedDeliveryNotesAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DeliveryNotesApi->GetModifiedDeliveryNotes");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling DeliveryNotesApi->GetModifiedDeliveryNotes");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling DeliveryNotesApi->GetModifiedDeliveryNotes");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling DeliveryNotesApi->GetModifiedDeliveryNotes");
            // verify the required parameter 'modifiedTimeStamp' is set
            if (modifiedTimeStamp == null)
                throw new ApiException(400, "Missing required parameter 'modifiedTimeStamp' when calling DeliveryNotesApi->GetModifiedDeliveryNotes");

            var localVarPath = "/dossiers/{dossierId}/deliverynotes/modified";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (modifiedTimeStamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modifiedTimeStamp", modifiedTimeStamp)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModifiedDeliveryNotes", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<DeliveryNoteServiceData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<DeliveryNoteServiceData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<DeliveryNoteServiceData>)));
        }

        /// <summary>
        /// Create Delivery Note Create new Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        public void InsertDeliveryNote (DeliveryNoteServiceData body, string dossierToken, int? dossierId)
        {
             InsertDeliveryNoteWithHttpInfo(body, dossierToken, dossierId);
        }

        /// <summary>
        /// Create Delivery Note Create new Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> InsertDeliveryNoteWithHttpInfo (DeliveryNoteServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling DeliveryNotesApi->InsertDeliveryNote");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling DeliveryNotesApi->InsertDeliveryNote");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DeliveryNotesApi->InsertDeliveryNote");

            var localVarPath = "/dossiers/{dossierId}/deliverynotes";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertDeliveryNote", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

        /// <summary>
        /// Create Delivery Note Create new Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task InsertDeliveryNoteAsync (DeliveryNoteServiceData body, string dossierToken, int? dossierId)
        {
             await InsertDeliveryNoteAsyncWithHttpInfo(body, dossierToken, dossierId);

        }

        /// <summary>
        /// Create Delivery Note Create new Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> InsertDeliveryNoteAsyncWithHttpInfo (DeliveryNoteServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling DeliveryNotesApi->InsertDeliveryNote");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling DeliveryNotesApi->InsertDeliveryNote");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DeliveryNotesApi->InsertDeliveryNote");

            var localVarPath = "/dossiers/{dossierId}/deliverynotes";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertDeliveryNote", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

        /// <summary>
        /// Update Delivery Note Modify Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        public void UpdateDeliveryNote (DeliveryNoteServiceData body, string dossierToken, int? dossierId)
        {
             UpdateDeliveryNoteWithHttpInfo(body, dossierToken, dossierId);
        }

        /// <summary>
        /// Update Delivery Note Modify Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> UpdateDeliveryNoteWithHttpInfo (DeliveryNoteServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling DeliveryNotesApi->UpdateDeliveryNote");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling DeliveryNotesApi->UpdateDeliveryNote");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DeliveryNotesApi->UpdateDeliveryNote");

            var localVarPath = "/dossiers/{dossierId}/deliverynotes";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateDeliveryNote", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

        /// <summary>
        /// Update Delivery Note Modify Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task UpdateDeliveryNoteAsync (DeliveryNoteServiceData body, string dossierToken, int? dossierId)
        {
             await UpdateDeliveryNoteAsyncWithHttpInfo(body, dossierToken, dossierId);

        }

        /// <summary>
        /// Update Delivery Note Modify Delivery Note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">DeliveryNote object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> UpdateDeliveryNoteAsyncWithHttpInfo (DeliveryNoteServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling DeliveryNotesApi->UpdateDeliveryNote");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling DeliveryNotesApi->UpdateDeliveryNote");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DeliveryNotesApi->UpdateDeliveryNote");

            var localVarPath = "/dossiers/{dossierId}/deliverynotes";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateDeliveryNote", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

    }
}
