/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IDossiersApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get Dossiertoken
        /// </summary>
        /// <remarks>
        /// Accept authentication token and return Dossiertoken
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID of the dossier you want to connect with</param>
        /// <param name="token">Authentication token</param>
        /// <param name="localeId">Locale to be included in the DossierToken.Possible values are:&lt;ul&gt;&lt;li&gt;0: keep default locale of the dossier&lt;/li&gt;&lt;li&gt;1: Nederlands (Dutch)&lt;/li&gt;&lt;li&gt;2: Frans (French)&lt;/li&gt;&lt;li&gt;3: Engels (English)&lt;/li&gt;&lt;li&gt;4: Duits (German)&lt;/li&gt;&lt;/ul&gt; (optional)</param>
        /// <returns>DossierTokenResult</returns>
        DossierTokenResult ConnectDossier (int? dossierId, string token, int? localeId = null);

        /// <summary>
        /// Get Dossiertoken
        /// </summary>
        /// <remarks>
        /// Accept authentication token and return Dossiertoken
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID of the dossier you want to connect with</param>
        /// <param name="token">Authentication token</param>
        /// <param name="localeId">Locale to be included in the DossierToken.Possible values are:&lt;ul&gt;&lt;li&gt;0: keep default locale of the dossier&lt;/li&gt;&lt;li&gt;1: Nederlands (Dutch)&lt;/li&gt;&lt;li&gt;2: Frans (French)&lt;/li&gt;&lt;li&gt;3: Engels (English)&lt;/li&gt;&lt;li&gt;4: Duits (German)&lt;/li&gt;&lt;/ul&gt; (optional)</param>
        /// <returns>ApiResponse of DossierTokenResult</returns>
        ApiResponse<DossierTokenResult> ConnectDossierWithHttpInfo (int? dossierId, string token, int? localeId = null);
        /// <summary>
        /// Get Dossiers
        /// </summary>
        /// <remarks>
        /// Accept authentication token and return Dossiers list
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token"> Authentication Token</param>
        /// <returns>List&lt;DossierServiceData&gt;</returns>
        List<DossierServiceData> GetDossiers (string token);

        /// <summary>
        /// Get Dossiers
        /// </summary>
        /// <remarks>
        /// Accept authentication token and return Dossiers list
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token"> Authentication Token</param>
        /// <returns>ApiResponse of List&lt;DossierServiceData&gt;</returns>
        ApiResponse<List<DossierServiceData>> GetDossiersWithHttpInfo (string token);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Get Dossiertoken
        /// </summary>
        /// <remarks>
        /// Accept authentication token and return Dossiertoken
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID of the dossier you want to connect with</param>
        /// <param name="token">Authentication token</param>
        /// <param name="localeId">Locale to be included in the DossierToken.Possible values are:&lt;ul&gt;&lt;li&gt;0: keep default locale of the dossier&lt;/li&gt;&lt;li&gt;1: Nederlands (Dutch)&lt;/li&gt;&lt;li&gt;2: Frans (French)&lt;/li&gt;&lt;li&gt;3: Engels (English)&lt;/li&gt;&lt;li&gt;4: Duits (German)&lt;/li&gt;&lt;/ul&gt; (optional)</param>
        /// <returns>Task of DossierTokenResult</returns>
        System.Threading.Tasks.Task<DossierTokenResult> ConnectDossierAsync (int? dossierId, string token, int? localeId = null);

        /// <summary>
        /// Get Dossiertoken
        /// </summary>
        /// <remarks>
        /// Accept authentication token and return Dossiertoken
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID of the dossier you want to connect with</param>
        /// <param name="token">Authentication token</param>
        /// <param name="localeId">Locale to be included in the DossierToken.Possible values are:&lt;ul&gt;&lt;li&gt;0: keep default locale of the dossier&lt;/li&gt;&lt;li&gt;1: Nederlands (Dutch)&lt;/li&gt;&lt;li&gt;2: Frans (French)&lt;/li&gt;&lt;li&gt;3: Engels (English)&lt;/li&gt;&lt;li&gt;4: Duits (German)&lt;/li&gt;&lt;/ul&gt; (optional)</param>
        /// <returns>Task of ApiResponse (DossierTokenResult)</returns>
        System.Threading.Tasks.Task<ApiResponse<DossierTokenResult>> ConnectDossierAsyncWithHttpInfo (int? dossierId, string token, int? localeId = null);
        /// <summary>
        /// Get Dossiers
        /// </summary>
        /// <remarks>
        /// Accept authentication token and return Dossiers list
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token"> Authentication Token</param>
        /// <returns>Task of List&lt;DossierServiceData&gt;</returns>
        System.Threading.Tasks.Task<List<DossierServiceData>> GetDossiersAsync (string token);

        /// <summary>
        /// Get Dossiers
        /// </summary>
        /// <remarks>
        /// Accept authentication token and return Dossiers list
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token"> Authentication Token</param>
        /// <returns>Task of ApiResponse (List&lt;DossierServiceData&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<DossierServiceData>>> GetDossiersAsyncWithHttpInfo (string token);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class DossiersApi : IDossiersApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="DossiersApi"/> class.
        /// </summary>
        /// <returns></returns>
        public DossiersApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DossiersApi"/> class
        /// </summary>
        /// <returns></returns>
        public DossiersApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DossiersApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public DossiersApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Get Dossiertoken Accept authentication token and return Dossiertoken
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID of the dossier you want to connect with</param>
        /// <param name="token">Authentication token</param>
        /// <param name="localeId">Locale to be included in the DossierToken.Possible values are:&lt;ul&gt;&lt;li&gt;0: keep default locale of the dossier&lt;/li&gt;&lt;li&gt;1: Nederlands (Dutch)&lt;/li&gt;&lt;li&gt;2: Frans (French)&lt;/li&gt;&lt;li&gt;3: Engels (English)&lt;/li&gt;&lt;li&gt;4: Duits (German)&lt;/li&gt;&lt;/ul&gt; (optional)</param>
        /// <returns>DossierTokenResult</returns>
        public DossierTokenResult ConnectDossier (int? dossierId, string token, int? localeId = null)
        {
             ApiResponse<DossierTokenResult> localVarResponse = ConnectDossierWithHttpInfo(dossierId, token, localeId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get Dossiertoken Accept authentication token and return Dossiertoken
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID of the dossier you want to connect with</param>
        /// <param name="token">Authentication token</param>
        /// <param name="localeId">Locale to be included in the DossierToken.Possible values are:&lt;ul&gt;&lt;li&gt;0: keep default locale of the dossier&lt;/li&gt;&lt;li&gt;1: Nederlands (Dutch)&lt;/li&gt;&lt;li&gt;2: Frans (French)&lt;/li&gt;&lt;li&gt;3: Engels (English)&lt;/li&gt;&lt;li&gt;4: Duits (German)&lt;/li&gt;&lt;/ul&gt; (optional)</param>
        /// <returns>ApiResponse of DossierTokenResult</returns>
        public ApiResponse< DossierTokenResult > ConnectDossierWithHttpInfo (int? dossierId, string token, int? localeId = null)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DossiersApi->ConnectDossier");
            // verify the required parameter 'token' is set
            if (token == null)
                throw new ApiException(400, "Missing required parameter 'token' when calling DossiersApi->ConnectDossier");

            var localVarPath = "/dossiers";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "dossierId", dossierId)); // query parameter
            if (localeId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "localeId", localeId)); // query parameter
            if (token != null) localVarHeaderParams.Add("Token", this.Configuration.ApiClient.ParameterToString(token)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ConnectDossier", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DossierTokenResult>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (DossierTokenResult) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DossierTokenResult)));
        }

        /// <summary>
        /// Get Dossiertoken Accept authentication token and return Dossiertoken
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID of the dossier you want to connect with</param>
        /// <param name="token">Authentication token</param>
        /// <param name="localeId">Locale to be included in the DossierToken.Possible values are:&lt;ul&gt;&lt;li&gt;0: keep default locale of the dossier&lt;/li&gt;&lt;li&gt;1: Nederlands (Dutch)&lt;/li&gt;&lt;li&gt;2: Frans (French)&lt;/li&gt;&lt;li&gt;3: Engels (English)&lt;/li&gt;&lt;li&gt;4: Duits (German)&lt;/li&gt;&lt;/ul&gt; (optional)</param>
        /// <returns>Task of DossierTokenResult</returns>
        public async System.Threading.Tasks.Task<DossierTokenResult> ConnectDossierAsync (int? dossierId, string token, int? localeId = null)
        {
             ApiResponse<DossierTokenResult> localVarResponse = await ConnectDossierAsyncWithHttpInfo(dossierId, token, localeId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get Dossiertoken Accept authentication token and return Dossiertoken
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID of the dossier you want to connect with</param>
        /// <param name="token">Authentication token</param>
        /// <param name="localeId">Locale to be included in the DossierToken.Possible values are:&lt;ul&gt;&lt;li&gt;0: keep default locale of the dossier&lt;/li&gt;&lt;li&gt;1: Nederlands (Dutch)&lt;/li&gt;&lt;li&gt;2: Frans (French)&lt;/li&gt;&lt;li&gt;3: Engels (English)&lt;/li&gt;&lt;li&gt;4: Duits (German)&lt;/li&gt;&lt;/ul&gt; (optional)</param>
        /// <returns>Task of ApiResponse (DossierTokenResult)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DossierTokenResult>> ConnectDossierAsyncWithHttpInfo (int? dossierId, string token, int? localeId = null)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling DossiersApi->ConnectDossier");
            // verify the required parameter 'token' is set
            if (token == null)
                throw new ApiException(400, "Missing required parameter 'token' when calling DossiersApi->ConnectDossier");

            var localVarPath = "/dossiers";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "dossierId", dossierId)); // query parameter
            if (localeId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "localeId", localeId)); // query parameter
            if (token != null) localVarHeaderParams.Add("Token", this.Configuration.ApiClient.ParameterToString(token)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ConnectDossier", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DossierTokenResult>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (DossierTokenResult) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DossierTokenResult)));
        }

        /// <summary>
        /// Get Dossiers Accept authentication token and return Dossiers list
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token"> Authentication Token</param>
        /// <returns>List&lt;DossierServiceData&gt;</returns>
        public List<DossierServiceData> GetDossiers (string token)
        {
             ApiResponse<List<DossierServiceData>> localVarResponse = GetDossiersWithHttpInfo(token);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get Dossiers Accept authentication token and return Dossiers list
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token"> Authentication Token</param>
        /// <returns>ApiResponse of List&lt;DossierServiceData&gt;</returns>
        public ApiResponse< List<DossierServiceData> > GetDossiersWithHttpInfo (string token)
        {
            // verify the required parameter 'token' is set
            if (token == null)
                throw new ApiException(400, "Missing required parameter 'token' when calling DossiersApi->GetDossiers");

            var localVarPath = "/dossiers";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (token != null) localVarHeaderParams.Add("Token", this.Configuration.ApiClient.ParameterToString(token)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDossiers", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<DossierServiceData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<DossierServiceData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<DossierServiceData>)));
        }

        /// <summary>
        /// Get Dossiers Accept authentication token and return Dossiers list
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token"> Authentication Token</param>
        /// <returns>Task of List&lt;DossierServiceData&gt;</returns>
        public async System.Threading.Tasks.Task<List<DossierServiceData>> GetDossiersAsync (string token)
        {
             ApiResponse<List<DossierServiceData>> localVarResponse = await GetDossiersAsyncWithHttpInfo(token);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get Dossiers Accept authentication token and return Dossiers list
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token"> Authentication Token</param>
        /// <returns>Task of ApiResponse (List&lt;DossierServiceData&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<DossierServiceData>>> GetDossiersAsyncWithHttpInfo (string token)
        {
            // verify the required parameter 'token' is set
            if (token == null)
                throw new ApiException(400, "Missing required parameter 'token' when calling DossiersApi->GetDossiers");

            var localVarPath = "/dossiers";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (token != null) localVarHeaderParams.Add("Token", this.Configuration.ApiClient.ParameterToString(token)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDossiers", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<DossierServiceData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<DossierServiceData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<DossierServiceData>)));
        }

    }
}
