/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IInvoicesApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Export Invoice
        /// </summary>
        /// <remarks>
        /// Accept dossier token and export Invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>ExportedInvoiceResult</returns>
        ExportedInvoiceResult ExportInvoice (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml);

        /// <summary>
        /// Export Invoice
        /// </summary>
        /// <remarks>
        /// Accept dossier token and export Invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>ApiResponse of ExportedInvoiceResult</returns>
        ApiResponse<ExportedInvoiceResult> ExportInvoiceWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml);
        /// <summary>
        /// Generate Invoice 
        /// </summary>
        /// <remarks>
        /// Generate Invoice in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Invoice method
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="publishEInvoice">publish eInvoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>ExportedInvoiceResult</returns>
        ExportedInvoiceResult GenerateInvoice (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? publishPdfDocument, bool? publishEInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml);

        /// <summary>
        /// Generate Invoice 
        /// </summary>
        /// <remarks>
        /// Generate Invoice in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Invoice method
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="publishEInvoice">publish eInvoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>ApiResponse of ExportedInvoiceResult</returns>
        ApiResponse<ExportedInvoiceResult> GenerateInvoiceWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? publishPdfDocument, bool? publishEInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml);
        /// <summary>
        /// Get Invoice
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>InvoiceServiceData</returns>
        InvoiceServiceData GetInvoice (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr);

        /// <summary>
        /// Get Invoice
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>ApiResponse of InvoiceServiceData</returns>
        ApiResponse<InvoiceServiceData> GetInvoiceWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr);
        /// <summary>
        /// Get modified invoices
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return modified invoices
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>List&lt;InvoiceServiceData&gt;</returns>
        List<InvoiceServiceData> GetModifiedInvoices (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp);

        /// <summary>
        /// Get modified invoices
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return modified invoices
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>ApiResponse of List&lt;InvoiceServiceData&gt;</returns>
        ApiResponse<List<InvoiceServiceData>> GetModifiedInvoicesWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp);
        /// <summary>
        /// Create invoice
        /// </summary>
        /// <remarks>
        /// Create new invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        void InsertInvoice (InvoiceServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Create invoice
        /// </summary>
        /// <remarks>
        /// Create new invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> InsertInvoiceWithHttpInfo (InvoiceServiceData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Update invoice
        /// </summary>
        /// <remarks>
        /// Modify invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        void UpdateInvoice (InvoiceServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Update invoice
        /// </summary>
        /// <remarks>
        /// Modify invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> UpdateInvoiceWithHttpInfo (InvoiceServiceData body, string dossierToken, int? dossierId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Export Invoice
        /// </summary>
        /// <remarks>
        /// Accept dossier token and export Invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>Task of ExportedInvoiceResult</returns>
        System.Threading.Tasks.Task<ExportedInvoiceResult> ExportInvoiceAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml);

        /// <summary>
        /// Export Invoice
        /// </summary>
        /// <remarks>
        /// Accept dossier token and export Invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>Task of ApiResponse (ExportedInvoiceResult)</returns>
        System.Threading.Tasks.Task<ApiResponse<ExportedInvoiceResult>> ExportInvoiceAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml);
        /// <summary>
        /// Generate Invoice 
        /// </summary>
        /// <remarks>
        /// Generate Invoice in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Invoice method
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="publishEInvoice">publish eInvoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>Task of ExportedInvoiceResult</returns>
        System.Threading.Tasks.Task<ExportedInvoiceResult> GenerateInvoiceAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? publishPdfDocument, bool? publishEInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml);

        /// <summary>
        /// Generate Invoice 
        /// </summary>
        /// <remarks>
        /// Generate Invoice in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Invoice method
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="publishEInvoice">publish eInvoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>Task of ApiResponse (ExportedInvoiceResult)</returns>
        System.Threading.Tasks.Task<ApiResponse<ExportedInvoiceResult>> GenerateInvoiceAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? publishPdfDocument, bool? publishEInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml);
        /// <summary>
        /// Get Invoice
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>Task of InvoiceServiceData</returns>
        System.Threading.Tasks.Task<InvoiceServiceData> GetInvoiceAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr);

        /// <summary>
        /// Get Invoice
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>Task of ApiResponse (InvoiceServiceData)</returns>
        System.Threading.Tasks.Task<ApiResponse<InvoiceServiceData>> GetInvoiceAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr);
        /// <summary>
        /// Get modified invoices
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return modified invoices
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of List&lt;InvoiceServiceData&gt;</returns>
        System.Threading.Tasks.Task<List<InvoiceServiceData>> GetModifiedInvoicesAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp);

        /// <summary>
        /// Get modified invoices
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return modified invoices
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of ApiResponse (List&lt;InvoiceServiceData&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<InvoiceServiceData>>> GetModifiedInvoicesAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp);
        /// <summary>
        /// Create invoice
        /// </summary>
        /// <remarks>
        /// Create new invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task InsertInvoiceAsync (InvoiceServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Create invoice
        /// </summary>
        /// <remarks>
        /// Create new invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> InsertInvoiceAsyncWithHttpInfo (InvoiceServiceData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Update invoice
        /// </summary>
        /// <remarks>
        /// Modify invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task UpdateInvoiceAsync (InvoiceServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Update invoice
        /// </summary>
        /// <remarks>
        /// Modify invoice
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> UpdateInvoiceAsyncWithHttpInfo (InvoiceServiceData body, string dossierToken, int? dossierId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class InvoicesApi : IInvoicesApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="InvoicesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public InvoicesApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="InvoicesApi"/> class
        /// </summary>
        /// <returns></returns>
        public InvoicesApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="InvoicesApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public InvoicesApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Export Invoice Accept dossier token and export Invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>ExportedInvoiceResult</returns>
        public ExportedInvoiceResult ExportInvoice (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml)
        {
             ApiResponse<ExportedInvoiceResult> localVarResponse = ExportInvoiceWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr, returnInvoice, returnPdfDocument, returnEInvoiceXml);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Export Invoice Accept dossier token and export Invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>ApiResponse of ExportedInvoiceResult</returns>
        public ApiResponse< ExportedInvoiceResult > ExportInvoiceWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'returnInvoice' is set
            if (returnInvoice == null)
                throw new ApiException(400, "Missing required parameter 'returnInvoice' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'returnPdfDocument' is set
            if (returnPdfDocument == null)
                throw new ApiException(400, "Missing required parameter 'returnPdfDocument' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'returnEInvoiceXml' is set
            if (returnEInvoiceXml == null)
                throw new ApiException(400, "Missing required parameter 'returnEInvoiceXml' when calling InvoicesApi->ExportInvoice");

            var localVarPath = "/dossiers/{dossierId}/invoices/export";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (returnInvoice != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnInvoice", returnInvoice)); // query parameter
            if (returnPdfDocument != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnPdfDocument", returnPdfDocument)); // query parameter
            if (returnEInvoiceXml != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnEInvoiceXml", returnEInvoiceXml)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ExportInvoice", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ExportedInvoiceResult>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ExportedInvoiceResult) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ExportedInvoiceResult)));
        }

        /// <summary>
        /// Export Invoice Accept dossier token and export Invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>Task of ExportedInvoiceResult</returns>
        public async System.Threading.Tasks.Task<ExportedInvoiceResult> ExportInvoiceAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml)
        {
             ApiResponse<ExportedInvoiceResult> localVarResponse = await ExportInvoiceAsyncWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr, returnInvoice, returnPdfDocument, returnEInvoiceXml);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Export Invoice Accept dossier token and export Invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>Task of ApiResponse (ExportedInvoiceResult)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ExportedInvoiceResult>> ExportInvoiceAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'returnInvoice' is set
            if (returnInvoice == null)
                throw new ApiException(400, "Missing required parameter 'returnInvoice' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'returnPdfDocument' is set
            if (returnPdfDocument == null)
                throw new ApiException(400, "Missing required parameter 'returnPdfDocument' when calling InvoicesApi->ExportInvoice");
            // verify the required parameter 'returnEInvoiceXml' is set
            if (returnEInvoiceXml == null)
                throw new ApiException(400, "Missing required parameter 'returnEInvoiceXml' when calling InvoicesApi->ExportInvoice");

            var localVarPath = "/dossiers/{dossierId}/invoices/export";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (returnInvoice != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnInvoice", returnInvoice)); // query parameter
            if (returnPdfDocument != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnPdfDocument", returnPdfDocument)); // query parameter
            if (returnEInvoiceXml != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnEInvoiceXml", returnEInvoiceXml)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ExportInvoice", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ExportedInvoiceResult>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ExportedInvoiceResult) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ExportedInvoiceResult)));
        }

        /// <summary>
        /// Generate Invoice  Generate Invoice in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Invoice method
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="publishEInvoice">publish eInvoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>ExportedInvoiceResult</returns>
        public ExportedInvoiceResult GenerateInvoice (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? publishPdfDocument, bool? publishEInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml)
        {
             ApiResponse<ExportedInvoiceResult> localVarResponse = GenerateInvoiceWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr, returnInvoice, publishPdfDocument, publishEInvoice, returnPdfDocument, returnEInvoiceXml);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Generate Invoice  Generate Invoice in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Invoice method
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="publishEInvoice">publish eInvoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>ApiResponse of ExportedInvoiceResult</returns>
        public ApiResponse< ExportedInvoiceResult > GenerateInvoiceWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? publishPdfDocument, bool? publishEInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'returnInvoice' is set
            if (returnInvoice == null)
                throw new ApiException(400, "Missing required parameter 'returnInvoice' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'publishPdfDocument' is set
            if (publishPdfDocument == null)
                throw new ApiException(400, "Missing required parameter 'publishPdfDocument' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'publishEInvoice' is set
            if (publishEInvoice == null)
                throw new ApiException(400, "Missing required parameter 'publishEInvoice' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'returnPdfDocument' is set
            if (returnPdfDocument == null)
                throw new ApiException(400, "Missing required parameter 'returnPdfDocument' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'returnEInvoiceXml' is set
            if (returnEInvoiceXml == null)
                throw new ApiException(400, "Missing required parameter 'returnEInvoiceXml' when calling InvoicesApi->GenerateInvoice");

            var localVarPath = "/dossiers/{dossierId}/invoices/generate";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (returnInvoice != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnInvoice", returnInvoice)); // query parameter
            if (publishPdfDocument != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "publishPdfDocument", publishPdfDocument)); // query parameter
            if (publishEInvoice != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "publishEInvoice", publishEInvoice)); // query parameter
            if (returnPdfDocument != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnPdfDocument", returnPdfDocument)); // query parameter
            if (returnEInvoiceXml != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnEInvoiceXml", returnEInvoiceXml)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GenerateInvoice", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ExportedInvoiceResult>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ExportedInvoiceResult) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ExportedInvoiceResult)));
        }

        /// <summary>
        /// Generate Invoice  Generate Invoice in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Invoice method
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="publishEInvoice">publish eInvoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>Task of ExportedInvoiceResult</returns>
        public async System.Threading.Tasks.Task<ExportedInvoiceResult> GenerateInvoiceAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? publishPdfDocument, bool? publishEInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml)
        {
             ApiResponse<ExportedInvoiceResult> localVarResponse = await GenerateInvoiceAsyncWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr, returnInvoice, publishPdfDocument, publishEInvoice, returnPdfDocument, returnEInvoiceXml);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Generate Invoice  Generate Invoice in pdf format.  Rendering of the pdf is server-side.&lt;BR&gt;If exact rendering of the pdf is required, publish the pdf in the application and use the Export Invoice method
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <param name="returnInvoice">return Invoice</param>
        /// <param name="publishPdfDocument">publish Pdf Document</param>
        /// <param name="publishEInvoice">publish eInvoice</param>
        /// <param name="returnPdfDocument">return Pdf Document</param>
        /// <param name="returnEInvoiceXml">return eInvoice Xml</param>
        /// <returns>Task of ApiResponse (ExportedInvoiceResult)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ExportedInvoiceResult>> GenerateInvoiceAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? publishPdfDocument, bool? publishEInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'returnInvoice' is set
            if (returnInvoice == null)
                throw new ApiException(400, "Missing required parameter 'returnInvoice' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'publishPdfDocument' is set
            if (publishPdfDocument == null)
                throw new ApiException(400, "Missing required parameter 'publishPdfDocument' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'publishEInvoice' is set
            if (publishEInvoice == null)
                throw new ApiException(400, "Missing required parameter 'publishEInvoice' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'returnPdfDocument' is set
            if (returnPdfDocument == null)
                throw new ApiException(400, "Missing required parameter 'returnPdfDocument' when calling InvoicesApi->GenerateInvoice");
            // verify the required parameter 'returnEInvoiceXml' is set
            if (returnEInvoiceXml == null)
                throw new ApiException(400, "Missing required parameter 'returnEInvoiceXml' when calling InvoicesApi->GenerateInvoice");

            var localVarPath = "/dossiers/{dossierId}/invoices/generate";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (returnInvoice != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnInvoice", returnInvoice)); // query parameter
            if (publishPdfDocument != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "publishPdfDocument", publishPdfDocument)); // query parameter
            if (publishEInvoice != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "publishEInvoice", publishEInvoice)); // query parameter
            if (returnPdfDocument != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnPdfDocument", returnPdfDocument)); // query parameter
            if (returnEInvoiceXml != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "returnEInvoiceXml", returnEInvoiceXml)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GenerateInvoice", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ExportedInvoiceResult>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ExportedInvoiceResult) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ExportedInvoiceResult)));
        }

        /// <summary>
        /// Get Invoice Accept dossier token and return invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>InvoiceServiceData</returns>
        public InvoiceServiceData GetInvoice (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)
        {
             ApiResponse<InvoiceServiceData> localVarResponse = GetInvoiceWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get Invoice Accept dossier token and return invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>ApiResponse of InvoiceServiceData</returns>
        public ApiResponse< InvoiceServiceData > GetInvoiceWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling InvoicesApi->GetInvoice");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling InvoicesApi->GetInvoice");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling InvoicesApi->GetInvoice");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling InvoicesApi->GetInvoice");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling InvoicesApi->GetInvoice");

            var localVarPath = "/dossiers/{dossierId}/invoices";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetInvoice", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<InvoiceServiceData>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (InvoiceServiceData) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(InvoiceServiceData)));
        }

        /// <summary>
        /// Get Invoice Accept dossier token and return invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>Task of InvoiceServiceData</returns>
        public async System.Threading.Tasks.Task<InvoiceServiceData> GetInvoiceAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)
        {
             ApiResponse<InvoiceServiceData> localVarResponse = await GetInvoiceAsyncWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get Invoice Accept dossier token and return invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="documentSeqNr">Document Nr</param>
        /// <returns>Task of ApiResponse (InvoiceServiceData)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<InvoiceServiceData>> GetInvoiceAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling InvoicesApi->GetInvoice");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling InvoicesApi->GetInvoice");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling InvoicesApi->GetInvoice");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling InvoicesApi->GetInvoice");
            // verify the required parameter 'documentSeqNr' is set
            if (documentSeqNr == null)
                throw new ApiException(400, "Missing required parameter 'documentSeqNr' when calling InvoicesApi->GetInvoice");

            var localVarPath = "/dossiers/{dossierId}/invoices";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (documentSeqNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "documentSeqNr", documentSeqNr)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetInvoice", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<InvoiceServiceData>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (InvoiceServiceData) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(InvoiceServiceData)));
        }

        /// <summary>
        /// Get modified invoices Accept dossier token and return modified invoices
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>List&lt;InvoiceServiceData&gt;</returns>
        public List<InvoiceServiceData> GetModifiedInvoices (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)
        {
             ApiResponse<List<InvoiceServiceData>> localVarResponse = GetModifiedInvoicesWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, modifiedTimeStamp);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get modified invoices Accept dossier token and return modified invoices
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>ApiResponse of List&lt;InvoiceServiceData&gt;</returns>
        public ApiResponse< List<InvoiceServiceData> > GetModifiedInvoicesWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling InvoicesApi->GetModifiedInvoices");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling InvoicesApi->GetModifiedInvoices");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling InvoicesApi->GetModifiedInvoices");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling InvoicesApi->GetModifiedInvoices");
            // verify the required parameter 'modifiedTimeStamp' is set
            if (modifiedTimeStamp == null)
                throw new ApiException(400, "Missing required parameter 'modifiedTimeStamp' when calling InvoicesApi->GetModifiedInvoices");

            var localVarPath = "/dossiers/{dossierId}/invoices/modified";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (modifiedTimeStamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modifiedTimeStamp", modifiedTimeStamp)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModifiedInvoices", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InvoiceServiceData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<InvoiceServiceData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InvoiceServiceData>)));
        }

        /// <summary>
        /// Get modified invoices Accept dossier token and return modified invoices
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of List&lt;InvoiceServiceData&gt;</returns>
        public async System.Threading.Tasks.Task<List<InvoiceServiceData>> GetModifiedInvoicesAsync (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)
        {
             ApiResponse<List<InvoiceServiceData>> localVarResponse = await GetModifiedInvoicesAsyncWithHttpInfo(dossierId, dossierToken, bookyearId, journalKey, modifiedTimeStamp);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get modified invoices Accept dossier token and return modified invoices
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="bookyearId">Bookyear ID</param>
        /// <param name="journalKey">Journal Key</param>
        /// <param name="modifiedTimeStamp">Modified Timestamp</param>
        /// <returns>Task of ApiResponse (List&lt;InvoiceServiceData&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<InvoiceServiceData>>> GetModifiedInvoicesAsyncWithHttpInfo (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling InvoicesApi->GetModifiedInvoices");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling InvoicesApi->GetModifiedInvoices");
            // verify the required parameter 'bookyearId' is set
            if (bookyearId == null)
                throw new ApiException(400, "Missing required parameter 'bookyearId' when calling InvoicesApi->GetModifiedInvoices");
            // verify the required parameter 'journalKey' is set
            if (journalKey == null)
                throw new ApiException(400, "Missing required parameter 'journalKey' when calling InvoicesApi->GetModifiedInvoices");
            // verify the required parameter 'modifiedTimeStamp' is set
            if (modifiedTimeStamp == null)
                throw new ApiException(400, "Missing required parameter 'modifiedTimeStamp' when calling InvoicesApi->GetModifiedInvoices");

            var localVarPath = "/dossiers/{dossierId}/invoices/modified";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (bookyearId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "bookyearId", bookyearId)); // query parameter
            if (journalKey != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "journalKey", journalKey)); // query parameter
            if (modifiedTimeStamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modifiedTimeStamp", modifiedTimeStamp)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModifiedInvoices", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InvoiceServiceData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<InvoiceServiceData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InvoiceServiceData>)));
        }

        /// <summary>
        /// Create invoice Create new invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        public void InsertInvoice (InvoiceServiceData body, string dossierToken, int? dossierId)
        {
             InsertInvoiceWithHttpInfo(body, dossierToken, dossierId);
        }

        /// <summary>
        /// Create invoice Create new invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> InsertInvoiceWithHttpInfo (InvoiceServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling InvoicesApi->InsertInvoice");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling InvoicesApi->InsertInvoice");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling InvoicesApi->InsertInvoice");

            var localVarPath = "/dossiers/{dossierId}/invoices";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertInvoice", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

        /// <summary>
        /// Create invoice Create new invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task InsertInvoiceAsync (InvoiceServiceData body, string dossierToken, int? dossierId)
        {
             await InsertInvoiceAsyncWithHttpInfo(body, dossierToken, dossierId);

        }

        /// <summary>
        /// Create invoice Create new invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> InsertInvoiceAsyncWithHttpInfo (InvoiceServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling InvoicesApi->InsertInvoice");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling InvoicesApi->InsertInvoice");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling InvoicesApi->InsertInvoice");

            var localVarPath = "/dossiers/{dossierId}/invoices";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertInvoice", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

        /// <summary>
        /// Update invoice Modify invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        public void UpdateInvoice (InvoiceServiceData body, string dossierToken, int? dossierId)
        {
             UpdateInvoiceWithHttpInfo(body, dossierToken, dossierId);
        }

        /// <summary>
        /// Update invoice Modify invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> UpdateInvoiceWithHttpInfo (InvoiceServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling InvoicesApi->UpdateInvoice");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling InvoicesApi->UpdateInvoice");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling InvoicesApi->UpdateInvoice");

            var localVarPath = "/dossiers/{dossierId}/invoices";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateInvoice", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

        /// <summary>
        /// Update invoice Modify invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task UpdateInvoiceAsync (InvoiceServiceData body, string dossierToken, int? dossierId)
        {
             await UpdateInvoiceAsyncWithHttpInfo(body, dossierToken, dossierId);

        }

        /// <summary>
        /// Update invoice Modify invoice
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Invoice object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> UpdateInvoiceAsyncWithHttpInfo (InvoiceServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling InvoicesApi->UpdateInvoice");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling InvoicesApi->UpdateInvoice");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling InvoicesApi->UpdateInvoice");

            var localVarPath = "/dossiers/{dossierId}/invoices";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateInvoice", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

    }
}
