/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IRappelsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Export Rappel
        /// </summary>
        /// <remarks>
        /// Accept dossier token and export Rappel
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">Relation ID</param>
        /// <param name="rappelId">Rappel ID</param>
        /// <returns>ExportedRappelResult</returns>
        ExportedRappelResult ExportRappel (int? dossierId, string dossierToken, int? relationId, int? rappelId);

        /// <summary>
        /// Export Rappel
        /// </summary>
        /// <remarks>
        /// Accept dossier token and export Rappel
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">Relation ID</param>
        /// <param name="rappelId">Rappel ID</param>
        /// <returns>ApiResponse of ExportedRappelResult</returns>
        ApiResponse<ExportedRappelResult> ExportRappelWithHttpInfo (int? dossierId, string dossierToken, int? relationId, int? rappelId);
        /// <summary>
        /// Get Rappel information
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return Rappel information
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="expirationDate">Expiration Date</param>
        /// <returns>List&lt;RappelServiceData&gt;</returns>
        List<RappelServiceData> GetRappelInformation (int? dossierId, string dossierToken, string expirationDate);

        /// <summary>
        /// Get Rappel information
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return Rappel information
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="expirationDate">Expiration Date</param>
        /// <returns>ApiResponse of List&lt;RappelServiceData&gt;</returns>
        ApiResponse<List<RappelServiceData>> GetRappelInformationWithHttpInfo (int? dossierId, string dossierToken, string expirationDate);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Export Rappel
        /// </summary>
        /// <remarks>
        /// Accept dossier token and export Rappel
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">Relation ID</param>
        /// <param name="rappelId">Rappel ID</param>
        /// <returns>Task of ExportedRappelResult</returns>
        System.Threading.Tasks.Task<ExportedRappelResult> ExportRappelAsync (int? dossierId, string dossierToken, int? relationId, int? rappelId);

        /// <summary>
        /// Export Rappel
        /// </summary>
        /// <remarks>
        /// Accept dossier token and export Rappel
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">Relation ID</param>
        /// <param name="rappelId">Rappel ID</param>
        /// <returns>Task of ApiResponse (ExportedRappelResult)</returns>
        System.Threading.Tasks.Task<ApiResponse<ExportedRappelResult>> ExportRappelAsyncWithHttpInfo (int? dossierId, string dossierToken, int? relationId, int? rappelId);
        /// <summary>
        /// Get Rappel information
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return Rappel information
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="expirationDate">Expiration Date</param>
        /// <returns>Task of List&lt;RappelServiceData&gt;</returns>
        System.Threading.Tasks.Task<List<RappelServiceData>> GetRappelInformationAsync (int? dossierId, string dossierToken, string expirationDate);

        /// <summary>
        /// Get Rappel information
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return Rappel information
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="expirationDate">Expiration Date</param>
        /// <returns>Task of ApiResponse (List&lt;RappelServiceData&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<RappelServiceData>>> GetRappelInformationAsyncWithHttpInfo (int? dossierId, string dossierToken, string expirationDate);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class RappelsApi : IRappelsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="RappelsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public RappelsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RappelsApi"/> class
        /// </summary>
        /// <returns></returns>
        public RappelsApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RappelsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public RappelsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Export Rappel Accept dossier token and export Rappel
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">Relation ID</param>
        /// <param name="rappelId">Rappel ID</param>
        /// <returns>ExportedRappelResult</returns>
        public ExportedRappelResult ExportRappel (int? dossierId, string dossierToken, int? relationId, int? rappelId)
        {
             ApiResponse<ExportedRappelResult> localVarResponse = ExportRappelWithHttpInfo(dossierId, dossierToken, relationId, rappelId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Export Rappel Accept dossier token and export Rappel
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">Relation ID</param>
        /// <param name="rappelId">Rappel ID</param>
        /// <returns>ApiResponse of ExportedRappelResult</returns>
        public ApiResponse< ExportedRappelResult > ExportRappelWithHttpInfo (int? dossierId, string dossierToken, int? relationId, int? rappelId)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling RappelsApi->ExportRappel");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling RappelsApi->ExportRappel");
            // verify the required parameter 'relationId' is set
            if (relationId == null)
                throw new ApiException(400, "Missing required parameter 'relationId' when calling RappelsApi->ExportRappel");
            // verify the required parameter 'rappelId' is set
            if (rappelId == null)
                throw new ApiException(400, "Missing required parameter 'rappelId' when calling RappelsApi->ExportRappel");

            var localVarPath = "/dossiers/{dossierId}/rappels/export";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (relationId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "relationId", relationId)); // query parameter
            if (rappelId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "rappelId", rappelId)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ExportRappel", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ExportedRappelResult>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ExportedRappelResult) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ExportedRappelResult)));
        }

        /// <summary>
        /// Export Rappel Accept dossier token and export Rappel
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">Relation ID</param>
        /// <param name="rappelId">Rappel ID</param>
        /// <returns>Task of ExportedRappelResult</returns>
        public async System.Threading.Tasks.Task<ExportedRappelResult> ExportRappelAsync (int? dossierId, string dossierToken, int? relationId, int? rappelId)
        {
             ApiResponse<ExportedRappelResult> localVarResponse = await ExportRappelAsyncWithHttpInfo(dossierId, dossierToken, relationId, rappelId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Export Rappel Accept dossier token and export Rappel
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">Relation ID</param>
        /// <param name="rappelId">Rappel ID</param>
        /// <returns>Task of ApiResponse (ExportedRappelResult)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ExportedRappelResult>> ExportRappelAsyncWithHttpInfo (int? dossierId, string dossierToken, int? relationId, int? rappelId)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling RappelsApi->ExportRappel");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling RappelsApi->ExportRappel");
            // verify the required parameter 'relationId' is set
            if (relationId == null)
                throw new ApiException(400, "Missing required parameter 'relationId' when calling RappelsApi->ExportRappel");
            // verify the required parameter 'rappelId' is set
            if (rappelId == null)
                throw new ApiException(400, "Missing required parameter 'rappelId' when calling RappelsApi->ExportRappel");

            var localVarPath = "/dossiers/{dossierId}/rappels/export";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (relationId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "relationId", relationId)); // query parameter
            if (rappelId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "rappelId", rappelId)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ExportRappel", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ExportedRappelResult>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ExportedRappelResult) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ExportedRappelResult)));
        }

        /// <summary>
        /// Get Rappel information Accept dossier token and return Rappel information
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="expirationDate">Expiration Date</param>
        /// <returns>List&lt;RappelServiceData&gt;</returns>
        public List<RappelServiceData> GetRappelInformation (int? dossierId, string dossierToken, string expirationDate)
        {
             ApiResponse<List<RappelServiceData>> localVarResponse = GetRappelInformationWithHttpInfo(dossierId, dossierToken, expirationDate);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get Rappel information Accept dossier token and return Rappel information
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="expirationDate">Expiration Date</param>
        /// <returns>ApiResponse of List&lt;RappelServiceData&gt;</returns>
        public ApiResponse< List<RappelServiceData> > GetRappelInformationWithHttpInfo (int? dossierId, string dossierToken, string expirationDate)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling RappelsApi->GetRappelInformation");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling RappelsApi->GetRappelInformation");
            // verify the required parameter 'expirationDate' is set
            if (expirationDate == null)
                throw new ApiException(400, "Missing required parameter 'expirationDate' when calling RappelsApi->GetRappelInformation");

            var localVarPath = "/dossiers/{dossierId}/rappels";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (expirationDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "expirationDate", expirationDate)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetRappelInformation", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<RappelServiceData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<RappelServiceData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<RappelServiceData>)));
        }

        /// <summary>
        /// Get Rappel information Accept dossier token and return Rappel information
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="expirationDate">Expiration Date</param>
        /// <returns>Task of List&lt;RappelServiceData&gt;</returns>
        public async System.Threading.Tasks.Task<List<RappelServiceData>> GetRappelInformationAsync (int? dossierId, string dossierToken, string expirationDate)
        {
             ApiResponse<List<RappelServiceData>> localVarResponse = await GetRappelInformationAsyncWithHttpInfo(dossierId, dossierToken, expirationDate);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get Rappel information Accept dossier token and return Rappel information
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="expirationDate">Expiration Date</param>
        /// <returns>Task of ApiResponse (List&lt;RappelServiceData&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<RappelServiceData>>> GetRappelInformationAsyncWithHttpInfo (int? dossierId, string dossierToken, string expirationDate)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling RappelsApi->GetRappelInformation");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling RappelsApi->GetRappelInformation");
            // verify the required parameter 'expirationDate' is set
            if (expirationDate == null)
                throw new ApiException(400, "Missing required parameter 'expirationDate' when calling RappelsApi->GetRappelInformation");

            var localVarPath = "/dossiers/{dossierId}/rappels";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (expirationDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "expirationDate", expirationDate)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetRappelInformation", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<RappelServiceData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<RappelServiceData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<RappelServiceData>)));
        }

    }
}
