/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IRelationsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get Modified Relations
        /// </summary>
        /// <remarks>
        /// Accept dossier token, modified Timestamp and return modified/deleted Relations (Syncrelations).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">modifiedTimeStamp (optional)</param>
        /// <returns>SyncRelations</returns>
        SyncRelations GetModifiedRelations (int? dossierId, string dossierToken, string modifiedTimeStamp = null);

        /// <summary>
        /// Get Modified Relations
        /// </summary>
        /// <remarks>
        /// Accept dossier token, modified Timestamp and return modified/deleted Relations (Syncrelations).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">modifiedTimeStamp (optional)</param>
        /// <returns>ApiResponse of SyncRelations</returns>
        ApiResponse<SyncRelations> GetModifiedRelationsWithHttpInfo (int? dossierId, string dossierToken, string modifiedTimeStamp = null);
        /// <summary>
        /// Get Relations
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return active Relations.  If one or more of the optional search parameters are provided, all relations that meet one or more of these conditions will be returned wether they are active or not
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">relation ID (optional)</param>
        /// <param name="extRelationId">External relation ID (optional)</param>
        /// <param name="name">relation name (optional)</param>
        /// <param name="vatNr">VAT Nr (optional)</param>
        /// <returns>List&lt;RelationServiceData&gt;</returns>
        List<RelationServiceData> GetRelations (int? dossierId, string dossierToken, int? relationId = null, int? extRelationId = null, string name = null, string vatNr = null);

        /// <summary>
        /// Get Relations
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return active Relations.  If one or more of the optional search parameters are provided, all relations that meet one or more of these conditions will be returned wether they are active or not
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">relation ID (optional)</param>
        /// <param name="extRelationId">External relation ID (optional)</param>
        /// <param name="name">relation name (optional)</param>
        /// <param name="vatNr">VAT Nr (optional)</param>
        /// <returns>ApiResponse of List&lt;RelationServiceData&gt;</returns>
        ApiResponse<List<RelationServiceData>> GetRelationsWithHttpInfo (int? dossierId, string dossierToken, int? relationId = null, int? extRelationId = null, string name = null, string vatNr = null);
        /// <summary>
        /// Modify or create Relation
        /// </summary>
        /// <remarks>
        /// Accept dossiertoken and relation object, return status
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">relation Object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        void InsertUpdateRelation (RelationServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Modify or create Relation
        /// </summary>
        /// <remarks>
        /// Accept dossiertoken and relation object, return status
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">relation Object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> InsertUpdateRelationWithHttpInfo (RelationServiceData body, string dossierToken, int? dossierId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Get Modified Relations
        /// </summary>
        /// <remarks>
        /// Accept dossier token, modified Timestamp and return modified/deleted Relations (Syncrelations).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">modifiedTimeStamp (optional)</param>
        /// <returns>Task of SyncRelations</returns>
        System.Threading.Tasks.Task<SyncRelations> GetModifiedRelationsAsync (int? dossierId, string dossierToken, string modifiedTimeStamp = null);

        /// <summary>
        /// Get Modified Relations
        /// </summary>
        /// <remarks>
        /// Accept dossier token, modified Timestamp and return modified/deleted Relations (Syncrelations).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">modifiedTimeStamp (optional)</param>
        /// <returns>Task of ApiResponse (SyncRelations)</returns>
        System.Threading.Tasks.Task<ApiResponse<SyncRelations>> GetModifiedRelationsAsyncWithHttpInfo (int? dossierId, string dossierToken, string modifiedTimeStamp = null);
        /// <summary>
        /// Get Relations
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return active Relations.  If one or more of the optional search parameters are provided, all relations that meet one or more of these conditions will be returned wether they are active or not
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">relation ID (optional)</param>
        /// <param name="extRelationId">External relation ID (optional)</param>
        /// <param name="name">relation name (optional)</param>
        /// <param name="vatNr">VAT Nr (optional)</param>
        /// <returns>Task of List&lt;RelationServiceData&gt;</returns>
        System.Threading.Tasks.Task<List<RelationServiceData>> GetRelationsAsync (int? dossierId, string dossierToken, int? relationId = null, int? extRelationId = null, string name = null, string vatNr = null);

        /// <summary>
        /// Get Relations
        /// </summary>
        /// <remarks>
        /// Accept dossier token and return active Relations.  If one or more of the optional search parameters are provided, all relations that meet one or more of these conditions will be returned wether they are active or not
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">relation ID (optional)</param>
        /// <param name="extRelationId">External relation ID (optional)</param>
        /// <param name="name">relation name (optional)</param>
        /// <param name="vatNr">VAT Nr (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;RelationServiceData&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<RelationServiceData>>> GetRelationsAsyncWithHttpInfo (int? dossierId, string dossierToken, int? relationId = null, int? extRelationId = null, string name = null, string vatNr = null);
        /// <summary>
        /// Modify or create Relation
        /// </summary>
        /// <remarks>
        /// Accept dossiertoken and relation object, return status
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">relation Object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task InsertUpdateRelationAsync (RelationServiceData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Modify or create Relation
        /// </summary>
        /// <remarks>
        /// Accept dossiertoken and relation object, return status
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">relation Object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> InsertUpdateRelationAsyncWithHttpInfo (RelationServiceData body, string dossierToken, int? dossierId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class RelationsApi : IRelationsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="RelationsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public RelationsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RelationsApi"/> class
        /// </summary>
        /// <returns></returns>
        public RelationsApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RelationsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public RelationsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Get Modified Relations Accept dossier token, modified Timestamp and return modified/deleted Relations (Syncrelations).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">modifiedTimeStamp (optional)</param>
        /// <returns>SyncRelations</returns>
        public SyncRelations GetModifiedRelations (int? dossierId, string dossierToken, string modifiedTimeStamp = null)
        {
             ApiResponse<SyncRelations> localVarResponse = GetModifiedRelationsWithHttpInfo(dossierId, dossierToken, modifiedTimeStamp);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get Modified Relations Accept dossier token, modified Timestamp and return modified/deleted Relations (Syncrelations).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">modifiedTimeStamp (optional)</param>
        /// <returns>ApiResponse of SyncRelations</returns>
        public ApiResponse< SyncRelations > GetModifiedRelationsWithHttpInfo (int? dossierId, string dossierToken, string modifiedTimeStamp = null)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling RelationsApi->GetModifiedRelations");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling RelationsApi->GetModifiedRelations");

            var localVarPath = "/dossiers/{dossierId}/relations/modified";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (modifiedTimeStamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modifiedTimeStamp", modifiedTimeStamp)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModifiedRelations", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SyncRelations>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SyncRelations) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SyncRelations)));
        }

        /// <summary>
        /// Get Modified Relations Accept dossier token, modified Timestamp and return modified/deleted Relations (Syncrelations).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">modifiedTimeStamp (optional)</param>
        /// <returns>Task of SyncRelations</returns>
        public async System.Threading.Tasks.Task<SyncRelations> GetModifiedRelationsAsync (int? dossierId, string dossierToken, string modifiedTimeStamp = null)
        {
             ApiResponse<SyncRelations> localVarResponse = await GetModifiedRelationsAsyncWithHttpInfo(dossierId, dossierToken, modifiedTimeStamp);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get Modified Relations Accept dossier token, modified Timestamp and return modified/deleted Relations (Syncrelations).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="modifiedTimeStamp">modifiedTimeStamp (optional)</param>
        /// <returns>Task of ApiResponse (SyncRelations)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SyncRelations>> GetModifiedRelationsAsyncWithHttpInfo (int? dossierId, string dossierToken, string modifiedTimeStamp = null)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling RelationsApi->GetModifiedRelations");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling RelationsApi->GetModifiedRelations");

            var localVarPath = "/dossiers/{dossierId}/relations/modified";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (modifiedTimeStamp != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modifiedTimeStamp", modifiedTimeStamp)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModifiedRelations", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SyncRelations>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SyncRelations) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SyncRelations)));
        }

        /// <summary>
        /// Get Relations Accept dossier token and return active Relations.  If one or more of the optional search parameters are provided, all relations that meet one or more of these conditions will be returned wether they are active or not
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">relation ID (optional)</param>
        /// <param name="extRelationId">External relation ID (optional)</param>
        /// <param name="name">relation name (optional)</param>
        /// <param name="vatNr">VAT Nr (optional)</param>
        /// <returns>List&lt;RelationServiceData&gt;</returns>
        public List<RelationServiceData> GetRelations (int? dossierId, string dossierToken, int? relationId = null, int? extRelationId = null, string name = null, string vatNr = null)
        {
             ApiResponse<List<RelationServiceData>> localVarResponse = GetRelationsWithHttpInfo(dossierId, dossierToken, relationId, extRelationId, name, vatNr);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get Relations Accept dossier token and return active Relations.  If one or more of the optional search parameters are provided, all relations that meet one or more of these conditions will be returned wether they are active or not
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">relation ID (optional)</param>
        /// <param name="extRelationId">External relation ID (optional)</param>
        /// <param name="name">relation name (optional)</param>
        /// <param name="vatNr">VAT Nr (optional)</param>
        /// <returns>ApiResponse of List&lt;RelationServiceData&gt;</returns>
        public ApiResponse< List<RelationServiceData> > GetRelationsWithHttpInfo (int? dossierId, string dossierToken, int? relationId = null, int? extRelationId = null, string name = null, string vatNr = null)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling RelationsApi->GetRelations");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling RelationsApi->GetRelations");

            var localVarPath = "/dossiers/{dossierId}/relations";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (relationId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "relationId", relationId)); // query parameter
            if (extRelationId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "extRelationId", extRelationId)); // query parameter
            if (name != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "name", name)); // query parameter
            if (vatNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "vatNr", vatNr)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetRelations", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<RelationServiceData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<RelationServiceData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<RelationServiceData>)));
        }

        /// <summary>
        /// Get Relations Accept dossier token and return active Relations.  If one or more of the optional search parameters are provided, all relations that meet one or more of these conditions will be returned wether they are active or not
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">relation ID (optional)</param>
        /// <param name="extRelationId">External relation ID (optional)</param>
        /// <param name="name">relation name (optional)</param>
        /// <param name="vatNr">VAT Nr (optional)</param>
        /// <returns>Task of List&lt;RelationServiceData&gt;</returns>
        public async System.Threading.Tasks.Task<List<RelationServiceData>> GetRelationsAsync (int? dossierId, string dossierToken, int? relationId = null, int? extRelationId = null, string name = null, string vatNr = null)
        {
             ApiResponse<List<RelationServiceData>> localVarResponse = await GetRelationsAsyncWithHttpInfo(dossierId, dossierToken, relationId, extRelationId, name, vatNr);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get Relations Accept dossier token and return active Relations.  If one or more of the optional search parameters are provided, all relations that meet one or more of these conditions will be returned wether they are active or not
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="dossierId">Dossier ID</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="relationId">relation ID (optional)</param>
        /// <param name="extRelationId">External relation ID (optional)</param>
        /// <param name="name">relation name (optional)</param>
        /// <param name="vatNr">VAT Nr (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;RelationServiceData&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<RelationServiceData>>> GetRelationsAsyncWithHttpInfo (int? dossierId, string dossierToken, int? relationId = null, int? extRelationId = null, string name = null, string vatNr = null)
        {
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling RelationsApi->GetRelations");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling RelationsApi->GetRelations");

            var localVarPath = "/dossiers/{dossierId}/relations";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (relationId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "relationId", relationId)); // query parameter
            if (extRelationId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "extRelationId", extRelationId)); // query parameter
            if (name != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "name", name)); // query parameter
            if (vatNr != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "vatNr", vatNr)); // query parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetRelations", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<RelationServiceData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<RelationServiceData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<RelationServiceData>)));
        }

        /// <summary>
        /// Modify or create Relation Accept dossiertoken and relation object, return status
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">relation Object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns></returns>
        public void InsertUpdateRelation (RelationServiceData body, string dossierToken, int? dossierId)
        {
             InsertUpdateRelationWithHttpInfo(body, dossierToken, dossierId);
        }

        /// <summary>
        /// Modify or create Relation Accept dossiertoken and relation object, return status
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">relation Object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> InsertUpdateRelationWithHttpInfo (RelationServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling RelationsApi->InsertUpdateRelation");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling RelationsApi->InsertUpdateRelation");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling RelationsApi->InsertUpdateRelation");

            var localVarPath = "/dossiers/{dossierId}/relations";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertUpdateRelation", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

        /// <summary>
        /// Modify or create Relation Accept dossiertoken and relation object, return status
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">relation Object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task InsertUpdateRelationAsync (RelationServiceData body, string dossierToken, int? dossierId)
        {
             await InsertUpdateRelationAsyncWithHttpInfo(body, dossierToken, dossierId);

        }

        /// <summary>
        /// Modify or create Relation Accept dossiertoken and relation object, return status
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">relation Object</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> InsertUpdateRelationAsyncWithHttpInfo (RelationServiceData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling RelationsApi->InsertUpdateRelation");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling RelationsApi->InsertUpdateRelation");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling RelationsApi->InsertUpdateRelation");

            var localVarPath = "/dossiers/{dossierId}/relations";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertUpdateRelation", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                null);
        }

    }
}
