/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IReportsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get history account report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History Account Query Data and return History Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;HistoryData&gt;</returns>
        List<HistoryData> GetReportHistoryAccount (HistoryAccountQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get history account report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History Account Query Data and return History Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;HistoryData&gt;</returns>
        ApiResponse<List<HistoryData>> GetReportHistoryAccountWithHttpInfo (HistoryAccountQueryData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Get history client report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History Relation Query Data and return History Client Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;HistoryData&gt;</returns>
        List<HistoryData> GetReportHistoryClient (HistoryRelationQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get history client report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History Relation Query Data and return History Client Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;HistoryData&gt;</returns>
        ApiResponse<List<HistoryData>> GetReportHistoryClientWithHttpInfo (HistoryRelationQueryData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Get history costcentre report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History CostCentre Query Data and return History CostCentre Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History CostCentre Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;HistoryCostCentreData&gt;</returns>
        List<HistoryCostCentreData> GetReportHistoryCostCentre (HistoryCostCentreQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get history costcentre report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History CostCentre Query Data and return History CostCentre Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History CostCentre Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;HistoryCostCentreData&gt;</returns>
        ApiResponse<List<HistoryCostCentreData>> GetReportHistoryCostCentreWithHttpInfo (HistoryCostCentreQueryData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Get history supplier report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History Relation Query Data and return History Supplier Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;HistoryData&gt;</returns>
        List<HistoryData> GetReportHistorySupplier (HistoryRelationQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get history supplier report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History Relation Query Data and return History Supplier Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;HistoryData&gt;</returns>
        ApiResponse<List<HistoryData>> GetReportHistorySupplierWithHttpInfo (HistoryRelationQueryData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Get open account report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and Open Account Query Data and return Open Account Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;OpenData&gt;</returns>
        List<OpenData> GetReportOpenAccount (OpenAccountQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get open account report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and Open Account Query Data and return Open Account Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;OpenData&gt;</returns>
        ApiResponse<List<OpenData>> GetReportOpenAccountWithHttpInfo (OpenAccountQueryData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Get open client report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and Open Relation Query Data and return Open Client Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;OpenData&gt;</returns>
        List<OpenData> GetReportOpenClient (OpenRelationQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get open client report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and Open Relation Query Data and return Open Client Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;OpenData&gt;</returns>
        ApiResponse<List<OpenData>> GetReportOpenClientWithHttpInfo (OpenRelationQueryData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Get open supplier report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and Open Relation Query Data and return Open Supplier Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;OpenData&gt;</returns>
        List<OpenData> GetReportOpenSupplier (OpenRelationQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get open supplier report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and Open Relation Query Data and return Open Supplier Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;OpenData&gt;</returns>
        ApiResponse<List<OpenData>> GetReportOpenSupplierWithHttpInfo (OpenRelationQueryData body, string dossierToken, int? dossierId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Get history account report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History Account Query Data and return History Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;HistoryData&gt;</returns>
        System.Threading.Tasks.Task<List<HistoryData>> GetReportHistoryAccountAsync (HistoryAccountQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get history account report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History Account Query Data and return History Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;HistoryData&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<HistoryData>>> GetReportHistoryAccountAsyncWithHttpInfo (HistoryAccountQueryData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Get history client report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History Relation Query Data and return History Client Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;HistoryData&gt;</returns>
        System.Threading.Tasks.Task<List<HistoryData>> GetReportHistoryClientAsync (HistoryRelationQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get history client report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History Relation Query Data and return History Client Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;HistoryData&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<HistoryData>>> GetReportHistoryClientAsyncWithHttpInfo (HistoryRelationQueryData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Get history costcentre report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History CostCentre Query Data and return History CostCentre Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History CostCentre Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;HistoryCostCentreData&gt;</returns>
        System.Threading.Tasks.Task<List<HistoryCostCentreData>> GetReportHistoryCostCentreAsync (HistoryCostCentreQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get history costcentre report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History CostCentre Query Data and return History CostCentre Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History CostCentre Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;HistoryCostCentreData&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<HistoryCostCentreData>>> GetReportHistoryCostCentreAsyncWithHttpInfo (HistoryCostCentreQueryData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Get history supplier report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History Relation Query Data and return History Supplier Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;HistoryData&gt;</returns>
        System.Threading.Tasks.Task<List<HistoryData>> GetReportHistorySupplierAsync (HistoryRelationQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get history supplier report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and History Relation Query Data and return History Supplier Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;HistoryData&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<HistoryData>>> GetReportHistorySupplierAsyncWithHttpInfo (HistoryRelationQueryData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Get open account report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and Open Account Query Data and return Open Account Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;OpenData&gt;</returns>
        System.Threading.Tasks.Task<List<OpenData>> GetReportOpenAccountAsync (OpenAccountQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get open account report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and Open Account Query Data and return Open Account Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;OpenData&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<OpenData>>> GetReportOpenAccountAsyncWithHttpInfo (OpenAccountQueryData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Get open client report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and Open Relation Query Data and return Open Client Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;OpenData&gt;</returns>
        System.Threading.Tasks.Task<List<OpenData>> GetReportOpenClientAsync (OpenRelationQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get open client report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and Open Relation Query Data and return Open Client Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;OpenData&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<OpenData>>> GetReportOpenClientAsyncWithHttpInfo (OpenRelationQueryData body, string dossierToken, int? dossierId);
        /// <summary>
        /// Get open supplier report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and Open Relation Query Data and return Open Supplier Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;OpenData&gt;</returns>
        System.Threading.Tasks.Task<List<OpenData>> GetReportOpenSupplierAsync (OpenRelationQueryData body, string dossierToken, int? dossierId);

        /// <summary>
        /// Get open supplier report
        /// </summary>
        /// <remarks>
        /// Accept dossier token and Open Relation Query Data and return Open Supplier Data
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;OpenData&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<OpenData>>> GetReportOpenSupplierAsyncWithHttpInfo (OpenRelationQueryData body, string dossierToken, int? dossierId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class ReportsApi : IReportsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="ReportsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ReportsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ReportsApi"/> class
        /// </summary>
        /// <returns></returns>
        public ReportsApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ReportsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public ReportsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Get history account report Accept dossier token and History Account Query Data and return History Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;HistoryData&gt;</returns>
        public List<HistoryData> GetReportHistoryAccount (HistoryAccountQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<HistoryData>> localVarResponse = GetReportHistoryAccountWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get history account report Accept dossier token and History Account Query Data and return History Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;HistoryData&gt;</returns>
        public ApiResponse< List<HistoryData> > GetReportHistoryAccountWithHttpInfo (HistoryAccountQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportHistoryAccount");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportHistoryAccount");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportHistoryAccount");

            var localVarPath = "/dossiers/{dossierId}/reports/accounts/history";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportHistoryAccount", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<HistoryData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<HistoryData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<HistoryData>)));
        }

        /// <summary>
        /// Get history account report Accept dossier token and History Account Query Data and return History Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;HistoryData&gt;</returns>
        public async System.Threading.Tasks.Task<List<HistoryData>> GetReportHistoryAccountAsync (HistoryAccountQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<HistoryData>> localVarResponse = await GetReportHistoryAccountAsyncWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get history account report Accept dossier token and History Account Query Data and return History Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;HistoryData&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<HistoryData>>> GetReportHistoryAccountAsyncWithHttpInfo (HistoryAccountQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportHistoryAccount");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportHistoryAccount");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportHistoryAccount");

            var localVarPath = "/dossiers/{dossierId}/reports/accounts/history";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportHistoryAccount", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<HistoryData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<HistoryData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<HistoryData>)));
        }

        /// <summary>
        /// Get history client report Accept dossier token and History Relation Query Data and return History Client Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;HistoryData&gt;</returns>
        public List<HistoryData> GetReportHistoryClient (HistoryRelationQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<HistoryData>> localVarResponse = GetReportHistoryClientWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get history client report Accept dossier token and History Relation Query Data and return History Client Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;HistoryData&gt;</returns>
        public ApiResponse< List<HistoryData> > GetReportHistoryClientWithHttpInfo (HistoryRelationQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportHistoryClient");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportHistoryClient");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportHistoryClient");

            var localVarPath = "/dossiers/{dossierId}/reports/clients/history";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportHistoryClient", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<HistoryData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<HistoryData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<HistoryData>)));
        }

        /// <summary>
        /// Get history client report Accept dossier token and History Relation Query Data and return History Client Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;HistoryData&gt;</returns>
        public async System.Threading.Tasks.Task<List<HistoryData>> GetReportHistoryClientAsync (HistoryRelationQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<HistoryData>> localVarResponse = await GetReportHistoryClientAsyncWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get history client report Accept dossier token and History Relation Query Data and return History Client Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;HistoryData&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<HistoryData>>> GetReportHistoryClientAsyncWithHttpInfo (HistoryRelationQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportHistoryClient");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportHistoryClient");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportHistoryClient");

            var localVarPath = "/dossiers/{dossierId}/reports/clients/history";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportHistoryClient", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<HistoryData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<HistoryData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<HistoryData>)));
        }

        /// <summary>
        /// Get history costcentre report Accept dossier token and History CostCentre Query Data and return History CostCentre Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History CostCentre Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;HistoryCostCentreData&gt;</returns>
        public List<HistoryCostCentreData> GetReportHistoryCostCentre (HistoryCostCentreQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<HistoryCostCentreData>> localVarResponse = GetReportHistoryCostCentreWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get history costcentre report Accept dossier token and History CostCentre Query Data and return History CostCentre Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History CostCentre Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;HistoryCostCentreData&gt;</returns>
        public ApiResponse< List<HistoryCostCentreData> > GetReportHistoryCostCentreWithHttpInfo (HistoryCostCentreQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportHistoryCostCentre");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportHistoryCostCentre");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportHistoryCostCentre");

            var localVarPath = "/dossiers/{dossierId}/reports/costcentres/history";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportHistoryCostCentre", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<HistoryCostCentreData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<HistoryCostCentreData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<HistoryCostCentreData>)));
        }

        /// <summary>
        /// Get history costcentre report Accept dossier token and History CostCentre Query Data and return History CostCentre Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History CostCentre Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;HistoryCostCentreData&gt;</returns>
        public async System.Threading.Tasks.Task<List<HistoryCostCentreData>> GetReportHistoryCostCentreAsync (HistoryCostCentreQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<HistoryCostCentreData>> localVarResponse = await GetReportHistoryCostCentreAsyncWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get history costcentre report Accept dossier token and History CostCentre Query Data and return History CostCentre Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History CostCentre Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;HistoryCostCentreData&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<HistoryCostCentreData>>> GetReportHistoryCostCentreAsyncWithHttpInfo (HistoryCostCentreQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportHistoryCostCentre");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportHistoryCostCentre");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportHistoryCostCentre");

            var localVarPath = "/dossiers/{dossierId}/reports/costcentres/history";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportHistoryCostCentre", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<HistoryCostCentreData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<HistoryCostCentreData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<HistoryCostCentreData>)));
        }

        /// <summary>
        /// Get history supplier report Accept dossier token and History Relation Query Data and return History Supplier Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;HistoryData&gt;</returns>
        public List<HistoryData> GetReportHistorySupplier (HistoryRelationQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<HistoryData>> localVarResponse = GetReportHistorySupplierWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get history supplier report Accept dossier token and History Relation Query Data and return History Supplier Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;HistoryData&gt;</returns>
        public ApiResponse< List<HistoryData> > GetReportHistorySupplierWithHttpInfo (HistoryRelationQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportHistorySupplier");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportHistorySupplier");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportHistorySupplier");

            var localVarPath = "/dossiers/{dossierId}/reports/suppliers/history";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportHistorySupplier", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<HistoryData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<HistoryData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<HistoryData>)));
        }

        /// <summary>
        /// Get history supplier report Accept dossier token and History Relation Query Data and return History Supplier Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;HistoryData&gt;</returns>
        public async System.Threading.Tasks.Task<List<HistoryData>> GetReportHistorySupplierAsync (HistoryRelationQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<HistoryData>> localVarResponse = await GetReportHistorySupplierAsyncWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get history supplier report Accept dossier token and History Relation Query Data and return History Supplier Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">History Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;HistoryData&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<HistoryData>>> GetReportHistorySupplierAsyncWithHttpInfo (HistoryRelationQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportHistorySupplier");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportHistorySupplier");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportHistorySupplier");

            var localVarPath = "/dossiers/{dossierId}/reports/suppliers/history";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportHistorySupplier", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<HistoryData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<HistoryData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<HistoryData>)));
        }

        /// <summary>
        /// Get open account report Accept dossier token and Open Account Query Data and return Open Account Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;OpenData&gt;</returns>
        public List<OpenData> GetReportOpenAccount (OpenAccountQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<OpenData>> localVarResponse = GetReportOpenAccountWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get open account report Accept dossier token and Open Account Query Data and return Open Account Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;OpenData&gt;</returns>
        public ApiResponse< List<OpenData> > GetReportOpenAccountWithHttpInfo (OpenAccountQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportOpenAccount");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportOpenAccount");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportOpenAccount");

            var localVarPath = "/dossiers/{dossierId}/reports/accounts/open";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportOpenAccount", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<OpenData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<OpenData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<OpenData>)));
        }

        /// <summary>
        /// Get open account report Accept dossier token and Open Account Query Data and return Open Account Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;OpenData&gt;</returns>
        public async System.Threading.Tasks.Task<List<OpenData>> GetReportOpenAccountAsync (OpenAccountQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<OpenData>> localVarResponse = await GetReportOpenAccountAsyncWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get open account report Accept dossier token and Open Account Query Data and return Open Account Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Account Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;OpenData&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<OpenData>>> GetReportOpenAccountAsyncWithHttpInfo (OpenAccountQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportOpenAccount");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportOpenAccount");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportOpenAccount");

            var localVarPath = "/dossiers/{dossierId}/reports/accounts/open";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportOpenAccount", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<OpenData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<OpenData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<OpenData>)));
        }

        /// <summary>
        /// Get open client report Accept dossier token and Open Relation Query Data and return Open Client Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;OpenData&gt;</returns>
        public List<OpenData> GetReportOpenClient (OpenRelationQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<OpenData>> localVarResponse = GetReportOpenClientWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get open client report Accept dossier token and Open Relation Query Data and return Open Client Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;OpenData&gt;</returns>
        public ApiResponse< List<OpenData> > GetReportOpenClientWithHttpInfo (OpenRelationQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportOpenClient");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportOpenClient");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportOpenClient");

            var localVarPath = "/dossiers/{dossierId}/reports/clients/open";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportOpenClient", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<OpenData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<OpenData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<OpenData>)));
        }

        /// <summary>
        /// Get open client report Accept dossier token and Open Relation Query Data and return Open Client Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;OpenData&gt;</returns>
        public async System.Threading.Tasks.Task<List<OpenData>> GetReportOpenClientAsync (OpenRelationQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<OpenData>> localVarResponse = await GetReportOpenClientAsyncWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get open client report Accept dossier token and Open Relation Query Data and return Open Client Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;OpenData&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<OpenData>>> GetReportOpenClientAsyncWithHttpInfo (OpenRelationQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportOpenClient");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportOpenClient");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportOpenClient");

            var localVarPath = "/dossiers/{dossierId}/reports/clients/open";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportOpenClient", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<OpenData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<OpenData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<OpenData>)));
        }

        /// <summary>
        /// Get open supplier report Accept dossier token and Open Relation Query Data and return Open Supplier Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>List&lt;OpenData&gt;</returns>
        public List<OpenData> GetReportOpenSupplier (OpenRelationQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<OpenData>> localVarResponse = GetReportOpenSupplierWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get open supplier report Accept dossier token and Open Relation Query Data and return Open Supplier Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>ApiResponse of List&lt;OpenData&gt;</returns>
        public ApiResponse< List<OpenData> > GetReportOpenSupplierWithHttpInfo (OpenRelationQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportOpenSupplier");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportOpenSupplier");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportOpenSupplier");

            var localVarPath = "/dossiers/{dossierId}/reports/suppliers/open";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportOpenSupplier", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<OpenData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<OpenData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<OpenData>)));
        }

        /// <summary>
        /// Get open supplier report Accept dossier token and Open Relation Query Data and return Open Supplier Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of List&lt;OpenData&gt;</returns>
        public async System.Threading.Tasks.Task<List<OpenData>> GetReportOpenSupplierAsync (OpenRelationQueryData body, string dossierToken, int? dossierId)
        {
             ApiResponse<List<OpenData>> localVarResponse = await GetReportOpenSupplierAsyncWithHttpInfo(body, dossierToken, dossierId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get open supplier report Accept dossier token and Open Relation Query Data and return Open Supplier Data
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">Open Relation Query Data</param>
        /// <param name="dossierToken">dossierToken</param>
        /// <param name="dossierId">Dossier ID</param>
        /// <returns>Task of ApiResponse (List&lt;OpenData&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<OpenData>>> GetReportOpenSupplierAsyncWithHttpInfo (OpenRelationQueryData body, string dossierToken, int? dossierId)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling ReportsApi->GetReportOpenSupplier");
            // verify the required parameter 'dossierToken' is set
            if (dossierToken == null)
                throw new ApiException(400, "Missing required parameter 'dossierToken' when calling ReportsApi->GetReportOpenSupplier");
            // verify the required parameter 'dossierId' is set
            if (dossierId == null)
                throw new ApiException(400, "Missing required parameter 'dossierId' when calling ReportsApi->GetReportOpenSupplier");

            var localVarPath = "/dossiers/{dossierId}/reports/suppliers/open";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (dossierId != null) localVarPathParams.Add("dossierId", this.Configuration.ApiClient.ParameterToString(dossierId)); // path parameter
            if (dossierToken != null) localVarHeaderParams.Add("dossierToken", this.Configuration.ApiClient.ParameterToString(dossierToken)); // header parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetReportOpenSupplier", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<OpenData>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<OpenData>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<OpenData>)));
        }

    }
}
