/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// AccountAmountKey
    /// </summary>
    [DataContract]
        public partial class AccountAmountKey :  IEquatable<AccountAmountKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AccountAmountKey" /> class.
        /// </summary>
        /// <param name="bookyearPeriodKey">bookyearPeriodKey.</param>
        /// <param name="accountKey">accountKey.</param>
        public AccountAmountKey(BookyearPeriodKey bookyearPeriodKey = default(BookyearPeriodKey), AccountKey accountKey = default(AccountKey))
        {
            this.BookyearPeriodKey = bookyearPeriodKey;
            this.AccountKey = accountKey;
        }
        
        /// <summary>
        /// Gets or Sets BookyearPeriodKey
        /// </summary>
        [DataMember(Name="bookyearPeriodKey", EmitDefaultValue=false)]
        public BookyearPeriodKey BookyearPeriodKey { get; set; }

        /// <summary>
        /// Gets or Sets AccountKey
        /// </summary>
        [DataMember(Name="accountKey", EmitDefaultValue=false)]
        public AccountKey AccountKey { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AccountAmountKey {\n");
            sb.Append("  BookyearPeriodKey: ").Append(BookyearPeriodKey).Append("\n");
            sb.Append("  AccountKey: ").Append(AccountKey).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AccountAmountKey);
        }

        /// <summary>
        /// Returns true if AccountAmountKey instances are equal
        /// </summary>
        /// <param name="input">Instance of AccountAmountKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AccountAmountKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BookyearPeriodKey == input.BookyearPeriodKey ||
                    (this.BookyearPeriodKey != null &&
                    this.BookyearPeriodKey.Equals(input.BookyearPeriodKey))
                ) && 
                (
                    this.AccountKey == input.AccountKey ||
                    (this.AccountKey != null &&
                    this.AccountKey.Equals(input.AccountKey))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BookyearPeriodKey != null)
                    hashCode = hashCode * 59 + this.BookyearPeriodKey.GetHashCode();
                if (this.AccountKey != null)
                    hashCode = hashCode * 59 + this.AccountKey.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
