/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// AccountAmountServiceData
    /// </summary>
    [DataContract]
        public partial class AccountAmountServiceData :  IEquatable<AccountAmountServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AccountAmountServiceData" /> class.
        /// </summary>
        /// <param name="accountAmountKey">accountAmountKey.</param>
        /// <param name="balance">balance.</param>
        public AccountAmountServiceData(AccountAmountKey accountAmountKey = default(AccountAmountKey), double? balance = default(double?))
        {
            this.AccountAmountKey = accountAmountKey;
            this.Balance = balance;
        }
        
        /// <summary>
        /// Gets or Sets AccountAmountKey
        /// </summary>
        [DataMember(Name="accountAmountKey", EmitDefaultValue=false)]
        public AccountAmountKey AccountAmountKey { get; set; }

        /// <summary>
        /// Gets or Sets Balance
        /// </summary>
        [DataMember(Name="balance", EmitDefaultValue=false)]
        public double? Balance { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AccountAmountServiceData {\n");
            sb.Append("  AccountAmountKey: ").Append(AccountAmountKey).Append("\n");
            sb.Append("  Balance: ").Append(Balance).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AccountAmountServiceData);
        }

        /// <summary>
        /// Returns true if AccountAmountServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of AccountAmountServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AccountAmountServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.AccountAmountKey == input.AccountAmountKey ||
                    (this.AccountAmountKey != null &&
                    this.AccountAmountKey.Equals(input.AccountAmountKey))
                ) && 
                (
                    this.Balance == input.Balance ||
                    (this.Balance != null &&
                    this.Balance.Equals(input.Balance))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.AccountAmountKey != null)
                    hashCode = hashCode * 59 + this.AccountAmountKey.GetHashCode();
                if (this.Balance != null)
                    hashCode = hashCode * 59 + this.Balance.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
