/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// AccountServiceData
    /// </summary>
    [DataContract]
        public partial class AccountServiceData :  IEquatable<AccountServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AccountServiceData" /> class.
        /// </summary>
        /// <param name="accountKey">accountKey (required).</param>
        /// <param name="description">description.</param>
        /// <param name="vatRecupPercentage">The VAT recuperation percentage of this account.</param>
        /// <param name="fiscProfessionalPercentage">The fiscal professional percentage of this account.</param>
        /// <param name="fiscRecupPercentage">The fiscal recuperation percentage of this account.</param>
        /// <param name="defaultCostCentreKey">defaultCostCentreKey.</param>
        public AccountServiceData(AccountKey accountKey = default(AccountKey), StringServiceData description = default(StringServiceData), double? vatRecupPercentage = default(double?), double? fiscProfessionalPercentage = default(double?), double? fiscRecupPercentage = default(double?), CostCentreKey defaultCostCentreKey = default(CostCentreKey))
        {
            // to ensure "accountKey" is required (not null)
            if (accountKey == null)
            {
                throw new InvalidDataException("accountKey is a required property for AccountServiceData and cannot be null");
            }
            else
            {
                this.AccountKey = accountKey;
            }
            this.Description = description;
            this.VatRecupPercentage = vatRecupPercentage;
            this.FiscProfessionalPercentage = fiscProfessionalPercentage;
            this.FiscRecupPercentage = fiscRecupPercentage;
            this.DefaultCostCentreKey = defaultCostCentreKey;
        }
        
        /// <summary>
        /// Gets or Sets AccountKey
        /// </summary>
        [DataMember(Name="accountKey", EmitDefaultValue=false)]
        public AccountKey AccountKey { get; set; }

        /// <summary>
        /// Gets or Sets Description
        /// </summary>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public StringServiceData Description { get; set; }

        /// <summary>
        /// The VAT recuperation percentage of this account
        /// </summary>
        /// <value>The VAT recuperation percentage of this account</value>
        [DataMember(Name="vatRecupPercentage", EmitDefaultValue=false)]
        public double? VatRecupPercentage { get; set; }

        /// <summary>
        /// The fiscal professional percentage of this account
        /// </summary>
        /// <value>The fiscal professional percentage of this account</value>
        [DataMember(Name="fiscProfessionalPercentage", EmitDefaultValue=false)]
        public double? FiscProfessionalPercentage { get; set; }

        /// <summary>
        /// The fiscal recuperation percentage of this account
        /// </summary>
        /// <value>The fiscal recuperation percentage of this account</value>
        [DataMember(Name="fiscRecupPercentage", EmitDefaultValue=false)]
        public double? FiscRecupPercentage { get; set; }

        /// <summary>
        /// Purchase VAT code
        /// </summary>
        /// <value>Purchase VAT code</value>
        [DataMember(Name="purchaseVatCode", EmitDefaultValue=false)]
        public string PurchaseVatCode { get; private set; }

        /// <summary>
        /// Sales VAT code
        /// </summary>
        /// <value>Sales VAT code</value>
        [DataMember(Name="salesVatCode", EmitDefaultValue=false)]
        public string SalesVatCode { get; private set; }

        /// <summary>
        /// Integer indicating if booking on this account requires a cost centre&lt;ul&gt;&lt;li&gt;Value 0 : No cost centre required&lt;/li&gt;&lt;li&gt;Value 1 : Cost Centre Mandatory&lt;/li&gt;&lt;li&gt;Value 2 : Cost Centre Not Mandatory&lt;/li&gt;&lt;/ul&gt;The value can only be changed through the application
        /// </summary>
        /// <value>Integer indicating if booking on this account requires a cost centre&lt;ul&gt;&lt;li&gt;Value 0 : No cost centre required&lt;/li&gt;&lt;li&gt;Value 1 : Cost Centre Mandatory&lt;/li&gt;&lt;li&gt;Value 2 : Cost Centre Not Mandatory&lt;/li&gt;&lt;/ul&gt;The value can only be changed through the application</value>
        [DataMember(Name="costCentreType", EmitDefaultValue=false)]
        public int? CostCentreType { get; private set; }

        /// <summary>
        /// Gets or Sets DefaultCostCentreKey
        /// </summary>
        [DataMember(Name="defaultCostCentreKey", EmitDefaultValue=false)]
        public CostCentreKey DefaultCostCentreKey { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AccountServiceData {\n");
            sb.Append("  AccountKey: ").Append(AccountKey).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  VatRecupPercentage: ").Append(VatRecupPercentage).Append("\n");
            sb.Append("  FiscProfessionalPercentage: ").Append(FiscProfessionalPercentage).Append("\n");
            sb.Append("  FiscRecupPercentage: ").Append(FiscRecupPercentage).Append("\n");
            sb.Append("  PurchaseVatCode: ").Append(PurchaseVatCode).Append("\n");
            sb.Append("  SalesVatCode: ").Append(SalesVatCode).Append("\n");
            sb.Append("  CostCentreType: ").Append(CostCentreType).Append("\n");
            sb.Append("  DefaultCostCentreKey: ").Append(DefaultCostCentreKey).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AccountServiceData);
        }

        /// <summary>
        /// Returns true if AccountServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of AccountServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AccountServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.AccountKey == input.AccountKey ||
                    (this.AccountKey != null &&
                    this.AccountKey.Equals(input.AccountKey))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.VatRecupPercentage == input.VatRecupPercentage ||
                    (this.VatRecupPercentage != null &&
                    this.VatRecupPercentage.Equals(input.VatRecupPercentage))
                ) && 
                (
                    this.FiscProfessionalPercentage == input.FiscProfessionalPercentage ||
                    (this.FiscProfessionalPercentage != null &&
                    this.FiscProfessionalPercentage.Equals(input.FiscProfessionalPercentage))
                ) && 
                (
                    this.FiscRecupPercentage == input.FiscRecupPercentage ||
                    (this.FiscRecupPercentage != null &&
                    this.FiscRecupPercentage.Equals(input.FiscRecupPercentage))
                ) && 
                (
                    this.PurchaseVatCode == input.PurchaseVatCode ||
                    (this.PurchaseVatCode != null &&
                    this.PurchaseVatCode.Equals(input.PurchaseVatCode))
                ) && 
                (
                    this.SalesVatCode == input.SalesVatCode ||
                    (this.SalesVatCode != null &&
                    this.SalesVatCode.Equals(input.SalesVatCode))
                ) && 
                (
                    this.CostCentreType == input.CostCentreType ||
                    (this.CostCentreType != null &&
                    this.CostCentreType.Equals(input.CostCentreType))
                ) && 
                (
                    this.DefaultCostCentreKey == input.DefaultCostCentreKey ||
                    (this.DefaultCostCentreKey != null &&
                    this.DefaultCostCentreKey.Equals(input.DefaultCostCentreKey))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.AccountKey != null)
                    hashCode = hashCode * 59 + this.AccountKey.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.VatRecupPercentage != null)
                    hashCode = hashCode * 59 + this.VatRecupPercentage.GetHashCode();
                if (this.FiscProfessionalPercentage != null)
                    hashCode = hashCode * 59 + this.FiscProfessionalPercentage.GetHashCode();
                if (this.FiscRecupPercentage != null)
                    hashCode = hashCode * 59 + this.FiscRecupPercentage.GetHashCode();
                if (this.PurchaseVatCode != null)
                    hashCode = hashCode * 59 + this.PurchaseVatCode.GetHashCode();
                if (this.SalesVatCode != null)
                    hashCode = hashCode * 59 + this.SalesVatCode.GetHashCode();
                if (this.CostCentreType != null)
                    hashCode = hashCode * 59 + this.CostCentreType.GetHashCode();
                if (this.DefaultCostCentreKey != null)
                    hashCode = hashCode * 59 + this.DefaultCostCentreKey.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
