/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// BalancingDetailServiceData
    /// </summary>
    [DataContract]
        public partial class BalancingDetailServiceData :  IEquatable<BalancingDetailServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BalancingDetailServiceData" /> class.
        /// </summary>
        /// <param name="type">type.</param>
        /// <param name="debetDocument">debetDocument.</param>
        /// <param name="creditDocument">creditDocument.</param>
        /// <param name="debetBalancedBookingAmount">debetBalancedBookingAmount.</param>
        /// <param name="creditBalancedBookingAmount">creditBalancedBookingAmount.</param>
        public BalancingDetailServiceData(BalancingTypeServiceData type = default(BalancingTypeServiceData), BalancingDocumentServiceData debetDocument = default(BalancingDocumentServiceData), BalancingDocumentServiceData creditDocument = default(BalancingDocumentServiceData), double? debetBalancedBookingAmount = default(double?), double? creditBalancedBookingAmount = default(double?))
        {
            this.Type = type;
            this.DebetDocument = debetDocument;
            this.CreditDocument = creditDocument;
            this.DebetBalancedBookingAmount = debetBalancedBookingAmount;
            this.CreditBalancedBookingAmount = creditBalancedBookingAmount;
        }
        
        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name="type", EmitDefaultValue=false)]
        public BalancingTypeServiceData Type { get; set; }

        /// <summary>
        /// Gets or Sets DebetDocument
        /// </summary>
        [DataMember(Name="debetDocument", EmitDefaultValue=false)]
        public BalancingDocumentServiceData DebetDocument { get; set; }

        /// <summary>
        /// Gets or Sets CreditDocument
        /// </summary>
        [DataMember(Name="creditDocument", EmitDefaultValue=false)]
        public BalancingDocumentServiceData CreditDocument { get; set; }

        /// <summary>
        /// Gets or Sets DebetBalancedBookingAmount
        /// </summary>
        [DataMember(Name="debetBalancedBookingAmount", EmitDefaultValue=false)]
        public double? DebetBalancedBookingAmount { get; set; }

        /// <summary>
        /// Gets or Sets CreditBalancedBookingAmount
        /// </summary>
        [DataMember(Name="creditBalancedBookingAmount", EmitDefaultValue=false)]
        public double? CreditBalancedBookingAmount { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BalancingDetailServiceData {\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  DebetDocument: ").Append(DebetDocument).Append("\n");
            sb.Append("  CreditDocument: ").Append(CreditDocument).Append("\n");
            sb.Append("  DebetBalancedBookingAmount: ").Append(DebetBalancedBookingAmount).Append("\n");
            sb.Append("  CreditBalancedBookingAmount: ").Append(CreditBalancedBookingAmount).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BalancingDetailServiceData);
        }

        /// <summary>
        /// Returns true if BalancingDetailServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of BalancingDetailServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BalancingDetailServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.DebetDocument == input.DebetDocument ||
                    (this.DebetDocument != null &&
                    this.DebetDocument.Equals(input.DebetDocument))
                ) && 
                (
                    this.CreditDocument == input.CreditDocument ||
                    (this.CreditDocument != null &&
                    this.CreditDocument.Equals(input.CreditDocument))
                ) && 
                (
                    this.DebetBalancedBookingAmount == input.DebetBalancedBookingAmount ||
                    (this.DebetBalancedBookingAmount != null &&
                    this.DebetBalancedBookingAmount.Equals(input.DebetBalancedBookingAmount))
                ) && 
                (
                    this.CreditBalancedBookingAmount == input.CreditBalancedBookingAmount ||
                    (this.CreditBalancedBookingAmount != null &&
                    this.CreditBalancedBookingAmount.Equals(input.CreditBalancedBookingAmount))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.DebetDocument != null)
                    hashCode = hashCode * 59 + this.DebetDocument.GetHashCode();
                if (this.CreditDocument != null)
                    hashCode = hashCode * 59 + this.CreditDocument.GetHashCode();
                if (this.DebetBalancedBookingAmount != null)
                    hashCode = hashCode * 59 + this.DebetBalancedBookingAmount.GetHashCode();
                if (this.CreditBalancedBookingAmount != null)
                    hashCode = hashCode * 59 + this.CreditBalancedBookingAmount.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
