/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// BalancingDocumentServiceData
    /// </summary>
    [DataContract]
        public partial class BalancingDocumentServiceData :  IEquatable<BalancingDocumentServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BalancingDocumentServiceData" /> class.
        /// </summary>
        /// <param name="balancingKey">balancingKey.</param>
        /// <param name="documentDate">documentDate.</param>
        /// <param name="currencyCode">currencyCode.</param>
        /// <param name="exchangeRate">exchangeRate.</param>
        /// <param name="comment">comment.</param>
        /// <param name="reference">reference.</param>
        /// <param name="debetBookingAmount">debetBookingAmount.</param>
        /// <param name="creditBookingAmount">creditBookingAmount.</param>
        /// <param name="debetDocumentAmount">debetDocumentAmount.</param>
        /// <param name="creditDocumentAmount">creditDocumentAmount.</param>
        public BalancingDocumentServiceData(BalancingKeyServiceData balancingKey = default(BalancingKeyServiceData), DateTime? documentDate = default(DateTime?), string currencyCode = default(string), double? exchangeRate = default(double?), string comment = default(string), string reference = default(string), double? debetBookingAmount = default(double?), double? creditBookingAmount = default(double?), double? debetDocumentAmount = default(double?), double? creditDocumentAmount = default(double?))
        {
            this.BalancingKey = balancingKey;
            this.DocumentDate = documentDate;
            this.CurrencyCode = currencyCode;
            this.ExchangeRate = exchangeRate;
            this.Comment = comment;
            this.Reference = reference;
            this.DebetBookingAmount = debetBookingAmount;
            this.CreditBookingAmount = creditBookingAmount;
            this.DebetDocumentAmount = debetDocumentAmount;
            this.CreditDocumentAmount = creditDocumentAmount;
        }
        
        /// <summary>
        /// Gets or Sets BalancingKey
        /// </summary>
        [DataMember(Name="balancingKey", EmitDefaultValue=false)]
        public BalancingKeyServiceData BalancingKey { get; set; }

        /// <summary>
        /// Gets or Sets DocumentDate
        /// </summary>
        [DataMember(Name="documentDate", EmitDefaultValue=false)]
        public DateTime? DocumentDate { get; set; }

        /// <summary>
        /// Gets or Sets CurrencyCode
        /// </summary>
        [DataMember(Name="currencyCode", EmitDefaultValue=false)]
        public string CurrencyCode { get; set; }

        /// <summary>
        /// Gets or Sets ExchangeRate
        /// </summary>
        [DataMember(Name="exchangeRate", EmitDefaultValue=false)]
        public double? ExchangeRate { get; set; }

        /// <summary>
        /// Gets or Sets Comment
        /// </summary>
        [DataMember(Name="comment", EmitDefaultValue=false)]
        public string Comment { get; set; }

        /// <summary>
        /// Gets or Sets Reference
        /// </summary>
        [DataMember(Name="reference", EmitDefaultValue=false)]
        public string Reference { get; set; }

        /// <summary>
        /// Gets or Sets DebetBookingAmount
        /// </summary>
        [DataMember(Name="debetBookingAmount", EmitDefaultValue=false)]
        public double? DebetBookingAmount { get; set; }

        /// <summary>
        /// Gets or Sets CreditBookingAmount
        /// </summary>
        [DataMember(Name="creditBookingAmount", EmitDefaultValue=false)]
        public double? CreditBookingAmount { get; set; }

        /// <summary>
        /// Gets or Sets DebetDocumentAmount
        /// </summary>
        [DataMember(Name="debetDocumentAmount", EmitDefaultValue=false)]
        public double? DebetDocumentAmount { get; set; }

        /// <summary>
        /// Gets or Sets CreditDocumentAmount
        /// </summary>
        [DataMember(Name="creditDocumentAmount", EmitDefaultValue=false)]
        public double? CreditDocumentAmount { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BalancingDocumentServiceData {\n");
            sb.Append("  BalancingKey: ").Append(BalancingKey).Append("\n");
            sb.Append("  DocumentDate: ").Append(DocumentDate).Append("\n");
            sb.Append("  CurrencyCode: ").Append(CurrencyCode).Append("\n");
            sb.Append("  ExchangeRate: ").Append(ExchangeRate).Append("\n");
            sb.Append("  Comment: ").Append(Comment).Append("\n");
            sb.Append("  Reference: ").Append(Reference).Append("\n");
            sb.Append("  DebetBookingAmount: ").Append(DebetBookingAmount).Append("\n");
            sb.Append("  CreditBookingAmount: ").Append(CreditBookingAmount).Append("\n");
            sb.Append("  DebetDocumentAmount: ").Append(DebetDocumentAmount).Append("\n");
            sb.Append("  CreditDocumentAmount: ").Append(CreditDocumentAmount).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BalancingDocumentServiceData);
        }

        /// <summary>
        /// Returns true if BalancingDocumentServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of BalancingDocumentServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BalancingDocumentServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BalancingKey == input.BalancingKey ||
                    (this.BalancingKey != null &&
                    this.BalancingKey.Equals(input.BalancingKey))
                ) && 
                (
                    this.DocumentDate == input.DocumentDate ||
                    (this.DocumentDate != null &&
                    this.DocumentDate.Equals(input.DocumentDate))
                ) && 
                (
                    this.CurrencyCode == input.CurrencyCode ||
                    (this.CurrencyCode != null &&
                    this.CurrencyCode.Equals(input.CurrencyCode))
                ) && 
                (
                    this.ExchangeRate == input.ExchangeRate ||
                    (this.ExchangeRate != null &&
                    this.ExchangeRate.Equals(input.ExchangeRate))
                ) && 
                (
                    this.Comment == input.Comment ||
                    (this.Comment != null &&
                    this.Comment.Equals(input.Comment))
                ) && 
                (
                    this.Reference == input.Reference ||
                    (this.Reference != null &&
                    this.Reference.Equals(input.Reference))
                ) && 
                (
                    this.DebetBookingAmount == input.DebetBookingAmount ||
                    (this.DebetBookingAmount != null &&
                    this.DebetBookingAmount.Equals(input.DebetBookingAmount))
                ) && 
                (
                    this.CreditBookingAmount == input.CreditBookingAmount ||
                    (this.CreditBookingAmount != null &&
                    this.CreditBookingAmount.Equals(input.CreditBookingAmount))
                ) && 
                (
                    this.DebetDocumentAmount == input.DebetDocumentAmount ||
                    (this.DebetDocumentAmount != null &&
                    this.DebetDocumentAmount.Equals(input.DebetDocumentAmount))
                ) && 
                (
                    this.CreditDocumentAmount == input.CreditDocumentAmount ||
                    (this.CreditDocumentAmount != null &&
                    this.CreditDocumentAmount.Equals(input.CreditDocumentAmount))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BalancingKey != null)
                    hashCode = hashCode * 59 + this.BalancingKey.GetHashCode();
                if (this.DocumentDate != null)
                    hashCode = hashCode * 59 + this.DocumentDate.GetHashCode();
                if (this.CurrencyCode != null)
                    hashCode = hashCode * 59 + this.CurrencyCode.GetHashCode();
                if (this.ExchangeRate != null)
                    hashCode = hashCode * 59 + this.ExchangeRate.GetHashCode();
                if (this.Comment != null)
                    hashCode = hashCode * 59 + this.Comment.GetHashCode();
                if (this.Reference != null)
                    hashCode = hashCode * 59 + this.Reference.GetHashCode();
                if (this.DebetBookingAmount != null)
                    hashCode = hashCode * 59 + this.DebetBookingAmount.GetHashCode();
                if (this.CreditBookingAmount != null)
                    hashCode = hashCode * 59 + this.CreditBookingAmount.GetHashCode();
                if (this.DebetDocumentAmount != null)
                    hashCode = hashCode * 59 + this.DebetDocumentAmount.GetHashCode();
                if (this.CreditDocumentAmount != null)
                    hashCode = hashCode * 59 + this.CreditDocumentAmount.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
