/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// BalancingKeyServiceData
    /// </summary>
    [DataContract]
        public partial class BalancingKeyServiceData :  IEquatable<BalancingKeyServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BalancingKeyServiceData" /> class.
        /// </summary>
        /// <param name="bookyearKey">bookyearKey.</param>
        /// <param name="journalKey">journalKey.</param>
        /// <param name="documentSequenceNr">documentSequenceNr.</param>
        /// <param name="lineSequenceNr">lineSequenceNr.</param>
        public BalancingKeyServiceData(BookyearKey bookyearKey = default(BookyearKey), string journalKey = default(string), int? documentSequenceNr = default(int?), int? lineSequenceNr = default(int?))
        {
            this.BookyearKey = bookyearKey;
            this.JournalKey = journalKey;
            this.DocumentSequenceNr = documentSequenceNr;
            this.LineSequenceNr = lineSequenceNr;
        }
        
        /// <summary>
        /// Gets or Sets BookyearKey
        /// </summary>
        [DataMember(Name="bookyearKey", EmitDefaultValue=false)]
        public BookyearKey BookyearKey { get; set; }

        /// <summary>
        /// Gets or Sets JournalKey
        /// </summary>
        [DataMember(Name="journalKey", EmitDefaultValue=false)]
        public string JournalKey { get; set; }

        /// <summary>
        /// Gets or Sets DocumentSequenceNr
        /// </summary>
        [DataMember(Name="documentSequenceNr", EmitDefaultValue=false)]
        public int? DocumentSequenceNr { get; set; }

        /// <summary>
        /// Gets or Sets LineSequenceNr
        /// </summary>
        [DataMember(Name="lineSequenceNr", EmitDefaultValue=false)]
        public int? LineSequenceNr { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BalancingKeyServiceData {\n");
            sb.Append("  BookyearKey: ").Append(BookyearKey).Append("\n");
            sb.Append("  JournalKey: ").Append(JournalKey).Append("\n");
            sb.Append("  DocumentSequenceNr: ").Append(DocumentSequenceNr).Append("\n");
            sb.Append("  LineSequenceNr: ").Append(LineSequenceNr).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BalancingKeyServiceData);
        }

        /// <summary>
        /// Returns true if BalancingKeyServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of BalancingKeyServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BalancingKeyServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BookyearKey == input.BookyearKey ||
                    (this.BookyearKey != null &&
                    this.BookyearKey.Equals(input.BookyearKey))
                ) && 
                (
                    this.JournalKey == input.JournalKey ||
                    (this.JournalKey != null &&
                    this.JournalKey.Equals(input.JournalKey))
                ) && 
                (
                    this.DocumentSequenceNr == input.DocumentSequenceNr ||
                    (this.DocumentSequenceNr != null &&
                    this.DocumentSequenceNr.Equals(input.DocumentSequenceNr))
                ) && 
                (
                    this.LineSequenceNr == input.LineSequenceNr ||
                    (this.LineSequenceNr != null &&
                    this.LineSequenceNr.Equals(input.LineSequenceNr))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BookyearKey != null)
                    hashCode = hashCode * 59 + this.BookyearKey.GetHashCode();
                if (this.JournalKey != null)
                    hashCode = hashCode * 59 + this.JournalKey.GetHashCode();
                if (this.DocumentSequenceNr != null)
                    hashCode = hashCode * 59 + this.DocumentSequenceNr.GetHashCode();
                if (this.LineSequenceNr != null)
                    hashCode = hashCode * 59 + this.LineSequenceNr.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
