/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// BalancingServiceData
    /// </summary>
    [DataContract]
        public partial class BalancingServiceData :  IEquatable<BalancingServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BalancingServiceData" /> class.
        /// </summary>
        /// <param name="debetKey">debetKey.</param>
        /// <param name="creditKey">creditKey.</param>
        /// <param name="balanceAmount">balanceAmount.</param>
        public BalancingServiceData(BalancingKeyServiceData debetKey = default(BalancingKeyServiceData), BalancingKeyServiceData creditKey = default(BalancingKeyServiceData), double? balanceAmount = default(double?))
        {
            this.DebetKey = debetKey;
            this.CreditKey = creditKey;
            this.BalanceAmount = balanceAmount;
        }
        
        /// <summary>
        /// Gets or Sets DebetKey
        /// </summary>
        [DataMember(Name="debetKey", EmitDefaultValue=false)]
        public BalancingKeyServiceData DebetKey { get; set; }

        /// <summary>
        /// Gets or Sets CreditKey
        /// </summary>
        [DataMember(Name="creditKey", EmitDefaultValue=false)]
        public BalancingKeyServiceData CreditKey { get; set; }

        /// <summary>
        /// Gets or Sets BalanceAmount
        /// </summary>
        [DataMember(Name="balanceAmount", EmitDefaultValue=false)]
        public double? BalanceAmount { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BalancingServiceData {\n");
            sb.Append("  DebetKey: ").Append(DebetKey).Append("\n");
            sb.Append("  CreditKey: ").Append(CreditKey).Append("\n");
            sb.Append("  BalanceAmount: ").Append(BalanceAmount).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BalancingServiceData);
        }

        /// <summary>
        /// Returns true if BalancingServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of BalancingServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BalancingServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.DebetKey == input.DebetKey ||
                    (this.DebetKey != null &&
                    this.DebetKey.Equals(input.DebetKey))
                ) && 
                (
                    this.CreditKey == input.CreditKey ||
                    (this.CreditKey != null &&
                    this.CreditKey.Equals(input.CreditKey))
                ) && 
                (
                    this.BalanceAmount == input.BalanceAmount ||
                    (this.BalanceAmount != null &&
                    this.BalanceAmount.Equals(input.BalanceAmount))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DebetKey != null)
                    hashCode = hashCode * 59 + this.DebetKey.GetHashCode();
                if (this.CreditKey != null)
                    hashCode = hashCode * 59 + this.CreditKey.GetHashCode();
                if (this.BalanceAmount != null)
                    hashCode = hashCode * 59 + this.BalanceAmount.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
