/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// BalancingTypeServiceData
    /// </summary>
    [DataContract]
        public partial class BalancingTypeServiceData :  IEquatable<BalancingTypeServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BalancingTypeServiceData" /> class.
        /// </summary>
        /// <param name="type">type.</param>
        /// <param name="externalRelationId">externalRelationId.</param>
        /// <param name="relationKey">relationKey.</param>
        /// <param name="accountNr">accountNr.</param>
        public BalancingTypeServiceData(string type = default(string), int? externalRelationId = default(int?), RelationKey relationKey = default(RelationKey), int? accountNr = default(int?))
        {
            this.Type = type;
            this.ExternalRelationId = externalRelationId;
            this.RelationKey = relationKey;
            this.AccountNr = accountNr;
        }
        
        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name="type", EmitDefaultValue=false)]
        public string Type { get; set; }

        /// <summary>
        /// Gets or Sets ExternalRelationId
        /// </summary>
        [DataMember(Name="externalRelationId", EmitDefaultValue=false)]
        public int? ExternalRelationId { get; set; }

        /// <summary>
        /// Gets or Sets RelationKey
        /// </summary>
        [DataMember(Name="relationKey", EmitDefaultValue=false)]
        public RelationKey RelationKey { get; set; }

        /// <summary>
        /// Gets or Sets AccountNr
        /// </summary>
        [DataMember(Name="accountNr", EmitDefaultValue=false)]
        public int? AccountNr { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BalancingTypeServiceData {\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  ExternalRelationId: ").Append(ExternalRelationId).Append("\n");
            sb.Append("  RelationKey: ").Append(RelationKey).Append("\n");
            sb.Append("  AccountNr: ").Append(AccountNr).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BalancingTypeServiceData);
        }

        /// <summary>
        /// Returns true if BalancingTypeServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of BalancingTypeServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BalancingTypeServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.ExternalRelationId == input.ExternalRelationId ||
                    (this.ExternalRelationId != null &&
                    this.ExternalRelationId.Equals(input.ExternalRelationId))
                ) && 
                (
                    this.RelationKey == input.RelationKey ||
                    (this.RelationKey != null &&
                    this.RelationKey.Equals(input.RelationKey))
                ) && 
                (
                    this.AccountNr == input.AccountNr ||
                    (this.AccountNr != null &&
                    this.AccountNr.Equals(input.AccountNr))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.ExternalRelationId != null)
                    hashCode = hashCode * 59 + this.ExternalRelationId.GetHashCode();
                if (this.RelationKey != null)
                    hashCode = hashCode * 59 + this.RelationKey.GetHashCode();
                if (this.AccountNr != null)
                    hashCode = hashCode * 59 + this.AccountNr.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
