/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Modified bookings list
    /// </summary>
    [DataContract]
        public partial class BookingReportData :  IEquatable<BookingReportData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BookingReportData" /> class.
        /// </summary>
        /// <param name="bookyearKey">bookyearKey.</param>
        /// <param name="journalType">journalType.</param>
        /// <param name="journalNr">journalNr.</param>
        /// <param name="documentSequenceNr">documentSequenceNr.</param>
        /// <param name="lineSequenceNr">lineSequenceNr.</param>
        /// <param name="bookyearPeriodeNr">bookyearPeriodeNr.</param>
        /// <param name="documentDate">documentDate.</param>
        /// <param name="expiryDate">expiryDate.</param>
        /// <param name="currencyCode">currencyCode.</param>
        /// <param name="exchangeRate">exchangeRate.</param>
        /// <param name="relationKey">relationKey.</param>
        /// <param name="comment">comment.</param>
        /// <param name="reference">reference.</param>
        /// <param name="accountKey">accountKey.</param>
        /// <param name="bookingAmount">bookingAmount.</param>
        /// <param name="documentAmount">documentAmount.</param>
        /// <param name="vatSectionCode">vatSectionCode.</param>
        /// <param name="vatRecuperationPercentage">vatRecuperationPercentage.</param>
        /// <param name="costCentreKey">costCentreKey.</param>
        public BookingReportData(BookyearKey bookyearKey = default(BookyearKey), int? journalType = default(int?), int? journalNr = default(int?), int? documentSequenceNr = default(int?), int? lineSequenceNr = default(int?), int? bookyearPeriodeNr = default(int?), DateTime? documentDate = default(DateTime?), DateTime? expiryDate = default(DateTime?), string currencyCode = default(string), double? exchangeRate = default(double?), RelationKey relationKey = default(RelationKey), string comment = default(string), string reference = default(string), int? accountKey = default(int?), double? bookingAmount = default(double?), double? documentAmount = default(double?), string vatSectionCode = default(string), double? vatRecuperationPercentage = default(double?), CostCentreKey costCentreKey = default(CostCentreKey))
        {
            this.BookyearKey = bookyearKey;
            this.JournalType = journalType;
            this.JournalNr = journalNr;
            this.DocumentSequenceNr = documentSequenceNr;
            this.LineSequenceNr = lineSequenceNr;
            this.BookyearPeriodeNr = bookyearPeriodeNr;
            this.DocumentDate = documentDate;
            this.ExpiryDate = expiryDate;
            this.CurrencyCode = currencyCode;
            this.ExchangeRate = exchangeRate;
            this.RelationKey = relationKey;
            this.Comment = comment;
            this.Reference = reference;
            this.AccountKey = accountKey;
            this.BookingAmount = bookingAmount;
            this.DocumentAmount = documentAmount;
            this.VatSectionCode = vatSectionCode;
            this.VatRecuperationPercentage = vatRecuperationPercentage;
            this.CostCentreKey = costCentreKey;
        }
        
        /// <summary>
        /// Gets or Sets BookyearKey
        /// </summary>
        [DataMember(Name="bookyearKey", EmitDefaultValue=false)]
        public BookyearKey BookyearKey { get; set; }

        /// <summary>
        /// Gets or Sets JournalType
        /// </summary>
        [DataMember(Name="journalType", EmitDefaultValue=false)]
        public int? JournalType { get; set; }

        /// <summary>
        /// Gets or Sets JournalNr
        /// </summary>
        [DataMember(Name="journalNr", EmitDefaultValue=false)]
        public int? JournalNr { get; set; }

        /// <summary>
        /// Gets or Sets DocumentSequenceNr
        /// </summary>
        [DataMember(Name="documentSequenceNr", EmitDefaultValue=false)]
        public int? DocumentSequenceNr { get; set; }

        /// <summary>
        /// Gets or Sets LineSequenceNr
        /// </summary>
        [DataMember(Name="lineSequenceNr", EmitDefaultValue=false)]
        public int? LineSequenceNr { get; set; }

        /// <summary>
        /// Gets or Sets BookyearPeriodeNr
        /// </summary>
        [DataMember(Name="bookyearPeriodeNr", EmitDefaultValue=false)]
        public int? BookyearPeriodeNr { get; set; }

        /// <summary>
        /// Gets or Sets DocumentDate
        /// </summary>
        [DataMember(Name="documentDate", EmitDefaultValue=false)]
        public DateTime? DocumentDate { get; set; }

        /// <summary>
        /// Gets or Sets ExpiryDate
        /// </summary>
        [DataMember(Name="expiryDate", EmitDefaultValue=false)]
        public DateTime? ExpiryDate { get; set; }

        /// <summary>
        /// Gets or Sets CurrencyCode
        /// </summary>
        [DataMember(Name="currencyCode", EmitDefaultValue=false)]
        public string CurrencyCode { get; set; }

        /// <summary>
        /// Gets or Sets ExchangeRate
        /// </summary>
        [DataMember(Name="exchangeRate", EmitDefaultValue=false)]
        public double? ExchangeRate { get; set; }

        /// <summary>
        /// Gets or Sets RelationKey
        /// </summary>
        [DataMember(Name="relationKey", EmitDefaultValue=false)]
        public RelationKey RelationKey { get; set; }

        /// <summary>
        /// Gets or Sets Comment
        /// </summary>
        [DataMember(Name="comment", EmitDefaultValue=false)]
        public string Comment { get; set; }

        /// <summary>
        /// Gets or Sets Reference
        /// </summary>
        [DataMember(Name="reference", EmitDefaultValue=false)]
        public string Reference { get; set; }

        /// <summary>
        /// Gets or Sets AccountKey
        /// </summary>
        [DataMember(Name="accountKey", EmitDefaultValue=false)]
        public int? AccountKey { get; set; }

        /// <summary>
        /// Gets or Sets BookingAmount
        /// </summary>
        [DataMember(Name="bookingAmount", EmitDefaultValue=false)]
        public double? BookingAmount { get; set; }

        /// <summary>
        /// Gets or Sets DocumentAmount
        /// </summary>
        [DataMember(Name="documentAmount", EmitDefaultValue=false)]
        public double? DocumentAmount { get; set; }

        /// <summary>
        /// Gets or Sets VatSectionCode
        /// </summary>
        [DataMember(Name="vatSectionCode", EmitDefaultValue=false)]
        public string VatSectionCode { get; set; }

        /// <summary>
        /// Gets or Sets VatRecuperationPercentage
        /// </summary>
        [DataMember(Name="vatRecuperationPercentage", EmitDefaultValue=false)]
        public double? VatRecuperationPercentage { get; set; }

        /// <summary>
        /// Gets or Sets CostCentreKey
        /// </summary>
        [DataMember(Name="costCentreKey", EmitDefaultValue=false)]
        public CostCentreKey CostCentreKey { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BookingReportData {\n");
            sb.Append("  BookyearKey: ").Append(BookyearKey).Append("\n");
            sb.Append("  JournalType: ").Append(JournalType).Append("\n");
            sb.Append("  JournalNr: ").Append(JournalNr).Append("\n");
            sb.Append("  DocumentSequenceNr: ").Append(DocumentSequenceNr).Append("\n");
            sb.Append("  LineSequenceNr: ").Append(LineSequenceNr).Append("\n");
            sb.Append("  BookyearPeriodeNr: ").Append(BookyearPeriodeNr).Append("\n");
            sb.Append("  DocumentDate: ").Append(DocumentDate).Append("\n");
            sb.Append("  ExpiryDate: ").Append(ExpiryDate).Append("\n");
            sb.Append("  CurrencyCode: ").Append(CurrencyCode).Append("\n");
            sb.Append("  ExchangeRate: ").Append(ExchangeRate).Append("\n");
            sb.Append("  RelationKey: ").Append(RelationKey).Append("\n");
            sb.Append("  Comment: ").Append(Comment).Append("\n");
            sb.Append("  Reference: ").Append(Reference).Append("\n");
            sb.Append("  AccountKey: ").Append(AccountKey).Append("\n");
            sb.Append("  BookingAmount: ").Append(BookingAmount).Append("\n");
            sb.Append("  DocumentAmount: ").Append(DocumentAmount).Append("\n");
            sb.Append("  VatSectionCode: ").Append(VatSectionCode).Append("\n");
            sb.Append("  VatRecuperationPercentage: ").Append(VatRecuperationPercentage).Append("\n");
            sb.Append("  CostCentreKey: ").Append(CostCentreKey).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BookingReportData);
        }

        /// <summary>
        /// Returns true if BookingReportData instances are equal
        /// </summary>
        /// <param name="input">Instance of BookingReportData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BookingReportData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BookyearKey == input.BookyearKey ||
                    (this.BookyearKey != null &&
                    this.BookyearKey.Equals(input.BookyearKey))
                ) && 
                (
                    this.JournalType == input.JournalType ||
                    (this.JournalType != null &&
                    this.JournalType.Equals(input.JournalType))
                ) && 
                (
                    this.JournalNr == input.JournalNr ||
                    (this.JournalNr != null &&
                    this.JournalNr.Equals(input.JournalNr))
                ) && 
                (
                    this.DocumentSequenceNr == input.DocumentSequenceNr ||
                    (this.DocumentSequenceNr != null &&
                    this.DocumentSequenceNr.Equals(input.DocumentSequenceNr))
                ) && 
                (
                    this.LineSequenceNr == input.LineSequenceNr ||
                    (this.LineSequenceNr != null &&
                    this.LineSequenceNr.Equals(input.LineSequenceNr))
                ) && 
                (
                    this.BookyearPeriodeNr == input.BookyearPeriodeNr ||
                    (this.BookyearPeriodeNr != null &&
                    this.BookyearPeriodeNr.Equals(input.BookyearPeriodeNr))
                ) && 
                (
                    this.DocumentDate == input.DocumentDate ||
                    (this.DocumentDate != null &&
                    this.DocumentDate.Equals(input.DocumentDate))
                ) && 
                (
                    this.ExpiryDate == input.ExpiryDate ||
                    (this.ExpiryDate != null &&
                    this.ExpiryDate.Equals(input.ExpiryDate))
                ) && 
                (
                    this.CurrencyCode == input.CurrencyCode ||
                    (this.CurrencyCode != null &&
                    this.CurrencyCode.Equals(input.CurrencyCode))
                ) && 
                (
                    this.ExchangeRate == input.ExchangeRate ||
                    (this.ExchangeRate != null &&
                    this.ExchangeRate.Equals(input.ExchangeRate))
                ) && 
                (
                    this.RelationKey == input.RelationKey ||
                    (this.RelationKey != null &&
                    this.RelationKey.Equals(input.RelationKey))
                ) && 
                (
                    this.Comment == input.Comment ||
                    (this.Comment != null &&
                    this.Comment.Equals(input.Comment))
                ) && 
                (
                    this.Reference == input.Reference ||
                    (this.Reference != null &&
                    this.Reference.Equals(input.Reference))
                ) && 
                (
                    this.AccountKey == input.AccountKey ||
                    (this.AccountKey != null &&
                    this.AccountKey.Equals(input.AccountKey))
                ) && 
                (
                    this.BookingAmount == input.BookingAmount ||
                    (this.BookingAmount != null &&
                    this.BookingAmount.Equals(input.BookingAmount))
                ) && 
                (
                    this.DocumentAmount == input.DocumentAmount ||
                    (this.DocumentAmount != null &&
                    this.DocumentAmount.Equals(input.DocumentAmount))
                ) && 
                (
                    this.VatSectionCode == input.VatSectionCode ||
                    (this.VatSectionCode != null &&
                    this.VatSectionCode.Equals(input.VatSectionCode))
                ) && 
                (
                    this.VatRecuperationPercentage == input.VatRecuperationPercentage ||
                    (this.VatRecuperationPercentage != null &&
                    this.VatRecuperationPercentage.Equals(input.VatRecuperationPercentage))
                ) && 
                (
                    this.CostCentreKey == input.CostCentreKey ||
                    (this.CostCentreKey != null &&
                    this.CostCentreKey.Equals(input.CostCentreKey))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BookyearKey != null)
                    hashCode = hashCode * 59 + this.BookyearKey.GetHashCode();
                if (this.JournalType != null)
                    hashCode = hashCode * 59 + this.JournalType.GetHashCode();
                if (this.JournalNr != null)
                    hashCode = hashCode * 59 + this.JournalNr.GetHashCode();
                if (this.DocumentSequenceNr != null)
                    hashCode = hashCode * 59 + this.DocumentSequenceNr.GetHashCode();
                if (this.LineSequenceNr != null)
                    hashCode = hashCode * 59 + this.LineSequenceNr.GetHashCode();
                if (this.BookyearPeriodeNr != null)
                    hashCode = hashCode * 59 + this.BookyearPeriodeNr.GetHashCode();
                if (this.DocumentDate != null)
                    hashCode = hashCode * 59 + this.DocumentDate.GetHashCode();
                if (this.ExpiryDate != null)
                    hashCode = hashCode * 59 + this.ExpiryDate.GetHashCode();
                if (this.CurrencyCode != null)
                    hashCode = hashCode * 59 + this.CurrencyCode.GetHashCode();
                if (this.ExchangeRate != null)
                    hashCode = hashCode * 59 + this.ExchangeRate.GetHashCode();
                if (this.RelationKey != null)
                    hashCode = hashCode * 59 + this.RelationKey.GetHashCode();
                if (this.Comment != null)
                    hashCode = hashCode * 59 + this.Comment.GetHashCode();
                if (this.Reference != null)
                    hashCode = hashCode * 59 + this.Reference.GetHashCode();
                if (this.AccountKey != null)
                    hashCode = hashCode * 59 + this.AccountKey.GetHashCode();
                if (this.BookingAmount != null)
                    hashCode = hashCode * 59 + this.BookingAmount.GetHashCode();
                if (this.DocumentAmount != null)
                    hashCode = hashCode * 59 + this.DocumentAmount.GetHashCode();
                if (this.VatSectionCode != null)
                    hashCode = hashCode * 59 + this.VatSectionCode.GetHashCode();
                if (this.VatRecuperationPercentage != null)
                    hashCode = hashCode * 59 + this.VatRecuperationPercentage.GetHashCode();
                if (this.CostCentreKey != null)
                    hashCode = hashCode * 59 + this.CostCentreKey.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
