/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// The periods belonging to this bookyear
    /// </summary>
    [DataContract]
        public partial class BookyearPeriodServiceData :  IEquatable<BookyearPeriodServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BookyearPeriodServiceData" /> class.
        /// </summary>
        /// <param name="bookyearPeriod">Key identifying the bookyear period (required).</param>
        /// <param name="startDate">The start date of this bookyear period (required).</param>
        /// <param name="endDate">The end date of this bookyear period (required).</param>
        public BookyearPeriodServiceData(int? bookyearPeriod = default(int?), DateTime? startDate = default(DateTime?), DateTime? endDate = default(DateTime?))
        {
            // to ensure "bookyearPeriod" is required (not null)
            if (bookyearPeriod == null)
            {
                throw new InvalidDataException("bookyearPeriod is a required property for BookyearPeriodServiceData and cannot be null");
            }
            else
            {
                this.BookyearPeriod = bookyearPeriod;
            }
            // to ensure "startDate" is required (not null)
            if (startDate == null)
            {
                throw new InvalidDataException("startDate is a required property for BookyearPeriodServiceData and cannot be null");
            }
            else
            {
                this.StartDate = startDate;
            }
            // to ensure "endDate" is required (not null)
            if (endDate == null)
            {
                throw new InvalidDataException("endDate is a required property for BookyearPeriodServiceData and cannot be null");
            }
            else
            {
                this.EndDate = endDate;
            }
        }
        
        /// <summary>
        /// Key identifying the bookyear period
        /// </summary>
        /// <value>Key identifying the bookyear period</value>
        [DataMember(Name="bookyearPeriod", EmitDefaultValue=false)]
        public int? BookyearPeriod { get; set; }

        /// <summary>
        /// The start date of this bookyear period
        /// </summary>
        /// <value>The start date of this bookyear period</value>
        [DataMember(Name="startDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? StartDate { get; set; }

        /// <summary>
        /// The end date of this bookyear period
        /// </summary>
        /// <value>The end date of this bookyear period</value>
        [DataMember(Name="endDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? EndDate { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BookyearPeriodServiceData {\n");
            sb.Append("  BookyearPeriod: ").Append(BookyearPeriod).Append("\n");
            sb.Append("  StartDate: ").Append(StartDate).Append("\n");
            sb.Append("  EndDate: ").Append(EndDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BookyearPeriodServiceData);
        }

        /// <summary>
        /// Returns true if BookyearPeriodServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of BookyearPeriodServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BookyearPeriodServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BookyearPeriod == input.BookyearPeriod ||
                    (this.BookyearPeriod != null &&
                    this.BookyearPeriod.Equals(input.BookyearPeriod))
                ) && 
                (
                    this.StartDate == input.StartDate ||
                    (this.StartDate != null &&
                    this.StartDate.Equals(input.StartDate))
                ) && 
                (
                    this.EndDate == input.EndDate ||
                    (this.EndDate != null &&
                    this.EndDate.Equals(input.EndDate))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BookyearPeriod != null)
                    hashCode = hashCode * 59 + this.BookyearPeriod.GetHashCode();
                if (this.StartDate != null)
                    hashCode = hashCode * 59 + this.StartDate.GetHashCode();
                if (this.EndDate != null)
                    hashCode = hashCode * 59 + this.EndDate.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
