/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// BookyearServiceData
    /// </summary>
    [DataContract]
        public partial class BookyearServiceData :  IEquatable<BookyearServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BookyearServiceData" /> class.
        /// </summary>
        /// <param name="bookyearKey">bookyearKey (required).</param>
        /// <param name="bookyearDescription">The description of the bookyear in the users locale.</param>
        /// <param name="startDate">The start date of this bookyear (required).</param>
        /// <param name="endDate">The end date of this bookyear (required).</param>
        /// <param name="closed">Check if the bookyear is closed (required).</param>
        /// <param name="periods">The periods belonging to this bookyear.</param>
        public BookyearServiceData(BookyearKey bookyearKey = default(BookyearKey), string bookyearDescription = default(string), DateTime? startDate = default(DateTime?), DateTime? endDate = default(DateTime?), bool? closed = default(bool?), List<BookyearPeriodServiceData> periods = default(List<BookyearPeriodServiceData>))
        {
            // to ensure "bookyearKey" is required (not null)
            if (bookyearKey == null)
            {
                throw new InvalidDataException("bookyearKey is a required property for BookyearServiceData and cannot be null");
            }
            else
            {
                this.BookyearKey = bookyearKey;
            }
            // to ensure "startDate" is required (not null)
            if (startDate == null)
            {
                throw new InvalidDataException("startDate is a required property for BookyearServiceData and cannot be null");
            }
            else
            {
                this.StartDate = startDate;
            }
            // to ensure "endDate" is required (not null)
            if (endDate == null)
            {
                throw new InvalidDataException("endDate is a required property for BookyearServiceData and cannot be null");
            }
            else
            {
                this.EndDate = endDate;
            }
            // to ensure "closed" is required (not null)
            if (closed == null)
            {
                throw new InvalidDataException("closed is a required property for BookyearServiceData and cannot be null");
            }
            else
            {
                this.Closed = closed;
            }
            this.BookyearDescription = bookyearDescription;
            this.Periods = periods;
        }
        
        /// <summary>
        /// Gets or Sets BookyearKey
        /// </summary>
        [DataMember(Name="bookyearKey", EmitDefaultValue=false)]
        public BookyearKey BookyearKey { get; set; }

        /// <summary>
        /// The description of the bookyear in the users locale
        /// </summary>
        /// <value>The description of the bookyear in the users locale</value>
        [DataMember(Name="bookyearDescription", EmitDefaultValue=false)]
        public string BookyearDescription { get; set; }

        /// <summary>
        /// The start date of this bookyear
        /// </summary>
        /// <value>The start date of this bookyear</value>
        [DataMember(Name="startDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? StartDate { get; set; }

        /// <summary>
        /// The end date of this bookyear
        /// </summary>
        /// <value>The end date of this bookyear</value>
        [DataMember(Name="endDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? EndDate { get; set; }

        /// <summary>
        /// Check if the bookyear is closed
        /// </summary>
        /// <value>Check if the bookyear is closed</value>
        [DataMember(Name="closed", EmitDefaultValue=false)]
        public bool? Closed { get; set; }

        /// <summary>
        /// The periods belonging to this bookyear
        /// </summary>
        /// <value>The periods belonging to this bookyear</value>
        [DataMember(Name="periods", EmitDefaultValue=false)]
        public List<BookyearPeriodServiceData> Periods { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BookyearServiceData {\n");
            sb.Append("  BookyearKey: ").Append(BookyearKey).Append("\n");
            sb.Append("  BookyearDescription: ").Append(BookyearDescription).Append("\n");
            sb.Append("  StartDate: ").Append(StartDate).Append("\n");
            sb.Append("  EndDate: ").Append(EndDate).Append("\n");
            sb.Append("  Closed: ").Append(Closed).Append("\n");
            sb.Append("  Periods: ").Append(Periods).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BookyearServiceData);
        }

        /// <summary>
        /// Returns true if BookyearServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of BookyearServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BookyearServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BookyearKey == input.BookyearKey ||
                    (this.BookyearKey != null &&
                    this.BookyearKey.Equals(input.BookyearKey))
                ) && 
                (
                    this.BookyearDescription == input.BookyearDescription ||
                    (this.BookyearDescription != null &&
                    this.BookyearDescription.Equals(input.BookyearDescription))
                ) && 
                (
                    this.StartDate == input.StartDate ||
                    (this.StartDate != null &&
                    this.StartDate.Equals(input.StartDate))
                ) && 
                (
                    this.EndDate == input.EndDate ||
                    (this.EndDate != null &&
                    this.EndDate.Equals(input.EndDate))
                ) && 
                (
                    this.Closed == input.Closed ||
                    (this.Closed != null &&
                    this.Closed.Equals(input.Closed))
                ) && 
                (
                    this.Periods == input.Periods ||
                    this.Periods != null &&
                    input.Periods != null &&
                    this.Periods.SequenceEqual(input.Periods)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BookyearKey != null)
                    hashCode = hashCode * 59 + this.BookyearKey.GetHashCode();
                if (this.BookyearDescription != null)
                    hashCode = hashCode * 59 + this.BookyearDescription.GetHashCode();
                if (this.StartDate != null)
                    hashCode = hashCode * 59 + this.StartDate.GetHashCode();
                if (this.EndDate != null)
                    hashCode = hashCode * 59 + this.EndDate.GetHashCode();
                if (this.Closed != null)
                    hashCode = hashCode * 59 + this.Closed.GetHashCode();
                if (this.Periods != null)
                    hashCode = hashCode * 59 + this.Periods.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
