/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Buy Sell Bookings and attachment list
    /// </summary>
    [DataContract]
        public partial class BuySellBookingAndAttachmentRequest :  IEquatable<BuySellBookingAndAttachmentRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BuySellBookingAndAttachmentRequest" /> class.
        /// </summary>
        /// <param name="buySellBookingServiceData">buySellBookingServiceData.</param>
        /// <param name="attachments">Attachments list.</param>
        public BuySellBookingAndAttachmentRequest(BuySellBookingServiceData buySellBookingServiceData = default(BuySellBookingServiceData), List<AttachementData> attachments = default(List<AttachementData>))
        {
            this.BuySellBookingServiceData = buySellBookingServiceData;
            this.Attachments = attachments;
        }
        
        /// <summary>
        /// Gets or Sets BuySellBookingServiceData
        /// </summary>
        [DataMember(Name="buySellBookingServiceData", EmitDefaultValue=false)]
        public BuySellBookingServiceData BuySellBookingServiceData { get; set; }

        /// <summary>
        /// Attachments list
        /// </summary>
        /// <value>Attachments list</value>
        [DataMember(Name="attachments", EmitDefaultValue=false)]
        public List<AttachementData> Attachments { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BuySellBookingAndAttachmentRequest {\n");
            sb.Append("  BuySellBookingServiceData: ").Append(BuySellBookingServiceData).Append("\n");
            sb.Append("  Attachments: ").Append(Attachments).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BuySellBookingAndAttachmentRequest);
        }

        /// <summary>
        /// Returns true if BuySellBookingAndAttachmentRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of BuySellBookingAndAttachmentRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BuySellBookingAndAttachmentRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BuySellBookingServiceData == input.BuySellBookingServiceData ||
                    (this.BuySellBookingServiceData != null &&
                    this.BuySellBookingServiceData.Equals(input.BuySellBookingServiceData))
                ) && 
                (
                    this.Attachments == input.Attachments ||
                    this.Attachments != null &&
                    input.Attachments != null &&
                    this.Attachments.SequenceEqual(input.Attachments)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BuySellBookingServiceData != null)
                    hashCode = hashCode * 59 + this.BuySellBookingServiceData.GetHashCode();
                if (this.Attachments != null)
                    hashCode = hashCode * 59 + this.Attachments.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
