/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Booking Lines
    /// </summary>
    [DataContract]
        public partial class BuySellBookingLineServiceData :  IEquatable<BuySellBookingLineServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BuySellBookingLineServiceData" /> class.
        /// </summary>
        /// <param name="accountKey">Account of the booking line.</param>
        /// <param name="baseAmount">Base Amount.</param>
        /// <param name="vatCodeKey">Vat Code ( ex : D06 , I21 , 06 , .. ).</param>
        /// <param name="vatAmount">VAT Amount.</param>
        /// <param name="comment">Line Comment.</param>
        /// <param name="costCentreKey">costCentreKey.</param>
        /// <param name="vatRecupPercentage">VAT Recuperation Percentage ( optional, default specified by account ).</param>
        /// <param name="intrastatServiceData">intrastatServiceData.</param>
        /// <param name="overflowBookingServiceData">overflowBookingServiceData.</param>
        public BuySellBookingLineServiceData(int? accountKey = default(int?), double? baseAmount = default(double?), string vatCodeKey = default(string), double? vatAmount = default(double?), string comment = default(string), CostCentreKey costCentreKey = default(CostCentreKey), double? vatRecupPercentage = default(double?), IntrastatServiceData intrastatServiceData = default(IntrastatServiceData), OverflowBookingServiceData overflowBookingServiceData = default(OverflowBookingServiceData))
        {
            this.AccountKey = accountKey;
            this.BaseAmount = baseAmount;
            this.VatCodeKey = vatCodeKey;
            this.VatAmount = vatAmount;
            this.Comment = comment;
            this.CostCentreKey = costCentreKey;
            this.VatRecupPercentage = vatRecupPercentage;
            this.IntrastatServiceData = intrastatServiceData;
            this.OverflowBookingServiceData = overflowBookingServiceData;
        }
        
        /// <summary>
        /// Account of the booking line
        /// </summary>
        /// <value>Account of the booking line</value>
        [DataMember(Name="accountKey", EmitDefaultValue=false)]
        public int? AccountKey { get; set; }

        /// <summary>
        /// Base Amount
        /// </summary>
        /// <value>Base Amount</value>
        [DataMember(Name="baseAmount", EmitDefaultValue=false)]
        public double? BaseAmount { get; set; }

        /// <summary>
        /// Vat Code ( ex : D06 , I21 , 06 , .. )
        /// </summary>
        /// <value>Vat Code ( ex : D06 , I21 , 06 , .. )</value>
        [DataMember(Name="vatCodeKey", EmitDefaultValue=false)]
        public string VatCodeKey { get; set; }

        /// <summary>
        /// VAT Amount
        /// </summary>
        /// <value>VAT Amount</value>
        [DataMember(Name="vatAmount", EmitDefaultValue=false)]
        public double? VatAmount { get; set; }

        /// <summary>
        /// Line Comment
        /// </summary>
        /// <value>Line Comment</value>
        [DataMember(Name="comment", EmitDefaultValue=false)]
        public string Comment { get; set; }

        /// <summary>
        /// Gets or Sets CostCentreKey
        /// </summary>
        [DataMember(Name="costCentreKey", EmitDefaultValue=false)]
        public CostCentreKey CostCentreKey { get; set; }

        /// <summary>
        /// VAT Recuperation Percentage ( optional, default specified by account )
        /// </summary>
        /// <value>VAT Recuperation Percentage ( optional, default specified by account )</value>
        [DataMember(Name="vatRecupPercentage", EmitDefaultValue=false)]
        public double? VatRecupPercentage { get; set; }

        /// <summary>
        /// Gets or Sets IntrastatServiceData
        /// </summary>
        [DataMember(Name="intrastatServiceData", EmitDefaultValue=false)]
        public IntrastatServiceData IntrastatServiceData { get; set; }

        /// <summary>
        /// Gets or Sets OverflowBookingServiceData
        /// </summary>
        [DataMember(Name="overflowBookingServiceData", EmitDefaultValue=false)]
        public OverflowBookingServiceData OverflowBookingServiceData { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BuySellBookingLineServiceData {\n");
            sb.Append("  AccountKey: ").Append(AccountKey).Append("\n");
            sb.Append("  BaseAmount: ").Append(BaseAmount).Append("\n");
            sb.Append("  VatCodeKey: ").Append(VatCodeKey).Append("\n");
            sb.Append("  VatAmount: ").Append(VatAmount).Append("\n");
            sb.Append("  Comment: ").Append(Comment).Append("\n");
            sb.Append("  CostCentreKey: ").Append(CostCentreKey).Append("\n");
            sb.Append("  VatRecupPercentage: ").Append(VatRecupPercentage).Append("\n");
            sb.Append("  IntrastatServiceData: ").Append(IntrastatServiceData).Append("\n");
            sb.Append("  OverflowBookingServiceData: ").Append(OverflowBookingServiceData).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BuySellBookingLineServiceData);
        }

        /// <summary>
        /// Returns true if BuySellBookingLineServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of BuySellBookingLineServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BuySellBookingLineServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.AccountKey == input.AccountKey ||
                    (this.AccountKey != null &&
                    this.AccountKey.Equals(input.AccountKey))
                ) && 
                (
                    this.BaseAmount == input.BaseAmount ||
                    (this.BaseAmount != null &&
                    this.BaseAmount.Equals(input.BaseAmount))
                ) && 
                (
                    this.VatCodeKey == input.VatCodeKey ||
                    (this.VatCodeKey != null &&
                    this.VatCodeKey.Equals(input.VatCodeKey))
                ) && 
                (
                    this.VatAmount == input.VatAmount ||
                    (this.VatAmount != null &&
                    this.VatAmount.Equals(input.VatAmount))
                ) && 
                (
                    this.Comment == input.Comment ||
                    (this.Comment != null &&
                    this.Comment.Equals(input.Comment))
                ) && 
                (
                    this.CostCentreKey == input.CostCentreKey ||
                    (this.CostCentreKey != null &&
                    this.CostCentreKey.Equals(input.CostCentreKey))
                ) && 
                (
                    this.VatRecupPercentage == input.VatRecupPercentage ||
                    (this.VatRecupPercentage != null &&
                    this.VatRecupPercentage.Equals(input.VatRecupPercentage))
                ) && 
                (
                    this.IntrastatServiceData == input.IntrastatServiceData ||
                    (this.IntrastatServiceData != null &&
                    this.IntrastatServiceData.Equals(input.IntrastatServiceData))
                ) && 
                (
                    this.OverflowBookingServiceData == input.OverflowBookingServiceData ||
                    (this.OverflowBookingServiceData != null &&
                    this.OverflowBookingServiceData.Equals(input.OverflowBookingServiceData))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.AccountKey != null)
                    hashCode = hashCode * 59 + this.AccountKey.GetHashCode();
                if (this.BaseAmount != null)
                    hashCode = hashCode * 59 + this.BaseAmount.GetHashCode();
                if (this.VatCodeKey != null)
                    hashCode = hashCode * 59 + this.VatCodeKey.GetHashCode();
                if (this.VatAmount != null)
                    hashCode = hashCode * 59 + this.VatAmount.GetHashCode();
                if (this.Comment != null)
                    hashCode = hashCode * 59 + this.Comment.GetHashCode();
                if (this.CostCentreKey != null)
                    hashCode = hashCode * 59 + this.CostCentreKey.GetHashCode();
                if (this.VatRecupPercentage != null)
                    hashCode = hashCode * 59 + this.VatRecupPercentage.GetHashCode();
                if (this.IntrastatServiceData != null)
                    hashCode = hashCode * 59 + this.IntrastatServiceData.GetHashCode();
                if (this.OverflowBookingServiceData != null)
                    hashCode = hashCode * 59 + this.OverflowBookingServiceData.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
