/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// BuySellBookingServiceData
    /// </summary>
    [DataContract]
        public partial class BuySellBookingServiceData :  IEquatable<BuySellBookingServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BuySellBookingServiceData" /> class.
        /// </summary>
        /// <param name="bookyearKey">bookyearKey (required).</param>
        /// <param name="journalKey">Journal Identification (required).</param>
        /// <param name="documentSequenceNr">Document number identification (required).</param>
        /// <param name="relationIdentificationServiceData">relationIdentificationServiceData (required).</param>
        /// <param name="bookyearPeriodeNr">Bookyear Period identification (required).</param>
        /// <param name="documentDate">Document Date (required).</param>
        /// <param name="expiryDate">Expiry Date (required).</param>
        /// <param name="comment">Comment.</param>
        /// <param name="reference">Reference.</param>
        /// <param name="amount">Total booking amount (required).</param>
        /// <param name="currencyCode">Currency Code (required).</param>
        /// <param name="exchangeRate">Exchange Rate (required).</param>
        /// <param name="bookingLines">Booking Lines.</param>
        /// <param name="paymentMethod">Type of payment : &lt;ul&gt;&lt;li&gt;Value 0 : Unknown&lt;/li&gt;&lt;li&gt;Value 1 : Bank Transfer&lt;/li&gt;&lt;li&gt;Value 2 : Cash&lt;/li&gt;&lt;li&gt;Value 3 : Creditcard&lt;/li&gt;&lt;li&gt;Value 4 : Domiciliering (Direct Debit)&lt;/li&gt;&lt;/ul&gt;.</param>
        public BuySellBookingServiceData(BookyearKey bookyearKey = default(BookyearKey), string journalKey = default(string), int? documentSequenceNr = default(int?), RelationIdentificationServiceData relationIdentificationServiceData = default(RelationIdentificationServiceData), int? bookyearPeriodeNr = default(int?), DateTime? documentDate = default(DateTime?), DateTime? expiryDate = default(DateTime?), string comment = default(string), string reference = default(string), double? amount = default(double?), string currencyCode = default(string), double? exchangeRate = default(double?), List<BuySellBookingLineServiceData> bookingLines = default(List<BuySellBookingLineServiceData>), int? paymentMethod = default(int?))
        {
            // to ensure "bookyearKey" is required (not null)
            if (bookyearKey == null)
            {
                throw new InvalidDataException("bookyearKey is a required property for BuySellBookingServiceData and cannot be null");
            }
            else
            {
                this.BookyearKey = bookyearKey;
            }
            // to ensure "journalKey" is required (not null)
            if (journalKey == null)
            {
                throw new InvalidDataException("journalKey is a required property for BuySellBookingServiceData and cannot be null");
            }
            else
            {
                this.JournalKey = journalKey;
            }
            // to ensure "documentSequenceNr" is required (not null)
            if (documentSequenceNr == null)
            {
                throw new InvalidDataException("documentSequenceNr is a required property for BuySellBookingServiceData and cannot be null");
            }
            else
            {
                this.DocumentSequenceNr = documentSequenceNr;
            }
            // to ensure "relationIdentificationServiceData" is required (not null)
            if (relationIdentificationServiceData == null)
            {
                throw new InvalidDataException("relationIdentificationServiceData is a required property for BuySellBookingServiceData and cannot be null");
            }
            else
            {
                this.RelationIdentificationServiceData = relationIdentificationServiceData;
            }
            // to ensure "bookyearPeriodeNr" is required (not null)
            if (bookyearPeriodeNr == null)
            {
                throw new InvalidDataException("bookyearPeriodeNr is a required property for BuySellBookingServiceData and cannot be null");
            }
            else
            {
                this.BookyearPeriodeNr = bookyearPeriodeNr;
            }
            // to ensure "documentDate" is required (not null)
            if (documentDate == null)
            {
                throw new InvalidDataException("documentDate is a required property for BuySellBookingServiceData and cannot be null");
            }
            else
            {
                this.DocumentDate = documentDate;
            }
            // to ensure "expiryDate" is required (not null)
            if (expiryDate == null)
            {
                throw new InvalidDataException("expiryDate is a required property for BuySellBookingServiceData and cannot be null");
            }
            else
            {
                this.ExpiryDate = expiryDate;
            }
            // to ensure "amount" is required (not null)
            if (amount == null)
            {
                throw new InvalidDataException("amount is a required property for BuySellBookingServiceData and cannot be null");
            }
            else
            {
                this.Amount = amount;
            }
            // to ensure "currencyCode" is required (not null)
            if (currencyCode == null)
            {
                throw new InvalidDataException("currencyCode is a required property for BuySellBookingServiceData and cannot be null");
            }
            else
            {
                this.CurrencyCode = currencyCode;
            }
            // to ensure "exchangeRate" is required (not null)
            if (exchangeRate == null)
            {
                throw new InvalidDataException("exchangeRate is a required property for BuySellBookingServiceData and cannot be null");
            }
            else
            {
                this.ExchangeRate = exchangeRate;
            }
            this.Comment = comment;
            this.Reference = reference;
            this.BookingLines = bookingLines;
            this.PaymentMethod = paymentMethod;
        }
        
        /// <summary>
        /// Gets or Sets BookyearKey
        /// </summary>
        [DataMember(Name="bookyearKey", EmitDefaultValue=false)]
        public BookyearKey BookyearKey { get; set; }

        /// <summary>
        /// Journal Identification
        /// </summary>
        /// <value>Journal Identification</value>
        [DataMember(Name="journalKey", EmitDefaultValue=false)]
        public string JournalKey { get; set; }

        /// <summary>
        /// Document number identification
        /// </summary>
        /// <value>Document number identification</value>
        [DataMember(Name="documentSequenceNr", EmitDefaultValue=false)]
        public int? DocumentSequenceNr { get; set; }

        /// <summary>
        /// Gets or Sets RelationIdentificationServiceData
        /// </summary>
        [DataMember(Name="relationIdentificationServiceData", EmitDefaultValue=false)]
        public RelationIdentificationServiceData RelationIdentificationServiceData { get; set; }

        /// <summary>
        /// Bookyear Period identification
        /// </summary>
        /// <value>Bookyear Period identification</value>
        [DataMember(Name="bookyearPeriodeNr", EmitDefaultValue=false)]
        public int? BookyearPeriodeNr { get; set; }

        /// <summary>
        /// Document Date
        /// </summary>
        /// <value>Document Date</value>
        [DataMember(Name="documentDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? DocumentDate { get; set; }

        /// <summary>
        /// Expiry Date
        /// </summary>
        /// <value>Expiry Date</value>
        [DataMember(Name="expiryDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? ExpiryDate { get; set; }

        /// <summary>
        /// Comment
        /// </summary>
        /// <value>Comment</value>
        [DataMember(Name="comment", EmitDefaultValue=false)]
        public string Comment { get; set; }

        /// <summary>
        /// Reference
        /// </summary>
        /// <value>Reference</value>
        [DataMember(Name="reference", EmitDefaultValue=false)]
        public string Reference { get; set; }

        /// <summary>
        /// Total booking amount
        /// </summary>
        /// <value>Total booking amount</value>
        [DataMember(Name="amount", EmitDefaultValue=false)]
        public double? Amount { get; set; }

        /// <summary>
        /// Currency Code
        /// </summary>
        /// <value>Currency Code</value>
        [DataMember(Name="currencyCode", EmitDefaultValue=false)]
        public string CurrencyCode { get; set; }

        /// <summary>
        /// Exchange Rate
        /// </summary>
        /// <value>Exchange Rate</value>
        [DataMember(Name="exchangeRate", EmitDefaultValue=false)]
        public double? ExchangeRate { get; set; }

        /// <summary>
        /// Booking Lines
        /// </summary>
        /// <value>Booking Lines</value>
        [DataMember(Name="bookingLines", EmitDefaultValue=false)]
        public List<BuySellBookingLineServiceData> BookingLines { get; set; }

        /// <summary>
        /// Type of payment : &lt;ul&gt;&lt;li&gt;Value 0 : Unknown&lt;/li&gt;&lt;li&gt;Value 1 : Bank Transfer&lt;/li&gt;&lt;li&gt;Value 2 : Cash&lt;/li&gt;&lt;li&gt;Value 3 : Creditcard&lt;/li&gt;&lt;li&gt;Value 4 : Domiciliering (Direct Debit)&lt;/li&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>Type of payment : &lt;ul&gt;&lt;li&gt;Value 0 : Unknown&lt;/li&gt;&lt;li&gt;Value 1 : Bank Transfer&lt;/li&gt;&lt;li&gt;Value 2 : Cash&lt;/li&gt;&lt;li&gt;Value 3 : Creditcard&lt;/li&gt;&lt;li&gt;Value 4 : Domiciliering (Direct Debit)&lt;/li&gt;&lt;/ul&gt;</value>
        [DataMember(Name="paymentMethod", EmitDefaultValue=false)]
        public int? PaymentMethod { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BuySellBookingServiceData {\n");
            sb.Append("  BookyearKey: ").Append(BookyearKey).Append("\n");
            sb.Append("  JournalKey: ").Append(JournalKey).Append("\n");
            sb.Append("  DocumentSequenceNr: ").Append(DocumentSequenceNr).Append("\n");
            sb.Append("  RelationIdentificationServiceData: ").Append(RelationIdentificationServiceData).Append("\n");
            sb.Append("  BookyearPeriodeNr: ").Append(BookyearPeriodeNr).Append("\n");
            sb.Append("  DocumentDate: ").Append(DocumentDate).Append("\n");
            sb.Append("  ExpiryDate: ").Append(ExpiryDate).Append("\n");
            sb.Append("  Comment: ").Append(Comment).Append("\n");
            sb.Append("  Reference: ").Append(Reference).Append("\n");
            sb.Append("  Amount: ").Append(Amount).Append("\n");
            sb.Append("  CurrencyCode: ").Append(CurrencyCode).Append("\n");
            sb.Append("  ExchangeRate: ").Append(ExchangeRate).Append("\n");
            sb.Append("  BookingLines: ").Append(BookingLines).Append("\n");
            sb.Append("  PaymentMethod: ").Append(PaymentMethod).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BuySellBookingServiceData);
        }

        /// <summary>
        /// Returns true if BuySellBookingServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of BuySellBookingServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BuySellBookingServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BookyearKey == input.BookyearKey ||
                    (this.BookyearKey != null &&
                    this.BookyearKey.Equals(input.BookyearKey))
                ) && 
                (
                    this.JournalKey == input.JournalKey ||
                    (this.JournalKey != null &&
                    this.JournalKey.Equals(input.JournalKey))
                ) && 
                (
                    this.DocumentSequenceNr == input.DocumentSequenceNr ||
                    (this.DocumentSequenceNr != null &&
                    this.DocumentSequenceNr.Equals(input.DocumentSequenceNr))
                ) && 
                (
                    this.RelationIdentificationServiceData == input.RelationIdentificationServiceData ||
                    (this.RelationIdentificationServiceData != null &&
                    this.RelationIdentificationServiceData.Equals(input.RelationIdentificationServiceData))
                ) && 
                (
                    this.BookyearPeriodeNr == input.BookyearPeriodeNr ||
                    (this.BookyearPeriodeNr != null &&
                    this.BookyearPeriodeNr.Equals(input.BookyearPeriodeNr))
                ) && 
                (
                    this.DocumentDate == input.DocumentDate ||
                    (this.DocumentDate != null &&
                    this.DocumentDate.Equals(input.DocumentDate))
                ) && 
                (
                    this.ExpiryDate == input.ExpiryDate ||
                    (this.ExpiryDate != null &&
                    this.ExpiryDate.Equals(input.ExpiryDate))
                ) && 
                (
                    this.Comment == input.Comment ||
                    (this.Comment != null &&
                    this.Comment.Equals(input.Comment))
                ) && 
                (
                    this.Reference == input.Reference ||
                    (this.Reference != null &&
                    this.Reference.Equals(input.Reference))
                ) && 
                (
                    this.Amount == input.Amount ||
                    (this.Amount != null &&
                    this.Amount.Equals(input.Amount))
                ) && 
                (
                    this.CurrencyCode == input.CurrencyCode ||
                    (this.CurrencyCode != null &&
                    this.CurrencyCode.Equals(input.CurrencyCode))
                ) && 
                (
                    this.ExchangeRate == input.ExchangeRate ||
                    (this.ExchangeRate != null &&
                    this.ExchangeRate.Equals(input.ExchangeRate))
                ) && 
                (
                    this.BookingLines == input.BookingLines ||
                    this.BookingLines != null &&
                    input.BookingLines != null &&
                    this.BookingLines.SequenceEqual(input.BookingLines)
                ) && 
                (
                    this.PaymentMethod == input.PaymentMethod ||
                    (this.PaymentMethod != null &&
                    this.PaymentMethod.Equals(input.PaymentMethod))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BookyearKey != null)
                    hashCode = hashCode * 59 + this.BookyearKey.GetHashCode();
                if (this.JournalKey != null)
                    hashCode = hashCode * 59 + this.JournalKey.GetHashCode();
                if (this.DocumentSequenceNr != null)
                    hashCode = hashCode * 59 + this.DocumentSequenceNr.GetHashCode();
                if (this.RelationIdentificationServiceData != null)
                    hashCode = hashCode * 59 + this.RelationIdentificationServiceData.GetHashCode();
                if (this.BookyearPeriodeNr != null)
                    hashCode = hashCode * 59 + this.BookyearPeriodeNr.GetHashCode();
                if (this.DocumentDate != null)
                    hashCode = hashCode * 59 + this.DocumentDate.GetHashCode();
                if (this.ExpiryDate != null)
                    hashCode = hashCode * 59 + this.ExpiryDate.GetHashCode();
                if (this.Comment != null)
                    hashCode = hashCode * 59 + this.Comment.GetHashCode();
                if (this.Reference != null)
                    hashCode = hashCode * 59 + this.Reference.GetHashCode();
                if (this.Amount != null)
                    hashCode = hashCode * 59 + this.Amount.GetHashCode();
                if (this.CurrencyCode != null)
                    hashCode = hashCode * 59 + this.CurrencyCode.GetHashCode();
                if (this.ExchangeRate != null)
                    hashCode = hashCode * 59 + this.ExchangeRate.GetHashCode();
                if (this.BookingLines != null)
                    hashCode = hashCode * 59 + this.BookingLines.GetHashCode();
                if (this.PaymentMethod != null)
                    hashCode = hashCode * 59 + this.PaymentMethod.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
