/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// CodaImportReportServiceData
    /// </summary>
    [DataContract]
        public partial class CodaImportReportServiceData :  IEquatable<CodaImportReportServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CodaImportReportServiceData" /> class.
        /// </summary>
        /// <param name="errorCode">errorCode.</param>
        /// <param name="codaImportItemReportLines">codaImportItemReportLines.</param>
        public CodaImportReportServiceData(int? errorCode = default(int?), List<CodaImportItemReportServiceData> codaImportItemReportLines = default(List<CodaImportItemReportServiceData>))
        {
            this.ErrorCode = errorCode;
            this.CodaImportItemReportLines = codaImportItemReportLines;
        }
        
        /// <summary>
        /// Gets or Sets ErrorCode
        /// </summary>
        [DataMember(Name="errorCode", EmitDefaultValue=false)]
        public int? ErrorCode { get; set; }

        /// <summary>
        /// Gets or Sets CodaImportItemReportLines
        /// </summary>
        [DataMember(Name="codaImportItemReportLines", EmitDefaultValue=false)]
        public List<CodaImportItemReportServiceData> CodaImportItemReportLines { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CodaImportReportServiceData {\n");
            sb.Append("  ErrorCode: ").Append(ErrorCode).Append("\n");
            sb.Append("  CodaImportItemReportLines: ").Append(CodaImportItemReportLines).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CodaImportReportServiceData);
        }

        /// <summary>
        /// Returns true if CodaImportReportServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of CodaImportReportServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CodaImportReportServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ErrorCode == input.ErrorCode ||
                    (this.ErrorCode != null &&
                    this.ErrorCode.Equals(input.ErrorCode))
                ) && 
                (
                    this.CodaImportItemReportLines == input.CodaImportItemReportLines ||
                    this.CodaImportItemReportLines != null &&
                    input.CodaImportItemReportLines != null &&
                    this.CodaImportItemReportLines.SequenceEqual(input.CodaImportItemReportLines)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ErrorCode != null)
                    hashCode = hashCode * 59 + this.ErrorCode.GetHashCode();
                if (this.CodaImportItemReportLines != null)
                    hashCode = hashCode * 59 + this.CodaImportItemReportLines.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
