/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Coda information ( Coda Move ) of the current financial transaction (optional)
    /// </summary>
    [DataContract]
        public partial class CodaLineServiceData :  IEquatable<CodaLineServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CodaLineServiceData" /> class.
        /// </summary>
        /// <param name="codaVersion">codaVersion (required).</param>
        /// <param name="codaMoveLineData">codaMoveLineData.</param>
        public CodaLineServiceData(CodaVersionData codaVersion = default(CodaVersionData), List<string> codaMoveLineData = default(List<string>))
        {
            // to ensure "codaVersion" is required (not null)
            if (codaVersion == null)
            {
                throw new InvalidDataException("codaVersion is a required property for CodaLineServiceData and cannot be null");
            }
            else
            {
                this.CodaVersion = codaVersion;
            }
            this.CodaMoveLineData = codaMoveLineData;
        }
        
        /// <summary>
        /// Gets or Sets CodaVersion
        /// </summary>
        [DataMember(Name="codaVersion", EmitDefaultValue=false)]
        public CodaVersionData CodaVersion { get; set; }

        /// <summary>
        /// Gets or Sets CodaMoveLineData
        /// </summary>
        [DataMember(Name="codaMoveLineData", EmitDefaultValue=false)]
        public List<string> CodaMoveLineData { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CodaLineServiceData {\n");
            sb.Append("  CodaVersion: ").Append(CodaVersion).Append("\n");
            sb.Append("  CodaMoveLineData: ").Append(CodaMoveLineData).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CodaLineServiceData);
        }

        /// <summary>
        /// Returns true if CodaLineServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of CodaLineServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CodaLineServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.CodaVersion == input.CodaVersion ||
                    (this.CodaVersion != null &&
                    this.CodaVersion.Equals(input.CodaVersion))
                ) && 
                (
                    this.CodaMoveLineData == input.CodaMoveLineData ||
                    this.CodaMoveLineData != null &&
                    input.CodaMoveLineData != null &&
                    this.CodaMoveLineData.SequenceEqual(input.CodaMoveLineData)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CodaVersion != null)
                    hashCode = hashCode * 59 + this.CodaVersion.GetHashCode();
                if (this.CodaMoveLineData != null)
                    hashCode = hashCode * 59 + this.CodaMoveLineData.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
