/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// The coda version identification
    /// </summary>
    [DataContract]
        public partial class CodaVersionData :  IEquatable<CodaVersionData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CodaVersionData" /> class.
        /// </summary>
        /// <param name="codaVersion">The field codaVersion can contain the values 1 or 2, representing the coda version 1 or 2 This field matches the coda version specified in the coda header. (required).</param>
        public CodaVersionData(int? codaVersion = default(int?))
        {
            // to ensure "codaVersion" is required (not null)
            if (codaVersion == null)
            {
                throw new InvalidDataException("codaVersion is a required property for CodaVersionData and cannot be null");
            }
            else
            {
                this.CodaVersion = codaVersion;
            }
        }
        
        /// <summary>
        /// The field codaVersion can contain the values 1 or 2, representing the coda version 1 or 2 This field matches the coda version specified in the coda header.
        /// </summary>
        /// <value>The field codaVersion can contain the values 1 or 2, representing the coda version 1 or 2 This field matches the coda version specified in the coda header.</value>
        [DataMember(Name="codaVersion", EmitDefaultValue=false)]
        public int? CodaVersion { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CodaVersionData {\n");
            sb.Append("  CodaVersion: ").Append(CodaVersion).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CodaVersionData);
        }

        /// <summary>
        /// Returns true if CodaVersionData instances are equal
        /// </summary>
        /// <param name="input">Instance of CodaVersionData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CodaVersionData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.CodaVersion == input.CodaVersion ||
                    (this.CodaVersion != null &&
                    this.CodaVersion.Equals(input.CodaVersion))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CodaVersion != null)
                    hashCode = hashCode * 59 + this.CodaVersion.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
