/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// CostCentreServiceData
    /// </summary>
    [DataContract]
        public partial class CostCentreServiceData :  IEquatable<CostCentreServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CostCentreServiceData" /> class.
        /// </summary>
        /// <param name="costCentreKey">costCentreKey (required).</param>
        /// <param name="description">description (required).</param>
        /// <param name="closed">Check if the cost centre is closed (required).</param>
        public CostCentreServiceData(CostCentreKey costCentreKey = default(CostCentreKey), StringServiceData description = default(StringServiceData), bool? closed = default(bool?))
        {
            // to ensure "costCentreKey" is required (not null)
            if (costCentreKey == null)
            {
                throw new InvalidDataException("costCentreKey is a required property for CostCentreServiceData and cannot be null");
            }
            else
            {
                this.CostCentreKey = costCentreKey;
            }
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new InvalidDataException("description is a required property for CostCentreServiceData and cannot be null");
            }
            else
            {
                this.Description = description;
            }
            // to ensure "closed" is required (not null)
            if (closed == null)
            {
                throw new InvalidDataException("closed is a required property for CostCentreServiceData and cannot be null");
            }
            else
            {
                this.Closed = closed;
            }
        }
        
        /// <summary>
        /// Gets or Sets CostCentreKey
        /// </summary>
        [DataMember(Name="costCentreKey", EmitDefaultValue=false)]
        public CostCentreKey CostCentreKey { get; set; }

        /// <summary>
        /// Gets or Sets Description
        /// </summary>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public StringServiceData Description { get; set; }

        /// <summary>
        /// Check if the cost centre is closed
        /// </summary>
        /// <value>Check if the cost centre is closed</value>
        [DataMember(Name="closed", EmitDefaultValue=false)]
        public bool? Closed { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CostCentreServiceData {\n");
            sb.Append("  CostCentreKey: ").Append(CostCentreKey).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Closed: ").Append(Closed).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CostCentreServiceData);
        }

        /// <summary>
        /// Returns true if CostCentreServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of CostCentreServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CostCentreServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.CostCentreKey == input.CostCentreKey ||
                    (this.CostCentreKey != null &&
                    this.CostCentreKey.Equals(input.CostCentreKey))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.Closed == input.Closed ||
                    (this.Closed != null &&
                    this.Closed.Equals(input.Closed))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CostCentreKey != null)
                    hashCode = hashCode * 59 + this.CostCentreKey.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.Closed != null)
                    hashCode = hashCode * 59 + this.Closed.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
