/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// CustomFieldServiceData
    /// </summary>
    [DataContract]
        public partial class CustomFieldServiceData :  IEquatable<CustomFieldServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CustomFieldServiceData" /> class.
        /// </summary>
        /// <param name="customFieldKey">customFieldKey.</param>
        /// <param name="description">description.</param>
        /// <param name="customFieldType">customFieldType.</param>
        /// <param name="templateCode">templateCode.</param>
        public CustomFieldServiceData(CustomFieldKey customFieldKey = default(CustomFieldKey), StringServiceData description = default(StringServiceData), int? customFieldType = default(int?), string templateCode = default(string))
        {
            this.CustomFieldKey = customFieldKey;
            this.Description = description;
            this.CustomFieldType = customFieldType;
            this.TemplateCode = templateCode;
        }
        
        /// <summary>
        /// Gets or Sets CustomFieldKey
        /// </summary>
        [DataMember(Name="customFieldKey", EmitDefaultValue=false)]
        public CustomFieldKey CustomFieldKey { get; set; }

        /// <summary>
        /// Gets or Sets Description
        /// </summary>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public StringServiceData Description { get; set; }

        /// <summary>
        /// Gets or Sets CustomFieldType
        /// </summary>
        [DataMember(Name="customFieldType", EmitDefaultValue=false)]
        public int? CustomFieldType { get; set; }

        /// <summary>
        /// Gets or Sets TemplateCode
        /// </summary>
        [DataMember(Name="templateCode", EmitDefaultValue=false)]
        public string TemplateCode { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CustomFieldServiceData {\n");
            sb.Append("  CustomFieldKey: ").Append(CustomFieldKey).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  CustomFieldType: ").Append(CustomFieldType).Append("\n");
            sb.Append("  TemplateCode: ").Append(TemplateCode).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CustomFieldServiceData);
        }

        /// <summary>
        /// Returns true if CustomFieldServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of CustomFieldServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CustomFieldServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.CustomFieldKey == input.CustomFieldKey ||
                    (this.CustomFieldKey != null &&
                    this.CustomFieldKey.Equals(input.CustomFieldKey))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.CustomFieldType == input.CustomFieldType ||
                    (this.CustomFieldType != null &&
                    this.CustomFieldType.Equals(input.CustomFieldType))
                ) && 
                (
                    this.TemplateCode == input.TemplateCode ||
                    (this.TemplateCode != null &&
                    this.TemplateCode.Equals(input.TemplateCode))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CustomFieldKey != null)
                    hashCode = hashCode * 59 + this.CustomFieldKey.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.CustomFieldType != null)
                    hashCode = hashCode * 59 + this.CustomFieldType.GetHashCode();
                if (this.TemplateCode != null)
                    hashCode = hashCode * 59 + this.TemplateCode.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
