/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Delivery note lines
    /// </summary>
    [DataContract]
        public partial class DeliveryNoteLineServiceData :  IEquatable<DeliveryNoteLineServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DeliveryNoteLineServiceData" /> class.
        /// </summary>
        /// <param name="externProductNr">externProductNr.</param>
        /// <param name="description">description.</param>
        /// <param name="count">count.</param>
        /// <param name="unit">unit.</param>
        /// <param name="unitPrice">unitPrice.</param>
        /// <param name="discountPercentage">discountPercentage.</param>
        /// <param name="vatCodeKey">vatCodeKey.</param>
        /// <param name="bookingAccountNr">bookingAccountNr.</param>
        /// <param name="costCentreKey">costCentreKey.</param>
        /// <param name="customFieldValueList">customFieldValueList.</param>
        public DeliveryNoteLineServiceData(string externProductNr = default(string), string description = default(string), double? count = default(double?), string unit = default(string), double? unitPrice = default(double?), double? discountPercentage = default(double?), string vatCodeKey = default(string), int? bookingAccountNr = default(int?), CostCentreKey costCentreKey = default(CostCentreKey), List<CustomFieldValueServiceData> customFieldValueList = default(List<CustomFieldValueServiceData>))
        {
            this.ExternProductNr = externProductNr;
            this.Description = description;
            this.Count = count;
            this.Unit = unit;
            this.UnitPrice = unitPrice;
            this.DiscountPercentage = discountPercentage;
            this.VatCodeKey = vatCodeKey;
            this.BookingAccountNr = bookingAccountNr;
            this.CostCentreKey = costCentreKey;
            this.CustomFieldValueList = customFieldValueList;
        }
        
        /// <summary>
        /// Gets or Sets ExternProductNr
        /// </summary>
        [DataMember(Name="externProductNr", EmitDefaultValue=false)]
        public string ExternProductNr { get; set; }

        /// <summary>
        /// Gets or Sets Description
        /// </summary>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Gets or Sets Count
        /// </summary>
        [DataMember(Name="count", EmitDefaultValue=false)]
        public double? Count { get; set; }

        /// <summary>
        /// Gets or Sets Unit
        /// </summary>
        [DataMember(Name="unit", EmitDefaultValue=false)]
        public string Unit { get; set; }

        /// <summary>
        /// Gets or Sets UnitPrice
        /// </summary>
        [DataMember(Name="unitPrice", EmitDefaultValue=false)]
        public double? UnitPrice { get; set; }

        /// <summary>
        /// Gets or Sets DiscountPercentage
        /// </summary>
        [DataMember(Name="discountPercentage", EmitDefaultValue=false)]
        public double? DiscountPercentage { get; set; }

        /// <summary>
        /// Gets or Sets VatCodeKey
        /// </summary>
        [DataMember(Name="vatCodeKey", EmitDefaultValue=false)]
        public string VatCodeKey { get; set; }

        /// <summary>
        /// Gets or Sets BookingAccountNr
        /// </summary>
        [DataMember(Name="bookingAccountNr", EmitDefaultValue=false)]
        public int? BookingAccountNr { get; set; }

        /// <summary>
        /// Gets or Sets CostCentreKey
        /// </summary>
        [DataMember(Name="costCentreKey", EmitDefaultValue=false)]
        public CostCentreKey CostCentreKey { get; set; }

        /// <summary>
        /// Gets or Sets CustomFieldValueList
        /// </summary>
        [DataMember(Name="customFieldValueList", EmitDefaultValue=false)]
        public List<CustomFieldValueServiceData> CustomFieldValueList { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DeliveryNoteLineServiceData {\n");
            sb.Append("  ExternProductNr: ").Append(ExternProductNr).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Count: ").Append(Count).Append("\n");
            sb.Append("  Unit: ").Append(Unit).Append("\n");
            sb.Append("  UnitPrice: ").Append(UnitPrice).Append("\n");
            sb.Append("  DiscountPercentage: ").Append(DiscountPercentage).Append("\n");
            sb.Append("  VatCodeKey: ").Append(VatCodeKey).Append("\n");
            sb.Append("  BookingAccountNr: ").Append(BookingAccountNr).Append("\n");
            sb.Append("  CostCentreKey: ").Append(CostCentreKey).Append("\n");
            sb.Append("  CustomFieldValueList: ").Append(CustomFieldValueList).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DeliveryNoteLineServiceData);
        }

        /// <summary>
        /// Returns true if DeliveryNoteLineServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of DeliveryNoteLineServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DeliveryNoteLineServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ExternProductNr == input.ExternProductNr ||
                    (this.ExternProductNr != null &&
                    this.ExternProductNr.Equals(input.ExternProductNr))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.Count == input.Count ||
                    (this.Count != null &&
                    this.Count.Equals(input.Count))
                ) && 
                (
                    this.Unit == input.Unit ||
                    (this.Unit != null &&
                    this.Unit.Equals(input.Unit))
                ) && 
                (
                    this.UnitPrice == input.UnitPrice ||
                    (this.UnitPrice != null &&
                    this.UnitPrice.Equals(input.UnitPrice))
                ) && 
                (
                    this.DiscountPercentage == input.DiscountPercentage ||
                    (this.DiscountPercentage != null &&
                    this.DiscountPercentage.Equals(input.DiscountPercentage))
                ) && 
                (
                    this.VatCodeKey == input.VatCodeKey ||
                    (this.VatCodeKey != null &&
                    this.VatCodeKey.Equals(input.VatCodeKey))
                ) && 
                (
                    this.BookingAccountNr == input.BookingAccountNr ||
                    (this.BookingAccountNr != null &&
                    this.BookingAccountNr.Equals(input.BookingAccountNr))
                ) && 
                (
                    this.CostCentreKey == input.CostCentreKey ||
                    (this.CostCentreKey != null &&
                    this.CostCentreKey.Equals(input.CostCentreKey))
                ) && 
                (
                    this.CustomFieldValueList == input.CustomFieldValueList ||
                    this.CustomFieldValueList != null &&
                    input.CustomFieldValueList != null &&
                    this.CustomFieldValueList.SequenceEqual(input.CustomFieldValueList)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ExternProductNr != null)
                    hashCode = hashCode * 59 + this.ExternProductNr.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.Count != null)
                    hashCode = hashCode * 59 + this.Count.GetHashCode();
                if (this.Unit != null)
                    hashCode = hashCode * 59 + this.Unit.GetHashCode();
                if (this.UnitPrice != null)
                    hashCode = hashCode * 59 + this.UnitPrice.GetHashCode();
                if (this.DiscountPercentage != null)
                    hashCode = hashCode * 59 + this.DiscountPercentage.GetHashCode();
                if (this.VatCodeKey != null)
                    hashCode = hashCode * 59 + this.VatCodeKey.GetHashCode();
                if (this.BookingAccountNr != null)
                    hashCode = hashCode * 59 + this.BookingAccountNr.GetHashCode();
                if (this.CostCentreKey != null)
                    hashCode = hashCode * 59 + this.CostCentreKey.GetHashCode();
                if (this.CustomFieldValueList != null)
                    hashCode = hashCode * 59 + this.CustomFieldValueList.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
