/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Delivery note data
    /// </summary>
    [DataContract]
        public partial class DeliveryNoteServiceData :  IEquatable<DeliveryNoteServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DeliveryNoteServiceData" /> class.
        /// </summary>
        /// <param name="bookyearKey">bookyearKey (required).</param>
        /// <param name="journalKey">Key identification of the journal ( L - journals ) (required).</param>
        /// <param name="documentSequenceNr">Key identification of the document number (required).</param>
        /// <param name="bookyearPeriodeNr">Key identification of  the bookyear period (required).</param>
        /// <param name="documentDate">Document date (required).</param>
        /// <param name="expiryDate">Expiry Date (required).</param>
        /// <param name="currencyCode">Currency code (required).</param>
        /// <param name="exchangeRate">Exchange Rate (required).</param>
        /// <param name="relationIdentificationServiceData">relationIdentificationServiceData (required).</param>
        /// <param name="comment">Comment.</param>
        /// <param name="reference">Reference.</param>
        /// <param name="financialDiscount">Financial discount amount.</param>
        /// <param name="customFieldValueList">List of Custom Field Value Data.</param>
        /// <param name="deliveryNoteLines">Delivery note lines.</param>
        public DeliveryNoteServiceData(BookyearKey bookyearKey = default(BookyearKey), string journalKey = default(string), int? documentSequenceNr = default(int?), int? bookyearPeriodeNr = default(int?), DateTime? documentDate = default(DateTime?), DateTime? expiryDate = default(DateTime?), string currencyCode = default(string), double? exchangeRate = default(double?), RelationIdentificationServiceData relationIdentificationServiceData = default(RelationIdentificationServiceData), string comment = default(string), string reference = default(string), double? financialDiscount = default(double?), List<CustomFieldValueServiceData> customFieldValueList = default(List<CustomFieldValueServiceData>), List<DeliveryNoteLineServiceData> deliveryNoteLines = default(List<DeliveryNoteLineServiceData>))
        {
            // to ensure "bookyearKey" is required (not null)
            if (bookyearKey == null)
            {
                throw new InvalidDataException("bookyearKey is a required property for DeliveryNoteServiceData and cannot be null");
            }
            else
            {
                this.BookyearKey = bookyearKey;
            }
            // to ensure "journalKey" is required (not null)
            if (journalKey == null)
            {
                throw new InvalidDataException("journalKey is a required property for DeliveryNoteServiceData and cannot be null");
            }
            else
            {
                this.JournalKey = journalKey;
            }
            // to ensure "documentSequenceNr" is required (not null)
            if (documentSequenceNr == null)
            {
                throw new InvalidDataException("documentSequenceNr is a required property for DeliveryNoteServiceData and cannot be null");
            }
            else
            {
                this.DocumentSequenceNr = documentSequenceNr;
            }
            // to ensure "bookyearPeriodeNr" is required (not null)
            if (bookyearPeriodeNr == null)
            {
                throw new InvalidDataException("bookyearPeriodeNr is a required property for DeliveryNoteServiceData and cannot be null");
            }
            else
            {
                this.BookyearPeriodeNr = bookyearPeriodeNr;
            }
            // to ensure "documentDate" is required (not null)
            if (documentDate == null)
            {
                throw new InvalidDataException("documentDate is a required property for DeliveryNoteServiceData and cannot be null");
            }
            else
            {
                this.DocumentDate = documentDate;
            }
            // to ensure "expiryDate" is required (not null)
            if (expiryDate == null)
            {
                throw new InvalidDataException("expiryDate is a required property for DeliveryNoteServiceData and cannot be null");
            }
            else
            {
                this.ExpiryDate = expiryDate;
            }
            // to ensure "currencyCode" is required (not null)
            if (currencyCode == null)
            {
                throw new InvalidDataException("currencyCode is a required property for DeliveryNoteServiceData and cannot be null");
            }
            else
            {
                this.CurrencyCode = currencyCode;
            }
            // to ensure "exchangeRate" is required (not null)
            if (exchangeRate == null)
            {
                throw new InvalidDataException("exchangeRate is a required property for DeliveryNoteServiceData and cannot be null");
            }
            else
            {
                this.ExchangeRate = exchangeRate;
            }
            // to ensure "relationIdentificationServiceData" is required (not null)
            if (relationIdentificationServiceData == null)
            {
                throw new InvalidDataException("relationIdentificationServiceData is a required property for DeliveryNoteServiceData and cannot be null");
            }
            else
            {
                this.RelationIdentificationServiceData = relationIdentificationServiceData;
            }
            this.Comment = comment;
            this.Reference = reference;
            this.FinancialDiscount = financialDiscount;
            this.CustomFieldValueList = customFieldValueList;
            this.DeliveryNoteLines = deliveryNoteLines;
        }
        
        /// <summary>
        /// Gets or Sets BookyearKey
        /// </summary>
        [DataMember(Name="bookyearKey", EmitDefaultValue=false)]
        public BookyearKey BookyearKey { get; set; }

        /// <summary>
        /// Key identification of the journal ( L - journals )
        /// </summary>
        /// <value>Key identification of the journal ( L - journals )</value>
        [DataMember(Name="journalKey", EmitDefaultValue=false)]
        public string JournalKey { get; set; }

        /// <summary>
        /// Key identification of the document number
        /// </summary>
        /// <value>Key identification of the document number</value>
        [DataMember(Name="documentSequenceNr", EmitDefaultValue=false)]
        public int? DocumentSequenceNr { get; set; }

        /// <summary>
        /// Key identification of  the bookyear period
        /// </summary>
        /// <value>Key identification of  the bookyear period</value>
        [DataMember(Name="bookyearPeriodeNr", EmitDefaultValue=false)]
        public int? BookyearPeriodeNr { get; set; }

        /// <summary>
        /// Document date
        /// </summary>
        /// <value>Document date</value>
        [DataMember(Name="documentDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? DocumentDate { get; set; }

        /// <summary>
        /// Expiry Date
        /// </summary>
        /// <value>Expiry Date</value>
        [DataMember(Name="expiryDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? ExpiryDate { get; set; }

        /// <summary>
        /// Currency code
        /// </summary>
        /// <value>Currency code</value>
        [DataMember(Name="currencyCode", EmitDefaultValue=false)]
        public string CurrencyCode { get; set; }

        /// <summary>
        /// Exchange Rate
        /// </summary>
        /// <value>Exchange Rate</value>
        [DataMember(Name="exchangeRate", EmitDefaultValue=false)]
        public double? ExchangeRate { get; set; }

        /// <summary>
        /// Gets or Sets RelationIdentificationServiceData
        /// </summary>
        [DataMember(Name="relationIdentificationServiceData", EmitDefaultValue=false)]
        public RelationIdentificationServiceData RelationIdentificationServiceData { get; set; }

        /// <summary>
        /// Comment
        /// </summary>
        /// <value>Comment</value>
        [DataMember(Name="comment", EmitDefaultValue=false)]
        public string Comment { get; set; }

        /// <summary>
        /// Reference
        /// </summary>
        /// <value>Reference</value>
        [DataMember(Name="reference", EmitDefaultValue=false)]
        public string Reference { get; set; }

        /// <summary>
        /// Financial discount amount
        /// </summary>
        /// <value>Financial discount amount</value>
        [DataMember(Name="financialDiscount", EmitDefaultValue=false)]
        public double? FinancialDiscount { get; set; }

        /// <summary>
        /// List of Custom Field Value Data
        /// </summary>
        /// <value>List of Custom Field Value Data</value>
        [DataMember(Name="customFieldValueList", EmitDefaultValue=false)]
        public List<CustomFieldValueServiceData> CustomFieldValueList { get; set; }

        /// <summary>
        /// Delivery note lines
        /// </summary>
        /// <value>Delivery note lines</value>
        [DataMember(Name="deliveryNoteLines", EmitDefaultValue=false)]
        public List<DeliveryNoteLineServiceData> DeliveryNoteLines { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DeliveryNoteServiceData {\n");
            sb.Append("  BookyearKey: ").Append(BookyearKey).Append("\n");
            sb.Append("  JournalKey: ").Append(JournalKey).Append("\n");
            sb.Append("  DocumentSequenceNr: ").Append(DocumentSequenceNr).Append("\n");
            sb.Append("  BookyearPeriodeNr: ").Append(BookyearPeriodeNr).Append("\n");
            sb.Append("  DocumentDate: ").Append(DocumentDate).Append("\n");
            sb.Append("  ExpiryDate: ").Append(ExpiryDate).Append("\n");
            sb.Append("  CurrencyCode: ").Append(CurrencyCode).Append("\n");
            sb.Append("  ExchangeRate: ").Append(ExchangeRate).Append("\n");
            sb.Append("  RelationIdentificationServiceData: ").Append(RelationIdentificationServiceData).Append("\n");
            sb.Append("  Comment: ").Append(Comment).Append("\n");
            sb.Append("  Reference: ").Append(Reference).Append("\n");
            sb.Append("  FinancialDiscount: ").Append(FinancialDiscount).Append("\n");
            sb.Append("  CustomFieldValueList: ").Append(CustomFieldValueList).Append("\n");
            sb.Append("  DeliveryNoteLines: ").Append(DeliveryNoteLines).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DeliveryNoteServiceData);
        }

        /// <summary>
        /// Returns true if DeliveryNoteServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of DeliveryNoteServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DeliveryNoteServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BookyearKey == input.BookyearKey ||
                    (this.BookyearKey != null &&
                    this.BookyearKey.Equals(input.BookyearKey))
                ) && 
                (
                    this.JournalKey == input.JournalKey ||
                    (this.JournalKey != null &&
                    this.JournalKey.Equals(input.JournalKey))
                ) && 
                (
                    this.DocumentSequenceNr == input.DocumentSequenceNr ||
                    (this.DocumentSequenceNr != null &&
                    this.DocumentSequenceNr.Equals(input.DocumentSequenceNr))
                ) && 
                (
                    this.BookyearPeriodeNr == input.BookyearPeriodeNr ||
                    (this.BookyearPeriodeNr != null &&
                    this.BookyearPeriodeNr.Equals(input.BookyearPeriodeNr))
                ) && 
                (
                    this.DocumentDate == input.DocumentDate ||
                    (this.DocumentDate != null &&
                    this.DocumentDate.Equals(input.DocumentDate))
                ) && 
                (
                    this.ExpiryDate == input.ExpiryDate ||
                    (this.ExpiryDate != null &&
                    this.ExpiryDate.Equals(input.ExpiryDate))
                ) && 
                (
                    this.CurrencyCode == input.CurrencyCode ||
                    (this.CurrencyCode != null &&
                    this.CurrencyCode.Equals(input.CurrencyCode))
                ) && 
                (
                    this.ExchangeRate == input.ExchangeRate ||
                    (this.ExchangeRate != null &&
                    this.ExchangeRate.Equals(input.ExchangeRate))
                ) && 
                (
                    this.RelationIdentificationServiceData == input.RelationIdentificationServiceData ||
                    (this.RelationIdentificationServiceData != null &&
                    this.RelationIdentificationServiceData.Equals(input.RelationIdentificationServiceData))
                ) && 
                (
                    this.Comment == input.Comment ||
                    (this.Comment != null &&
                    this.Comment.Equals(input.Comment))
                ) && 
                (
                    this.Reference == input.Reference ||
                    (this.Reference != null &&
                    this.Reference.Equals(input.Reference))
                ) && 
                (
                    this.FinancialDiscount == input.FinancialDiscount ||
                    (this.FinancialDiscount != null &&
                    this.FinancialDiscount.Equals(input.FinancialDiscount))
                ) && 
                (
                    this.CustomFieldValueList == input.CustomFieldValueList ||
                    this.CustomFieldValueList != null &&
                    input.CustomFieldValueList != null &&
                    this.CustomFieldValueList.SequenceEqual(input.CustomFieldValueList)
                ) && 
                (
                    this.DeliveryNoteLines == input.DeliveryNoteLines ||
                    this.DeliveryNoteLines != null &&
                    input.DeliveryNoteLines != null &&
                    this.DeliveryNoteLines.SequenceEqual(input.DeliveryNoteLines)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BookyearKey != null)
                    hashCode = hashCode * 59 + this.BookyearKey.GetHashCode();
                if (this.JournalKey != null)
                    hashCode = hashCode * 59 + this.JournalKey.GetHashCode();
                if (this.DocumentSequenceNr != null)
                    hashCode = hashCode * 59 + this.DocumentSequenceNr.GetHashCode();
                if (this.BookyearPeriodeNr != null)
                    hashCode = hashCode * 59 + this.BookyearPeriodeNr.GetHashCode();
                if (this.DocumentDate != null)
                    hashCode = hashCode * 59 + this.DocumentDate.GetHashCode();
                if (this.ExpiryDate != null)
                    hashCode = hashCode * 59 + this.ExpiryDate.GetHashCode();
                if (this.CurrencyCode != null)
                    hashCode = hashCode * 59 + this.CurrencyCode.GetHashCode();
                if (this.ExchangeRate != null)
                    hashCode = hashCode * 59 + this.ExchangeRate.GetHashCode();
                if (this.RelationIdentificationServiceData != null)
                    hashCode = hashCode * 59 + this.RelationIdentificationServiceData.GetHashCode();
                if (this.Comment != null)
                    hashCode = hashCode * 59 + this.Comment.GetHashCode();
                if (this.Reference != null)
                    hashCode = hashCode * 59 + this.Reference.GetHashCode();
                if (this.FinancialDiscount != null)
                    hashCode = hashCode * 59 + this.FinancialDiscount.GetHashCode();
                if (this.CustomFieldValueList != null)
                    hashCode = hashCode * 59 + this.CustomFieldValueList.GetHashCode();
                if (this.DeliveryNoteLines != null)
                    hashCode = hashCode * 59 + this.DeliveryNoteLines.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
