/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Deleted bookings list
    /// </summary>
    [DataContract]
        public partial class DocumentKey :  IEquatable<DocumentKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentKey" /> class.
        /// </summary>
        /// <param name="bookyearKey">bookyearKey.</param>
        /// <param name="journalType">Journal Type ID, possible values :&lt;ul&gt;&lt;li&gt;0 : Unknown&lt;/li&gt;&lt;li&gt;1 : Buy&lt;/li&gt;&lt;li&gt;2 : Sell&lt;/li&gt;&lt;li&gt;3 : Financial&lt;/li&gt;&lt;li&gt;4 : Divers&lt;/li&gt;&lt;li&gt;7 : Delivery&lt;/li&gt;.</param>
        /// <param name="journalSequenceNr">journalSequenceNr.</param>
        /// <param name="documentSequenceNr">documentSequenceNr.</param>
        public DocumentKey(BookyearKey bookyearKey = default(BookyearKey), int? journalType = default(int?), int? journalSequenceNr = default(int?), int? documentSequenceNr = default(int?))
        {
            this.BookyearKey = bookyearKey;
            this.JournalType = journalType;
            this.JournalSequenceNr = journalSequenceNr;
            this.DocumentSequenceNr = documentSequenceNr;
        }
        
        /// <summary>
        /// Gets or Sets BookyearKey
        /// </summary>
        [DataMember(Name="bookyearKey", EmitDefaultValue=false)]
        public BookyearKey BookyearKey { get; set; }

        /// <summary>
        /// Journal Type ID, possible values :&lt;ul&gt;&lt;li&gt;0 : Unknown&lt;/li&gt;&lt;li&gt;1 : Buy&lt;/li&gt;&lt;li&gt;2 : Sell&lt;/li&gt;&lt;li&gt;3 : Financial&lt;/li&gt;&lt;li&gt;4 : Divers&lt;/li&gt;&lt;li&gt;7 : Delivery&lt;/li&gt;
        /// </summary>
        /// <value>Journal Type ID, possible values :&lt;ul&gt;&lt;li&gt;0 : Unknown&lt;/li&gt;&lt;li&gt;1 : Buy&lt;/li&gt;&lt;li&gt;2 : Sell&lt;/li&gt;&lt;li&gt;3 : Financial&lt;/li&gt;&lt;li&gt;4 : Divers&lt;/li&gt;&lt;li&gt;7 : Delivery&lt;/li&gt;</value>
        [DataMember(Name="journalType", EmitDefaultValue=false)]
        public int? JournalType { get; set; }

        /// <summary>
        /// Gets or Sets JournalSequenceNr
        /// </summary>
        [DataMember(Name="journalSequenceNr", EmitDefaultValue=false)]
        public int? JournalSequenceNr { get; set; }

        /// <summary>
        /// Gets or Sets DocumentSequenceNr
        /// </summary>
        [DataMember(Name="documentSequenceNr", EmitDefaultValue=false)]
        public int? DocumentSequenceNr { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DocumentKey {\n");
            sb.Append("  BookyearKey: ").Append(BookyearKey).Append("\n");
            sb.Append("  JournalType: ").Append(JournalType).Append("\n");
            sb.Append("  JournalSequenceNr: ").Append(JournalSequenceNr).Append("\n");
            sb.Append("  DocumentSequenceNr: ").Append(DocumentSequenceNr).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DocumentKey);
        }

        /// <summary>
        /// Returns true if DocumentKey instances are equal
        /// </summary>
        /// <param name="input">Instance of DocumentKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DocumentKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BookyearKey == input.BookyearKey ||
                    (this.BookyearKey != null &&
                    this.BookyearKey.Equals(input.BookyearKey))
                ) && 
                (
                    this.JournalType == input.JournalType ||
                    (this.JournalType != null &&
                    this.JournalType.Equals(input.JournalType))
                ) && 
                (
                    this.JournalSequenceNr == input.JournalSequenceNr ||
                    (this.JournalSequenceNr != null &&
                    this.JournalSequenceNr.Equals(input.JournalSequenceNr))
                ) && 
                (
                    this.DocumentSequenceNr == input.DocumentSequenceNr ||
                    (this.DocumentSequenceNr != null &&
                    this.DocumentSequenceNr.Equals(input.DocumentSequenceNr))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BookyearKey != null)
                    hashCode = hashCode * 59 + this.BookyearKey.GetHashCode();
                if (this.JournalType != null)
                    hashCode = hashCode * 59 + this.JournalType.GetHashCode();
                if (this.JournalSequenceNr != null)
                    hashCode = hashCode * 59 + this.JournalSequenceNr.GetHashCode();
                if (this.DocumentSequenceNr != null)
                    hashCode = hashCode * 59 + this.DocumentSequenceNr.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
