/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DossierServiceData
    /// </summary>
    [DataContract]
        public partial class DossierServiceData :  IEquatable<DossierServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DossierServiceData" /> class.
        /// </summary>
        /// <param name="dossierKey">dossierKey.</param>
        /// <param name="dossierDescription">Description of the dossier.</param>
        /// <param name="streetAndNr">streetAndNr.</param>
        /// <param name="country">country.</param>
        /// <param name="postalCode">postalCode.</param>
        /// <param name="city">city.</param>
        /// <param name="vatNr">VAT Nr (Enterprise Nr, KBO-nr).</param>
        /// <param name="url">url.</param>
        /// <param name="email">email.</param>
        public DossierServiceData(DossierKey dossierKey = default(DossierKey), string dossierDescription = default(string), string streetAndNr = default(string), string country = default(string), string postalCode = default(string), string city = default(string), string vatNr = default(string), string url = default(string), string email = default(string))
        {
            this.DossierKey = dossierKey;
            this.DossierDescription = dossierDescription;
            this.StreetAndNr = streetAndNr;
            this.Country = country;
            this.PostalCode = postalCode;
            this.City = city;
            this.VatNr = vatNr;
            this.Url = url;
            this.Email = email;
        }
        
        /// <summary>
        /// Gets or Sets DossierKey
        /// </summary>
        [DataMember(Name="dossierKey", EmitDefaultValue=false)]
        public DossierKey DossierKey { get; set; }

        /// <summary>
        /// Description of the dossier
        /// </summary>
        /// <value>Description of the dossier</value>
        [DataMember(Name="dossierDescription", EmitDefaultValue=false)]
        public string DossierDescription { get; set; }

        /// <summary>
        /// Gets or Sets StreetAndNr
        /// </summary>
        [DataMember(Name="streetAndNr", EmitDefaultValue=false)]
        public string StreetAndNr { get; set; }

        /// <summary>
        /// Gets or Sets Country
        /// </summary>
        [DataMember(Name="country", EmitDefaultValue=false)]
        public string Country { get; set; }

        /// <summary>
        /// Gets or Sets PostalCode
        /// </summary>
        [DataMember(Name="postalCode", EmitDefaultValue=false)]
        public string PostalCode { get; set; }

        /// <summary>
        /// Gets or Sets City
        /// </summary>
        [DataMember(Name="city", EmitDefaultValue=false)]
        public string City { get; set; }

        /// <summary>
        /// VAT Nr (Enterprise Nr, KBO-nr)
        /// </summary>
        /// <value>VAT Nr (Enterprise Nr, KBO-nr)</value>
        [DataMember(Name="vatNr", EmitDefaultValue=false)]
        public string VatNr { get; set; }

        /// <summary>
        /// Gets or Sets Url
        /// </summary>
        [DataMember(Name="url", EmitDefaultValue=false)]
        public string Url { get; set; }

        /// <summary>
        /// Gets or Sets Email
        /// </summary>
        [DataMember(Name="email", EmitDefaultValue=false)]
        public string Email { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DossierServiceData {\n");
            sb.Append("  DossierKey: ").Append(DossierKey).Append("\n");
            sb.Append("  DossierDescription: ").Append(DossierDescription).Append("\n");
            sb.Append("  StreetAndNr: ").Append(StreetAndNr).Append("\n");
            sb.Append("  Country: ").Append(Country).Append("\n");
            sb.Append("  PostalCode: ").Append(PostalCode).Append("\n");
            sb.Append("  City: ").Append(City).Append("\n");
            sb.Append("  VatNr: ").Append(VatNr).Append("\n");
            sb.Append("  Url: ").Append(Url).Append("\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DossierServiceData);
        }

        /// <summary>
        /// Returns true if DossierServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of DossierServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DossierServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.DossierKey == input.DossierKey ||
                    (this.DossierKey != null &&
                    this.DossierKey.Equals(input.DossierKey))
                ) && 
                (
                    this.DossierDescription == input.DossierDescription ||
                    (this.DossierDescription != null &&
                    this.DossierDescription.Equals(input.DossierDescription))
                ) && 
                (
                    this.StreetAndNr == input.StreetAndNr ||
                    (this.StreetAndNr != null &&
                    this.StreetAndNr.Equals(input.StreetAndNr))
                ) && 
                (
                    this.Country == input.Country ||
                    (this.Country != null &&
                    this.Country.Equals(input.Country))
                ) && 
                (
                    this.PostalCode == input.PostalCode ||
                    (this.PostalCode != null &&
                    this.PostalCode.Equals(input.PostalCode))
                ) && 
                (
                    this.City == input.City ||
                    (this.City != null &&
                    this.City.Equals(input.City))
                ) && 
                (
                    this.VatNr == input.VatNr ||
                    (this.VatNr != null &&
                    this.VatNr.Equals(input.VatNr))
                ) && 
                (
                    this.Url == input.Url ||
                    (this.Url != null &&
                    this.Url.Equals(input.Url))
                ) && 
                (
                    this.Email == input.Email ||
                    (this.Email != null &&
                    this.Email.Equals(input.Email))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DossierKey != null)
                    hashCode = hashCode * 59 + this.DossierKey.GetHashCode();
                if (this.DossierDescription != null)
                    hashCode = hashCode * 59 + this.DossierDescription.GetHashCode();
                if (this.StreetAndNr != null)
                    hashCode = hashCode * 59 + this.StreetAndNr.GetHashCode();
                if (this.Country != null)
                    hashCode = hashCode * 59 + this.Country.GetHashCode();
                if (this.PostalCode != null)
                    hashCode = hashCode * 59 + this.PostalCode.GetHashCode();
                if (this.City != null)
                    hashCode = hashCode * 59 + this.City.GetHashCode();
                if (this.VatNr != null)
                    hashCode = hashCode * 59 + this.VatNr.GetHashCode();
                if (this.Url != null)
                    hashCode = hashCode * 59 + this.Url.GetHashCode();
                if (this.Email != null)
                    hashCode = hashCode * 59 + this.Email.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
