/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Exported Delivery Note
    /// </summary>
    [DataContract]
        public partial class ExportedDeliveryNoteResult :  IEquatable<ExportedDeliveryNoteResult>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ExportedDeliveryNoteResult" /> class.
        /// </summary>
        /// <param name="deliveryNoteServiceData">deliveryNoteServiceData.</param>
        /// <param name="publishUrl">Publish URL of the delivery note.</param>
        /// <param name="pdfDocument">The delivery note PDF.</param>
        public ExportedDeliveryNoteResult(DeliveryNoteServiceData deliveryNoteServiceData = default(DeliveryNoteServiceData), string publishUrl = default(string), byte[] pdfDocument = default(byte[]))
        {
            this.DeliveryNoteServiceData = deliveryNoteServiceData;
            this.PublishUrl = publishUrl;
            this.PdfDocument = pdfDocument;
        }
        
        /// <summary>
        /// Gets or Sets DeliveryNoteServiceData
        /// </summary>
        [DataMember(Name="deliveryNoteServiceData", EmitDefaultValue=false)]
        public DeliveryNoteServiceData DeliveryNoteServiceData { get; set; }

        /// <summary>
        /// Publish URL of the delivery note
        /// </summary>
        /// <value>Publish URL of the delivery note</value>
        [DataMember(Name="publishUrl", EmitDefaultValue=false)]
        public string PublishUrl { get; set; }

        /// <summary>
        /// The delivery note PDF
        /// </summary>
        /// <value>The delivery note PDF</value>
        [DataMember(Name="pdfDocument", EmitDefaultValue=false)]
        public byte[] PdfDocument { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ExportedDeliveryNoteResult {\n");
            sb.Append("  DeliveryNoteServiceData: ").Append(DeliveryNoteServiceData).Append("\n");
            sb.Append("  PublishUrl: ").Append(PublishUrl).Append("\n");
            sb.Append("  PdfDocument: ").Append(PdfDocument).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ExportedDeliveryNoteResult);
        }

        /// <summary>
        /// Returns true if ExportedDeliveryNoteResult instances are equal
        /// </summary>
        /// <param name="input">Instance of ExportedDeliveryNoteResult to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ExportedDeliveryNoteResult input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.DeliveryNoteServiceData == input.DeliveryNoteServiceData ||
                    (this.DeliveryNoteServiceData != null &&
                    this.DeliveryNoteServiceData.Equals(input.DeliveryNoteServiceData))
                ) && 
                (
                    this.PublishUrl == input.PublishUrl ||
                    (this.PublishUrl != null &&
                    this.PublishUrl.Equals(input.PublishUrl))
                ) && 
                (
                    this.PdfDocument == input.PdfDocument ||
                    (this.PdfDocument != null &&
                    this.PdfDocument.Equals(input.PdfDocument))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DeliveryNoteServiceData != null)
                    hashCode = hashCode * 59 + this.DeliveryNoteServiceData.GetHashCode();
                if (this.PublishUrl != null)
                    hashCode = hashCode * 59 + this.PublishUrl.GetHashCode();
                if (this.PdfDocument != null)
                    hashCode = hashCode * 59 + this.PdfDocument.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
