/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Exported Invoice
    /// </summary>
    [DataContract]
        public partial class ExportedInvoiceResult :  IEquatable<ExportedInvoiceResult>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ExportedInvoiceResult" /> class.
        /// </summary>
        /// <param name="invoiceServiceData">invoiceServiceData.</param>
        /// <param name="publishUrl">Publish URL of the invoice.</param>
        /// <param name="pdfDocument">The invoice pdf.</param>
        /// <param name="electronicInvoiceXml">The invoice xml.</param>
        public ExportedInvoiceResult(InvoiceServiceData invoiceServiceData = default(InvoiceServiceData), string publishUrl = default(string), byte[] pdfDocument = default(byte[]), byte[] electronicInvoiceXml = default(byte[]))
        {
            this.InvoiceServiceData = invoiceServiceData;
            this.PublishUrl = publishUrl;
            this.PdfDocument = pdfDocument;
            this.ElectronicInvoiceXml = electronicInvoiceXml;
        }
        
        /// <summary>
        /// Gets or Sets InvoiceServiceData
        /// </summary>
        [DataMember(Name="invoiceServiceData", EmitDefaultValue=false)]
        public InvoiceServiceData InvoiceServiceData { get; set; }

        /// <summary>
        /// Publish URL of the invoice
        /// </summary>
        /// <value>Publish URL of the invoice</value>
        [DataMember(Name="publishUrl", EmitDefaultValue=false)]
        public string PublishUrl { get; set; }

        /// <summary>
        /// The invoice pdf
        /// </summary>
        /// <value>The invoice pdf</value>
        [DataMember(Name="pdfDocument", EmitDefaultValue=false)]
        public byte[] PdfDocument { get; set; }

        /// <summary>
        /// The invoice xml
        /// </summary>
        /// <value>The invoice xml</value>
        [DataMember(Name="electronicInvoiceXml", EmitDefaultValue=false)]
        public byte[] ElectronicInvoiceXml { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ExportedInvoiceResult {\n");
            sb.Append("  InvoiceServiceData: ").Append(InvoiceServiceData).Append("\n");
            sb.Append("  PublishUrl: ").Append(PublishUrl).Append("\n");
            sb.Append("  PdfDocument: ").Append(PdfDocument).Append("\n");
            sb.Append("  ElectronicInvoiceXml: ").Append(ElectronicInvoiceXml).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ExportedInvoiceResult);
        }

        /// <summary>
        /// Returns true if ExportedInvoiceResult instances are equal
        /// </summary>
        /// <param name="input">Instance of ExportedInvoiceResult to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ExportedInvoiceResult input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.InvoiceServiceData == input.InvoiceServiceData ||
                    (this.InvoiceServiceData != null &&
                    this.InvoiceServiceData.Equals(input.InvoiceServiceData))
                ) && 
                (
                    this.PublishUrl == input.PublishUrl ||
                    (this.PublishUrl != null &&
                    this.PublishUrl.Equals(input.PublishUrl))
                ) && 
                (
                    this.PdfDocument == input.PdfDocument ||
                    (this.PdfDocument != null &&
                    this.PdfDocument.Equals(input.PdfDocument))
                ) && 
                (
                    this.ElectronicInvoiceXml == input.ElectronicInvoiceXml ||
                    (this.ElectronicInvoiceXml != null &&
                    this.ElectronicInvoiceXml.Equals(input.ElectronicInvoiceXml))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.InvoiceServiceData != null)
                    hashCode = hashCode * 59 + this.InvoiceServiceData.GetHashCode();
                if (this.PublishUrl != null)
                    hashCode = hashCode * 59 + this.PublishUrl.GetHashCode();
                if (this.PdfDocument != null)
                    hashCode = hashCode * 59 + this.PdfDocument.GetHashCode();
                if (this.ElectronicInvoiceXml != null)
                    hashCode = hashCode * 59 + this.ElectronicInvoiceXml.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
