/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Financial booking lines
    /// </summary>
    [DataContract]
        public partial class FinancialDiversBookingLineServiceData :  IEquatable<FinancialDiversBookingLineServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FinancialDiversBookingLineServiceData" /> class.
        /// </summary>
        /// <param name="type">Type of the booking line ( \&quot;A\&quot; &#x3D; Account , \&quot;C\&quot; &#x3D; Client , \&quot;S\&quot; &#x3D; Supplier (required).</param>
        /// <param name="accountKey">In case type is account, identification of the account.</param>
        /// <param name="externalRelationId">In case type is client or supplier, identification of the relation.</param>
        /// <param name="reference">Reference.</param>
        /// <param name="amount">Amount (required).</param>
        /// <param name="costCentreKey">costCentreKey.</param>
        /// <param name="codaInfo">codaInfo.</param>
        public FinancialDiversBookingLineServiceData(string type = default(string), int? accountKey = default(int?), int? externalRelationId = default(int?), string reference = default(string), double? amount = default(double?), CostCentreKey costCentreKey = default(CostCentreKey), CodaLineServiceData codaInfo = default(CodaLineServiceData))
        {
            // to ensure "type" is required (not null)
            if (type == null)
            {
                throw new InvalidDataException("type is a required property for FinancialDiversBookingLineServiceData and cannot be null");
            }
            else
            {
                this.Type = type;
            }
            // to ensure "amount" is required (not null)
            if (amount == null)
            {
                throw new InvalidDataException("amount is a required property for FinancialDiversBookingLineServiceData and cannot be null");
            }
            else
            {
                this.Amount = amount;
            }
            this.AccountKey = accountKey;
            this.ExternalRelationId = externalRelationId;
            this.Reference = reference;
            this.CostCentreKey = costCentreKey;
            this.CodaInfo = codaInfo;
        }
        
        /// <summary>
        /// Type of the booking line ( \&quot;A\&quot; &#x3D; Account , \&quot;C\&quot; &#x3D; Client , \&quot;S\&quot; &#x3D; Supplier
        /// </summary>
        /// <value>Type of the booking line ( \&quot;A\&quot; &#x3D; Account , \&quot;C\&quot; &#x3D; Client , \&quot;S\&quot; &#x3D; Supplier</value>
        [DataMember(Name="type", EmitDefaultValue=false)]
        public string Type { get; set; }

        /// <summary>
        /// In case type is account, identification of the account
        /// </summary>
        /// <value>In case type is account, identification of the account</value>
        [DataMember(Name="accountKey", EmitDefaultValue=false)]
        public int? AccountKey { get; set; }

        /// <summary>
        /// In case type is client or supplier, identification of the relation
        /// </summary>
        /// <value>In case type is client or supplier, identification of the relation</value>
        [DataMember(Name="externalRelationId", EmitDefaultValue=false)]
        public int? ExternalRelationId { get; set; }

        /// <summary>
        /// Reference
        /// </summary>
        /// <value>Reference</value>
        [DataMember(Name="reference", EmitDefaultValue=false)]
        public string Reference { get; set; }

        /// <summary>
        /// Amount
        /// </summary>
        /// <value>Amount</value>
        [DataMember(Name="amount", EmitDefaultValue=false)]
        public double? Amount { get; set; }

        /// <summary>
        /// Gets or Sets CostCentreKey
        /// </summary>
        [DataMember(Name="costCentreKey", EmitDefaultValue=false)]
        public CostCentreKey CostCentreKey { get; set; }

        /// <summary>
        /// Gets or Sets CodaInfo
        /// </summary>
        [DataMember(Name="codaInfo", EmitDefaultValue=false)]
        public CodaLineServiceData CodaInfo { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class FinancialDiversBookingLineServiceData {\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  AccountKey: ").Append(AccountKey).Append("\n");
            sb.Append("  ExternalRelationId: ").Append(ExternalRelationId).Append("\n");
            sb.Append("  Reference: ").Append(Reference).Append("\n");
            sb.Append("  Amount: ").Append(Amount).Append("\n");
            sb.Append("  CostCentreKey: ").Append(CostCentreKey).Append("\n");
            sb.Append("  CodaInfo: ").Append(CodaInfo).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as FinancialDiversBookingLineServiceData);
        }

        /// <summary>
        /// Returns true if FinancialDiversBookingLineServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of FinancialDiversBookingLineServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(FinancialDiversBookingLineServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.AccountKey == input.AccountKey ||
                    (this.AccountKey != null &&
                    this.AccountKey.Equals(input.AccountKey))
                ) && 
                (
                    this.ExternalRelationId == input.ExternalRelationId ||
                    (this.ExternalRelationId != null &&
                    this.ExternalRelationId.Equals(input.ExternalRelationId))
                ) && 
                (
                    this.Reference == input.Reference ||
                    (this.Reference != null &&
                    this.Reference.Equals(input.Reference))
                ) && 
                (
                    this.Amount == input.Amount ||
                    (this.Amount != null &&
                    this.Amount.Equals(input.Amount))
                ) && 
                (
                    this.CostCentreKey == input.CostCentreKey ||
                    (this.CostCentreKey != null &&
                    this.CostCentreKey.Equals(input.CostCentreKey))
                ) && 
                (
                    this.CodaInfo == input.CodaInfo ||
                    (this.CodaInfo != null &&
                    this.CodaInfo.Equals(input.CodaInfo))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.AccountKey != null)
                    hashCode = hashCode * 59 + this.AccountKey.GetHashCode();
                if (this.ExternalRelationId != null)
                    hashCode = hashCode * 59 + this.ExternalRelationId.GetHashCode();
                if (this.Reference != null)
                    hashCode = hashCode * 59 + this.Reference.GetHashCode();
                if (this.Amount != null)
                    hashCode = hashCode * 59 + this.Amount.GetHashCode();
                if (this.CostCentreKey != null)
                    hashCode = hashCode * 59 + this.CostCentreKey.GetHashCode();
                if (this.CodaInfo != null)
                    hashCode = hashCode * 59 + this.CodaInfo.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
