/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// FinancialDiversBookingServiceData
    /// </summary>
    [DataContract]
        public partial class FinancialDiversBookingServiceData :  IEquatable<FinancialDiversBookingServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FinancialDiversBookingServiceData" /> class.
        /// </summary>
        /// <param name="bookyearKey">bookyearKey (required).</param>
        /// <param name="journalKey">Identification of the journal ( F or D - journals ) (required).</param>
        /// <param name="documentSequenceNr">Identification of the document number (required).</param>
        /// <param name="bookyearPeriodeNr">Identification of the bookyear period (required).</param>
        /// <param name="documentDate">Document Date (required).</param>
        /// <param name="exchangeRate">Exchange Rate (required).</param>
        /// <param name="bookingLines">Financial booking lines.</param>
        public FinancialDiversBookingServiceData(BookyearKey bookyearKey = default(BookyearKey), string journalKey = default(string), int? documentSequenceNr = default(int?), int? bookyearPeriodeNr = default(int?), DateTime? documentDate = default(DateTime?), double? exchangeRate = default(double?), List<FinancialDiversBookingLineServiceData> bookingLines = default(List<FinancialDiversBookingLineServiceData>))
        {
            // to ensure "bookyearKey" is required (not null)
            if (bookyearKey == null)
            {
                throw new InvalidDataException("bookyearKey is a required property for FinancialDiversBookingServiceData and cannot be null");
            }
            else
            {
                this.BookyearKey = bookyearKey;
            }
            // to ensure "journalKey" is required (not null)
            if (journalKey == null)
            {
                throw new InvalidDataException("journalKey is a required property for FinancialDiversBookingServiceData and cannot be null");
            }
            else
            {
                this.JournalKey = journalKey;
            }
            // to ensure "documentSequenceNr" is required (not null)
            if (documentSequenceNr == null)
            {
                throw new InvalidDataException("documentSequenceNr is a required property for FinancialDiversBookingServiceData and cannot be null");
            }
            else
            {
                this.DocumentSequenceNr = documentSequenceNr;
            }
            // to ensure "bookyearPeriodeNr" is required (not null)
            if (bookyearPeriodeNr == null)
            {
                throw new InvalidDataException("bookyearPeriodeNr is a required property for FinancialDiversBookingServiceData and cannot be null");
            }
            else
            {
                this.BookyearPeriodeNr = bookyearPeriodeNr;
            }
            // to ensure "documentDate" is required (not null)
            if (documentDate == null)
            {
                throw new InvalidDataException("documentDate is a required property for FinancialDiversBookingServiceData and cannot be null");
            }
            else
            {
                this.DocumentDate = documentDate;
            }
            // to ensure "exchangeRate" is required (not null)
            if (exchangeRate == null)
            {
                throw new InvalidDataException("exchangeRate is a required property for FinancialDiversBookingServiceData and cannot be null");
            }
            else
            {
                this.ExchangeRate = exchangeRate;
            }
            this.BookingLines = bookingLines;
        }
        
        /// <summary>
        /// Gets or Sets BookyearKey
        /// </summary>
        [DataMember(Name="bookyearKey", EmitDefaultValue=false)]
        public BookyearKey BookyearKey { get; set; }

        /// <summary>
        /// Identification of the journal ( F or D - journals )
        /// </summary>
        /// <value>Identification of the journal ( F or D - journals )</value>
        [DataMember(Name="journalKey", EmitDefaultValue=false)]
        public string JournalKey { get; set; }

        /// <summary>
        /// Identification of the document number
        /// </summary>
        /// <value>Identification of the document number</value>
        [DataMember(Name="documentSequenceNr", EmitDefaultValue=false)]
        public int? DocumentSequenceNr { get; set; }

        /// <summary>
        /// Identification of the bookyear period
        /// </summary>
        /// <value>Identification of the bookyear period</value>
        [DataMember(Name="bookyearPeriodeNr", EmitDefaultValue=false)]
        public int? BookyearPeriodeNr { get; set; }

        /// <summary>
        /// Document Date
        /// </summary>
        /// <value>Document Date</value>
        [DataMember(Name="documentDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? DocumentDate { get; set; }

        /// <summary>
        /// Exchange Rate
        /// </summary>
        /// <value>Exchange Rate</value>
        [DataMember(Name="exchangeRate", EmitDefaultValue=false)]
        public double? ExchangeRate { get; set; }

        /// <summary>
        /// Financial booking lines
        /// </summary>
        /// <value>Financial booking lines</value>
        [DataMember(Name="bookingLines", EmitDefaultValue=false)]
        public List<FinancialDiversBookingLineServiceData> BookingLines { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class FinancialDiversBookingServiceData {\n");
            sb.Append("  BookyearKey: ").Append(BookyearKey).Append("\n");
            sb.Append("  JournalKey: ").Append(JournalKey).Append("\n");
            sb.Append("  DocumentSequenceNr: ").Append(DocumentSequenceNr).Append("\n");
            sb.Append("  BookyearPeriodeNr: ").Append(BookyearPeriodeNr).Append("\n");
            sb.Append("  DocumentDate: ").Append(DocumentDate).Append("\n");
            sb.Append("  ExchangeRate: ").Append(ExchangeRate).Append("\n");
            sb.Append("  BookingLines: ").Append(BookingLines).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as FinancialDiversBookingServiceData);
        }

        /// <summary>
        /// Returns true if FinancialDiversBookingServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of FinancialDiversBookingServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(FinancialDiversBookingServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BookyearKey == input.BookyearKey ||
                    (this.BookyearKey != null &&
                    this.BookyearKey.Equals(input.BookyearKey))
                ) && 
                (
                    this.JournalKey == input.JournalKey ||
                    (this.JournalKey != null &&
                    this.JournalKey.Equals(input.JournalKey))
                ) && 
                (
                    this.DocumentSequenceNr == input.DocumentSequenceNr ||
                    (this.DocumentSequenceNr != null &&
                    this.DocumentSequenceNr.Equals(input.DocumentSequenceNr))
                ) && 
                (
                    this.BookyearPeriodeNr == input.BookyearPeriodeNr ||
                    (this.BookyearPeriodeNr != null &&
                    this.BookyearPeriodeNr.Equals(input.BookyearPeriodeNr))
                ) && 
                (
                    this.DocumentDate == input.DocumentDate ||
                    (this.DocumentDate != null &&
                    this.DocumentDate.Equals(input.DocumentDate))
                ) && 
                (
                    this.ExchangeRate == input.ExchangeRate ||
                    (this.ExchangeRate != null &&
                    this.ExchangeRate.Equals(input.ExchangeRate))
                ) && 
                (
                    this.BookingLines == input.BookingLines ||
                    this.BookingLines != null &&
                    input.BookingLines != null &&
                    this.BookingLines.SequenceEqual(input.BookingLines)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BookyearKey != null)
                    hashCode = hashCode * 59 + this.BookyearKey.GetHashCode();
                if (this.JournalKey != null)
                    hashCode = hashCode * 59 + this.JournalKey.GetHashCode();
                if (this.DocumentSequenceNr != null)
                    hashCode = hashCode * 59 + this.DocumentSequenceNr.GetHashCode();
                if (this.BookyearPeriodeNr != null)
                    hashCode = hashCode * 59 + this.BookyearPeriodeNr.GetHashCode();
                if (this.DocumentDate != null)
                    hashCode = hashCode * 59 + this.DocumentDate.GetHashCode();
                if (this.ExchangeRate != null)
                    hashCode = hashCode * 59 + this.ExchangeRate.GetHashCode();
                if (this.BookingLines != null)
                    hashCode = hashCode * 59 + this.BookingLines.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
