/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// HistoryCostCentreData
    /// </summary>
    [DataContract]
        public partial class HistoryCostCentreData :  IEquatable<HistoryCostCentreData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="HistoryCostCentreData" /> class.
        /// </summary>
        /// <param name="bookyearKey">bookyearKey.</param>
        /// <param name="journalKey">journalKey.</param>
        /// <param name="documentSequenceNr">documentSequenceNr.</param>
        /// <param name="bookyearPeriodNr">bookyearPeriodNr.</param>
        /// <param name="relationKey">relationKey.</param>
        /// <param name="relationName">relationName.</param>
        /// <param name="documentDate">documentDate.</param>
        /// <param name="debetBookingAmount">debetBookingAmount.</param>
        /// <param name="creditBookingAmount">creditBookingAmount.</param>
        /// <param name="comment">comment.</param>
        /// <param name="costCentreKey">costCentreKey.</param>
        /// <param name="costCentreName">costCentreName.</param>
        /// <param name="activeCostCentre">activeCostCentre.</param>
        /// <param name="accountKey">accountKey.</param>
        /// <param name="accountName">accountName.</param>
        public HistoryCostCentreData(BookyearKey bookyearKey = default(BookyearKey), string journalKey = default(string), int? documentSequenceNr = default(int?), int? bookyearPeriodNr = default(int?), RelationKey relationKey = default(RelationKey), string relationName = default(string), DateTime? documentDate = default(DateTime?), double? debetBookingAmount = default(double?), double? creditBookingAmount = default(double?), string comment = default(string), CostCentreKey costCentreKey = default(CostCentreKey), string costCentreName = default(string), bool? activeCostCentre = default(bool?), AccountKey accountKey = default(AccountKey), string accountName = default(string))
        {
            this.BookyearKey = bookyearKey;
            this.JournalKey = journalKey;
            this.DocumentSequenceNr = documentSequenceNr;
            this.BookyearPeriodNr = bookyearPeriodNr;
            this.RelationKey = relationKey;
            this.RelationName = relationName;
            this.DocumentDate = documentDate;
            this.DebetBookingAmount = debetBookingAmount;
            this.CreditBookingAmount = creditBookingAmount;
            this.Comment = comment;
            this.CostCentreKey = costCentreKey;
            this.CostCentreName = costCentreName;
            this.ActiveCostCentre = activeCostCentre;
            this.AccountKey = accountKey;
            this.AccountName = accountName;
        }
        
        /// <summary>
        /// Gets or Sets BookyearKey
        /// </summary>
        [DataMember(Name="bookyearKey", EmitDefaultValue=false)]
        public BookyearKey BookyearKey { get; set; }

        /// <summary>
        /// Gets or Sets JournalKey
        /// </summary>
        [DataMember(Name="journalKey", EmitDefaultValue=false)]
        public string JournalKey { get; set; }

        /// <summary>
        /// Gets or Sets DocumentSequenceNr
        /// </summary>
        [DataMember(Name="documentSequenceNr", EmitDefaultValue=false)]
        public int? DocumentSequenceNr { get; set; }

        /// <summary>
        /// Gets or Sets BookyearPeriodNr
        /// </summary>
        [DataMember(Name="bookyearPeriodNr", EmitDefaultValue=false)]
        public int? BookyearPeriodNr { get; set; }

        /// <summary>
        /// Gets or Sets RelationKey
        /// </summary>
        [DataMember(Name="relationKey", EmitDefaultValue=false)]
        public RelationKey RelationKey { get; set; }

        /// <summary>
        /// Gets or Sets RelationName
        /// </summary>
        [DataMember(Name="relationName", EmitDefaultValue=false)]
        public string RelationName { get; set; }

        /// <summary>
        /// Gets or Sets DocumentDate
        /// </summary>
        [DataMember(Name="documentDate", EmitDefaultValue=false)]
        public DateTime? DocumentDate { get; set; }

        /// <summary>
        /// Gets or Sets DebetBookingAmount
        /// </summary>
        [DataMember(Name="debetBookingAmount", EmitDefaultValue=false)]
        public double? DebetBookingAmount { get; set; }

        /// <summary>
        /// Gets or Sets CreditBookingAmount
        /// </summary>
        [DataMember(Name="creditBookingAmount", EmitDefaultValue=false)]
        public double? CreditBookingAmount { get; set; }

        /// <summary>
        /// Gets or Sets Comment
        /// </summary>
        [DataMember(Name="comment", EmitDefaultValue=false)]
        public string Comment { get; set; }

        /// <summary>
        /// Gets or Sets CostCentreKey
        /// </summary>
        [DataMember(Name="costCentreKey", EmitDefaultValue=false)]
        public CostCentreKey CostCentreKey { get; set; }

        /// <summary>
        /// Gets or Sets CostCentreName
        /// </summary>
        [DataMember(Name="costCentreName", EmitDefaultValue=false)]
        public string CostCentreName { get; set; }

        /// <summary>
        /// Gets or Sets ActiveCostCentre
        /// </summary>
        [DataMember(Name="activeCostCentre", EmitDefaultValue=false)]
        public bool? ActiveCostCentre { get; set; }

        /// <summary>
        /// Gets or Sets AccountKey
        /// </summary>
        [DataMember(Name="accountKey", EmitDefaultValue=false)]
        public AccountKey AccountKey { get; set; }

        /// <summary>
        /// Gets or Sets AccountName
        /// </summary>
        [DataMember(Name="accountName", EmitDefaultValue=false)]
        public string AccountName { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class HistoryCostCentreData {\n");
            sb.Append("  BookyearKey: ").Append(BookyearKey).Append("\n");
            sb.Append("  JournalKey: ").Append(JournalKey).Append("\n");
            sb.Append("  DocumentSequenceNr: ").Append(DocumentSequenceNr).Append("\n");
            sb.Append("  BookyearPeriodNr: ").Append(BookyearPeriodNr).Append("\n");
            sb.Append("  RelationKey: ").Append(RelationKey).Append("\n");
            sb.Append("  RelationName: ").Append(RelationName).Append("\n");
            sb.Append("  DocumentDate: ").Append(DocumentDate).Append("\n");
            sb.Append("  DebetBookingAmount: ").Append(DebetBookingAmount).Append("\n");
            sb.Append("  CreditBookingAmount: ").Append(CreditBookingAmount).Append("\n");
            sb.Append("  Comment: ").Append(Comment).Append("\n");
            sb.Append("  CostCentreKey: ").Append(CostCentreKey).Append("\n");
            sb.Append("  CostCentreName: ").Append(CostCentreName).Append("\n");
            sb.Append("  ActiveCostCentre: ").Append(ActiveCostCentre).Append("\n");
            sb.Append("  AccountKey: ").Append(AccountKey).Append("\n");
            sb.Append("  AccountName: ").Append(AccountName).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as HistoryCostCentreData);
        }

        /// <summary>
        /// Returns true if HistoryCostCentreData instances are equal
        /// </summary>
        /// <param name="input">Instance of HistoryCostCentreData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(HistoryCostCentreData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BookyearKey == input.BookyearKey ||
                    (this.BookyearKey != null &&
                    this.BookyearKey.Equals(input.BookyearKey))
                ) && 
                (
                    this.JournalKey == input.JournalKey ||
                    (this.JournalKey != null &&
                    this.JournalKey.Equals(input.JournalKey))
                ) && 
                (
                    this.DocumentSequenceNr == input.DocumentSequenceNr ||
                    (this.DocumentSequenceNr != null &&
                    this.DocumentSequenceNr.Equals(input.DocumentSequenceNr))
                ) && 
                (
                    this.BookyearPeriodNr == input.BookyearPeriodNr ||
                    (this.BookyearPeriodNr != null &&
                    this.BookyearPeriodNr.Equals(input.BookyearPeriodNr))
                ) && 
                (
                    this.RelationKey == input.RelationKey ||
                    (this.RelationKey != null &&
                    this.RelationKey.Equals(input.RelationKey))
                ) && 
                (
                    this.RelationName == input.RelationName ||
                    (this.RelationName != null &&
                    this.RelationName.Equals(input.RelationName))
                ) && 
                (
                    this.DocumentDate == input.DocumentDate ||
                    (this.DocumentDate != null &&
                    this.DocumentDate.Equals(input.DocumentDate))
                ) && 
                (
                    this.DebetBookingAmount == input.DebetBookingAmount ||
                    (this.DebetBookingAmount != null &&
                    this.DebetBookingAmount.Equals(input.DebetBookingAmount))
                ) && 
                (
                    this.CreditBookingAmount == input.CreditBookingAmount ||
                    (this.CreditBookingAmount != null &&
                    this.CreditBookingAmount.Equals(input.CreditBookingAmount))
                ) && 
                (
                    this.Comment == input.Comment ||
                    (this.Comment != null &&
                    this.Comment.Equals(input.Comment))
                ) && 
                (
                    this.CostCentreKey == input.CostCentreKey ||
                    (this.CostCentreKey != null &&
                    this.CostCentreKey.Equals(input.CostCentreKey))
                ) && 
                (
                    this.CostCentreName == input.CostCentreName ||
                    (this.CostCentreName != null &&
                    this.CostCentreName.Equals(input.CostCentreName))
                ) && 
                (
                    this.ActiveCostCentre == input.ActiveCostCentre ||
                    (this.ActiveCostCentre != null &&
                    this.ActiveCostCentre.Equals(input.ActiveCostCentre))
                ) && 
                (
                    this.AccountKey == input.AccountKey ||
                    (this.AccountKey != null &&
                    this.AccountKey.Equals(input.AccountKey))
                ) && 
                (
                    this.AccountName == input.AccountName ||
                    (this.AccountName != null &&
                    this.AccountName.Equals(input.AccountName))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BookyearKey != null)
                    hashCode = hashCode * 59 + this.BookyearKey.GetHashCode();
                if (this.JournalKey != null)
                    hashCode = hashCode * 59 + this.JournalKey.GetHashCode();
                if (this.DocumentSequenceNr != null)
                    hashCode = hashCode * 59 + this.DocumentSequenceNr.GetHashCode();
                if (this.BookyearPeriodNr != null)
                    hashCode = hashCode * 59 + this.BookyearPeriodNr.GetHashCode();
                if (this.RelationKey != null)
                    hashCode = hashCode * 59 + this.RelationKey.GetHashCode();
                if (this.RelationName != null)
                    hashCode = hashCode * 59 + this.RelationName.GetHashCode();
                if (this.DocumentDate != null)
                    hashCode = hashCode * 59 + this.DocumentDate.GetHashCode();
                if (this.DebetBookingAmount != null)
                    hashCode = hashCode * 59 + this.DebetBookingAmount.GetHashCode();
                if (this.CreditBookingAmount != null)
                    hashCode = hashCode * 59 + this.CreditBookingAmount.GetHashCode();
                if (this.Comment != null)
                    hashCode = hashCode * 59 + this.Comment.GetHashCode();
                if (this.CostCentreKey != null)
                    hashCode = hashCode * 59 + this.CostCentreKey.GetHashCode();
                if (this.CostCentreName != null)
                    hashCode = hashCode * 59 + this.CostCentreName.GetHashCode();
                if (this.ActiveCostCentre != null)
                    hashCode = hashCode * 59 + this.ActiveCostCentre.GetHashCode();
                if (this.AccountKey != null)
                    hashCode = hashCode * 59 + this.AccountKey.GetHashCode();
                if (this.AccountName != null)
                    hashCode = hashCode * 59 + this.AccountName.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
