/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// HistoryCostCentreQueryData
    /// </summary>
    [DataContract]
        public partial class HistoryCostCentreQueryData :  IEquatable<HistoryCostCentreQueryData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="HistoryCostCentreQueryData" /> class.
        /// </summary>
        /// <param name="fromBookyearKey">fromBookyearKey.</param>
        /// <param name="toBookyearKey">toBookyearKey.</param>
        /// <param name="fromBookyearPeriodNr">fromBookyearPeriodNr.</param>
        /// <param name="toBookyearPeriodNr">toBookyearPeriodNr.</param>
        /// <param name="fromAccountNr">fromAccountNr.</param>
        /// <param name="toAccountNr">toAccountNr.</param>
        /// <param name="showActiveCostCentres">showActiveCostCentres.</param>
        /// <param name="showInactiveCostCentres">showInactiveCostCentres.</param>
        /// <param name="showEmptyCostcentres">showEmptyCostcentres.</param>
        public HistoryCostCentreQueryData(BookyearKey fromBookyearKey = default(BookyearKey), BookyearKey toBookyearKey = default(BookyearKey), int? fromBookyearPeriodNr = default(int?), int? toBookyearPeriodNr = default(int?), int? fromAccountNr = default(int?), int? toAccountNr = default(int?), bool? showActiveCostCentres = default(bool?), bool? showInactiveCostCentres = default(bool?), bool? showEmptyCostcentres = default(bool?))
        {
            this.FromBookyearKey = fromBookyearKey;
            this.ToBookyearKey = toBookyearKey;
            this.FromBookyearPeriodNr = fromBookyearPeriodNr;
            this.ToBookyearPeriodNr = toBookyearPeriodNr;
            this.FromAccountNr = fromAccountNr;
            this.ToAccountNr = toAccountNr;
            this.ShowActiveCostCentres = showActiveCostCentres;
            this.ShowInactiveCostCentres = showInactiveCostCentres;
            this.ShowEmptyCostcentres = showEmptyCostcentres;
        }
        
        /// <summary>
        /// Gets or Sets FromBookyearKey
        /// </summary>
        [DataMember(Name="fromBookyearKey", EmitDefaultValue=false)]
        public BookyearKey FromBookyearKey { get; set; }

        /// <summary>
        /// Gets or Sets ToBookyearKey
        /// </summary>
        [DataMember(Name="toBookyearKey", EmitDefaultValue=false)]
        public BookyearKey ToBookyearKey { get; set; }

        /// <summary>
        /// Gets or Sets FromBookyearPeriodNr
        /// </summary>
        [DataMember(Name="fromBookyearPeriodNr", EmitDefaultValue=false)]
        public int? FromBookyearPeriodNr { get; set; }

        /// <summary>
        /// Gets or Sets ToBookyearPeriodNr
        /// </summary>
        [DataMember(Name="toBookyearPeriodNr", EmitDefaultValue=false)]
        public int? ToBookyearPeriodNr { get; set; }

        /// <summary>
        /// Gets or Sets FromAccountNr
        /// </summary>
        [DataMember(Name="fromAccountNr", EmitDefaultValue=false)]
        public int? FromAccountNr { get; set; }

        /// <summary>
        /// Gets or Sets ToAccountNr
        /// </summary>
        [DataMember(Name="toAccountNr", EmitDefaultValue=false)]
        public int? ToAccountNr { get; set; }

        /// <summary>
        /// Gets or Sets ShowActiveCostCentres
        /// </summary>
        [DataMember(Name="showActiveCostCentres", EmitDefaultValue=false)]
        public bool? ShowActiveCostCentres { get; set; }

        /// <summary>
        /// Gets or Sets ShowInactiveCostCentres
        /// </summary>
        [DataMember(Name="showInactiveCostCentres", EmitDefaultValue=false)]
        public bool? ShowInactiveCostCentres { get; set; }

        /// <summary>
        /// Gets or Sets ShowEmptyCostcentres
        /// </summary>
        [DataMember(Name="showEmptyCostcentres", EmitDefaultValue=false)]
        public bool? ShowEmptyCostcentres { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class HistoryCostCentreQueryData {\n");
            sb.Append("  FromBookyearKey: ").Append(FromBookyearKey).Append("\n");
            sb.Append("  ToBookyearKey: ").Append(ToBookyearKey).Append("\n");
            sb.Append("  FromBookyearPeriodNr: ").Append(FromBookyearPeriodNr).Append("\n");
            sb.Append("  ToBookyearPeriodNr: ").Append(ToBookyearPeriodNr).Append("\n");
            sb.Append("  FromAccountNr: ").Append(FromAccountNr).Append("\n");
            sb.Append("  ToAccountNr: ").Append(ToAccountNr).Append("\n");
            sb.Append("  ShowActiveCostCentres: ").Append(ShowActiveCostCentres).Append("\n");
            sb.Append("  ShowInactiveCostCentres: ").Append(ShowInactiveCostCentres).Append("\n");
            sb.Append("  ShowEmptyCostcentres: ").Append(ShowEmptyCostcentres).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as HistoryCostCentreQueryData);
        }

        /// <summary>
        /// Returns true if HistoryCostCentreQueryData instances are equal
        /// </summary>
        /// <param name="input">Instance of HistoryCostCentreQueryData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(HistoryCostCentreQueryData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.FromBookyearKey == input.FromBookyearKey ||
                    (this.FromBookyearKey != null &&
                    this.FromBookyearKey.Equals(input.FromBookyearKey))
                ) && 
                (
                    this.ToBookyearKey == input.ToBookyearKey ||
                    (this.ToBookyearKey != null &&
                    this.ToBookyearKey.Equals(input.ToBookyearKey))
                ) && 
                (
                    this.FromBookyearPeriodNr == input.FromBookyearPeriodNr ||
                    (this.FromBookyearPeriodNr != null &&
                    this.FromBookyearPeriodNr.Equals(input.FromBookyearPeriodNr))
                ) && 
                (
                    this.ToBookyearPeriodNr == input.ToBookyearPeriodNr ||
                    (this.ToBookyearPeriodNr != null &&
                    this.ToBookyearPeriodNr.Equals(input.ToBookyearPeriodNr))
                ) && 
                (
                    this.FromAccountNr == input.FromAccountNr ||
                    (this.FromAccountNr != null &&
                    this.FromAccountNr.Equals(input.FromAccountNr))
                ) && 
                (
                    this.ToAccountNr == input.ToAccountNr ||
                    (this.ToAccountNr != null &&
                    this.ToAccountNr.Equals(input.ToAccountNr))
                ) && 
                (
                    this.ShowActiveCostCentres == input.ShowActiveCostCentres ||
                    (this.ShowActiveCostCentres != null &&
                    this.ShowActiveCostCentres.Equals(input.ShowActiveCostCentres))
                ) && 
                (
                    this.ShowInactiveCostCentres == input.ShowInactiveCostCentres ||
                    (this.ShowInactiveCostCentres != null &&
                    this.ShowInactiveCostCentres.Equals(input.ShowInactiveCostCentres))
                ) && 
                (
                    this.ShowEmptyCostcentres == input.ShowEmptyCostcentres ||
                    (this.ShowEmptyCostcentres != null &&
                    this.ShowEmptyCostcentres.Equals(input.ShowEmptyCostcentres))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.FromBookyearKey != null)
                    hashCode = hashCode * 59 + this.FromBookyearKey.GetHashCode();
                if (this.ToBookyearKey != null)
                    hashCode = hashCode * 59 + this.ToBookyearKey.GetHashCode();
                if (this.FromBookyearPeriodNr != null)
                    hashCode = hashCode * 59 + this.FromBookyearPeriodNr.GetHashCode();
                if (this.ToBookyearPeriodNr != null)
                    hashCode = hashCode * 59 + this.ToBookyearPeriodNr.GetHashCode();
                if (this.FromAccountNr != null)
                    hashCode = hashCode * 59 + this.FromAccountNr.GetHashCode();
                if (this.ToAccountNr != null)
                    hashCode = hashCode * 59 + this.ToAccountNr.GetHashCode();
                if (this.ShowActiveCostCentres != null)
                    hashCode = hashCode * 59 + this.ShowActiveCostCentres.GetHashCode();
                if (this.ShowInactiveCostCentres != null)
                    hashCode = hashCode * 59 + this.ShowInactiveCostCentres.GetHashCode();
                if (this.ShowEmptyCostcentres != null)
                    hashCode = hashCode * 59 + this.ShowEmptyCostcentres.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
