/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Only if relationId &#x3D; -1, external_Relation_Id is used to query the data,&lt;br/&gt;otherwise the (internal) relation_Id is used to query the data.
    /// </summary>
    [DataContract]
        public partial class HistoryRelationQueryData :  IEquatable<HistoryRelationQueryData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="HistoryRelationQueryData" /> class.
        /// </summary>
        /// <param name="fromBookyearKey">fromBookyearKey.</param>
        /// <param name="toBookyearKey">toBookyearKey.</param>
        /// <param name="fromBookyearPeriodNr">fromBookyearPeriodNr.</param>
        /// <param name="toBookyearPeriodNr">toBookyearPeriodNr.</param>
        /// <param name="externalRelationId">externalRelationId.</param>
        /// <param name="relationId">relationId.</param>
        public HistoryRelationQueryData(BookyearKey fromBookyearKey = default(BookyearKey), BookyearKey toBookyearKey = default(BookyearKey), int? fromBookyearPeriodNr = default(int?), int? toBookyearPeriodNr = default(int?), int? externalRelationId = default(int?), int? relationId = default(int?))
        {
            this.FromBookyearKey = fromBookyearKey;
            this.ToBookyearKey = toBookyearKey;
            this.FromBookyearPeriodNr = fromBookyearPeriodNr;
            this.ToBookyearPeriodNr = toBookyearPeriodNr;
            this.ExternalRelationId = externalRelationId;
            this.RelationId = relationId;
        }
        
        /// <summary>
        /// Gets or Sets FromBookyearKey
        /// </summary>
        [DataMember(Name="fromBookyearKey", EmitDefaultValue=false)]
        public BookyearKey FromBookyearKey { get; set; }

        /// <summary>
        /// Gets or Sets ToBookyearKey
        /// </summary>
        [DataMember(Name="toBookyearKey", EmitDefaultValue=false)]
        public BookyearKey ToBookyearKey { get; set; }

        /// <summary>
        /// Gets or Sets FromBookyearPeriodNr
        /// </summary>
        [DataMember(Name="fromBookyearPeriodNr", EmitDefaultValue=false)]
        public int? FromBookyearPeriodNr { get; set; }

        /// <summary>
        /// Gets or Sets ToBookyearPeriodNr
        /// </summary>
        [DataMember(Name="toBookyearPeriodNr", EmitDefaultValue=false)]
        public int? ToBookyearPeriodNr { get; set; }

        /// <summary>
        /// Gets or Sets ExternalRelationId
        /// </summary>
        [DataMember(Name="externalRelationId", EmitDefaultValue=false)]
        public int? ExternalRelationId { get; set; }

        /// <summary>
        /// Gets or Sets RelationId
        /// </summary>
        [DataMember(Name="relationId", EmitDefaultValue=false)]
        public int? RelationId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class HistoryRelationQueryData {\n");
            sb.Append("  FromBookyearKey: ").Append(FromBookyearKey).Append("\n");
            sb.Append("  ToBookyearKey: ").Append(ToBookyearKey).Append("\n");
            sb.Append("  FromBookyearPeriodNr: ").Append(FromBookyearPeriodNr).Append("\n");
            sb.Append("  ToBookyearPeriodNr: ").Append(ToBookyearPeriodNr).Append("\n");
            sb.Append("  ExternalRelationId: ").Append(ExternalRelationId).Append("\n");
            sb.Append("  RelationId: ").Append(RelationId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as HistoryRelationQueryData);
        }

        /// <summary>
        /// Returns true if HistoryRelationQueryData instances are equal
        /// </summary>
        /// <param name="input">Instance of HistoryRelationQueryData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(HistoryRelationQueryData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.FromBookyearKey == input.FromBookyearKey ||
                    (this.FromBookyearKey != null &&
                    this.FromBookyearKey.Equals(input.FromBookyearKey))
                ) && 
                (
                    this.ToBookyearKey == input.ToBookyearKey ||
                    (this.ToBookyearKey != null &&
                    this.ToBookyearKey.Equals(input.ToBookyearKey))
                ) && 
                (
                    this.FromBookyearPeriodNr == input.FromBookyearPeriodNr ||
                    (this.FromBookyearPeriodNr != null &&
                    this.FromBookyearPeriodNr.Equals(input.FromBookyearPeriodNr))
                ) && 
                (
                    this.ToBookyearPeriodNr == input.ToBookyearPeriodNr ||
                    (this.ToBookyearPeriodNr != null &&
                    this.ToBookyearPeriodNr.Equals(input.ToBookyearPeriodNr))
                ) && 
                (
                    this.ExternalRelationId == input.ExternalRelationId ||
                    (this.ExternalRelationId != null &&
                    this.ExternalRelationId.Equals(input.ExternalRelationId))
                ) && 
                (
                    this.RelationId == input.RelationId ||
                    (this.RelationId != null &&
                    this.RelationId.Equals(input.RelationId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.FromBookyearKey != null)
                    hashCode = hashCode * 59 + this.FromBookyearKey.GetHashCode();
                if (this.ToBookyearKey != null)
                    hashCode = hashCode * 59 + this.ToBookyearKey.GetHashCode();
                if (this.FromBookyearPeriodNr != null)
                    hashCode = hashCode * 59 + this.FromBookyearPeriodNr.GetHashCode();
                if (this.ToBookyearPeriodNr != null)
                    hashCode = hashCode * 59 + this.ToBookyearPeriodNr.GetHashCode();
                if (this.ExternalRelationId != null)
                    hashCode = hashCode * 59 + this.ExternalRelationId.GetHashCode();
                if (this.RelationId != null)
                    hashCode = hashCode * 59 + this.RelationId.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
