/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Invoice lines
    /// </summary>
    [DataContract]
        public partial class InvoiceLineServiceData :  IEquatable<InvoiceLineServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InvoiceLineServiceData" /> class.
        /// </summary>
        /// <param name="externProductNr">Identification of the external product nr. ( Optional ).</param>
        /// <param name="description">Line description.</param>
        /// <param name="count">Count.</param>
        /// <param name="unit">Unit.</param>
        /// <param name="unitPrice">Unit Price.</param>
        /// <param name="discountPercentage">Percentage of discount on the line&#x27;s total amount.</param>
        /// <param name="vatCodeKey">Identification of the vat code ( 06 , 21 , ... ) (required).</param>
        /// <param name="bookingAccountNr">Identification of the booking account (required).</param>
        /// <param name="costCentreKey">costCentreKey.</param>
        /// <param name="customFieldValueList">List of Custom Field Value Data.</param>
        /// <param name="intrastatServiceData">intrastatServiceData.</param>
        public InvoiceLineServiceData(string externProductNr = default(string), string description = default(string), double? count = default(double?), string unit = default(string), double? unitPrice = default(double?), double? discountPercentage = default(double?), string vatCodeKey = default(string), int? bookingAccountNr = default(int?), CostCentreKey costCentreKey = default(CostCentreKey), List<CustomFieldValueServiceData> customFieldValueList = default(List<CustomFieldValueServiceData>), IntrastatServiceData intrastatServiceData = default(IntrastatServiceData))
        {
            // to ensure "vatCodeKey" is required (not null)
            if (vatCodeKey == null)
            {
                throw new InvalidDataException("vatCodeKey is a required property for InvoiceLineServiceData and cannot be null");
            }
            else
            {
                this.VatCodeKey = vatCodeKey;
            }
            // to ensure "bookingAccountNr" is required (not null)
            if (bookingAccountNr == null)
            {
                throw new InvalidDataException("bookingAccountNr is a required property for InvoiceLineServiceData and cannot be null");
            }
            else
            {
                this.BookingAccountNr = bookingAccountNr;
            }
            this.ExternProductNr = externProductNr;
            this.Description = description;
            this.Count = count;
            this.Unit = unit;
            this.UnitPrice = unitPrice;
            this.DiscountPercentage = discountPercentage;
            this.CostCentreKey = costCentreKey;
            this.CustomFieldValueList = customFieldValueList;
            this.IntrastatServiceData = intrastatServiceData;
        }
        
        /// <summary>
        /// Identification of the external product nr. ( Optional )
        /// </summary>
        /// <value>Identification of the external product nr. ( Optional )</value>
        [DataMember(Name="externProductNr", EmitDefaultValue=false)]
        public string ExternProductNr { get; set; }

        /// <summary>
        /// Line description
        /// </summary>
        /// <value>Line description</value>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Count
        /// </summary>
        /// <value>Count</value>
        [DataMember(Name="count", EmitDefaultValue=false)]
        public double? Count { get; set; }

        /// <summary>
        /// Unit
        /// </summary>
        /// <value>Unit</value>
        [DataMember(Name="unit", EmitDefaultValue=false)]
        public string Unit { get; set; }

        /// <summary>
        /// Unit Price
        /// </summary>
        /// <value>Unit Price</value>
        [DataMember(Name="unitPrice", EmitDefaultValue=false)]
        public double? UnitPrice { get; set; }

        /// <summary>
        /// Percentage of discount on the line&#x27;s total amount
        /// </summary>
        /// <value>Percentage of discount on the line&#x27;s total amount</value>
        [DataMember(Name="discountPercentage", EmitDefaultValue=false)]
        public double? DiscountPercentage { get; set; }

        /// <summary>
        /// Identification of the vat code ( 06 , 21 , ... )
        /// </summary>
        /// <value>Identification of the vat code ( 06 , 21 , ... )</value>
        [DataMember(Name="vatCodeKey", EmitDefaultValue=false)]
        public string VatCodeKey { get; set; }

        /// <summary>
        /// Identification of the booking account
        /// </summary>
        /// <value>Identification of the booking account</value>
        [DataMember(Name="bookingAccountNr", EmitDefaultValue=false)]
        public int? BookingAccountNr { get; set; }

        /// <summary>
        /// Gets or Sets CostCentreKey
        /// </summary>
        [DataMember(Name="costCentreKey", EmitDefaultValue=false)]
        public CostCentreKey CostCentreKey { get; set; }

        /// <summary>
        /// List of Custom Field Value Data
        /// </summary>
        /// <value>List of Custom Field Value Data</value>
        [DataMember(Name="customFieldValueList", EmitDefaultValue=false)]
        public List<CustomFieldValueServiceData> CustomFieldValueList { get; set; }

        /// <summary>
        /// Gets or Sets IntrastatServiceData
        /// </summary>
        [DataMember(Name="intrastatServiceData", EmitDefaultValue=false)]
        public IntrastatServiceData IntrastatServiceData { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InvoiceLineServiceData {\n");
            sb.Append("  ExternProductNr: ").Append(ExternProductNr).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Count: ").Append(Count).Append("\n");
            sb.Append("  Unit: ").Append(Unit).Append("\n");
            sb.Append("  UnitPrice: ").Append(UnitPrice).Append("\n");
            sb.Append("  DiscountPercentage: ").Append(DiscountPercentage).Append("\n");
            sb.Append("  VatCodeKey: ").Append(VatCodeKey).Append("\n");
            sb.Append("  BookingAccountNr: ").Append(BookingAccountNr).Append("\n");
            sb.Append("  CostCentreKey: ").Append(CostCentreKey).Append("\n");
            sb.Append("  CustomFieldValueList: ").Append(CustomFieldValueList).Append("\n");
            sb.Append("  IntrastatServiceData: ").Append(IntrastatServiceData).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as InvoiceLineServiceData);
        }

        /// <summary>
        /// Returns true if InvoiceLineServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of InvoiceLineServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InvoiceLineServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ExternProductNr == input.ExternProductNr ||
                    (this.ExternProductNr != null &&
                    this.ExternProductNr.Equals(input.ExternProductNr))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.Count == input.Count ||
                    (this.Count != null &&
                    this.Count.Equals(input.Count))
                ) && 
                (
                    this.Unit == input.Unit ||
                    (this.Unit != null &&
                    this.Unit.Equals(input.Unit))
                ) && 
                (
                    this.UnitPrice == input.UnitPrice ||
                    (this.UnitPrice != null &&
                    this.UnitPrice.Equals(input.UnitPrice))
                ) && 
                (
                    this.DiscountPercentage == input.DiscountPercentage ||
                    (this.DiscountPercentage != null &&
                    this.DiscountPercentage.Equals(input.DiscountPercentage))
                ) && 
                (
                    this.VatCodeKey == input.VatCodeKey ||
                    (this.VatCodeKey != null &&
                    this.VatCodeKey.Equals(input.VatCodeKey))
                ) && 
                (
                    this.BookingAccountNr == input.BookingAccountNr ||
                    (this.BookingAccountNr != null &&
                    this.BookingAccountNr.Equals(input.BookingAccountNr))
                ) && 
                (
                    this.CostCentreKey == input.CostCentreKey ||
                    (this.CostCentreKey != null &&
                    this.CostCentreKey.Equals(input.CostCentreKey))
                ) && 
                (
                    this.CustomFieldValueList == input.CustomFieldValueList ||
                    this.CustomFieldValueList != null &&
                    input.CustomFieldValueList != null &&
                    this.CustomFieldValueList.SequenceEqual(input.CustomFieldValueList)
                ) && 
                (
                    this.IntrastatServiceData == input.IntrastatServiceData ||
                    (this.IntrastatServiceData != null &&
                    this.IntrastatServiceData.Equals(input.IntrastatServiceData))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ExternProductNr != null)
                    hashCode = hashCode * 59 + this.ExternProductNr.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.Count != null)
                    hashCode = hashCode * 59 + this.Count.GetHashCode();
                if (this.Unit != null)
                    hashCode = hashCode * 59 + this.Unit.GetHashCode();
                if (this.UnitPrice != null)
                    hashCode = hashCode * 59 + this.UnitPrice.GetHashCode();
                if (this.DiscountPercentage != null)
                    hashCode = hashCode * 59 + this.DiscountPercentage.GetHashCode();
                if (this.VatCodeKey != null)
                    hashCode = hashCode * 59 + this.VatCodeKey.GetHashCode();
                if (this.BookingAccountNr != null)
                    hashCode = hashCode * 59 + this.BookingAccountNr.GetHashCode();
                if (this.CostCentreKey != null)
                    hashCode = hashCode * 59 + this.CostCentreKey.GetHashCode();
                if (this.CustomFieldValueList != null)
                    hashCode = hashCode * 59 + this.CustomFieldValueList.GetHashCode();
                if (this.IntrastatServiceData != null)
                    hashCode = hashCode * 59 + this.IntrastatServiceData.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
