/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// JournalServiceData
    /// </summary>
    [DataContract]
        public partial class JournalServiceData :  IEquatable<JournalServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="JournalServiceData" /> class.
        /// </summary>
        /// <param name="bookyearKey">bookyearKey (required).</param>
        /// <param name="journalKey">Key for the journal (required).</param>
        /// <param name="name">Description of the journal (required).</param>
        /// <param name="closed">Check if the journal is closed (required).</param>
        /// <param name="currencyCode">Currency code of the journal.</param>
        /// <param name="lastBookedDocumentNr">Last booked document number in this journal.</param>
        /// <param name="protectedPeriod">Bookyear period indicating until when this journal is protected.</param>
        /// <param name="closedPeriod">Bookyear period from when this journal is closed.</param>
        /// <param name="insertionType">Specifies the current type of insertion. This is only relevant for sale journals.&lt;ul&gt;&lt;li&gt; Value 1 : Bookings&lt;/li&gt;&lt;li&gt; Value 2 : Invoices VAT exclusive&lt;/li&gt;&lt;li&gt; Value 3 : Invoices VAT inclusive&lt;/li&gt;&lt;li&gt; Value 4 : Delivery Notes VAT exclusive&lt;/li&gt;&lt;li&gt; Value 5 : Delivery Notes VAT inclusive&lt;/li&gt;&lt;/ul&gt;.</param>
        /// <param name="customFieldList">customFieldList.</param>
        /// <param name="customFieldLineList">customFieldLineList.</param>
        public JournalServiceData(BookyearKey bookyearKey = default(BookyearKey), string journalKey = default(string), string name = default(string), bool? closed = default(bool?), string currencyCode = default(string), int? lastBookedDocumentNr = default(int?), int? protectedPeriod = default(int?), int? closedPeriod = default(int?), int? insertionType = default(int?), List<CustomFieldKey> customFieldList = default(List<CustomFieldKey>), List<CustomFieldKey> customFieldLineList = default(List<CustomFieldKey>))
        {
            // to ensure "bookyearKey" is required (not null)
            if (bookyearKey == null)
            {
                throw new InvalidDataException("bookyearKey is a required property for JournalServiceData and cannot be null");
            }
            else
            {
                this.BookyearKey = bookyearKey;
            }
            // to ensure "journalKey" is required (not null)
            if (journalKey == null)
            {
                throw new InvalidDataException("journalKey is a required property for JournalServiceData and cannot be null");
            }
            else
            {
                this.JournalKey = journalKey;
            }
            // to ensure "name" is required (not null)
            if (name == null)
            {
                throw new InvalidDataException("name is a required property for JournalServiceData and cannot be null");
            }
            else
            {
                this.Name = name;
            }
            // to ensure "closed" is required (not null)
            if (closed == null)
            {
                throw new InvalidDataException("closed is a required property for JournalServiceData and cannot be null");
            }
            else
            {
                this.Closed = closed;
            }
            this.CurrencyCode = currencyCode;
            this.LastBookedDocumentNr = lastBookedDocumentNr;
            this.ProtectedPeriod = protectedPeriod;
            this.ClosedPeriod = closedPeriod;
            this.InsertionType = insertionType;
            this.CustomFieldList = customFieldList;
            this.CustomFieldLineList = customFieldLineList;
        }
        
        /// <summary>
        /// Gets or Sets BookyearKey
        /// </summary>
        [DataMember(Name="bookyearKey", EmitDefaultValue=false)]
        public BookyearKey BookyearKey { get; set; }

        /// <summary>
        /// Key for the journal
        /// </summary>
        /// <value>Key for the journal</value>
        [DataMember(Name="journalKey", EmitDefaultValue=false)]
        public string JournalKey { get; set; }

        /// <summary>
        /// Description of the journal
        /// </summary>
        /// <value>Description of the journal</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Check if the journal is closed
        /// </summary>
        /// <value>Check if the journal is closed</value>
        [DataMember(Name="closed", EmitDefaultValue=false)]
        public bool? Closed { get; set; }

        /// <summary>
        /// Currency code of the journal
        /// </summary>
        /// <value>Currency code of the journal</value>
        [DataMember(Name="currencyCode", EmitDefaultValue=false)]
        public string CurrencyCode { get; set; }

        /// <summary>
        /// Last booked document number in this journal
        /// </summary>
        /// <value>Last booked document number in this journal</value>
        [DataMember(Name="lastBookedDocumentNr", EmitDefaultValue=false)]
        public int? LastBookedDocumentNr { get; set; }

        /// <summary>
        /// Bookyear period indicating until when this journal is protected
        /// </summary>
        /// <value>Bookyear period indicating until when this journal is protected</value>
        [DataMember(Name="protectedPeriod", EmitDefaultValue=false)]
        public int? ProtectedPeriod { get; set; }

        /// <summary>
        /// Bookyear period from when this journal is closed
        /// </summary>
        /// <value>Bookyear period from when this journal is closed</value>
        [DataMember(Name="closedPeriod", EmitDefaultValue=false)]
        public int? ClosedPeriod { get; set; }

        /// <summary>
        /// Specifies the current type of insertion. This is only relevant for sale journals.&lt;ul&gt;&lt;li&gt; Value 1 : Bookings&lt;/li&gt;&lt;li&gt; Value 2 : Invoices VAT exclusive&lt;/li&gt;&lt;li&gt; Value 3 : Invoices VAT inclusive&lt;/li&gt;&lt;li&gt; Value 4 : Delivery Notes VAT exclusive&lt;/li&gt;&lt;li&gt; Value 5 : Delivery Notes VAT inclusive&lt;/li&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>Specifies the current type of insertion. This is only relevant for sale journals.&lt;ul&gt;&lt;li&gt; Value 1 : Bookings&lt;/li&gt;&lt;li&gt; Value 2 : Invoices VAT exclusive&lt;/li&gt;&lt;li&gt; Value 3 : Invoices VAT inclusive&lt;/li&gt;&lt;li&gt; Value 4 : Delivery Notes VAT exclusive&lt;/li&gt;&lt;li&gt; Value 5 : Delivery Notes VAT inclusive&lt;/li&gt;&lt;/ul&gt;</value>
        [DataMember(Name="insertionType", EmitDefaultValue=false)]
        public int? InsertionType { get; set; }

        /// <summary>
        /// Gets or Sets CustomFieldList
        /// </summary>
        [DataMember(Name="customFieldList", EmitDefaultValue=false)]
        public List<CustomFieldKey> CustomFieldList { get; set; }

        /// <summary>
        /// Gets or Sets CustomFieldLineList
        /// </summary>
        [DataMember(Name="customFieldLineList", EmitDefaultValue=false)]
        public List<CustomFieldKey> CustomFieldLineList { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class JournalServiceData {\n");
            sb.Append("  BookyearKey: ").Append(BookyearKey).Append("\n");
            sb.Append("  JournalKey: ").Append(JournalKey).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Closed: ").Append(Closed).Append("\n");
            sb.Append("  CurrencyCode: ").Append(CurrencyCode).Append("\n");
            sb.Append("  LastBookedDocumentNr: ").Append(LastBookedDocumentNr).Append("\n");
            sb.Append("  ProtectedPeriod: ").Append(ProtectedPeriod).Append("\n");
            sb.Append("  ClosedPeriod: ").Append(ClosedPeriod).Append("\n");
            sb.Append("  InsertionType: ").Append(InsertionType).Append("\n");
            sb.Append("  CustomFieldList: ").Append(CustomFieldList).Append("\n");
            sb.Append("  CustomFieldLineList: ").Append(CustomFieldLineList).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as JournalServiceData);
        }

        /// <summary>
        /// Returns true if JournalServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of JournalServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(JournalServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BookyearKey == input.BookyearKey ||
                    (this.BookyearKey != null &&
                    this.BookyearKey.Equals(input.BookyearKey))
                ) && 
                (
                    this.JournalKey == input.JournalKey ||
                    (this.JournalKey != null &&
                    this.JournalKey.Equals(input.JournalKey))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Closed == input.Closed ||
                    (this.Closed != null &&
                    this.Closed.Equals(input.Closed))
                ) && 
                (
                    this.CurrencyCode == input.CurrencyCode ||
                    (this.CurrencyCode != null &&
                    this.CurrencyCode.Equals(input.CurrencyCode))
                ) && 
                (
                    this.LastBookedDocumentNr == input.LastBookedDocumentNr ||
                    (this.LastBookedDocumentNr != null &&
                    this.LastBookedDocumentNr.Equals(input.LastBookedDocumentNr))
                ) && 
                (
                    this.ProtectedPeriod == input.ProtectedPeriod ||
                    (this.ProtectedPeriod != null &&
                    this.ProtectedPeriod.Equals(input.ProtectedPeriod))
                ) && 
                (
                    this.ClosedPeriod == input.ClosedPeriod ||
                    (this.ClosedPeriod != null &&
                    this.ClosedPeriod.Equals(input.ClosedPeriod))
                ) && 
                (
                    this.InsertionType == input.InsertionType ||
                    (this.InsertionType != null &&
                    this.InsertionType.Equals(input.InsertionType))
                ) && 
                (
                    this.CustomFieldList == input.CustomFieldList ||
                    this.CustomFieldList != null &&
                    input.CustomFieldList != null &&
                    this.CustomFieldList.SequenceEqual(input.CustomFieldList)
                ) && 
                (
                    this.CustomFieldLineList == input.CustomFieldLineList ||
                    this.CustomFieldLineList != null &&
                    input.CustomFieldLineList != null &&
                    this.CustomFieldLineList.SequenceEqual(input.CustomFieldLineList)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BookyearKey != null)
                    hashCode = hashCode * 59 + this.BookyearKey.GetHashCode();
                if (this.JournalKey != null)
                    hashCode = hashCode * 59 + this.JournalKey.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Closed != null)
                    hashCode = hashCode * 59 + this.Closed.GetHashCode();
                if (this.CurrencyCode != null)
                    hashCode = hashCode * 59 + this.CurrencyCode.GetHashCode();
                if (this.LastBookedDocumentNr != null)
                    hashCode = hashCode * 59 + this.LastBookedDocumentNr.GetHashCode();
                if (this.ProtectedPeriod != null)
                    hashCode = hashCode * 59 + this.ProtectedPeriod.GetHashCode();
                if (this.ClosedPeriod != null)
                    hashCode = hashCode * 59 + this.ClosedPeriod.GetHashCode();
                if (this.InsertionType != null)
                    hashCode = hashCode * 59 + this.InsertionType.GetHashCode();
                if (this.CustomFieldList != null)
                    hashCode = hashCode * 59 + this.CustomFieldList.GetHashCode();
                if (this.CustomFieldLineList != null)
                    hashCode = hashCode * 59 + this.CustomFieldLineList.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
