/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Overflow booking data
    /// </summary>
    [DataContract]
        public partial class OverflowBookingServiceData :  IEquatable<OverflowBookingServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OverflowBookingServiceData" /> class.
        /// </summary>
        /// <param name="beginDate">Start date of the overflow booking period.</param>
        /// <param name="endDate">End date of the overflow booking period.</param>
        /// <param name="overflowBookingPeriodType">Overflow booking period type (0 &#x3D; Bookyear, 1 &#x3D; period).</param>
        /// <param name="accountNr">Account number of the overflow booking.</param>
        public OverflowBookingServiceData(DateTime? beginDate = default(DateTime?), DateTime? endDate = default(DateTime?), int? overflowBookingPeriodType = default(int?), int? accountNr = default(int?))
        {
            this.BeginDate = beginDate;
            this.EndDate = endDate;
            this.OverflowBookingPeriodType = overflowBookingPeriodType;
            this.AccountNr = accountNr;
        }
        
        /// <summary>
        /// Start date of the overflow booking period
        /// </summary>
        /// <value>Start date of the overflow booking period</value>
        [DataMember(Name="beginDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? BeginDate { get; set; }

        /// <summary>
        /// End date of the overflow booking period
        /// </summary>
        /// <value>End date of the overflow booking period</value>
        [DataMember(Name="endDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? EndDate { get; set; }

        /// <summary>
        /// Overflow booking period type (0 &#x3D; Bookyear, 1 &#x3D; period)
        /// </summary>
        /// <value>Overflow booking period type (0 &#x3D; Bookyear, 1 &#x3D; period)</value>
        [DataMember(Name="overflowBookingPeriodType", EmitDefaultValue=false)]
        public int? OverflowBookingPeriodType { get; set; }

        /// <summary>
        /// Account number of the overflow booking
        /// </summary>
        /// <value>Account number of the overflow booking</value>
        [DataMember(Name="accountNr", EmitDefaultValue=false)]
        public int? AccountNr { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class OverflowBookingServiceData {\n");
            sb.Append("  BeginDate: ").Append(BeginDate).Append("\n");
            sb.Append("  EndDate: ").Append(EndDate).Append("\n");
            sb.Append("  OverflowBookingPeriodType: ").Append(OverflowBookingPeriodType).Append("\n");
            sb.Append("  AccountNr: ").Append(AccountNr).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as OverflowBookingServiceData);
        }

        /// <summary>
        /// Returns true if OverflowBookingServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of OverflowBookingServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(OverflowBookingServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BeginDate == input.BeginDate ||
                    (this.BeginDate != null &&
                    this.BeginDate.Equals(input.BeginDate))
                ) && 
                (
                    this.EndDate == input.EndDate ||
                    (this.EndDate != null &&
                    this.EndDate.Equals(input.EndDate))
                ) && 
                (
                    this.OverflowBookingPeriodType == input.OverflowBookingPeriodType ||
                    (this.OverflowBookingPeriodType != null &&
                    this.OverflowBookingPeriodType.Equals(input.OverflowBookingPeriodType))
                ) && 
                (
                    this.AccountNr == input.AccountNr ||
                    (this.AccountNr != null &&
                    this.AccountNr.Equals(input.AccountNr))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BeginDate != null)
                    hashCode = hashCode * 59 + this.BeginDate.GetHashCode();
                if (this.EndDate != null)
                    hashCode = hashCode * 59 + this.EndDate.GetHashCode();
                if (this.OverflowBookingPeriodType != null)
                    hashCode = hashCode * 59 + this.OverflowBookingPeriodType.GetHashCode();
                if (this.AccountNr != null)
                    hashCode = hashCode * 59 + this.AccountNr.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
