/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProductGroupServiceData
    /// </summary>
    [DataContract]
        public partial class ProductGroupServiceData :  IEquatable<ProductGroupServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProductGroupServiceData" /> class.
        /// </summary>
        /// <param name="productGroupKey">productGroupKey (required).</param>
        /// <param name="description">description (required).</param>
        public ProductGroupServiceData(ProductGroupKey productGroupKey = default(ProductGroupKey), StringServiceData description = default(StringServiceData))
        {
            // to ensure "productGroupKey" is required (not null)
            if (productGroupKey == null)
            {
                throw new InvalidDataException("productGroupKey is a required property for ProductGroupServiceData and cannot be null");
            }
            else
            {
                this.ProductGroupKey = productGroupKey;
            }
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new InvalidDataException("description is a required property for ProductGroupServiceData and cannot be null");
            }
            else
            {
                this.Description = description;
            }
        }
        
        /// <summary>
        /// Gets or Sets ProductGroupKey
        /// </summary>
        [DataMember(Name="productGroupKey", EmitDefaultValue=false)]
        public ProductGroupKey ProductGroupKey { get; set; }

        /// <summary>
        /// Gets or Sets Description
        /// </summary>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public StringServiceData Description { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProductGroupServiceData {\n");
            sb.Append("  ProductGroupKey: ").Append(ProductGroupKey).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProductGroupServiceData);
        }

        /// <summary>
        /// Returns true if ProductGroupServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of ProductGroupServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProductGroupServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProductGroupKey == input.ProductGroupKey ||
                    (this.ProductGroupKey != null &&
                    this.ProductGroupKey.Equals(input.ProductGroupKey))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProductGroupKey != null)
                    hashCode = hashCode * 59 + this.ProductGroupKey.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
