/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProductServiceData
    /// </summary>
    [DataContract]
        public partial class ProductServiceData :  IEquatable<ProductServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProductServiceData" /> class.
        /// </summary>
        /// <param name="productKey">productKey (required).</param>
        /// <param name="externProductNr">External product identification.</param>
        /// <param name="code">code (required).</param>
        /// <param name="description">description (required).</param>
        /// <param name="priceVatExclusive">Price VAT exclusive (required).</param>
        /// <param name="priceVatInclusive">Price VAT inclusive (required).</param>
        /// <param name="currencyCode">Currency code (required).</param>
        /// <param name="vatCode">VAT code (required).</param>
        /// <param name="supplierInfo">Remarks for this product from the supplier.</param>
        /// <param name="unit">Unit (required).</param>
        /// <param name="defaultCostCentre">defaultCostCentre.</param>
        /// <param name="defaultBookingAccountNr">Default booking account identification (required).</param>
        /// <param name="active">Boolean indicating if this product is active (required) (default to true).</param>
        /// <param name="productGroup">productGroup.</param>
        public ProductServiceData(ProductKey productKey = default(ProductKey), string externProductNr = default(string), StringServiceData code = default(StringServiceData), StringServiceData description = default(StringServiceData), double? priceVatExclusive = default(double?), double? priceVatInclusive = default(double?), string currencyCode = default(string), string vatCode = default(string), string supplierInfo = default(string), string unit = default(string), CostCentreKey defaultCostCentre = default(CostCentreKey), int? defaultBookingAccountNr = default(int?), bool? active = true, ProductGroupKey productGroup = default(ProductGroupKey))
        {
            // to ensure "productKey" is required (not null)
            if (productKey == null)
            {
                throw new InvalidDataException("productKey is a required property for ProductServiceData and cannot be null");
            }
            else
            {
                this.ProductKey = productKey;
            }
            // to ensure "code" is required (not null)
            if (code == null)
            {
                throw new InvalidDataException("code is a required property for ProductServiceData and cannot be null");
            }
            else
            {
                this.Code = code;
            }
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new InvalidDataException("description is a required property for ProductServiceData and cannot be null");
            }
            else
            {
                this.Description = description;
            }
            // to ensure "priceVatExclusive" is required (not null)
            if (priceVatExclusive == null)
            {
                throw new InvalidDataException("priceVatExclusive is a required property for ProductServiceData and cannot be null");
            }
            else
            {
                this.PriceVatExclusive = priceVatExclusive;
            }
            // to ensure "priceVatInclusive" is required (not null)
            if (priceVatInclusive == null)
            {
                throw new InvalidDataException("priceVatInclusive is a required property for ProductServiceData and cannot be null");
            }
            else
            {
                this.PriceVatInclusive = priceVatInclusive;
            }
            // to ensure "currencyCode" is required (not null)
            if (currencyCode == null)
            {
                throw new InvalidDataException("currencyCode is a required property for ProductServiceData and cannot be null");
            }
            else
            {
                this.CurrencyCode = currencyCode;
            }
            // to ensure "vatCode" is required (not null)
            if (vatCode == null)
            {
                throw new InvalidDataException("vatCode is a required property for ProductServiceData and cannot be null");
            }
            else
            {
                this.VatCode = vatCode;
            }
            // to ensure "unit" is required (not null)
            if (unit == null)
            {
                throw new InvalidDataException("unit is a required property for ProductServiceData and cannot be null");
            }
            else
            {
                this.Unit = unit;
            }
            // to ensure "defaultBookingAccountNr" is required (not null)
            if (defaultBookingAccountNr == null)
            {
                throw new InvalidDataException("defaultBookingAccountNr is a required property for ProductServiceData and cannot be null");
            }
            else
            {
                this.DefaultBookingAccountNr = defaultBookingAccountNr;
            }
            // to ensure "active" is required (not null)
            if (active == null)
            {
                throw new InvalidDataException("active is a required property for ProductServiceData and cannot be null");
            }
            else
            {
                this.Active = active;
            }
            this.ExternProductNr = externProductNr;
            this.SupplierInfo = supplierInfo;
            this.DefaultCostCentre = defaultCostCentre;
            this.ProductGroup = productGroup;
        }
        
        /// <summary>
        /// Gets or Sets ProductKey
        /// </summary>
        [DataMember(Name="productKey", EmitDefaultValue=false)]
        public ProductKey ProductKey { get; set; }

        /// <summary>
        /// External product identification
        /// </summary>
        /// <value>External product identification</value>
        [DataMember(Name="externProductNr", EmitDefaultValue=false)]
        public string ExternProductNr { get; set; }

        /// <summary>
        /// Gets or Sets Code
        /// </summary>
        [DataMember(Name="code", EmitDefaultValue=false)]
        public StringServiceData Code { get; set; }

        /// <summary>
        /// Gets or Sets Description
        /// </summary>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public StringServiceData Description { get; set; }

        /// <summary>
        /// Price VAT exclusive
        /// </summary>
        /// <value>Price VAT exclusive</value>
        [DataMember(Name="priceVatExclusive", EmitDefaultValue=false)]
        public double? PriceVatExclusive { get; set; }

        /// <summary>
        /// Price VAT inclusive
        /// </summary>
        /// <value>Price VAT inclusive</value>
        [DataMember(Name="priceVatInclusive", EmitDefaultValue=false)]
        public double? PriceVatInclusive { get; set; }

        /// <summary>
        /// Currency code
        /// </summary>
        /// <value>Currency code</value>
        [DataMember(Name="currencyCode", EmitDefaultValue=false)]
        public string CurrencyCode { get; set; }

        /// <summary>
        /// VAT code
        /// </summary>
        /// <value>VAT code</value>
        [DataMember(Name="vatCode", EmitDefaultValue=false)]
        public string VatCode { get; set; }

        /// <summary>
        /// Remarks for this product from the supplier
        /// </summary>
        /// <value>Remarks for this product from the supplier</value>
        [DataMember(Name="supplierInfo", EmitDefaultValue=false)]
        public string SupplierInfo { get; set; }

        /// <summary>
        /// Unit
        /// </summary>
        /// <value>Unit</value>
        [DataMember(Name="unit", EmitDefaultValue=false)]
        public string Unit { get; set; }

        /// <summary>
        /// Gets or Sets DefaultCostCentre
        /// </summary>
        [DataMember(Name="defaultCostCentre", EmitDefaultValue=false)]
        public CostCentreKey DefaultCostCentre { get; set; }

        /// <summary>
        /// Default booking account identification
        /// </summary>
        /// <value>Default booking account identification</value>
        [DataMember(Name="defaultBookingAccountNr", EmitDefaultValue=false)]
        public int? DefaultBookingAccountNr { get; set; }

        /// <summary>
        /// Boolean indicating if this product is active
        /// </summary>
        /// <value>Boolean indicating if this product is active</value>
        [DataMember(Name="active", EmitDefaultValue=false)]
        public bool? Active { get; set; }

        /// <summary>
        /// Gets or Sets ProductGroup
        /// </summary>
        [DataMember(Name="productGroup", EmitDefaultValue=false)]
        public ProductGroupKey ProductGroup { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProductServiceData {\n");
            sb.Append("  ProductKey: ").Append(ProductKey).Append("\n");
            sb.Append("  ExternProductNr: ").Append(ExternProductNr).Append("\n");
            sb.Append("  Code: ").Append(Code).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  PriceVatExclusive: ").Append(PriceVatExclusive).Append("\n");
            sb.Append("  PriceVatInclusive: ").Append(PriceVatInclusive).Append("\n");
            sb.Append("  CurrencyCode: ").Append(CurrencyCode).Append("\n");
            sb.Append("  VatCode: ").Append(VatCode).Append("\n");
            sb.Append("  SupplierInfo: ").Append(SupplierInfo).Append("\n");
            sb.Append("  Unit: ").Append(Unit).Append("\n");
            sb.Append("  DefaultCostCentre: ").Append(DefaultCostCentre).Append("\n");
            sb.Append("  DefaultBookingAccountNr: ").Append(DefaultBookingAccountNr).Append("\n");
            sb.Append("  Active: ").Append(Active).Append("\n");
            sb.Append("  ProductGroup: ").Append(ProductGroup).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProductServiceData);
        }

        /// <summary>
        /// Returns true if ProductServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of ProductServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProductServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProductKey == input.ProductKey ||
                    (this.ProductKey != null &&
                    this.ProductKey.Equals(input.ProductKey))
                ) && 
                (
                    this.ExternProductNr == input.ExternProductNr ||
                    (this.ExternProductNr != null &&
                    this.ExternProductNr.Equals(input.ExternProductNr))
                ) && 
                (
                    this.Code == input.Code ||
                    (this.Code != null &&
                    this.Code.Equals(input.Code))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.PriceVatExclusive == input.PriceVatExclusive ||
                    (this.PriceVatExclusive != null &&
                    this.PriceVatExclusive.Equals(input.PriceVatExclusive))
                ) && 
                (
                    this.PriceVatInclusive == input.PriceVatInclusive ||
                    (this.PriceVatInclusive != null &&
                    this.PriceVatInclusive.Equals(input.PriceVatInclusive))
                ) && 
                (
                    this.CurrencyCode == input.CurrencyCode ||
                    (this.CurrencyCode != null &&
                    this.CurrencyCode.Equals(input.CurrencyCode))
                ) && 
                (
                    this.VatCode == input.VatCode ||
                    (this.VatCode != null &&
                    this.VatCode.Equals(input.VatCode))
                ) && 
                (
                    this.SupplierInfo == input.SupplierInfo ||
                    (this.SupplierInfo != null &&
                    this.SupplierInfo.Equals(input.SupplierInfo))
                ) && 
                (
                    this.Unit == input.Unit ||
                    (this.Unit != null &&
                    this.Unit.Equals(input.Unit))
                ) && 
                (
                    this.DefaultCostCentre == input.DefaultCostCentre ||
                    (this.DefaultCostCentre != null &&
                    this.DefaultCostCentre.Equals(input.DefaultCostCentre))
                ) && 
                (
                    this.DefaultBookingAccountNr == input.DefaultBookingAccountNr ||
                    (this.DefaultBookingAccountNr != null &&
                    this.DefaultBookingAccountNr.Equals(input.DefaultBookingAccountNr))
                ) && 
                (
                    this.Active == input.Active ||
                    (this.Active != null &&
                    this.Active.Equals(input.Active))
                ) && 
                (
                    this.ProductGroup == input.ProductGroup ||
                    (this.ProductGroup != null &&
                    this.ProductGroup.Equals(input.ProductGroup))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProductKey != null)
                    hashCode = hashCode * 59 + this.ProductKey.GetHashCode();
                if (this.ExternProductNr != null)
                    hashCode = hashCode * 59 + this.ExternProductNr.GetHashCode();
                if (this.Code != null)
                    hashCode = hashCode * 59 + this.Code.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.PriceVatExclusive != null)
                    hashCode = hashCode * 59 + this.PriceVatExclusive.GetHashCode();
                if (this.PriceVatInclusive != null)
                    hashCode = hashCode * 59 + this.PriceVatInclusive.GetHashCode();
                if (this.CurrencyCode != null)
                    hashCode = hashCode * 59 + this.CurrencyCode.GetHashCode();
                if (this.VatCode != null)
                    hashCode = hashCode * 59 + this.VatCode.GetHashCode();
                if (this.SupplierInfo != null)
                    hashCode = hashCode * 59 + this.SupplierInfo.GetHashCode();
                if (this.Unit != null)
                    hashCode = hashCode * 59 + this.Unit.GetHashCode();
                if (this.DefaultCostCentre != null)
                    hashCode = hashCode * 59 + this.DefaultCostCentre.GetHashCode();
                if (this.DefaultBookingAccountNr != null)
                    hashCode = hashCode * 59 + this.DefaultBookingAccountNr.GetHashCode();
                if (this.Active != null)
                    hashCode = hashCode * 59 + this.Active.GetHashCode();
                if (this.ProductGroup != null)
                    hashCode = hashCode * 59 + this.ProductGroup.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
