/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// RappelServiceData
    /// </summary>
    [DataContract]
        public partial class RappelServiceData :  IEquatable<RappelServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RappelServiceData" /> class.
        /// </summary>
        /// <param name="relation">relation.</param>
        /// <param name="invoiceList">Rappel invoice list.</param>
        public RappelServiceData(RelationServiceData relation = default(RelationServiceData), List<RappelInvoiceServiceData> invoiceList = default(List<RappelInvoiceServiceData>))
        {
            this.Relation = relation;
            this.InvoiceList = invoiceList;
        }
        
        /// <summary>
        /// Gets or Sets Relation
        /// </summary>
        [DataMember(Name="relation", EmitDefaultValue=false)]
        public RelationServiceData Relation { get; set; }

        /// <summary>
        /// Rappel invoice list
        /// </summary>
        /// <value>Rappel invoice list</value>
        [DataMember(Name="invoiceList", EmitDefaultValue=false)]
        public List<RappelInvoiceServiceData> InvoiceList { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class RappelServiceData {\n");
            sb.Append("  Relation: ").Append(Relation).Append("\n");
            sb.Append("  InvoiceList: ").Append(InvoiceList).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as RappelServiceData);
        }

        /// <summary>
        /// Returns true if RappelServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of RappelServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(RappelServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Relation == input.Relation ||
                    (this.Relation != null &&
                    this.Relation.Equals(input.Relation))
                ) && 
                (
                    this.InvoiceList == input.InvoiceList ||
                    this.InvoiceList != null &&
                    input.InvoiceList != null &&
                    this.InvoiceList.SequenceEqual(input.InvoiceList)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Relation != null)
                    hashCode = hashCode * 59 + this.Relation.GetHashCode();
                if (this.InvoiceList != null)
                    hashCode = hashCode * 59 + this.InvoiceList.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
