/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// RelationServiceData
    /// </summary>
    [DataContract]
        public partial class RelationServiceData :  IEquatable<RelationServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RelationServiceData" /> class.
        /// </summary>
        /// <param name="relationIdentificationServiceData">relationIdentificationServiceData (required).</param>
        /// <param name="name">Relation Name.</param>
        /// <param name="firstName">Relation first name.</param>
        /// <param name="_client">boolean indicating if this relation is a client.</param>
        /// <param name="defaultBookingAccountClient">Default booking account related to this client.</param>
        /// <param name="supplier">boolean indicating if this relation is a supplier.</param>
        /// <param name="defaultBookingAccountSupplier">Default booking account related to this supplier.</param>
        /// <param name="streetAndNr">Street and nr.</param>
        /// <param name="postalCode">Postal Code.</param>
        /// <param name="city">City.</param>
        /// <param name="country">Country Code. Allowable values: BE , NL , DE , GB , ...</param>
        /// <param name="deliveryStreetAndNr">Delivery Street and nr.</param>
        /// <param name="deliveryPostalCode">Delivery Postal Code.</param>
        /// <param name="deliveryCity">Delivery City.</param>
        /// <param name="deliveryCountry">Delivery Country Code. Allowable values: BE , NL , DE , GB , ...</param>
        /// <param name="telephone">Telephone.</param>
        /// <param name="email">Email.</param>
        /// <param name="fax">Fax number.</param>
        /// <param name="mobile">Mobile number.</param>
        /// <param name="url">Url.</param>
        /// <param name="bankAccountNr">Bank account nr (National Standard).</param>
        /// <param name="ibanAccountNr">Bank account nr ( IBAN standard ).</param>
        /// <param name="bicCode">BIC code.</param>
        /// <param name="financialDiscount">Financial Discount granted.</param>
        /// <param name="profession">Profession.</param>
        /// <param name="contactPerson">Contact person.</param>
        /// <param name="corporationType">Corporation Type&lt;ul&gt;&lt;li&gt;0 : NP&lt;/li&gt;&lt;li&gt;1 : NV&lt;/li&gt;&lt;li&gt;2 : BVBA&lt;/li&gt;&lt;li&gt;3 : CVBA&lt;/li&gt;&lt;li&gt;4 : CVOA&lt;/li&gt;&lt;li&gt;5 : Comm. V&lt;/li&gt;&lt;li&gt;6 : Comm. VA&lt;/li&gt;&lt;li&gt;7 : VOF&lt;/li&gt;&lt;li&gt;8 : VZW&lt;/li&gt;&lt;li&gt;9 : BV&lt;/li&gt;&lt;li&gt;10 : AG&lt;/li&gt;&lt;li&gt;11 : GmbH&lt;/li&gt;&lt;li&gt;12 : KG&lt;/li&gt;&lt;li&gt;13 : KGA&lt;/li&gt;&lt;li&gt;14 : OHG&lt;/li&gt;&lt;li&gt;15 : Plc&lt;/li&gt;&lt;li&gt;16 : Ltd&lt;/li&gt;&lt;li&gt;17 : LP&lt;/li&gt;&lt;li&gt;18 : Unlimited&lt;/li&gt;&lt;li&gt;19 : Inc.&lt;/li&gt;&lt;li&gt;20 : SA&lt;/li&gt;&lt;li&gt;21 : SRL&lt;/li&gt;&lt;li&gt;22 : SA&lt;/li&gt;&lt;li&gt;23 : Ltda&lt;/li&gt;&lt;li&gt;24 : FV&lt;/li&gt;&lt;li&gt;25 : PS&lt;/li&gt;&lt;li&gt;26 : LV&lt;/li&gt;&lt;/ul&gt;.</param>
        /// <param name="currencyCode">Currency Code (e.g. EUR).</param>
        /// <param name="remarks">Remarks.</param>
        /// <param name="vatNr">VAT Nr ( In case BE, format should be BE0xxx.xxx.xxx ).</param>
        /// <param name="vatType">Vat Type (Btw plichtigheid):&lt;ul&gt;&lt;li&gt;0 : Onbekend&lt;/li&gt;&lt;li&gt;1 : Belgische BTW-plichtige&lt;/li&gt;&lt;li&gt;4 : Intracommunautaire BTW-plichtige&lt;/li&gt;&lt;li&gt;6 : BTW-plichtige buiten EU&lt;/li&gt;&lt;li&gt;7 : Particulier Belgie&lt;/li&gt;&lt;li&gt;8 : Particulier EU&lt;/li&gt;&lt;li&gt;9 : Particulier niet-EU&lt;/li&gt;&lt;li&gt;10: Niet btw-plichtig&lt;/li&gt;&lt;/ul&gt;.</param>
        /// <param name="expirationType">Expiration Type. 1 : End of month, 2 : After invoice date.</param>
        /// <param name="expirationDays">Number of days after expiration type.</param>
        /// <param name="searchField1">Search field 1.</param>
        /// <param name="searchField2">Search field 2.</param>
        /// <param name="externCustomerNr">Customer number as known by supplier.</param>
        /// <param name="sddReference">Sepa Direct Debit reference.</param>
        /// <param name="sddSeqtype">Sepa Direct Debit sequence type:&lt;ul&gt;&lt;li&gt;Value 1 : First&lt;/li&gt;&lt;li&gt;Value 2 : Recurrent&lt;/li&gt;&lt;li&gt;Value 3 : Last&lt;/li&gt;&lt;li&gt;Value 4 : One time&lt;/li&gt;&lt;/ul&gt;.</param>
        /// <param name="sddMandateType">Sepa Direct Debit Mandate Type:&lt;ul&gt;&lt;li&gt;Value 1 : Core&lt;/li&gt;&lt;li&gt;Value 2 : B2B&lt;/li&gt;&lt;/ul&gt;.</param>
        /// <param name="sddSignatureDate">Sepa Direct Debit signature date.</param>
        /// <param name="sddActive">Sepa Direct Debit Active flag.</param>
        /// <param name="factLanguage">Invoice language.  0 : Nederlands, 1 : Francais, 2 : English.</param>
        /// <param name="active">Indication if the relation is active.</param>
        public RelationServiceData(RelationIdentificationServiceData relationIdentificationServiceData = default(RelationIdentificationServiceData), string name = default(string), string firstName = default(string), bool? _client = default(bool?), int? defaultBookingAccountClient = default(int?), bool? supplier = default(bool?), int? defaultBookingAccountSupplier = default(int?), string streetAndNr = default(string), string postalCode = default(string), string city = default(string), string country = default(string), string deliveryStreetAndNr = default(string), string deliveryPostalCode = default(string), string deliveryCity = default(string), string deliveryCountry = default(string), string telephone = default(string), string email = default(string), string fax = default(string), string mobile = default(string), string url = default(string), string bankAccountNr = default(string), string ibanAccountNr = default(string), string bicCode = default(string), bool? financialDiscount = default(bool?), string profession = default(string), string contactPerson = default(string), int? corporationType = default(int?), string currencyCode = default(string), string remarks = default(string), string vatNr = default(string), int? vatType = default(int?), int? expirationType = default(int?), int? expirationDays = default(int?), string searchField1 = default(string), string searchField2 = default(string), string externCustomerNr = default(string), string sddReference = default(string), int? sddSeqtype = default(int?), int? sddMandateType = default(int?), DateTime? sddSignatureDate = default(DateTime?), bool? sddActive = default(bool?), int? factLanguage = default(int?), bool? active = default(bool?))
        {
            // to ensure "relationIdentificationServiceData" is required (not null)
            if (relationIdentificationServiceData == null)
            {
                throw new InvalidDataException("relationIdentificationServiceData is a required property for RelationServiceData and cannot be null");
            }
            else
            {
                this.RelationIdentificationServiceData = relationIdentificationServiceData;
            }
            this.Name = name;
            this.FirstName = firstName;
            this.Client = _client;
            this.DefaultBookingAccountClient = defaultBookingAccountClient;
            this.Supplier = supplier;
            this.DefaultBookingAccountSupplier = defaultBookingAccountSupplier;
            this.StreetAndNr = streetAndNr;
            this.PostalCode = postalCode;
            this.City = city;
            this.Country = country;
            this.DeliveryStreetAndNr = deliveryStreetAndNr;
            this.DeliveryPostalCode = deliveryPostalCode;
            this.DeliveryCity = deliveryCity;
            this.DeliveryCountry = deliveryCountry;
            this.Telephone = telephone;
            this.Email = email;
            this.Fax = fax;
            this.Mobile = mobile;
            this.Url = url;
            this.BankAccountNr = bankAccountNr;
            this.IbanAccountNr = ibanAccountNr;
            this.BicCode = bicCode;
            this.FinancialDiscount = financialDiscount;
            this.Profession = profession;
            this.ContactPerson = contactPerson;
            this.CorporationType = corporationType;
            this.CurrencyCode = currencyCode;
            this.Remarks = remarks;
            this.VatNr = vatNr;
            this.VatType = vatType;
            this.ExpirationType = expirationType;
            this.ExpirationDays = expirationDays;
            this.SearchField1 = searchField1;
            this.SearchField2 = searchField2;
            this.ExternCustomerNr = externCustomerNr;
            this.SddReference = sddReference;
            this.SddSeqtype = sddSeqtype;
            this.SddMandateType = sddMandateType;
            this.SddSignatureDate = sddSignatureDate;
            this.SddActive = sddActive;
            this.FactLanguage = factLanguage;
            this.Active = active;
        }
        
        /// <summary>
        /// Gets or Sets RelationIdentificationServiceData
        /// </summary>
        [DataMember(Name="relationIdentificationServiceData", EmitDefaultValue=false)]
        public RelationIdentificationServiceData RelationIdentificationServiceData { get; set; }

        /// <summary>
        /// Relation Name
        /// </summary>
        /// <value>Relation Name</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Relation first name
        /// </summary>
        /// <value>Relation first name</value>
        [DataMember(Name="firstName", EmitDefaultValue=false)]
        public string FirstName { get; set; }

        /// <summary>
        /// boolean indicating if this relation is a client
        /// </summary>
        /// <value>boolean indicating if this relation is a client</value>
        [DataMember(Name="client", EmitDefaultValue=false)]
        public bool? Client { get; set; }

        /// <summary>
        /// Default booking account related to this client
        /// </summary>
        /// <value>Default booking account related to this client</value>
        [DataMember(Name="defaultBookingAccountClient", EmitDefaultValue=false)]
        public int? DefaultBookingAccountClient { get; set; }

        /// <summary>
        /// boolean indicating if this relation is a supplier
        /// </summary>
        /// <value>boolean indicating if this relation is a supplier</value>
        [DataMember(Name="supplier", EmitDefaultValue=false)]
        public bool? Supplier { get; set; }

        /// <summary>
        /// Default booking account related to this supplier
        /// </summary>
        /// <value>Default booking account related to this supplier</value>
        [DataMember(Name="defaultBookingAccountSupplier", EmitDefaultValue=false)]
        public int? DefaultBookingAccountSupplier { get; set; }

        /// <summary>
        /// Street and nr
        /// </summary>
        /// <value>Street and nr</value>
        [DataMember(Name="streetAndNr", EmitDefaultValue=false)]
        public string StreetAndNr { get; set; }

        /// <summary>
        /// Postal Code
        /// </summary>
        /// <value>Postal Code</value>
        [DataMember(Name="postalCode", EmitDefaultValue=false)]
        public string PostalCode { get; set; }

        /// <summary>
        /// City
        /// </summary>
        /// <value>City</value>
        [DataMember(Name="city", EmitDefaultValue=false)]
        public string City { get; set; }

        /// <summary>
        /// Country Code. Allowable values: BE , NL , DE , GB , ..
        /// </summary>
        /// <value>Country Code. Allowable values: BE , NL , DE , GB , ..</value>
        [DataMember(Name="country", EmitDefaultValue=false)]
        public string Country { get; set; }

        /// <summary>
        /// Delivery Street and nr
        /// </summary>
        /// <value>Delivery Street and nr</value>
        [DataMember(Name="deliveryStreetAndNr", EmitDefaultValue=false)]
        public string DeliveryStreetAndNr { get; set; }

        /// <summary>
        /// Delivery Postal Code
        /// </summary>
        /// <value>Delivery Postal Code</value>
        [DataMember(Name="deliveryPostalCode", EmitDefaultValue=false)]
        public string DeliveryPostalCode { get; set; }

        /// <summary>
        /// Delivery City
        /// </summary>
        /// <value>Delivery City</value>
        [DataMember(Name="deliveryCity", EmitDefaultValue=false)]
        public string DeliveryCity { get; set; }

        /// <summary>
        /// Delivery Country Code. Allowable values: BE , NL , DE , GB , ..
        /// </summary>
        /// <value>Delivery Country Code. Allowable values: BE , NL , DE , GB , ..</value>
        [DataMember(Name="deliveryCountry", EmitDefaultValue=false)]
        public string DeliveryCountry { get; set; }

        /// <summary>
        /// Telephone
        /// </summary>
        /// <value>Telephone</value>
        [DataMember(Name="telephone", EmitDefaultValue=false)]
        public string Telephone { get; set; }

        /// <summary>
        /// Email
        /// </summary>
        /// <value>Email</value>
        [DataMember(Name="email", EmitDefaultValue=false)]
        public string Email { get; set; }

        /// <summary>
        /// Fax number
        /// </summary>
        /// <value>Fax number</value>
        [DataMember(Name="fax", EmitDefaultValue=false)]
        public string Fax { get; set; }

        /// <summary>
        /// Mobile number
        /// </summary>
        /// <value>Mobile number</value>
        [DataMember(Name="mobile", EmitDefaultValue=false)]
        public string Mobile { get; set; }

        /// <summary>
        /// Url
        /// </summary>
        /// <value>Url</value>
        [DataMember(Name="url", EmitDefaultValue=false)]
        public string Url { get; set; }

        /// <summary>
        /// Bank account nr (National Standard)
        /// </summary>
        /// <value>Bank account nr (National Standard)</value>
        [DataMember(Name="bankAccountNr", EmitDefaultValue=false)]
        public string BankAccountNr { get; set; }

        /// <summary>
        /// Bank account nr ( IBAN standard )
        /// </summary>
        /// <value>Bank account nr ( IBAN standard )</value>
        [DataMember(Name="ibanAccountNr", EmitDefaultValue=false)]
        public string IbanAccountNr { get; set; }

        /// <summary>
        /// BIC code
        /// </summary>
        /// <value>BIC code</value>
        [DataMember(Name="bicCode", EmitDefaultValue=false)]
        public string BicCode { get; set; }

        /// <summary>
        /// Financial Discount granted
        /// </summary>
        /// <value>Financial Discount granted</value>
        [DataMember(Name="financialDiscount", EmitDefaultValue=false)]
        public bool? FinancialDiscount { get; set; }

        /// <summary>
        /// Profession
        /// </summary>
        /// <value>Profession</value>
        [DataMember(Name="profession", EmitDefaultValue=false)]
        public string Profession { get; set; }

        /// <summary>
        /// Contact person
        /// </summary>
        /// <value>Contact person</value>
        [DataMember(Name="contactPerson", EmitDefaultValue=false)]
        public string ContactPerson { get; set; }

        /// <summary>
        /// Corporation Type&lt;ul&gt;&lt;li&gt;0 : NP&lt;/li&gt;&lt;li&gt;1 : NV&lt;/li&gt;&lt;li&gt;2 : BVBA&lt;/li&gt;&lt;li&gt;3 : CVBA&lt;/li&gt;&lt;li&gt;4 : CVOA&lt;/li&gt;&lt;li&gt;5 : Comm. V&lt;/li&gt;&lt;li&gt;6 : Comm. VA&lt;/li&gt;&lt;li&gt;7 : VOF&lt;/li&gt;&lt;li&gt;8 : VZW&lt;/li&gt;&lt;li&gt;9 : BV&lt;/li&gt;&lt;li&gt;10 : AG&lt;/li&gt;&lt;li&gt;11 : GmbH&lt;/li&gt;&lt;li&gt;12 : KG&lt;/li&gt;&lt;li&gt;13 : KGA&lt;/li&gt;&lt;li&gt;14 : OHG&lt;/li&gt;&lt;li&gt;15 : Plc&lt;/li&gt;&lt;li&gt;16 : Ltd&lt;/li&gt;&lt;li&gt;17 : LP&lt;/li&gt;&lt;li&gt;18 : Unlimited&lt;/li&gt;&lt;li&gt;19 : Inc.&lt;/li&gt;&lt;li&gt;20 : SA&lt;/li&gt;&lt;li&gt;21 : SRL&lt;/li&gt;&lt;li&gt;22 : SA&lt;/li&gt;&lt;li&gt;23 : Ltda&lt;/li&gt;&lt;li&gt;24 : FV&lt;/li&gt;&lt;li&gt;25 : PS&lt;/li&gt;&lt;li&gt;26 : LV&lt;/li&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>Corporation Type&lt;ul&gt;&lt;li&gt;0 : NP&lt;/li&gt;&lt;li&gt;1 : NV&lt;/li&gt;&lt;li&gt;2 : BVBA&lt;/li&gt;&lt;li&gt;3 : CVBA&lt;/li&gt;&lt;li&gt;4 : CVOA&lt;/li&gt;&lt;li&gt;5 : Comm. V&lt;/li&gt;&lt;li&gt;6 : Comm. VA&lt;/li&gt;&lt;li&gt;7 : VOF&lt;/li&gt;&lt;li&gt;8 : VZW&lt;/li&gt;&lt;li&gt;9 : BV&lt;/li&gt;&lt;li&gt;10 : AG&lt;/li&gt;&lt;li&gt;11 : GmbH&lt;/li&gt;&lt;li&gt;12 : KG&lt;/li&gt;&lt;li&gt;13 : KGA&lt;/li&gt;&lt;li&gt;14 : OHG&lt;/li&gt;&lt;li&gt;15 : Plc&lt;/li&gt;&lt;li&gt;16 : Ltd&lt;/li&gt;&lt;li&gt;17 : LP&lt;/li&gt;&lt;li&gt;18 : Unlimited&lt;/li&gt;&lt;li&gt;19 : Inc.&lt;/li&gt;&lt;li&gt;20 : SA&lt;/li&gt;&lt;li&gt;21 : SRL&lt;/li&gt;&lt;li&gt;22 : SA&lt;/li&gt;&lt;li&gt;23 : Ltda&lt;/li&gt;&lt;li&gt;24 : FV&lt;/li&gt;&lt;li&gt;25 : PS&lt;/li&gt;&lt;li&gt;26 : LV&lt;/li&gt;&lt;/ul&gt;</value>
        [DataMember(Name="corporationType", EmitDefaultValue=false)]
        public int? CorporationType { get; set; }

        /// <summary>
        /// Currency Code (e.g. EUR)
        /// </summary>
        /// <value>Currency Code (e.g. EUR)</value>
        [DataMember(Name="currencyCode", EmitDefaultValue=false)]
        public string CurrencyCode { get; set; }

        /// <summary>
        /// Remarks
        /// </summary>
        /// <value>Remarks</value>
        [DataMember(Name="remarks", EmitDefaultValue=false)]
        public string Remarks { get; set; }

        /// <summary>
        /// VAT Nr ( In case BE, format should be BE0xxx.xxx.xxx )
        /// </summary>
        /// <value>VAT Nr ( In case BE, format should be BE0xxx.xxx.xxx )</value>
        [DataMember(Name="vatNr", EmitDefaultValue=false)]
        public string VatNr { get; set; }

        /// <summary>
        /// Vat Type (Btw plichtigheid):&lt;ul&gt;&lt;li&gt;0 : Onbekend&lt;/li&gt;&lt;li&gt;1 : Belgische BTW-plichtige&lt;/li&gt;&lt;li&gt;4 : Intracommunautaire BTW-plichtige&lt;/li&gt;&lt;li&gt;6 : BTW-plichtige buiten EU&lt;/li&gt;&lt;li&gt;7 : Particulier Belgie&lt;/li&gt;&lt;li&gt;8 : Particulier EU&lt;/li&gt;&lt;li&gt;9 : Particulier niet-EU&lt;/li&gt;&lt;li&gt;10: Niet btw-plichtig&lt;/li&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>Vat Type (Btw plichtigheid):&lt;ul&gt;&lt;li&gt;0 : Onbekend&lt;/li&gt;&lt;li&gt;1 : Belgische BTW-plichtige&lt;/li&gt;&lt;li&gt;4 : Intracommunautaire BTW-plichtige&lt;/li&gt;&lt;li&gt;6 : BTW-plichtige buiten EU&lt;/li&gt;&lt;li&gt;7 : Particulier Belgie&lt;/li&gt;&lt;li&gt;8 : Particulier EU&lt;/li&gt;&lt;li&gt;9 : Particulier niet-EU&lt;/li&gt;&lt;li&gt;10: Niet btw-plichtig&lt;/li&gt;&lt;/ul&gt;</value>
        [DataMember(Name="vatType", EmitDefaultValue=false)]
        public int? VatType { get; set; }

        /// <summary>
        /// Expiration Type. 1 : End of month, 2 : After invoice date
        /// </summary>
        /// <value>Expiration Type. 1 : End of month, 2 : After invoice date</value>
        [DataMember(Name="expirationType", EmitDefaultValue=false)]
        public int? ExpirationType { get; set; }

        /// <summary>
        /// Number of days after expiration type
        /// </summary>
        /// <value>Number of days after expiration type</value>
        [DataMember(Name="expirationDays", EmitDefaultValue=false)]
        public int? ExpirationDays { get; set; }

        /// <summary>
        /// Search field 1
        /// </summary>
        /// <value>Search field 1</value>
        [DataMember(Name="searchField1", EmitDefaultValue=false)]
        public string SearchField1 { get; set; }

        /// <summary>
        /// Search field 2
        /// </summary>
        /// <value>Search field 2</value>
        [DataMember(Name="searchField2", EmitDefaultValue=false)]
        public string SearchField2 { get; set; }

        /// <summary>
        /// Customer number as known by supplier
        /// </summary>
        /// <value>Customer number as known by supplier</value>
        [DataMember(Name="externCustomerNr", EmitDefaultValue=false)]
        public string ExternCustomerNr { get; set; }

        /// <summary>
        /// Sepa Direct Debit reference
        /// </summary>
        /// <value>Sepa Direct Debit reference</value>
        [DataMember(Name="sddReference", EmitDefaultValue=false)]
        public string SddReference { get; set; }

        /// <summary>
        /// Sepa Direct Debit sequence type:&lt;ul&gt;&lt;li&gt;Value 1 : First&lt;/li&gt;&lt;li&gt;Value 2 : Recurrent&lt;/li&gt;&lt;li&gt;Value 3 : Last&lt;/li&gt;&lt;li&gt;Value 4 : One time&lt;/li&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>Sepa Direct Debit sequence type:&lt;ul&gt;&lt;li&gt;Value 1 : First&lt;/li&gt;&lt;li&gt;Value 2 : Recurrent&lt;/li&gt;&lt;li&gt;Value 3 : Last&lt;/li&gt;&lt;li&gt;Value 4 : One time&lt;/li&gt;&lt;/ul&gt;</value>
        [DataMember(Name="sddSeqtype", EmitDefaultValue=false)]
        public int? SddSeqtype { get; set; }

        /// <summary>
        /// Sepa Direct Debit Mandate Type:&lt;ul&gt;&lt;li&gt;Value 1 : Core&lt;/li&gt;&lt;li&gt;Value 2 : B2B&lt;/li&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>Sepa Direct Debit Mandate Type:&lt;ul&gt;&lt;li&gt;Value 1 : Core&lt;/li&gt;&lt;li&gt;Value 2 : B2B&lt;/li&gt;&lt;/ul&gt;</value>
        [DataMember(Name="sddMandateType", EmitDefaultValue=false)]
        public int? SddMandateType { get; set; }

        /// <summary>
        /// Sepa Direct Debit signature date
        /// </summary>
        /// <value>Sepa Direct Debit signature date</value>
        [DataMember(Name="sddSignatureDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? SddSignatureDate { get; set; }

        /// <summary>
        /// Sepa Direct Debit Active flag
        /// </summary>
        /// <value>Sepa Direct Debit Active flag</value>
        [DataMember(Name="sddActive", EmitDefaultValue=false)]
        public bool? SddActive { get; set; }

        /// <summary>
        /// Invoice language.  0 : Nederlands, 1 : Francais, 2 : English
        /// </summary>
        /// <value>Invoice language.  0 : Nederlands, 1 : Francais, 2 : English</value>
        [DataMember(Name="factLanguage", EmitDefaultValue=false)]
        public int? FactLanguage { get; set; }

        /// <summary>
        /// Indication if the relation is active
        /// </summary>
        /// <value>Indication if the relation is active</value>
        [DataMember(Name="active", EmitDefaultValue=false)]
        public bool? Active { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class RelationServiceData {\n");
            sb.Append("  RelationIdentificationServiceData: ").Append(RelationIdentificationServiceData).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  FirstName: ").Append(FirstName).Append("\n");
            sb.Append("  Client: ").Append(Client).Append("\n");
            sb.Append("  DefaultBookingAccountClient: ").Append(DefaultBookingAccountClient).Append("\n");
            sb.Append("  Supplier: ").Append(Supplier).Append("\n");
            sb.Append("  DefaultBookingAccountSupplier: ").Append(DefaultBookingAccountSupplier).Append("\n");
            sb.Append("  StreetAndNr: ").Append(StreetAndNr).Append("\n");
            sb.Append("  PostalCode: ").Append(PostalCode).Append("\n");
            sb.Append("  City: ").Append(City).Append("\n");
            sb.Append("  Country: ").Append(Country).Append("\n");
            sb.Append("  DeliveryStreetAndNr: ").Append(DeliveryStreetAndNr).Append("\n");
            sb.Append("  DeliveryPostalCode: ").Append(DeliveryPostalCode).Append("\n");
            sb.Append("  DeliveryCity: ").Append(DeliveryCity).Append("\n");
            sb.Append("  DeliveryCountry: ").Append(DeliveryCountry).Append("\n");
            sb.Append("  Telephone: ").Append(Telephone).Append("\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("  Fax: ").Append(Fax).Append("\n");
            sb.Append("  Mobile: ").Append(Mobile).Append("\n");
            sb.Append("  Url: ").Append(Url).Append("\n");
            sb.Append("  BankAccountNr: ").Append(BankAccountNr).Append("\n");
            sb.Append("  IbanAccountNr: ").Append(IbanAccountNr).Append("\n");
            sb.Append("  BicCode: ").Append(BicCode).Append("\n");
            sb.Append("  FinancialDiscount: ").Append(FinancialDiscount).Append("\n");
            sb.Append("  Profession: ").Append(Profession).Append("\n");
            sb.Append("  ContactPerson: ").Append(ContactPerson).Append("\n");
            sb.Append("  CorporationType: ").Append(CorporationType).Append("\n");
            sb.Append("  CurrencyCode: ").Append(CurrencyCode).Append("\n");
            sb.Append("  Remarks: ").Append(Remarks).Append("\n");
            sb.Append("  VatNr: ").Append(VatNr).Append("\n");
            sb.Append("  VatType: ").Append(VatType).Append("\n");
            sb.Append("  ExpirationType: ").Append(ExpirationType).Append("\n");
            sb.Append("  ExpirationDays: ").Append(ExpirationDays).Append("\n");
            sb.Append("  SearchField1: ").Append(SearchField1).Append("\n");
            sb.Append("  SearchField2: ").Append(SearchField2).Append("\n");
            sb.Append("  ExternCustomerNr: ").Append(ExternCustomerNr).Append("\n");
            sb.Append("  SddReference: ").Append(SddReference).Append("\n");
            sb.Append("  SddSeqtype: ").Append(SddSeqtype).Append("\n");
            sb.Append("  SddMandateType: ").Append(SddMandateType).Append("\n");
            sb.Append("  SddSignatureDate: ").Append(SddSignatureDate).Append("\n");
            sb.Append("  SddActive: ").Append(SddActive).Append("\n");
            sb.Append("  FactLanguage: ").Append(FactLanguage).Append("\n");
            sb.Append("  Active: ").Append(Active).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as RelationServiceData);
        }

        /// <summary>
        /// Returns true if RelationServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of RelationServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(RelationServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.RelationIdentificationServiceData == input.RelationIdentificationServiceData ||
                    (this.RelationIdentificationServiceData != null &&
                    this.RelationIdentificationServiceData.Equals(input.RelationIdentificationServiceData))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.FirstName == input.FirstName ||
                    (this.FirstName != null &&
                    this.FirstName.Equals(input.FirstName))
                ) && 
                (
                    this.Client == input.Client ||
                    (this.Client != null &&
                    this.Client.Equals(input.Client))
                ) && 
                (
                    this.DefaultBookingAccountClient == input.DefaultBookingAccountClient ||
                    (this.DefaultBookingAccountClient != null &&
                    this.DefaultBookingAccountClient.Equals(input.DefaultBookingAccountClient))
                ) && 
                (
                    this.Supplier == input.Supplier ||
                    (this.Supplier != null &&
                    this.Supplier.Equals(input.Supplier))
                ) && 
                (
                    this.DefaultBookingAccountSupplier == input.DefaultBookingAccountSupplier ||
                    (this.DefaultBookingAccountSupplier != null &&
                    this.DefaultBookingAccountSupplier.Equals(input.DefaultBookingAccountSupplier))
                ) && 
                (
                    this.StreetAndNr == input.StreetAndNr ||
                    (this.StreetAndNr != null &&
                    this.StreetAndNr.Equals(input.StreetAndNr))
                ) && 
                (
                    this.PostalCode == input.PostalCode ||
                    (this.PostalCode != null &&
                    this.PostalCode.Equals(input.PostalCode))
                ) && 
                (
                    this.City == input.City ||
                    (this.City != null &&
                    this.City.Equals(input.City))
                ) && 
                (
                    this.Country == input.Country ||
                    (this.Country != null &&
                    this.Country.Equals(input.Country))
                ) && 
                (
                    this.DeliveryStreetAndNr == input.DeliveryStreetAndNr ||
                    (this.DeliveryStreetAndNr != null &&
                    this.DeliveryStreetAndNr.Equals(input.DeliveryStreetAndNr))
                ) && 
                (
                    this.DeliveryPostalCode == input.DeliveryPostalCode ||
                    (this.DeliveryPostalCode != null &&
                    this.DeliveryPostalCode.Equals(input.DeliveryPostalCode))
                ) && 
                (
                    this.DeliveryCity == input.DeliveryCity ||
                    (this.DeliveryCity != null &&
                    this.DeliveryCity.Equals(input.DeliveryCity))
                ) && 
                (
                    this.DeliveryCountry == input.DeliveryCountry ||
                    (this.DeliveryCountry != null &&
                    this.DeliveryCountry.Equals(input.DeliveryCountry))
                ) && 
                (
                    this.Telephone == input.Telephone ||
                    (this.Telephone != null &&
                    this.Telephone.Equals(input.Telephone))
                ) && 
                (
                    this.Email == input.Email ||
                    (this.Email != null &&
                    this.Email.Equals(input.Email))
                ) && 
                (
                    this.Fax == input.Fax ||
                    (this.Fax != null &&
                    this.Fax.Equals(input.Fax))
                ) && 
                (
                    this.Mobile == input.Mobile ||
                    (this.Mobile != null &&
                    this.Mobile.Equals(input.Mobile))
                ) && 
                (
                    this.Url == input.Url ||
                    (this.Url != null &&
                    this.Url.Equals(input.Url))
                ) && 
                (
                    this.BankAccountNr == input.BankAccountNr ||
                    (this.BankAccountNr != null &&
                    this.BankAccountNr.Equals(input.BankAccountNr))
                ) && 
                (
                    this.IbanAccountNr == input.IbanAccountNr ||
                    (this.IbanAccountNr != null &&
                    this.IbanAccountNr.Equals(input.IbanAccountNr))
                ) && 
                (
                    this.BicCode == input.BicCode ||
                    (this.BicCode != null &&
                    this.BicCode.Equals(input.BicCode))
                ) && 
                (
                    this.FinancialDiscount == input.FinancialDiscount ||
                    (this.FinancialDiscount != null &&
                    this.FinancialDiscount.Equals(input.FinancialDiscount))
                ) && 
                (
                    this.Profession == input.Profession ||
                    (this.Profession != null &&
                    this.Profession.Equals(input.Profession))
                ) && 
                (
                    this.ContactPerson == input.ContactPerson ||
                    (this.ContactPerson != null &&
                    this.ContactPerson.Equals(input.ContactPerson))
                ) && 
                (
                    this.CorporationType == input.CorporationType ||
                    (this.CorporationType != null &&
                    this.CorporationType.Equals(input.CorporationType))
                ) && 
                (
                    this.CurrencyCode == input.CurrencyCode ||
                    (this.CurrencyCode != null &&
                    this.CurrencyCode.Equals(input.CurrencyCode))
                ) && 
                (
                    this.Remarks == input.Remarks ||
                    (this.Remarks != null &&
                    this.Remarks.Equals(input.Remarks))
                ) && 
                (
                    this.VatNr == input.VatNr ||
                    (this.VatNr != null &&
                    this.VatNr.Equals(input.VatNr))
                ) && 
                (
                    this.VatType == input.VatType ||
                    (this.VatType != null &&
                    this.VatType.Equals(input.VatType))
                ) && 
                (
                    this.ExpirationType == input.ExpirationType ||
                    (this.ExpirationType != null &&
                    this.ExpirationType.Equals(input.ExpirationType))
                ) && 
                (
                    this.ExpirationDays == input.ExpirationDays ||
                    (this.ExpirationDays != null &&
                    this.ExpirationDays.Equals(input.ExpirationDays))
                ) && 
                (
                    this.SearchField1 == input.SearchField1 ||
                    (this.SearchField1 != null &&
                    this.SearchField1.Equals(input.SearchField1))
                ) && 
                (
                    this.SearchField2 == input.SearchField2 ||
                    (this.SearchField2 != null &&
                    this.SearchField2.Equals(input.SearchField2))
                ) && 
                (
                    this.ExternCustomerNr == input.ExternCustomerNr ||
                    (this.ExternCustomerNr != null &&
                    this.ExternCustomerNr.Equals(input.ExternCustomerNr))
                ) && 
                (
                    this.SddReference == input.SddReference ||
                    (this.SddReference != null &&
                    this.SddReference.Equals(input.SddReference))
                ) && 
                (
                    this.SddSeqtype == input.SddSeqtype ||
                    (this.SddSeqtype != null &&
                    this.SddSeqtype.Equals(input.SddSeqtype))
                ) && 
                (
                    this.SddMandateType == input.SddMandateType ||
                    (this.SddMandateType != null &&
                    this.SddMandateType.Equals(input.SddMandateType))
                ) && 
                (
                    this.SddSignatureDate == input.SddSignatureDate ||
                    (this.SddSignatureDate != null &&
                    this.SddSignatureDate.Equals(input.SddSignatureDate))
                ) && 
                (
                    this.SddActive == input.SddActive ||
                    (this.SddActive != null &&
                    this.SddActive.Equals(input.SddActive))
                ) && 
                (
                    this.FactLanguage == input.FactLanguage ||
                    (this.FactLanguage != null &&
                    this.FactLanguage.Equals(input.FactLanguage))
                ) && 
                (
                    this.Active == input.Active ||
                    (this.Active != null &&
                    this.Active.Equals(input.Active))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.RelationIdentificationServiceData != null)
                    hashCode = hashCode * 59 + this.RelationIdentificationServiceData.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.FirstName != null)
                    hashCode = hashCode * 59 + this.FirstName.GetHashCode();
                if (this.Client != null)
                    hashCode = hashCode * 59 + this.Client.GetHashCode();
                if (this.DefaultBookingAccountClient != null)
                    hashCode = hashCode * 59 + this.DefaultBookingAccountClient.GetHashCode();
                if (this.Supplier != null)
                    hashCode = hashCode * 59 + this.Supplier.GetHashCode();
                if (this.DefaultBookingAccountSupplier != null)
                    hashCode = hashCode * 59 + this.DefaultBookingAccountSupplier.GetHashCode();
                if (this.StreetAndNr != null)
                    hashCode = hashCode * 59 + this.StreetAndNr.GetHashCode();
                if (this.PostalCode != null)
                    hashCode = hashCode * 59 + this.PostalCode.GetHashCode();
                if (this.City != null)
                    hashCode = hashCode * 59 + this.City.GetHashCode();
                if (this.Country != null)
                    hashCode = hashCode * 59 + this.Country.GetHashCode();
                if (this.DeliveryStreetAndNr != null)
                    hashCode = hashCode * 59 + this.DeliveryStreetAndNr.GetHashCode();
                if (this.DeliveryPostalCode != null)
                    hashCode = hashCode * 59 + this.DeliveryPostalCode.GetHashCode();
                if (this.DeliveryCity != null)
                    hashCode = hashCode * 59 + this.DeliveryCity.GetHashCode();
                if (this.DeliveryCountry != null)
                    hashCode = hashCode * 59 + this.DeliveryCountry.GetHashCode();
                if (this.Telephone != null)
                    hashCode = hashCode * 59 + this.Telephone.GetHashCode();
                if (this.Email != null)
                    hashCode = hashCode * 59 + this.Email.GetHashCode();
                if (this.Fax != null)
                    hashCode = hashCode * 59 + this.Fax.GetHashCode();
                if (this.Mobile != null)
                    hashCode = hashCode * 59 + this.Mobile.GetHashCode();
                if (this.Url != null)
                    hashCode = hashCode * 59 + this.Url.GetHashCode();
                if (this.BankAccountNr != null)
                    hashCode = hashCode * 59 + this.BankAccountNr.GetHashCode();
                if (this.IbanAccountNr != null)
                    hashCode = hashCode * 59 + this.IbanAccountNr.GetHashCode();
                if (this.BicCode != null)
                    hashCode = hashCode * 59 + this.BicCode.GetHashCode();
                if (this.FinancialDiscount != null)
                    hashCode = hashCode * 59 + this.FinancialDiscount.GetHashCode();
                if (this.Profession != null)
                    hashCode = hashCode * 59 + this.Profession.GetHashCode();
                if (this.ContactPerson != null)
                    hashCode = hashCode * 59 + this.ContactPerson.GetHashCode();
                if (this.CorporationType != null)
                    hashCode = hashCode * 59 + this.CorporationType.GetHashCode();
                if (this.CurrencyCode != null)
                    hashCode = hashCode * 59 + this.CurrencyCode.GetHashCode();
                if (this.Remarks != null)
                    hashCode = hashCode * 59 + this.Remarks.GetHashCode();
                if (this.VatNr != null)
                    hashCode = hashCode * 59 + this.VatNr.GetHashCode();
                if (this.VatType != null)
                    hashCode = hashCode * 59 + this.VatType.GetHashCode();
                if (this.ExpirationType != null)
                    hashCode = hashCode * 59 + this.ExpirationType.GetHashCode();
                if (this.ExpirationDays != null)
                    hashCode = hashCode * 59 + this.ExpirationDays.GetHashCode();
                if (this.SearchField1 != null)
                    hashCode = hashCode * 59 + this.SearchField1.GetHashCode();
                if (this.SearchField2 != null)
                    hashCode = hashCode * 59 + this.SearchField2.GetHashCode();
                if (this.ExternCustomerNr != null)
                    hashCode = hashCode * 59 + this.ExternCustomerNr.GetHashCode();
                if (this.SddReference != null)
                    hashCode = hashCode * 59 + this.SddReference.GetHashCode();
                if (this.SddSeqtype != null)
                    hashCode = hashCode * 59 + this.SddSeqtype.GetHashCode();
                if (this.SddMandateType != null)
                    hashCode = hashCode * 59 + this.SddMandateType.GetHashCode();
                if (this.SddSignatureDate != null)
                    hashCode = hashCode * 59 + this.SddSignatureDate.GetHashCode();
                if (this.SddActive != null)
                    hashCode = hashCode * 59 + this.SddActive.GetHashCode();
                if (this.FactLanguage != null)
                    hashCode = hashCode * 59 + this.FactLanguage.GetHashCode();
                if (this.Active != null)
                    hashCode = hashCode * 59 + this.Active.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
