/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Multi language product description
    /// </summary>
    [DataContract]
        public partial class StringServiceData :  IEquatable<StringServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="StringServiceData" /> class.
        /// </summary>
        /// <param name="descriptionNL">descriptionNL.</param>
        /// <param name="descriptionFR">descriptionFR.</param>
        /// <param name="descriptionEN">descriptionEN.</param>
        public StringServiceData(string descriptionNL = default(string), string descriptionFR = default(string), string descriptionEN = default(string))
        {
            this.DescriptionNL = descriptionNL;
            this.DescriptionFR = descriptionFR;
            this.DescriptionEN = descriptionEN;
        }
        
        /// <summary>
        /// Gets or Sets DescriptionNL
        /// </summary>
        [DataMember(Name="description_NL", EmitDefaultValue=false)]
        public string DescriptionNL { get; set; }

        /// <summary>
        /// Gets or Sets DescriptionFR
        /// </summary>
        [DataMember(Name="description_FR", EmitDefaultValue=false)]
        public string DescriptionFR { get; set; }

        /// <summary>
        /// Gets or Sets DescriptionEN
        /// </summary>
        [DataMember(Name="description_EN", EmitDefaultValue=false)]
        public string DescriptionEN { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class StringServiceData {\n");
            sb.Append("  DescriptionNL: ").Append(DescriptionNL).Append("\n");
            sb.Append("  DescriptionFR: ").Append(DescriptionFR).Append("\n");
            sb.Append("  DescriptionEN: ").Append(DescriptionEN).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as StringServiceData);
        }

        /// <summary>
        /// Returns true if StringServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of StringServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(StringServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.DescriptionNL == input.DescriptionNL ||
                    (this.DescriptionNL != null &&
                    this.DescriptionNL.Equals(input.DescriptionNL))
                ) && 
                (
                    this.DescriptionFR == input.DescriptionFR ||
                    (this.DescriptionFR != null &&
                    this.DescriptionFR.Equals(input.DescriptionFR))
                ) && 
                (
                    this.DescriptionEN == input.DescriptionEN ||
                    (this.DescriptionEN != null &&
                    this.DescriptionEN.Equals(input.DescriptionEN))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DescriptionNL != null)
                    hashCode = hashCode * 59 + this.DescriptionNL.GetHashCode();
                if (this.DescriptionFR != null)
                    hashCode = hashCode * 59 + this.DescriptionFR.GetHashCode();
                if (this.DescriptionEN != null)
                    hashCode = hashCode * 59 + this.DescriptionEN.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
