/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Modified and deleted Accounts
    /// </summary>
    [DataContract]
        public partial class SyncAccounts :  IEquatable<SyncAccounts>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SyncAccounts" /> class.
        /// </summary>
        /// <param name="modified">modified.</param>
        /// <param name="deleted">deleted.</param>
        public SyncAccounts(List<AccountServiceData> modified = default(List<AccountServiceData>), List<AccountServiceData> deleted = default(List<AccountServiceData>))
        {
            this.Modified = modified;
            this.Deleted = deleted;
        }
        
        /// <summary>
        /// Gets or Sets Modified
        /// </summary>
        [DataMember(Name="modified", EmitDefaultValue=false)]
        public List<AccountServiceData> Modified { get; set; }

        /// <summary>
        /// Gets or Sets Deleted
        /// </summary>
        [DataMember(Name="deleted", EmitDefaultValue=false)]
        public List<AccountServiceData> Deleted { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SyncAccounts {\n");
            sb.Append("  Modified: ").Append(Modified).Append("\n");
            sb.Append("  Deleted: ").Append(Deleted).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SyncAccounts);
        }

        /// <summary>
        /// Returns true if SyncAccounts instances are equal
        /// </summary>
        /// <param name="input">Instance of SyncAccounts to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SyncAccounts input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Modified == input.Modified ||
                    this.Modified != null &&
                    input.Modified != null &&
                    this.Modified.SequenceEqual(input.Modified)
                ) && 
                (
                    this.Deleted == input.Deleted ||
                    this.Deleted != null &&
                    input.Deleted != null &&
                    this.Deleted.SequenceEqual(input.Deleted)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Modified != null)
                    hashCode = hashCode * 59 + this.Modified.GetHashCode();
                if (this.Deleted != null)
                    hashCode = hashCode * 59 + this.Deleted.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
