/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Modified and deleted balancings lists
    /// </summary>
    [DataContract]
        public partial class SyncBalancings :  IEquatable<SyncBalancings>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SyncBalancings" /> class.
        /// </summary>
        /// <param name="modifiedBalancings">modifiedBalancings.</param>
        /// <param name="deletedBalancings">deletedBalancings.</param>
        public SyncBalancings(List<BalancingDetailServiceData> modifiedBalancings = default(List<BalancingDetailServiceData>), List<BalancingDetailServiceData> deletedBalancings = default(List<BalancingDetailServiceData>))
        {
            this.ModifiedBalancings = modifiedBalancings;
            this.DeletedBalancings = deletedBalancings;
        }
        
        /// <summary>
        /// Gets or Sets ModifiedBalancings
        /// </summary>
        [DataMember(Name="modifiedBalancings", EmitDefaultValue=false)]
        public List<BalancingDetailServiceData> ModifiedBalancings { get; set; }

        /// <summary>
        /// Gets or Sets DeletedBalancings
        /// </summary>
        [DataMember(Name="deletedBalancings", EmitDefaultValue=false)]
        public List<BalancingDetailServiceData> DeletedBalancings { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SyncBalancings {\n");
            sb.Append("  ModifiedBalancings: ").Append(ModifiedBalancings).Append("\n");
            sb.Append("  DeletedBalancings: ").Append(DeletedBalancings).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SyncBalancings);
        }

        /// <summary>
        /// Returns true if SyncBalancings instances are equal
        /// </summary>
        /// <param name="input">Instance of SyncBalancings to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SyncBalancings input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ModifiedBalancings == input.ModifiedBalancings ||
                    this.ModifiedBalancings != null &&
                    input.ModifiedBalancings != null &&
                    this.ModifiedBalancings.SequenceEqual(input.ModifiedBalancings)
                ) && 
                (
                    this.DeletedBalancings == input.DeletedBalancings ||
                    this.DeletedBalancings != null &&
                    input.DeletedBalancings != null &&
                    this.DeletedBalancings.SequenceEqual(input.DeletedBalancings)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ModifiedBalancings != null)
                    hashCode = hashCode * 59 + this.ModifiedBalancings.GetHashCode();
                if (this.DeletedBalancings != null)
                    hashCode = hashCode * 59 + this.DeletedBalancings.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
