/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Modified and deleted booking lists
    /// </summary>
    [DataContract]
        public partial class SyncBookings :  IEquatable<SyncBookings>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SyncBookings" /> class.
        /// </summary>
        /// <param name="modifiedBookings">Modified bookings list.</param>
        /// <param name="deletedBookings">Deleted bookings list.</param>
        public SyncBookings(List<BookingReportData> modifiedBookings = default(List<BookingReportData>), List<DocumentKey> deletedBookings = default(List<DocumentKey>))
        {
            this.ModifiedBookings = modifiedBookings;
            this.DeletedBookings = deletedBookings;
        }
        
        /// <summary>
        /// Modified bookings list
        /// </summary>
        /// <value>Modified bookings list</value>
        [DataMember(Name="modifiedBookings", EmitDefaultValue=false)]
        public List<BookingReportData> ModifiedBookings { get; set; }

        /// <summary>
        /// Deleted bookings list
        /// </summary>
        /// <value>Deleted bookings list</value>
        [DataMember(Name="deletedBookings", EmitDefaultValue=false)]
        public List<DocumentKey> DeletedBookings { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SyncBookings {\n");
            sb.Append("  ModifiedBookings: ").Append(ModifiedBookings).Append("\n");
            sb.Append("  DeletedBookings: ").Append(DeletedBookings).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SyncBookings);
        }

        /// <summary>
        /// Returns true if SyncBookings instances are equal
        /// </summary>
        /// <param name="input">Instance of SyncBookings to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SyncBookings input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ModifiedBookings == input.ModifiedBookings ||
                    this.ModifiedBookings != null &&
                    input.ModifiedBookings != null &&
                    this.ModifiedBookings.SequenceEqual(input.ModifiedBookings)
                ) && 
                (
                    this.DeletedBookings == input.DeletedBookings ||
                    this.DeletedBookings != null &&
                    input.DeletedBookings != null &&
                    this.DeletedBookings.SequenceEqual(input.DeletedBookings)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ModifiedBookings != null)
                    hashCode = hashCode * 59 + this.ModifiedBookings.GetHashCode();
                if (this.DeletedBookings != null)
                    hashCode = hashCode * 59 + this.DeletedBookings.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
