/* 
 * Octopus Rest API
 *
 * API to connect with Octopus
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// VatCodeServiceData
    /// </summary>
    [DataContract]
        public partial class VatCodeServiceData :  IEquatable<VatCodeServiceData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="VatCodeServiceData" /> class.
        /// </summary>
        /// <param name="code">Vat code key description (required).</param>
        /// <param name="description">Vat code description.</param>
        /// <param name="type">Type of Vat code : &lt;ul&gt;&lt;li&gt;1 : VT_BUY&lt;/li&gt;&lt;li&gt;2 : VT_SELL&lt;/li&gt;&lt;li&gt;3 : VT_BUY_CREDIT_NOTE&lt;li&gt;4 : VT_SELL_CREDIT_NOTE&lt;/ul&gt;.</param>
        /// <param name="basePercentage">Base vat percentage.</param>
        /// <param name="defaultSellBookingAccountNr">defaultSellBookingAccountNr.</param>
        public VatCodeServiceData(string code = default(string), string description = default(string), int? type = default(int?), double? basePercentage = default(double?), int? defaultSellBookingAccountNr = default(int?))
        {
            // to ensure "code" is required (not null)
            if (code == null)
            {
                throw new InvalidDataException("code is a required property for VatCodeServiceData and cannot be null");
            }
            else
            {
                this.Code = code;
            }
            this.Description = description;
            this.Type = type;
            this.BasePercentage = basePercentage;
            this.DefaultSellBookingAccountNr = defaultSellBookingAccountNr;
        }
        
        /// <summary>
        /// Vat code key description
        /// </summary>
        /// <value>Vat code key description</value>
        [DataMember(Name="code", EmitDefaultValue=false)]
        public string Code { get; set; }

        /// <summary>
        /// Vat code description
        /// </summary>
        /// <value>Vat code description</value>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Type of Vat code : &lt;ul&gt;&lt;li&gt;1 : VT_BUY&lt;/li&gt;&lt;li&gt;2 : VT_SELL&lt;/li&gt;&lt;li&gt;3 : VT_BUY_CREDIT_NOTE&lt;li&gt;4 : VT_SELL_CREDIT_NOTE&lt;/ul&gt;
        /// </summary>
        /// <value>Type of Vat code : &lt;ul&gt;&lt;li&gt;1 : VT_BUY&lt;/li&gt;&lt;li&gt;2 : VT_SELL&lt;/li&gt;&lt;li&gt;3 : VT_BUY_CREDIT_NOTE&lt;li&gt;4 : VT_SELL_CREDIT_NOTE&lt;/ul&gt;</value>
        [DataMember(Name="type", EmitDefaultValue=false)]
        public int? Type { get; set; }

        /// <summary>
        /// Base vat percentage
        /// </summary>
        /// <value>Base vat percentage</value>
        [DataMember(Name="basePercentage", EmitDefaultValue=false)]
        public double? BasePercentage { get; set; }

        /// <summary>
        /// Gets or Sets DefaultSellBookingAccountNr
        /// </summary>
        [DataMember(Name="defaultSellBookingAccountNr", EmitDefaultValue=false)]
        public int? DefaultSellBookingAccountNr { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class VatCodeServiceData {\n");
            sb.Append("  Code: ").Append(Code).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  BasePercentage: ").Append(BasePercentage).Append("\n");
            sb.Append("  DefaultSellBookingAccountNr: ").Append(DefaultSellBookingAccountNr).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as VatCodeServiceData);
        }

        /// <summary>
        /// Returns true if VatCodeServiceData instances are equal
        /// </summary>
        /// <param name="input">Instance of VatCodeServiceData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(VatCodeServiceData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Code == input.Code ||
                    (this.Code != null &&
                    this.Code.Equals(input.Code))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.BasePercentage == input.BasePercentage ||
                    (this.BasePercentage != null &&
                    this.BasePercentage.Equals(input.BasePercentage))
                ) && 
                (
                    this.DefaultSellBookingAccountNr == input.DefaultSellBookingAccountNr ||
                    (this.DefaultSellBookingAccountNr != null &&
                    this.DefaultSellBookingAccountNr.Equals(input.DefaultSellBookingAccountNr))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Code != null)
                    hashCode = hashCode * 59 + this.Code.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.BasePercentage != null)
                    hashCode = hashCode * 59 + this.BasePercentage.GetHashCode();
                if (this.DefaultSellBookingAccountNr != null)
                    hashCode = hashCode * 59 + this.DefaultSellBookingAccountNr.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
