# IO.Swagger.Api.AccountsApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetAccounts**](AccountsApi.md#getaccounts) | **GET** /dossiers/{dossierId}/accounts | Get Accounts
[**GetModifiedAccountAmounts**](AccountsApi.md#getmodifiedaccountamounts) | **GET** /dossiers/{dossierId}/accounts/amounts/modified | Get Modified Account Amounts
[**GetModifiedAccounts**](AccountsApi.md#getmodifiedaccounts) | **GET** /dossiers/{dossierId}/accounts/modified | Get Modified Accounts
[**InsertUpdateAccount**](AccountsApi.md#insertupdateaccount) | **PUT** /dossiers/{dossierId}/accounts | Modify or Create Account

<a name="getaccounts"></a>
# **GetAccounts**
> List<AccountServiceData> GetAccounts (int? dossierId, int? bookyearId, string dossierToken)

Get Accounts

Accept dossier token and return Accounts.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetAccountsExample
    {
        public void main()
        {
            var apiInstance = new AccountsApi();
            var dossierId = 56;  // int? | Dossier ID
            var bookyearId = 56;  // int? | Bookyear ID
            var dossierToken = dossierToken_example;  // string | Dossier Token

            try
            {
                // Get Accounts
                List&lt;AccountServiceData&gt; result = apiInstance.GetAccounts(dossierId, bookyearId, dossierToken);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountsApi.GetAccounts: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **bookyearId** | **int?**| Bookyear ID | 
 **dossierToken** | **string**| Dossier Token | 

### Return type

[**List<AccountServiceData>**](AccountServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getmodifiedaccountamounts"></a>
# **GetModifiedAccountAmounts**
> SyncAccountAmounts GetModifiedAccountAmounts (int? dossierId, string dossierToken, string modifiedTimeStamp = null)

Get Modified Account Amounts

Accept dossier token, modified timestamp, and return modified/deleted Account Amounts.  

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetModifiedAccountAmountsExample
    {
        public void main()
        {
            var apiInstance = new AccountsApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | Dossier Token
            var modifiedTimeStamp = modifiedTimeStamp_example;  // string | Modified Timestamp (optional) 

            try
            {
                // Get Modified Account Amounts
                SyncAccountAmounts result = apiInstance.GetModifiedAccountAmounts(dossierId, dossierToken, modifiedTimeStamp);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountsApi.GetModifiedAccountAmounts: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| Dossier Token | 
 **modifiedTimeStamp** | **string**| Modified Timestamp | [optional] 

### Return type

[**SyncAccountAmounts**](SyncAccountAmounts.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getmodifiedaccounts"></a>
# **GetModifiedAccounts**
> SyncAccounts GetModifiedAccounts (int? dossierId, string modifiedTimeStamp, string dossierToken)

Get Modified Accounts

Accept dossier token, modified timestamp, and return modified/deleted Accounts.  

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetModifiedAccountsExample
    {
        public void main()
        {
            var apiInstance = new AccountsApi();
            var dossierId = 56;  // int? | Dossier ID
            var modifiedTimeStamp = modifiedTimeStamp_example;  // string | Modified Timestamp
            var dossierToken = dossierToken_example;  // string | Dossier Token

            try
            {
                // Get Modified Accounts
                SyncAccounts result = apiInstance.GetModifiedAccounts(dossierId, modifiedTimeStamp, dossierToken);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountsApi.GetModifiedAccounts: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **modifiedTimeStamp** | **string**| Modified Timestamp | 
 **dossierToken** | **string**| Dossier Token | 

### Return type

[**SyncAccounts**](SyncAccounts.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="insertupdateaccount"></a>
# **InsertUpdateAccount**
> void InsertUpdateAccount (AccountServiceData body, string dossierToken, int? dossierId)

Modify or Create Account

Accept dossier token and modified or new account.  

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class InsertUpdateAccountExample
    {
        public void main()
        {
            var apiInstance = new AccountsApi();
            var body = new AccountServiceData(); // AccountServiceData | Account
            var dossierToken = dossierToken_example;  // string | Dossier Token
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Modify or Create Account
                apiInstance.InsertUpdateAccount(body, dossierToken, dossierId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountsApi.InsertUpdateAccount: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AccountServiceData**](AccountServiceData.md)| Account | 
 **dossierToken** | **string**| Dossier Token | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
