# IO.Swagger.Api.AuthenticationApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**AuthenticateUser**](AuthenticationApi.md#authenticateuser) | **POST** /authentication | Authenticate

<a name="authenticateuser"></a>
# **AuthenticateUser**
> AuthenticationToken AuthenticateUser (Credentials body, string softwareHouseUuid)

Authenticate

Authenticate user and return token (valid for 10 minutes)

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AuthenticateUserExample
    {
        public void main()
        {
            var apiInstance = new AuthenticationApi();
            var body = new Credentials(); // Credentials | The user name and password for login
            var softwareHouseUuid = softwareHouseUuid_example;  // string | The Software House ID (provided by Octopus)

            try
            {
                // Authenticate
                AuthenticationToken result = apiInstance.AuthenticateUser(body, softwareHouseUuid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AuthenticationApi.AuthenticateUser: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Credentials**](Credentials.md)| The user name and password for login | 
 **softwareHouseUuid** | **string**| The Software House ID (provided by Octopus) | 

### Return type

[**AuthenticationToken**](AuthenticationToken.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
