# IO.Swagger.Api.BalancingsApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetModifiedBalancingRelations**](BalancingsApi.md#getmodifiedbalancingrelations) | **GET** /dossiers/{dossierId}/balancings/modified | Get modified balancings 
[**InsertBalancing**](BalancingsApi.md#insertbalancing) | **POST** /dossiers/{dossierId}/balancings | Insert balancing

<a name="getmodifiedbalancingrelations"></a>
# **GetModifiedBalancingRelations**
> SyncBalancings GetModifiedBalancingRelations (int? dossierId, string dossierToken, string modifiedTimeStamp)

Get modified balancings 

Accept dossier token and modifiedTimeStamp and return modified and deleted balancings

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetModifiedBalancingRelationsExample
    {
        public void main()
        {
            var apiInstance = new BalancingsApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var modifiedTimeStamp = modifiedTimeStamp_example;  // string | Modified Timestamp

            try
            {
                // Get modified balancings 
                SyncBalancings result = apiInstance.GetModifiedBalancingRelations(dossierId, dossierToken, modifiedTimeStamp);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BalancingsApi.GetModifiedBalancingRelations: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **modifiedTimeStamp** | **string**| Modified Timestamp | 

### Return type

[**SyncBalancings**](SyncBalancings.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="insertbalancing"></a>
# **InsertBalancing**
> void InsertBalancing (BalancingServiceData body, string dossierToken, int? dossierId)

Insert balancing

Accept dossier token and balancing data, and insert balancing

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class InsertBalancingExample
    {
        public void main()
        {
            var apiInstance = new BalancingsApi();
            var body = new BalancingServiceData(); // BalancingServiceData | Balancing data object
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Insert balancing
                apiInstance.InsertBalancing(body, dossierToken, dossierId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BalancingsApi.InsertBalancing: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**BalancingServiceData**](BalancingServiceData.md)| Balancing data object | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
