# IO.Swagger.Api.BookingsApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**AddAttachementToBooking**](BookingsApi.md#addattachementtobooking) | **POST** /dossiers/{dossierId}/bookyears/{bookyearId}/bookings/attachements | Add Attachement to booking
[**GetReportModifiedBooking**](BookingsApi.md#getreportmodifiedbooking) | **GET** /dossiers/{dossierId}/bookyears/{bookyearId}/bookings/modified | Get modified bookings

<a name="addattachementtobooking"></a>
# **AddAttachementToBooking**
> void AddAttachementToBooking (AttachementData body, string dossierToken, string journalKey, int? documentSequennceNr, int? dossierId, int? bookyearId)

Add Attachement to booking

Accept dossiertoken, Dossier ID, Bookyear Key, Journal Key, Document sequence Nr. and attachement

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AddAttachementToBookingExample
    {
        public void main()
        {
            var apiInstance = new BookingsApi();
            var body = new AttachementData(); // AttachementData | Attachement
            var dossierToken = dossierToken_example;  // string | dossierToken
            var journalKey = journalKey_example;  // string | Journal Key
            var documentSequennceNr = 56;  // int? | Document Sequence Nr
            var dossierId = 56;  // int? | Dossier ID
            var bookyearId = 56;  // int? | Bookyear Id

            try
            {
                // Add Attachement to booking
                apiInstance.AddAttachementToBooking(body, dossierToken, journalKey, documentSequennceNr, dossierId, bookyearId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BookingsApi.AddAttachementToBooking: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AttachementData**](AttachementData.md)| Attachement | 
 **dossierToken** | **string**| dossierToken | 
 **journalKey** | **string**| Journal Key | 
 **documentSequennceNr** | **int?**| Document Sequence Nr | 
 **dossierId** | **int?**| Dossier ID | 
 **bookyearId** | **int?**| Bookyear Id | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getreportmodifiedbooking"></a>
# **GetReportModifiedBooking**
> SyncBookings GetReportModifiedBooking (int? dossierId, string dossierToken, int? bookyearId, int? journalTypeId, string modifiedTimeStamp)

Get modified bookings

Accept dossier token, bookyear Id, Journal Type Id and modifiedTimeStamp and return modified and deleted bookings lists

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetReportModifiedBookingExample
    {
        public void main()
        {
            var apiInstance = new BookingsApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var bookyearId = 56;  // int? | Bookyear ID
            var journalTypeId = 56;  // int? | Journal Type ID (1 = Buy, 2 = Sell, 3 = Financial, 4 = Divers)
            var modifiedTimeStamp = modifiedTimeStamp_example;  // string | Modified Timestamp

            try
            {
                // Get modified bookings
                SyncBookings result = apiInstance.GetReportModifiedBooking(dossierId, dossierToken, bookyearId, journalTypeId, modifiedTimeStamp);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BookingsApi.GetReportModifiedBooking: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalTypeId** | **int?**| Journal Type ID (1 &#x3D; Buy, 2 &#x3D; Sell, 3 &#x3D; Financial, 4 &#x3D; Divers) | 
 **modifiedTimeStamp** | **string**| Modified Timestamp | 

### Return type

[**SyncBookings**](SyncBookings.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
