# IO.Swagger.Api.BuySellBookingsApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetBuySellBooking**](BuySellBookingsApi.md#getbuysellbooking) | **GET** /dossiers/{dossierId}/buysellbookings | Get Buy Sell Booking
[**GetModifiedBuySellBookings**](BuySellBookingsApi.md#getmodifiedbuysellbookings) | **GET** /dossiers/{dossierId}/buysellbookings/modified | Get modified Buy/Sell Bookings
[**InsertBuySellBooking**](BuySellBookingsApi.md#insertbuysellbooking) | **POST** /dossiers/{dossierId}/buysellbookings | Create Buy Sell Booking
[**UpdateBuySellBooking**](BuySellBookingsApi.md#updatebuysellbooking) | **PUT** /dossiers/{dossierId}/buysellbookings | Update Booking

<a name="getbuysellbooking"></a>
# **GetBuySellBooking**
> BuySellBookingServiceData GetBuySellBooking (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)

Get Buy Sell Booking

Accept Dossier ID, Dossier token, Bookyear Id, Journal ID, Document Nr and return Buy/Sell Booking

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetBuySellBookingExample
    {
        public void main()
        {
            var apiInstance = new BuySellBookingsApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var bookyearId = 56;  // int? | Bookyear ID
            var journalKey = journalKey_example;  // string | Journal Key
            var documentSeqNr = 56;  // int? | Document Nr

            try
            {
                // Get Buy Sell Booking
                BuySellBookingServiceData result = apiInstance.GetBuySellBooking(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BuySellBookingsApi.GetBuySellBooking: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalKey** | **string**| Journal Key | 
 **documentSeqNr** | **int?**| Document Nr | 

### Return type

[**BuySellBookingServiceData**](BuySellBookingServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getmodifiedbuysellbookings"></a>
# **GetModifiedBuySellBookings**
> List<BuySellBookingServiceData> GetModifiedBuySellBookings (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)

Get modified Buy/Sell Bookings

Accept dossier token and return modified Buy/Sell Bookings

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetModifiedBuySellBookingsExample
    {
        public void main()
        {
            var apiInstance = new BuySellBookingsApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var bookyearId = 56;  // int? | Bookyear ID
            var journalKey = journalKey_example;  // string | Journal Key
            var modifiedTimeStamp = modifiedTimeStamp_example;  // string | Modified Timestamp

            try
            {
                // Get modified Buy/Sell Bookings
                List&lt;BuySellBookingServiceData&gt; result = apiInstance.GetModifiedBuySellBookings(dossierId, dossierToken, bookyearId, journalKey, modifiedTimeStamp);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BuySellBookingsApi.GetModifiedBuySellBookings: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalKey** | **string**| Journal Key | 
 **modifiedTimeStamp** | **string**| Modified Timestamp | 

### Return type

[**List<BuySellBookingServiceData>**](BuySellBookingServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="insertbuysellbooking"></a>
# **InsertBuySellBooking**
> void InsertBuySellBooking (BuySellBookingAndAttachmentRequest body, string dossierToken, int? dossierId)

Create Buy Sell Booking

Create Buy Sell Booking, with or without attachements

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class InsertBuySellBookingExample
    {
        public void main()
        {
            var apiInstance = new BuySellBookingsApi();
            var body = new BuySellBookingAndAttachmentRequest(); // BuySellBookingAndAttachmentRequest | Buy/Sell Booking object and attachment list
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Create Buy Sell Booking
                apiInstance.InsertBuySellBooking(body, dossierToken, dossierId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BuySellBookingsApi.InsertBuySellBooking: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**BuySellBookingAndAttachmentRequest**](BuySellBookingAndAttachmentRequest.md)| Buy/Sell Booking object and attachment list | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="updatebuysellbooking"></a>
# **UpdateBuySellBooking**
> void UpdateBuySellBooking (BuySellBookingServiceData body, string dossierToken, int? dossierId)

Update Booking

Modify Buy/Sell Booking

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateBuySellBookingExample
    {
        public void main()
        {
            var apiInstance = new BuySellBookingsApi();
            var body = new BuySellBookingServiceData(); // BuySellBookingServiceData | Buy/Sell Booking object
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Update Booking
                apiInstance.UpdateBuySellBooking(body, dossierToken, dossierId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BuySellBookingsApi.UpdateBuySellBooking: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**BuySellBookingServiceData**](BuySellBookingServiceData.md)| Buy/Sell Booking object | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
