# IO.Swagger.Api.CodaApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ImportCoda**](CodaApi.md#importcoda) | **POST** /dossiers/{dossierId}/coda | Import coda

<a name="importcoda"></a>
# **ImportCoda**
> CodaImportReportServiceData ImportCoda (string body, string dossierToken, int? dossierId)

Import coda

Accept dossiertoken and coda data and import coda

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ImportCodaExample
    {
        public void main()
        {
            var apiInstance = new CodaApi();
            var body = new string(); // string | Coda data
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Import coda
                CodaImportReportServiceData result = apiInstance.ImportCoda(body, dossierToken, dossierId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CodaApi.ImportCoda: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**string**](string.md)| Coda data | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

[**CodaImportReportServiceData**](CodaImportReportServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
