# IO.Swagger.Api.CostCentresApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetActiveCostCentres**](CostCentresApi.md#getactivecostcentres) | **GET** /dossiers/{dossierId}/costcentres/active | Get Active (closed &#x3D; false) Costcentres
[**GetCostCentres**](CostCentresApi.md#getcostcentres) | **GET** /dossiers/{dossierId}/costcentres | Get Costcentres
[**InsertUpdateCostCentre**](CostCentresApi.md#insertupdatecostcentre) | **PUT** /dossiers/{dossierId}/costcentres | Update Costcentre

<a name="getactivecostcentres"></a>
# **GetActiveCostCentres**
> List<CostCentreServiceData> GetActiveCostCentres (int? dossierId, string dossierToken)

Get Active (closed = false) Costcentres

Accept dossier token and return active Costcentres

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetActiveCostCentresExample
    {
        public void main()
        {
            var apiInstance = new CostCentresApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken

            try
            {
                // Get Active (closed = false) Costcentres
                List&lt;CostCentreServiceData&gt; result = apiInstance.GetActiveCostCentres(dossierId, dossierToken);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CostCentresApi.GetActiveCostCentres: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 

### Return type

[**List<CostCentreServiceData>**](CostCentreServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getcostcentres"></a>
# **GetCostCentres**
> List<CostCentreServiceData> GetCostCentres (int? dossierId, string dossierToken)

Get Costcentres

Accept dossier token and return Costcentres

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetCostCentresExample
    {
        public void main()
        {
            var apiInstance = new CostCentresApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken

            try
            {
                // Get Costcentres
                List&lt;CostCentreServiceData&gt; result = apiInstance.GetCostCentres(dossierId, dossierToken);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CostCentresApi.GetCostCentres: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 

### Return type

[**List<CostCentreServiceData>**](CostCentreServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="insertupdatecostcentre"></a>
# **InsertUpdateCostCentre**
> void InsertUpdateCostCentre (CostCentreServiceData body, string dossierToken, int? dossierId)

Update Costcentre

Accept dossiertoken and updated costcentre object, return status

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class InsertUpdateCostCentreExample
    {
        public void main()
        {
            var apiInstance = new CostCentresApi();
            var body = new CostCentreServiceData(); // CostCentreServiceData | Costcentre Object
            var dossierToken = dossierToken_example;  // string | Dossiertoken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Update Costcentre
                apiInstance.InsertUpdateCostCentre(body, dossierToken, dossierId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CostCentresApi.InsertUpdateCostCentre: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**CostCentreServiceData**](CostCentreServiceData.md)| Costcentre Object | 
 **dossierToken** | **string**| Dossiertoken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
