# IO.Swagger.Api.CustomFieldsApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetCustomFields**](CustomFieldsApi.md#getcustomfields) | **GET** /dossiers/{dossierId}/customfields | Get Custom Fields

<a name="getcustomfields"></a>
# **GetCustomFields**
> List<CustomFieldServiceData> GetCustomFields (int? dossierId, string dossierToken)

Get Custom Fields

Accept dossier token and return Custom Fields

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetCustomFieldsExample
    {
        public void main()
        {
            var apiInstance = new CustomFieldsApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken

            try
            {
                // Get Custom Fields
                List&lt;CustomFieldServiceData&gt; result = apiInstance.GetCustomFields(dossierId, dossierToken);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CustomFieldsApi.GetCustomFields: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 

### Return type

[**List<CustomFieldServiceData>**](CustomFieldServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
