# IO.Swagger.Api.DeliveryNotesApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ExportDeliveryNote**](DeliveryNotesApi.md#exportdeliverynote) | **GET** /dossiers/{dossierId}/deliverynotes/export | Export Delivery Note
[**GenerateDeliveryNote**](DeliveryNotesApi.md#generatedeliverynote) | **POST** /dossiers/{dossierId}/deliverynotes/generate | Generate Delivery Note
[**GetDeliveryNote**](DeliveryNotesApi.md#getdeliverynote) | **GET** /dossiers/{dossierId}/deliverynotes | Get Delivery Note
[**GetModifiedDeliveryNotes**](DeliveryNotesApi.md#getmodifieddeliverynotes) | **GET** /dossiers/{dossierId}/deliverynotes/modified | Get modified Delivery Notes
[**InsertDeliveryNote**](DeliveryNotesApi.md#insertdeliverynote) | **POST** /dossiers/{dossierId}/deliverynotes | Create Delivery Note
[**UpdateDeliveryNote**](DeliveryNotesApi.md#updatedeliverynote) | **PUT** /dossiers/{dossierId}/deliverynotes | Update Delivery Note

<a name="exportdeliverynote"></a>
# **ExportDeliveryNote**
> ExportedDeliveryNoteResult ExportDeliveryNote (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnDeliveryNote, bool? returnPdfDocument)

Export Delivery Note

Accept dossier token and export Delivery Note

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ExportDeliveryNoteExample
    {
        public void main()
        {
            var apiInstance = new DeliveryNotesApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var bookyearId = 56;  // int? | Bookyear ID
            var journalKey = journalKey_example;  // string | Journal Key
            var documentSeqNr = 56;  // int? | Document Nr
            var returnDeliveryNote = true;  // bool? | return Delivery Note
            var returnPdfDocument = true;  // bool? | return Pdf Document

            try
            {
                // Export Delivery Note
                ExportedDeliveryNoteResult result = apiInstance.ExportDeliveryNote(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr, returnDeliveryNote, returnPdfDocument);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DeliveryNotesApi.ExportDeliveryNote: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalKey** | **string**| Journal Key | 
 **documentSeqNr** | **int?**| Document Nr | 
 **returnDeliveryNote** | **bool?**| return Delivery Note | 
 **returnPdfDocument** | **bool?**| return Pdf Document | 

### Return type

[**ExportedDeliveryNoteResult**](ExportedDeliveryNoteResult.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="generatedeliverynote"></a>
# **GenerateDeliveryNote**
> ExportedDeliveryNoteResult GenerateDeliveryNote (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? publishPdfDocument, bool? returnDeliveryNote, bool? returnPdfDocument)

Generate Delivery Note

Generate Delivery Note in pdf format.  Rendering of the pdf is server-side.<BR>If exact rendering of the pdf is required, publish the pdf in the application and use the Export Delivery Note method

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GenerateDeliveryNoteExample
    {
        public void main()
        {
            var apiInstance = new DeliveryNotesApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var bookyearId = 56;  // int? | Bookyear ID
            var journalKey = journalKey_example;  // string | Journal Key
            var documentSeqNr = 56;  // int? | Document Nr
            var publishPdfDocument = true;  // bool? | publish Pdf Document
            var returnDeliveryNote = true;  // bool? | return Delivery Note
            var returnPdfDocument = true;  // bool? | return Pdf Document

            try
            {
                // Generate Delivery Note
                ExportedDeliveryNoteResult result = apiInstance.GenerateDeliveryNote(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr, publishPdfDocument, returnDeliveryNote, returnPdfDocument);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DeliveryNotesApi.GenerateDeliveryNote: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalKey** | **string**| Journal Key | 
 **documentSeqNr** | **int?**| Document Nr | 
 **publishPdfDocument** | **bool?**| publish Pdf Document | 
 **returnDeliveryNote** | **bool?**| return Delivery Note | 
 **returnPdfDocument** | **bool?**| return Pdf Document | 

### Return type

[**ExportedDeliveryNoteResult**](ExportedDeliveryNoteResult.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getdeliverynote"></a>
# **GetDeliveryNote**
> DeliveryNoteServiceData GetDeliveryNote (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)

Get Delivery Note

Accept dossier token and return Delivery Note

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetDeliveryNoteExample
    {
        public void main()
        {
            var apiInstance = new DeliveryNotesApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var bookyearId = 56;  // int? | Bookyear ID
            var journalKey = journalKey_example;  // string | Journal Key
            var documentSeqNr = 56;  // int? | Document Nr

            try
            {
                // Get Delivery Note
                DeliveryNoteServiceData result = apiInstance.GetDeliveryNote(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DeliveryNotesApi.GetDeliveryNote: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalKey** | **string**| Journal Key | 
 **documentSeqNr** | **int?**| Document Nr | 

### Return type

[**DeliveryNoteServiceData**](DeliveryNoteServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getmodifieddeliverynotes"></a>
# **GetModifiedDeliveryNotes**
> List<DeliveryNoteServiceData> GetModifiedDeliveryNotes (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)

Get modified Delivery Notes

Accept dossier token and return modified Delivery Notes

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetModifiedDeliveryNotesExample
    {
        public void main()
        {
            var apiInstance = new DeliveryNotesApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var bookyearId = 56;  // int? | Bookyear ID
            var journalKey = journalKey_example;  // string | Journal Key
            var modifiedTimeStamp = modifiedTimeStamp_example;  // string | Modified Timestamp

            try
            {
                // Get modified Delivery Notes
                List&lt;DeliveryNoteServiceData&gt; result = apiInstance.GetModifiedDeliveryNotes(dossierId, dossierToken, bookyearId, journalKey, modifiedTimeStamp);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DeliveryNotesApi.GetModifiedDeliveryNotes: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalKey** | **string**| Journal Key | 
 **modifiedTimeStamp** | **string**| Modified Timestamp | 

### Return type

[**List<DeliveryNoteServiceData>**](DeliveryNoteServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="insertdeliverynote"></a>
# **InsertDeliveryNote**
> void InsertDeliveryNote (DeliveryNoteServiceData body, string dossierToken, int? dossierId)

Create Delivery Note

Create new Delivery Note

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class InsertDeliveryNoteExample
    {
        public void main()
        {
            var apiInstance = new DeliveryNotesApi();
            var body = new DeliveryNoteServiceData(); // DeliveryNoteServiceData | DeliveryNote object
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Create Delivery Note
                apiInstance.InsertDeliveryNote(body, dossierToken, dossierId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DeliveryNotesApi.InsertDeliveryNote: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**DeliveryNoteServiceData**](DeliveryNoteServiceData.md)| DeliveryNote object | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="updatedeliverynote"></a>
# **UpdateDeliveryNote**
> void UpdateDeliveryNote (DeliveryNoteServiceData body, string dossierToken, int? dossierId)

Update Delivery Note

Modify Delivery Note

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateDeliveryNoteExample
    {
        public void main()
        {
            var apiInstance = new DeliveryNotesApi();
            var body = new DeliveryNoteServiceData(); // DeliveryNoteServiceData | DeliveryNote object
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Update Delivery Note
                apiInstance.UpdateDeliveryNote(body, dossierToken, dossierId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DeliveryNotesApi.UpdateDeliveryNote: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**DeliveryNoteServiceData**](DeliveryNoteServiceData.md)| DeliveryNote object | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
