# IO.Swagger.Api.DossiersApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ConnectDossier**](DossiersApi.md#connectdossier) | **POST** /dossiers | Get Dossiertoken
[**GetDossiers**](DossiersApi.md#getdossiers) | **GET** /dossiers | Get Dossiers

<a name="connectdossier"></a>
# **ConnectDossier**
> DossierTokenResult ConnectDossier (int? dossierId, string token, int? localeId = null)

Get Dossiertoken

Accept authentication token and return Dossiertoken

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ConnectDossierExample
    {
        public void main()
        {
            var apiInstance = new DossiersApi();
            var dossierId = 56;  // int? | Dossier ID of the dossier you want to connect with
            var token = token_example;  // string | Authentication token
            var localeId = 56;  // int? | Locale to be included in the DossierToken.Possible values are:<ul><li>0: keep default locale of the dossier</li><li>1: Nederlands (Dutch)</li><li>2: Frans (French)</li><li>3: Engels (English)</li><li>4: Duits (German)</li></ul> (optional) 

            try
            {
                // Get Dossiertoken
                DossierTokenResult result = apiInstance.ConnectDossier(dossierId, token, localeId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DossiersApi.ConnectDossier: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID of the dossier you want to connect with | 
 **token** | **string**| Authentication token | 
 **localeId** | **int?**| Locale to be included in the DossierToken.Possible values are:&lt;ul&gt;&lt;li&gt;0: keep default locale of the dossier&lt;/li&gt;&lt;li&gt;1: Nederlands (Dutch)&lt;/li&gt;&lt;li&gt;2: Frans (French)&lt;/li&gt;&lt;li&gt;3: Engels (English)&lt;/li&gt;&lt;li&gt;4: Duits (German)&lt;/li&gt;&lt;/ul&gt; | [optional] 

### Return type

[**DossierTokenResult**](DossierTokenResult.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getdossiers"></a>
# **GetDossiers**
> List<DossierServiceData> GetDossiers (string token)

Get Dossiers

Accept authentication token and return Dossiers list

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetDossiersExample
    {
        public void main()
        {
            var apiInstance = new DossiersApi();
            var token = token_example;  // string |  Authentication Token

            try
            {
                // Get Dossiers
                List&lt;DossierServiceData&gt; result = apiInstance.GetDossiers(token);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DossiersApi.GetDossiers: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **string**|  Authentication Token | 

### Return type

[**List<DossierServiceData>**](DossierServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
