# IO.Swagger.Api.ErrorsApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GenerateSampleError**](ErrorsApi.md#generatesampleerror) | **GET** /error | Generate error

<a name="generatesampleerror"></a>
# **GenerateSampleError**
> void GenerateSampleError (int? errorCode, int? localeId = null)

Generate error

Generate error and return sample ErrorResult object

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GenerateSampleErrorExample
    {
        public void main()
        {
            var apiInstance = new ErrorsApi();
            var errorCode = 56;  // int? | Error code to generate
            var localeId = 56;  // int? | Locale of the error message (optional) 

            try
            {
                // Generate error
                apiInstance.GenerateSampleError(errorCode, localeId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ErrorsApi.GenerateSampleError: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **errorCode** | **int?**| Error code to generate | 
 **localeId** | **int?**| Locale of the error message | [optional] 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
