# IO.Swagger.Api.FinancialDiversBookingsApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetFinancialDiversBooking**](FinancialDiversBookingsApi.md#getfinancialdiversbooking) | **GET** /dossiers/{dossierId}/financialdiversbookings | Get Financial Divers Booking
[**GetModifiedFinancialDiversBookings**](FinancialDiversBookingsApi.md#getmodifiedfinancialdiversbookings) | **GET** /dossiers/{dossierId}/financialdiversbookings/modified | Get modified Financial Divers Bookings
[**InsertFinancialDiversBooking**](FinancialDiversBookingsApi.md#insertfinancialdiversbooking) | **POST** /dossiers/{dossierId}/financialdiversbookings | Create Booking
[**UpdateFinancialDiversBooking**](FinancialDiversBookingsApi.md#updatefinancialdiversbooking) | **PUT** /dossiers/{dossierId}/financialdiversbookings | Update Bookings

<a name="getfinancialdiversbooking"></a>
# **GetFinancialDiversBooking**
> FinancialDiversBookingServiceData GetFinancialDiversBooking (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)

Get Financial Divers Booking

Accept Dossier ID, Dossier token, Bookyear Id, Journal ID, Document Nr and return Financial Divers Booking

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetFinancialDiversBookingExample
    {
        public void main()
        {
            var apiInstance = new FinancialDiversBookingsApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var bookyearId = 56;  // int? | Bookyear ID
            var journalKey = journalKey_example;  // string | Journal Key
            var documentSeqNr = 56;  // int? | Document Nr

            try
            {
                // Get Financial Divers Booking
                FinancialDiversBookingServiceData result = apiInstance.GetFinancialDiversBooking(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FinancialDiversBookingsApi.GetFinancialDiversBooking: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalKey** | **string**| Journal Key | 
 **documentSeqNr** | **int?**| Document Nr | 

### Return type

[**FinancialDiversBookingServiceData**](FinancialDiversBookingServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getmodifiedfinancialdiversbookings"></a>
# **GetModifiedFinancialDiversBookings**
> List<FinancialDiversBookingServiceData> GetModifiedFinancialDiversBookings (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)

Get modified Financial Divers Bookings

Accept dossier token and return modified Financial Divers Bookings

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetModifiedFinancialDiversBookingsExample
    {
        public void main()
        {
            var apiInstance = new FinancialDiversBookingsApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var bookyearId = 56;  // int? | Bookyear ID
            var journalKey = journalKey_example;  // string | Journal Key
            var modifiedTimeStamp = modifiedTimeStamp_example;  // string | Modified Timestamp

            try
            {
                // Get modified Financial Divers Bookings
                List&lt;FinancialDiversBookingServiceData&gt; result = apiInstance.GetModifiedFinancialDiversBookings(dossierId, dossierToken, bookyearId, journalKey, modifiedTimeStamp);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FinancialDiversBookingsApi.GetModifiedFinancialDiversBookings: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalKey** | **string**| Journal Key | 
 **modifiedTimeStamp** | **string**| Modified Timestamp | 

### Return type

[**List<FinancialDiversBookingServiceData>**](FinancialDiversBookingServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="insertfinancialdiversbooking"></a>
# **InsertFinancialDiversBooking**
> void InsertFinancialDiversBooking (FinancialDiversBookingAndAttachmentRequest body, string dossierToken, int? dossierId)

Create Booking

Create Financial Divers Booking

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class InsertFinancialDiversBookingExample
    {
        public void main()
        {
            var apiInstance = new FinancialDiversBookingsApi();
            var body = new FinancialDiversBookingAndAttachmentRequest(); // FinancialDiversBookingAndAttachmentRequest | Financial Divers Booking object and attachment list
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Create Booking
                apiInstance.InsertFinancialDiversBooking(body, dossierToken, dossierId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FinancialDiversBookingsApi.InsertFinancialDiversBooking: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**FinancialDiversBookingAndAttachmentRequest**](FinancialDiversBookingAndAttachmentRequest.md)| Financial Divers Booking object and attachment list | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="updatefinancialdiversbooking"></a>
# **UpdateFinancialDiversBooking**
> void UpdateFinancialDiversBooking (FinancialDiversBookingServiceData body, string dossierToken, int? dossierId)

Update Bookings

Modify Financial Divers Bookings

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateFinancialDiversBookingExample
    {
        public void main()
        {
            var apiInstance = new FinancialDiversBookingsApi();
            var body = new FinancialDiversBookingServiceData(); // FinancialDiversBookingServiceData | FinancialDiversBooking object
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Update Bookings
                apiInstance.UpdateFinancialDiversBooking(body, dossierToken, dossierId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FinancialDiversBookingsApi.UpdateFinancialDiversBooking: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**FinancialDiversBookingServiceData**](FinancialDiversBookingServiceData.md)| FinancialDiversBooking object | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
