# IO.Swagger.Model.IntrastatServiceData
## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**IsoCountrycode** | **string** | ISO code member state of origin/destination, eg. \&quot;BE\&quot; | [optional] 
**TransactionCode** | **int?** | Transaction code :&lt;ul&gt;&lt;li&gt;1 : Transactions accompanied by actual or planned transfer of ownership from residents to non-residents with a financial&lt;br/&gt;or other compensation(except the transactions listed under 2, 7, and 8).&lt;/li&gt;&lt;li&gt;2 : Return shipping and free replacement of goods after registration of the original transaction.&lt;/li&gt;&lt;li&gt;3 : Transactions involving ownership transfer without financial or \&quot;in kind\&quot; compensations (ex. shipment of relief goods).&lt;/li&gt;&lt;li&gt;4 : Transactions with a view to processing under contract ( without ownership transfer to the processor).&lt;/li&gt;&lt;li&gt;5 : Transactions after subcontracting (without property tranfer to the subcontractant).&lt;/li&gt;&lt;li&gt;6 : Transactions after repair or maintenance, except in case of intergovernmental programs for coordinated manufacturing.&lt;br/&gt;This service can be free or paid.  This transactions include no (future) tranfer of property rights.&lt;/li&gt;&lt;li&gt;7 : Transactions in relation to common defense programs or other intergovernmental programs for common manufacturing.&lt;/li&gt;&lt;li&gt;8 : Transactions within the framework of a contract for general construction work or road building or hydraulic engineering&lt;br/&gt; where the goods are to be invoiced separately and an invoice for the entire contract is drawn up.&lt;/li&gt;&lt;li&gt;9 : Other transactions that do not match with existing codes.&lt;/li&gt;&lt;/ul&gt; | [optional] 
**ProductCode** | **string** | Product Code | [optional] 
**Region** | **int?** | Region of origin/destination : &lt;ul&gt;&lt;li&gt;1 : Flemish region&lt;li&gt;2 : Walloon region&lt;li&gt;3 : Brussels capital region&lt;/ul&gt; | [optional] 
**Weight** | **double?** | Net weight | [optional] 
**UnitCount** | **double?** | Number of units | [optional] 
**TransportCode** | **int?** | Transport code : &lt;ul&gt;&lt;li&gt;0 : No entry&lt;li&gt;1 : Transport by sea (also if wagon, motorvehicle, trailer, trailer without tractor or lighter aboard of ship)&lt;li&gt;2 : Transport by rail (even Truck on wagon)&lt;li&gt;3 : Road transport&lt;li&gt;4 : Air transport&lt;li&gt;5 : Send by mail&lt;li&gt;7 : Fixed transport installation(eg. pipe-line, high voltage line)&lt;li&gt;8 : Inland waterway transport&lt;li&gt;9 : On his own (applies to sold goods that cross the border on their own when exported or imported &lt;br/&gt; such as airplanes, trucks, schips, etc...)&lt;/ul&gt; | [optional] 
**IncoTerms** | **string** | Inco Terms : &lt;ul&gt;&lt;li&gt;CFR - Cost and Freight&lt;li&gt;CIF - Cost, Insurance and Freight&lt;li&gt;CIP - Free transport and insurance up to a given destination&lt;li&gt;CPT - Transport free up to a given destination&lt;li&gt;DAP - Delivered At Place EXW&lt;li&gt;DAT - Franco at terminal&lt;li&gt;DDP - Delivered Duty Paid&lt;li&gt;EXW - Ex works&lt;li&gt;FAS - Franco alongside ship&lt;li&gt;FCA - Free Carrier&lt;li&gt;FOB - Free On Board&lt;li&gt;N   - No entry&lt;/ul&gt; | [optional] 
**OriginCountry** | **string** | Country of origin code | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

