# IO.Swagger.Api.InvoicesApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ExportInvoice**](InvoicesApi.md#exportinvoice) | **GET** /dossiers/{dossierId}/invoices/export | Export Invoice
[**GenerateInvoice**](InvoicesApi.md#generateinvoice) | **POST** /dossiers/{dossierId}/invoices/generate | Generate Invoice 
[**GetInvoice**](InvoicesApi.md#getinvoice) | **GET** /dossiers/{dossierId}/invoices | Get Invoice
[**GetModifiedInvoices**](InvoicesApi.md#getmodifiedinvoices) | **GET** /dossiers/{dossierId}/invoices/modified | Get modified invoices
[**InsertInvoice**](InvoicesApi.md#insertinvoice) | **POST** /dossiers/{dossierId}/invoices | Create invoice
[**UpdateInvoice**](InvoicesApi.md#updateinvoice) | **PUT** /dossiers/{dossierId}/invoices | Update invoice

<a name="exportinvoice"></a>
# **ExportInvoice**
> ExportedInvoiceResult ExportInvoice (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml)

Export Invoice

Accept dossier token and export Invoice

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ExportInvoiceExample
    {
        public void main()
        {
            var apiInstance = new InvoicesApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var bookyearId = 56;  // int? | Bookyear ID
            var journalKey = journalKey_example;  // string | Journal Key
            var documentSeqNr = 56;  // int? | Document Nr
            var returnInvoice = true;  // bool? | return Invoice
            var returnPdfDocument = true;  // bool? | return Pdf Document
            var returnEInvoiceXml = true;  // bool? | return eInvoice Xml

            try
            {
                // Export Invoice
                ExportedInvoiceResult result = apiInstance.ExportInvoice(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr, returnInvoice, returnPdfDocument, returnEInvoiceXml);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling InvoicesApi.ExportInvoice: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalKey** | **string**| Journal Key | 
 **documentSeqNr** | **int?**| Document Nr | 
 **returnInvoice** | **bool?**| return Invoice | 
 **returnPdfDocument** | **bool?**| return Pdf Document | 
 **returnEInvoiceXml** | **bool?**| return eInvoice Xml | 

### Return type

[**ExportedInvoiceResult**](ExportedInvoiceResult.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="generateinvoice"></a>
# **GenerateInvoice**
> ExportedInvoiceResult GenerateInvoice (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr, bool? returnInvoice, bool? publishPdfDocument, bool? publishEInvoice, bool? returnPdfDocument, bool? returnEInvoiceXml)

Generate Invoice 

Generate Invoice in pdf format.  Rendering of the pdf is server-side.<BR>If exact rendering of the pdf is required, publish the pdf in the application and use the Export Invoice method

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GenerateInvoiceExample
    {
        public void main()
        {
            var apiInstance = new InvoicesApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var bookyearId = 56;  // int? | Bookyear ID
            var journalKey = journalKey_example;  // string | Journal Key
            var documentSeqNr = 56;  // int? | Document Nr
            var returnInvoice = true;  // bool? | return Invoice
            var publishPdfDocument = true;  // bool? | publish Pdf Document
            var publishEInvoice = true;  // bool? | publish eInvoice
            var returnPdfDocument = true;  // bool? | return Pdf Document
            var returnEInvoiceXml = true;  // bool? | return eInvoice Xml

            try
            {
                // Generate Invoice 
                ExportedInvoiceResult result = apiInstance.GenerateInvoice(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr, returnInvoice, publishPdfDocument, publishEInvoice, returnPdfDocument, returnEInvoiceXml);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling InvoicesApi.GenerateInvoice: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalKey** | **string**| Journal Key | 
 **documentSeqNr** | **int?**| Document Nr | 
 **returnInvoice** | **bool?**| return Invoice | 
 **publishPdfDocument** | **bool?**| publish Pdf Document | 
 **publishEInvoice** | **bool?**| publish eInvoice | 
 **returnPdfDocument** | **bool?**| return Pdf Document | 
 **returnEInvoiceXml** | **bool?**| return eInvoice Xml | 

### Return type

[**ExportedInvoiceResult**](ExportedInvoiceResult.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getinvoice"></a>
# **GetInvoice**
> InvoiceServiceData GetInvoice (int? dossierId, string dossierToken, int? bookyearId, string journalKey, int? documentSeqNr)

Get Invoice

Accept dossier token and return invoice

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetInvoiceExample
    {
        public void main()
        {
            var apiInstance = new InvoicesApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var bookyearId = 56;  // int? | Bookyear ID
            var journalKey = journalKey_example;  // string | Journal Key
            var documentSeqNr = 56;  // int? | Document Nr

            try
            {
                // Get Invoice
                InvoiceServiceData result = apiInstance.GetInvoice(dossierId, dossierToken, bookyearId, journalKey, documentSeqNr);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling InvoicesApi.GetInvoice: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalKey** | **string**| Journal Key | 
 **documentSeqNr** | **int?**| Document Nr | 

### Return type

[**InvoiceServiceData**](InvoiceServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getmodifiedinvoices"></a>
# **GetModifiedInvoices**
> List<InvoiceServiceData> GetModifiedInvoices (int? dossierId, string dossierToken, int? bookyearId, string journalKey, string modifiedTimeStamp)

Get modified invoices

Accept dossier token and return modified invoices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetModifiedInvoicesExample
    {
        public void main()
        {
            var apiInstance = new InvoicesApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var bookyearId = 56;  // int? | Bookyear ID
            var journalKey = journalKey_example;  // string | Journal Key
            var modifiedTimeStamp = modifiedTimeStamp_example;  // string | Modified Timestamp

            try
            {
                // Get modified invoices
                List&lt;InvoiceServiceData&gt; result = apiInstance.GetModifiedInvoices(dossierId, dossierToken, bookyearId, journalKey, modifiedTimeStamp);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling InvoicesApi.GetModifiedInvoices: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalKey** | **string**| Journal Key | 
 **modifiedTimeStamp** | **string**| Modified Timestamp | 

### Return type

[**List<InvoiceServiceData>**](InvoiceServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="insertinvoice"></a>
# **InsertInvoice**
> void InsertInvoice (InvoiceServiceData body, string dossierToken, int? dossierId)

Create invoice

Create new invoice

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class InsertInvoiceExample
    {
        public void main()
        {
            var apiInstance = new InvoicesApi();
            var body = new InvoiceServiceData(); // InvoiceServiceData | Invoice object
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Create invoice
                apiInstance.InsertInvoice(body, dossierToken, dossierId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling InvoicesApi.InsertInvoice: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**InvoiceServiceData**](InvoiceServiceData.md)| Invoice object | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="updateinvoice"></a>
# **UpdateInvoice**
> void UpdateInvoice (InvoiceServiceData body, string dossierToken, int? dossierId)

Update invoice

Modify invoice

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateInvoiceExample
    {
        public void main()
        {
            var apiInstance = new InvoicesApi();
            var body = new InvoiceServiceData(); // InvoiceServiceData | Invoice object
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Update invoice
                apiInstance.UpdateInvoice(body, dossierToken, dossierId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling InvoicesApi.UpdateInvoice: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**InvoiceServiceData**](InvoiceServiceData.md)| Invoice object | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
