# IO.Swagger.Api.JournalsApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetFinancialJournalBalance**](JournalsApi.md#getfinancialjournalbalance) | **GET** /dossiers/{dossierId}/bookyears/{bookyearId}/journals/{journalKey} | Get Financial Journal Balance
[**GetJournals**](JournalsApi.md#getjournals) | **GET** /dossiers/{dossierId}/bookyears/{bookyearId}/journals | Get Journals

<a name="getfinancialjournalbalance"></a>
# **GetFinancialJournalBalance**
> List<JournalBalance> GetFinancialJournalBalance (int? dossierId, int? bookyearId, string journalKey, string dossierToken)

Get Financial Journal Balance

Accept dossier token, bookYearKey and JournalKey, and retrieves the journal balance

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetFinancialJournalBalanceExample
    {
        public void main()
        {
            var apiInstance = new JournalsApi();
            var dossierId = 56;  // int? | Dossier ID
            var bookyearId = 56;  // int? | Bookyear ID
            var journalKey = journalKey_example;  // string | Journal Key
            var dossierToken = dossierToken_example;  // string | dossierToken

            try
            {
                // Get Financial Journal Balance
                List&lt;JournalBalance&gt; result = apiInstance.GetFinancialJournalBalance(dossierId, bookyearId, journalKey, dossierToken);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling JournalsApi.GetFinancialJournalBalance: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **bookyearId** | **int?**| Bookyear ID | 
 **journalKey** | **string**| Journal Key | 
 **dossierToken** | **string**| dossierToken | 

### Return type

[**List<JournalBalance>**](JournalBalance.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getjournals"></a>
# **GetJournals**
> List<JournalServiceData> GetJournals (int? dossierId, int? bookyearId, string dossierToken)

Get Journals

Accept dossier token and bookYearKey and retrieves the journals for this bookyear

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetJournalsExample
    {
        public void main()
        {
            var apiInstance = new JournalsApi();
            var dossierId = 56;  // int? | Dossier ID
            var bookyearId = 56;  // int? | Bookyear ID
            var dossierToken = dossierToken_example;  // string | dossierToken

            try
            {
                // Get Journals
                List&lt;JournalServiceData&gt; result = apiInstance.GetJournals(dossierId, bookyearId, dossierToken);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling JournalsApi.GetJournals: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **bookyearId** | **int?**| Bookyear ID | 
 **dossierToken** | **string**| dossierToken | 

### Return type

[**List<JournalServiceData>**](JournalServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
