# IO.Swagger.Api.ProductsApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetProducts**](ProductsApi.md#getproducts) | **GET** /dossiers/{dossierId}/products | Get Products
[**InsertUpdateProduct**](ProductsApi.md#insertupdateproduct) | **PUT** /dossiers/{dossierId}/products | Modify or create Product

<a name="getproducts"></a>
# **GetProducts**
> List<ProductServiceData> GetProducts (int? dossierId, string dossierToken)

Get Products

Accept dossier token and return Products

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetProductsExample
    {
        public void main()
        {
            var apiInstance = new ProductsApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken

            try
            {
                // Get Products
                List&lt;ProductServiceData&gt; result = apiInstance.GetProducts(dossierId, dossierToken);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProductsApi.GetProducts: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 

### Return type

[**List<ProductServiceData>**](ProductServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="insertupdateproduct"></a>
# **InsertUpdateProduct**
> void InsertUpdateProduct (ProductServiceData body, string dossierToken, int? dossierId)

Modify or create Product

Accept dossiertoken and product object, return status

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class InsertUpdateProductExample
    {
        public void main()
        {
            var apiInstance = new ProductsApi();
            var body = new ProductServiceData(); // ProductServiceData | productObject
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Modify or create Product
                apiInstance.InsertUpdateProduct(body, dossierToken, dossierId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProductsApi.InsertUpdateProduct: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ProductServiceData**](ProductServiceData.md)| productObject | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
