# IO.Swagger.Api.RappelsApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ExportRappel**](RappelsApi.md#exportrappel) | **GET** /dossiers/{dossierId}/rappels/export | Export Rappel
[**GetRappelInformation**](RappelsApi.md#getrappelinformation) | **GET** /dossiers/{dossierId}/rappels | Get Rappel information

<a name="exportrappel"></a>
# **ExportRappel**
> ExportedRappelResult ExportRappel (int? dossierId, string dossierToken, int? relationId, int? rappelId)

Export Rappel

Accept dossier token and export Rappel

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ExportRappelExample
    {
        public void main()
        {
            var apiInstance = new RappelsApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var relationId = 56;  // int? | Relation ID
            var rappelId = 56;  // int? | Rappel ID

            try
            {
                // Export Rappel
                ExportedRappelResult result = apiInstance.ExportRappel(dossierId, dossierToken, relationId, rappelId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling RappelsApi.ExportRappel: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **relationId** | **int?**| Relation ID | 
 **rappelId** | **int?**| Rappel ID | 

### Return type

[**ExportedRappelResult**](ExportedRappelResult.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getrappelinformation"></a>
# **GetRappelInformation**
> List<RappelServiceData> GetRappelInformation (int? dossierId, string dossierToken, string expirationDate)

Get Rappel information

Accept dossier token and return Rappel information

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetRappelInformationExample
    {
        public void main()
        {
            var apiInstance = new RappelsApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var expirationDate = expirationDate_example;  // string | Expiration Date

            try
            {
                // Get Rappel information
                List&lt;RappelServiceData&gt; result = apiInstance.GetRappelInformation(dossierId, dossierToken, expirationDate);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling RappelsApi.GetRappelInformation: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **expirationDate** | **string**| Expiration Date | 

### Return type

[**List<RappelServiceData>**](RappelServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
