# IO.Swagger.Model.RelationServiceData
## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**RelationIdentificationServiceData** | [**RelationIdentificationServiceData**](RelationIdentificationServiceData.md) |  | 
**Name** | **string** | Relation Name | [optional] 
**FirstName** | **string** | Relation first name | [optional] 
**Client** | **bool?** | boolean indicating if this relation is a client | [optional] 
**DefaultBookingAccountClient** | **int?** | Default booking account related to this client | [optional] 
**Supplier** | **bool?** | boolean indicating if this relation is a supplier | [optional] 
**DefaultBookingAccountSupplier** | **int?** | Default booking account related to this supplier | [optional] 
**StreetAndNr** | **string** | Street and nr | [optional] 
**PostalCode** | **string** | Postal Code | [optional] 
**City** | **string** | City | [optional] 
**Country** | **string** | Country Code. Allowable values: BE , NL , DE , GB , .. | [optional] 
**DeliveryStreetAndNr** | **string** | Delivery Street and nr | [optional] 
**DeliveryPostalCode** | **string** | Delivery Postal Code | [optional] 
**DeliveryCity** | **string** | Delivery City | [optional] 
**DeliveryCountry** | **string** | Delivery Country Code. Allowable values: BE , NL , DE , GB , .. | [optional] 
**Telephone** | **string** | Telephone | [optional] 
**Email** | **string** | Email | [optional] 
**Fax** | **string** | Fax number | [optional] 
**Mobile** | **string** | Mobile number | [optional] 
**Url** | **string** | Url | [optional] 
**BankAccountNr** | **string** | Bank account nr (National Standard) | [optional] 
**IbanAccountNr** | **string** | Bank account nr ( IBAN standard ) | [optional] 
**BicCode** | **string** | BIC code | [optional] 
**FinancialDiscount** | **bool?** | Financial Discount granted | [optional] 
**Profession** | **string** | Profession | [optional] 
**ContactPerson** | **string** | Contact person | [optional] 
**CorporationType** | **int?** | Corporation Type&lt;ul&gt;&lt;li&gt;0 : NP&lt;/li&gt;&lt;li&gt;1 : NV&lt;/li&gt;&lt;li&gt;2 : BVBA&lt;/li&gt;&lt;li&gt;3 : CVBA&lt;/li&gt;&lt;li&gt;4 : CVOA&lt;/li&gt;&lt;li&gt;5 : Comm. V&lt;/li&gt;&lt;li&gt;6 : Comm. VA&lt;/li&gt;&lt;li&gt;7 : VOF&lt;/li&gt;&lt;li&gt;8 : VZW&lt;/li&gt;&lt;li&gt;9 : BV&lt;/li&gt;&lt;li&gt;10 : AG&lt;/li&gt;&lt;li&gt;11 : GmbH&lt;/li&gt;&lt;li&gt;12 : KG&lt;/li&gt;&lt;li&gt;13 : KGA&lt;/li&gt;&lt;li&gt;14 : OHG&lt;/li&gt;&lt;li&gt;15 : Plc&lt;/li&gt;&lt;li&gt;16 : Ltd&lt;/li&gt;&lt;li&gt;17 : LP&lt;/li&gt;&lt;li&gt;18 : Unlimited&lt;/li&gt;&lt;li&gt;19 : Inc.&lt;/li&gt;&lt;li&gt;20 : SA&lt;/li&gt;&lt;li&gt;21 : SRL&lt;/li&gt;&lt;li&gt;22 : SA&lt;/li&gt;&lt;li&gt;23 : Ltda&lt;/li&gt;&lt;li&gt;24 : FV&lt;/li&gt;&lt;li&gt;25 : PS&lt;/li&gt;&lt;li&gt;26 : LV&lt;/li&gt;&lt;/ul&gt; | [optional] 
**CurrencyCode** | **string** | Currency Code (e.g. EUR) | [optional] 
**Remarks** | **string** | Remarks | [optional] 
**VatNr** | **string** | VAT Nr ( In case BE, format should be BE0xxx.xxx.xxx ) | [optional] 
**VatType** | **int?** | Vat Type (Btw plichtigheid):&lt;ul&gt;&lt;li&gt;0 : Onbekend&lt;/li&gt;&lt;li&gt;1 : Belgische BTW-plichtige&lt;/li&gt;&lt;li&gt;4 : Intracommunautaire BTW-plichtige&lt;/li&gt;&lt;li&gt;6 : BTW-plichtige buiten EU&lt;/li&gt;&lt;li&gt;7 : Particulier Belgie&lt;/li&gt;&lt;li&gt;8 : Particulier EU&lt;/li&gt;&lt;li&gt;9 : Particulier niet-EU&lt;/li&gt;&lt;li&gt;10: Niet btw-plichtig&lt;/li&gt;&lt;/ul&gt; | [optional] 
**ExpirationType** | **int?** | Expiration Type. 1 : End of month, 2 : After invoice date | [optional] 
**ExpirationDays** | **int?** | Number of days after expiration type | [optional] 
**SearchField1** | **string** | Search field 1 | [optional] 
**SearchField2** | **string** | Search field 2 | [optional] 
**ExternCustomerNr** | **string** | Customer number as known by supplier | [optional] 
**SddReference** | **string** | Sepa Direct Debit reference | [optional] 
**SddSeqtype** | **int?** | Sepa Direct Debit sequence type:&lt;ul&gt;&lt;li&gt;Value 1 : First&lt;/li&gt;&lt;li&gt;Value 2 : Recurrent&lt;/li&gt;&lt;li&gt;Value 3 : Last&lt;/li&gt;&lt;li&gt;Value 4 : One time&lt;/li&gt;&lt;/ul&gt; | [optional] 
**SddMandateType** | **int?** | Sepa Direct Debit Mandate Type:&lt;ul&gt;&lt;li&gt;Value 1 : Core&lt;/li&gt;&lt;li&gt;Value 2 : B2B&lt;/li&gt;&lt;/ul&gt; | [optional] 
**SddSignatureDate** | **DateTime?** | Sepa Direct Debit signature date | [optional] 
**SddActive** | **bool?** | Sepa Direct Debit Active flag | [optional] 
**FactLanguage** | **int?** | Invoice language.  0 : Nederlands, 1 : Francais, 2 : English | [optional] 
**Active** | **bool?** | Indication if the relation is active | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

