# IO.Swagger.Api.RelationsApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetModifiedRelations**](RelationsApi.md#getmodifiedrelations) | **GET** /dossiers/{dossierId}/relations/modified | Get Modified Relations
[**GetRelations**](RelationsApi.md#getrelations) | **GET** /dossiers/{dossierId}/relations | Get Relations
[**InsertUpdateRelation**](RelationsApi.md#insertupdaterelation) | **PUT** /dossiers/{dossierId}/relations | Modify or create Relation

<a name="getmodifiedrelations"></a>
# **GetModifiedRelations**
> SyncRelations GetModifiedRelations (int? dossierId, string dossierToken, string modifiedTimeStamp = null)

Get Modified Relations

Accept dossier token, modified Timestamp and return modified/deleted Relations (Syncrelations).

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetModifiedRelationsExample
    {
        public void main()
        {
            var apiInstance = new RelationsApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var modifiedTimeStamp = modifiedTimeStamp_example;  // string | modifiedTimeStamp (optional) 

            try
            {
                // Get Modified Relations
                SyncRelations result = apiInstance.GetModifiedRelations(dossierId, dossierToken, modifiedTimeStamp);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling RelationsApi.GetModifiedRelations: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **modifiedTimeStamp** | **string**| modifiedTimeStamp | [optional] 

### Return type

[**SyncRelations**](SyncRelations.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getrelations"></a>
# **GetRelations**
> List<RelationServiceData> GetRelations (int? dossierId, string dossierToken, int? relationId = null, int? extRelationId = null, string name = null, string vatNr = null)

Get Relations

Accept dossier token and return active Relations.  If one or more of the optional search parameters are provided, all relations that meet one or more of these conditions will be returned wether they are active or not

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetRelationsExample
    {
        public void main()
        {
            var apiInstance = new RelationsApi();
            var dossierId = 56;  // int? | Dossier ID
            var dossierToken = dossierToken_example;  // string | dossierToken
            var relationId = 56;  // int? | relation ID (optional) 
            var extRelationId = 56;  // int? | External relation ID (optional) 
            var name = name_example;  // string | relation name (optional) 
            var vatNr = vatNr_example;  // string | VAT Nr (optional) 

            try
            {
                // Get Relations
                List&lt;RelationServiceData&gt; result = apiInstance.GetRelations(dossierId, dossierToken, relationId, extRelationId, name, vatNr);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling RelationsApi.GetRelations: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dossierId** | **int?**| Dossier ID | 
 **dossierToken** | **string**| dossierToken | 
 **relationId** | **int?**| relation ID | [optional] 
 **extRelationId** | **int?**| External relation ID | [optional] 
 **name** | **string**| relation name | [optional] 
 **vatNr** | **string**| VAT Nr | [optional] 

### Return type

[**List<RelationServiceData>**](RelationServiceData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="insertupdaterelation"></a>
# **InsertUpdateRelation**
> void InsertUpdateRelation (RelationServiceData body, string dossierToken, int? dossierId)

Modify or create Relation

Accept dossiertoken and relation object, return status

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class InsertUpdateRelationExample
    {
        public void main()
        {
            var apiInstance = new RelationsApi();
            var body = new RelationServiceData(); // RelationServiceData | relation Object
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Modify or create Relation
                apiInstance.InsertUpdateRelation(body, dossierToken, dossierId);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling RelationsApi.InsertUpdateRelation: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**RelationServiceData**](RelationServiceData.md)| relation Object | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
