# IO.Swagger.Api.ReportsApi

All URIs are relative to *https://service.inaras.be/octopus-rest-api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetReportHistoryAccount**](ReportsApi.md#getreporthistoryaccount) | **POST** /dossiers/{dossierId}/reports/accounts/history | Get history account report
[**GetReportHistoryClient**](ReportsApi.md#getreporthistoryclient) | **POST** /dossiers/{dossierId}/reports/clients/history | Get history client report
[**GetReportHistoryCostCentre**](ReportsApi.md#getreporthistorycostcentre) | **POST** /dossiers/{dossierId}/reports/costcentres/history | Get history costcentre report
[**GetReportHistorySupplier**](ReportsApi.md#getreporthistorysupplier) | **POST** /dossiers/{dossierId}/reports/suppliers/history | Get history supplier report
[**GetReportOpenAccount**](ReportsApi.md#getreportopenaccount) | **POST** /dossiers/{dossierId}/reports/accounts/open | Get open account report
[**GetReportOpenClient**](ReportsApi.md#getreportopenclient) | **POST** /dossiers/{dossierId}/reports/clients/open | Get open client report
[**GetReportOpenSupplier**](ReportsApi.md#getreportopensupplier) | **POST** /dossiers/{dossierId}/reports/suppliers/open | Get open supplier report

<a name="getreporthistoryaccount"></a>
# **GetReportHistoryAccount**
> List<HistoryData> GetReportHistoryAccount (HistoryAccountQueryData body, string dossierToken, int? dossierId)

Get history account report

Accept dossier token and History Account Query Data and return History Data

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetReportHistoryAccountExample
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var body = new HistoryAccountQueryData(); // HistoryAccountQueryData | History Account Query Data
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Get history account report
                List&lt;HistoryData&gt; result = apiInstance.GetReportHistoryAccount(body, dossierToken, dossierId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.GetReportHistoryAccount: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HistoryAccountQueryData**](HistoryAccountQueryData.md)| History Account Query Data | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

[**List<HistoryData>**](HistoryData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getreporthistoryclient"></a>
# **GetReportHistoryClient**
> List<HistoryData> GetReportHistoryClient (HistoryRelationQueryData body, string dossierToken, int? dossierId)

Get history client report

Accept dossier token and History Relation Query Data and return History Client Data

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetReportHistoryClientExample
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var body = new HistoryRelationQueryData(); // HistoryRelationQueryData | History Relation Query Data
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Get history client report
                List&lt;HistoryData&gt; result = apiInstance.GetReportHistoryClient(body, dossierToken, dossierId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.GetReportHistoryClient: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HistoryRelationQueryData**](HistoryRelationQueryData.md)| History Relation Query Data | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

[**List<HistoryData>**](HistoryData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getreporthistorycostcentre"></a>
# **GetReportHistoryCostCentre**
> List<HistoryCostCentreData> GetReportHistoryCostCentre (HistoryCostCentreQueryData body, string dossierToken, int? dossierId)

Get history costcentre report

Accept dossier token and History CostCentre Query Data and return History CostCentre Data

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetReportHistoryCostCentreExample
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var body = new HistoryCostCentreQueryData(); // HistoryCostCentreQueryData | History CostCentre Query Data
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Get history costcentre report
                List&lt;HistoryCostCentreData&gt; result = apiInstance.GetReportHistoryCostCentre(body, dossierToken, dossierId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.GetReportHistoryCostCentre: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HistoryCostCentreQueryData**](HistoryCostCentreQueryData.md)| History CostCentre Query Data | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

[**List<HistoryCostCentreData>**](HistoryCostCentreData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getreporthistorysupplier"></a>
# **GetReportHistorySupplier**
> List<HistoryData> GetReportHistorySupplier (HistoryRelationQueryData body, string dossierToken, int? dossierId)

Get history supplier report

Accept dossier token and History Relation Query Data and return History Supplier Data

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetReportHistorySupplierExample
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var body = new HistoryRelationQueryData(); // HistoryRelationQueryData | History Relation Query Data
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Get history supplier report
                List&lt;HistoryData&gt; result = apiInstance.GetReportHistorySupplier(body, dossierToken, dossierId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.GetReportHistorySupplier: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HistoryRelationQueryData**](HistoryRelationQueryData.md)| History Relation Query Data | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

[**List<HistoryData>**](HistoryData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getreportopenaccount"></a>
# **GetReportOpenAccount**
> List<OpenData> GetReportOpenAccount (OpenAccountQueryData body, string dossierToken, int? dossierId)

Get open account report

Accept dossier token and Open Account Query Data and return Open Account Data

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetReportOpenAccountExample
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var body = new OpenAccountQueryData(); // OpenAccountQueryData | Open Account Query Data
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Get open account report
                List&lt;OpenData&gt; result = apiInstance.GetReportOpenAccount(body, dossierToken, dossierId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.GetReportOpenAccount: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**OpenAccountQueryData**](OpenAccountQueryData.md)| Open Account Query Data | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

[**List<OpenData>**](OpenData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getreportopenclient"></a>
# **GetReportOpenClient**
> List<OpenData> GetReportOpenClient (OpenRelationQueryData body, string dossierToken, int? dossierId)

Get open client report

Accept dossier token and Open Relation Query Data and return Open Client Data

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetReportOpenClientExample
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var body = new OpenRelationQueryData(); // OpenRelationQueryData | Open Relation Query Data
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Get open client report
                List&lt;OpenData&gt; result = apiInstance.GetReportOpenClient(body, dossierToken, dossierId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.GetReportOpenClient: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**OpenRelationQueryData**](OpenRelationQueryData.md)| Open Relation Query Data | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

[**List<OpenData>**](OpenData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="getreportopensupplier"></a>
# **GetReportOpenSupplier**
> List<OpenData> GetReportOpenSupplier (OpenRelationQueryData body, string dossierToken, int? dossierId)

Get open supplier report

Accept dossier token and Open Relation Query Data and return Open Supplier Data

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetReportOpenSupplierExample
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var body = new OpenRelationQueryData(); // OpenRelationQueryData | Open Relation Query Data
            var dossierToken = dossierToken_example;  // string | dossierToken
            var dossierId = 56;  // int? | Dossier ID

            try
            {
                // Get open supplier report
                List&lt;OpenData&gt; result = apiInstance.GetReportOpenSupplier(body, dossierToken, dossierId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.GetReportOpenSupplier: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**OpenRelationQueryData**](OpenRelationQueryData.md)| Open Relation Query Data | 
 **dossierToken** | **string**| dossierToken | 
 **dossierId** | **int?**| Dossier ID | 

### Return type

[**List<OpenData>**](OpenData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
